// A Bison parser, made by GNU Bison 3.3.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2019 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Undocumented macros, especially those whose name start with YY_,
// are private implementation details.  Do not rely on them.

// //                    "%code top" blocks.
#line 30 "DynareBison.yy" // lalr1.cc:423

class ParsingDriver;

#line 42 "DynareBison.cc" // lalr1.cc:423




#include "DynareBison.hh"


// Unqualified %code blocks.
#line 48 "DynareBison.yy" // lalr1.cc:435

/* Little hack: we redefine the macro which computes the locations, because
   we need to access the location from within the parsing driver for error
   and warning messages. */
#define YYLLOC_DEFAULT(Current, Rhs, N)                         \
  do {                                                          \
    if (N)                                                      \
      {                                                         \
        (Current).begin = YYRHSLOC(Rhs, 1).begin;               \
        (Current).end   = YYRHSLOC(Rhs, N).end;                 \
      }                                                         \
    else                                                        \
      {                                                         \
        (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end;	\
      }                                                         \
    driver.location = (Current);                                \
  } while(false)

#include "ParsingDriver.hh"

/* this "connects" the bison parser in the driver to the flex scanner class
 * object. it defines the yylex() function call to pull the next token from the
 * current lexer object of the driver context. */
#undef yylex
#define yylex driver.lexer->lex

#line 78 "DynareBison.cc" // lalr1.cc:435


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 25 "DynareBison.yy" // lalr1.cc:510
namespace Dynare {
#line 173 "DynareBison.cc" // lalr1.cc:510

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  parser::parser (ParsingDriver &driver_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | Symbol types.  |
  `---------------*/

  // basic_symbol.
#if 201103L <= YY_CPLUSPLUS
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (basic_symbol&& that)
    : Base (std::move (that))
    , value ()
    , location (std::move (that.location))
  {
    switch (this->type_get ())
    {
      case 837: // prior_distribution
      case 838: // prior_pdf
        value.move< PriorDistributions > (std::move (that.value));
        break;

      case 712: // change_type_arg
        value.move< SymbolType > (std::move (that.value));
        break;

      case 716: // expression
      case 719: // expression_or_empty
      case 743: // equation
      case 746: // hand_side
        value.move< expr_t > (std::move (that.value));
        break;

      case 1003: // calibration_range
        value.move< pair<expr_t,expr_t> > (std::move (that.value));
        break;

      case 702: // named_var_elem
      case 847: // subsamples_eq_opt
      case 1468: // integer_range_w_inf
        value.move< pair<string,string> > (std::move (that.value));
        break;

      case 88: // FLOAT_NUMBER
      case 89: // DATES
      case 137: // INT_NUMBER
      case 234: // NAME
      case 296: // QUOTED_STRING
      case 349: // TEX_NAME
      case 472: // ALPHA
      case 473: // BETA
      case 474: // ABAND
      case 475: // NINV
      case 476: // CMS
      case 477: // NCMS
      case 478: // CNUM
      case 479: // GAMMA
      case 480: // INV_GAMMA
      case 481: // INV_GAMMA1
      case 482: // INV_GAMMA2
      case 483: // NORMAL
      case 484: // UNIFORM
      case 485: // EPS
      case 486: // PDF
      case 487: // FIG
      case 488: // DR
      case 489: // NONE
      case 490: // PRIOR
      case 491: // PRIOR_VARIANCE
      case 492: // HESSIAN
      case 493: // IDENTITY_MATRIX
      case 494: // DIRICHLET
      case 495: // DIAGONAL
      case 496: // OPTIMAL
      case 817: // signed_integer
      case 818: // non_negative_number
      case 819: // signed_number
      case 820: // signed_inf
      case 821: // signed_number_w_inf
      case 839: // date_str
      case 840: // date_expr
      case 873: // list_sub_sampling_option
      case 874: // sub_sampling_options
      case 901: // filename
      case 902: // namespace_qualified_symbol
      case 903: // namespace_qualified_filename
      case 1466: // range
      case 1467: // integer_range
      case 1469: // signed_integer_range
      case 1476: // vec_value_1
      case 1477: // vec_value
      case 1478: // vec_value_list
      case 1479: // vec_of_vec_value
      case 1480: // vec_value_1_w_inf
      case 1481: // vec_value_w_inf
      case 1482: // symbol
      case 1483: // number
        value.move< string > (std::move (that.value));
        break;

      case 862: // prior_eq_opt
      case 867: // options_eq_opt
        value.move< tuple<string,string,string,string> > (std::move (that.value));
        break;

      case 1470: // vec_int_number
      case 1471: // vec_int_elem
      case 1472: // vec_int_1
      case 1473: // vec_int
        value.move< vector<int> > (std::move (that.value));
        break;

      case 703: // named_var_1
      case 704: // named_var
        value.move< vector<pair<string,string>> > (std::move (that.value));
        break;

      case 643: // SYMBOL_VEC
      case 713: // change_type_var_list
      case 1474: // vec_str_1
      case 1475: // vec_str
        value.move< vector<string> > (std::move (that.value));
        break;

      default:
        break;
    }

  }
#endif

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->type_get ())
    {
      case 837: // prior_distribution
      case 838: // prior_pdf
        value.copy< PriorDistributions > (YY_MOVE (that.value));
        break;

      case 712: // change_type_arg
        value.copy< SymbolType > (YY_MOVE (that.value));
        break;

      case 716: // expression
      case 719: // expression_or_empty
      case 743: // equation
      case 746: // hand_side
        value.copy< expr_t > (YY_MOVE (that.value));
        break;

      case 1003: // calibration_range
        value.copy< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case 702: // named_var_elem
      case 847: // subsamples_eq_opt
      case 1468: // integer_range_w_inf
        value.copy< pair<string,string> > (YY_MOVE (that.value));
        break;

      case 88: // FLOAT_NUMBER
      case 89: // DATES
      case 137: // INT_NUMBER
      case 234: // NAME
      case 296: // QUOTED_STRING
      case 349: // TEX_NAME
      case 472: // ALPHA
      case 473: // BETA
      case 474: // ABAND
      case 475: // NINV
      case 476: // CMS
      case 477: // NCMS
      case 478: // CNUM
      case 479: // GAMMA
      case 480: // INV_GAMMA
      case 481: // INV_GAMMA1
      case 482: // INV_GAMMA2
      case 483: // NORMAL
      case 484: // UNIFORM
      case 485: // EPS
      case 486: // PDF
      case 487: // FIG
      case 488: // DR
      case 489: // NONE
      case 490: // PRIOR
      case 491: // PRIOR_VARIANCE
      case 492: // HESSIAN
      case 493: // IDENTITY_MATRIX
      case 494: // DIRICHLET
      case 495: // DIAGONAL
      case 496: // OPTIMAL
      case 817: // signed_integer
      case 818: // non_negative_number
      case 819: // signed_number
      case 820: // signed_inf
      case 821: // signed_number_w_inf
      case 839: // date_str
      case 840: // date_expr
      case 873: // list_sub_sampling_option
      case 874: // sub_sampling_options
      case 901: // filename
      case 902: // namespace_qualified_symbol
      case 903: // namespace_qualified_filename
      case 1466: // range
      case 1467: // integer_range
      case 1469: // signed_integer_range
      case 1476: // vec_value_1
      case 1477: // vec_value
      case 1478: // vec_value_list
      case 1479: // vec_of_vec_value
      case 1480: // vec_value_1_w_inf
      case 1481: // vec_value_w_inf
      case 1482: // symbol
      case 1483: // number
        value.copy< string > (YY_MOVE (that.value));
        break;

      case 862: // prior_eq_opt
      case 867: // options_eq_opt
        value.copy< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case 1470: // vec_int_number
      case 1471: // vec_int_elem
      case 1472: // vec_int_1
      case 1473: // vec_int
        value.copy< vector<int> > (YY_MOVE (that.value));
        break;

      case 703: // named_var_1
      case 704: // named_var
        value.copy< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case 643: // SYMBOL_VEC
      case 713: // change_type_var_list
      case 1474: // vec_str_1
      case 1475: // vec_str
        value.copy< vector<string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }



  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return Base::type_get () == empty_symbol;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->type_get ())
    {
      case 837: // prior_distribution
      case 838: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (s.value));
        break;

      case 712: // change_type_arg
        value.move< SymbolType > (YY_MOVE (s.value));
        break;

      case 716: // expression
      case 719: // expression_or_empty
      case 743: // equation
      case 746: // hand_side
        value.move< expr_t > (YY_MOVE (s.value));
        break;

      case 1003: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (s.value));
        break;

      case 702: // named_var_elem
      case 847: // subsamples_eq_opt
      case 1468: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (s.value));
        break;

      case 88: // FLOAT_NUMBER
      case 89: // DATES
      case 137: // INT_NUMBER
      case 234: // NAME
      case 296: // QUOTED_STRING
      case 349: // TEX_NAME
      case 472: // ALPHA
      case 473: // BETA
      case 474: // ABAND
      case 475: // NINV
      case 476: // CMS
      case 477: // NCMS
      case 478: // CNUM
      case 479: // GAMMA
      case 480: // INV_GAMMA
      case 481: // INV_GAMMA1
      case 482: // INV_GAMMA2
      case 483: // NORMAL
      case 484: // UNIFORM
      case 485: // EPS
      case 486: // PDF
      case 487: // FIG
      case 488: // DR
      case 489: // NONE
      case 490: // PRIOR
      case 491: // PRIOR_VARIANCE
      case 492: // HESSIAN
      case 493: // IDENTITY_MATRIX
      case 494: // DIRICHLET
      case 495: // DIAGONAL
      case 496: // OPTIMAL
      case 817: // signed_integer
      case 818: // non_negative_number
      case 819: // signed_number
      case 820: // signed_inf
      case 821: // signed_number_w_inf
      case 839: // date_str
      case 840: // date_expr
      case 873: // list_sub_sampling_option
      case 874: // sub_sampling_options
      case 901: // filename
      case 902: // namespace_qualified_symbol
      case 903: // namespace_qualified_filename
      case 1466: // range
      case 1467: // integer_range
      case 1469: // signed_integer_range
      case 1476: // vec_value_1
      case 1477: // vec_value
      case 1478: // vec_value_list
      case 1479: // vec_of_vec_value
      case 1480: // vec_value_1_w_inf
      case 1481: // vec_value_w_inf
      case 1482: // symbol
      case 1483: // number
        value.move< string > (YY_MOVE (s.value));
        break;

      case 862: // prior_eq_opt
      case 867: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (s.value));
        break;

      case 1470: // vec_int_number
      case 1471: // vec_int_elem
      case 1472: // vec_int_1
      case 1473: // vec_int
        value.move< vector<int> > (YY_MOVE (s.value));
        break;

      case 703: // named_var_1
      case 704: // named_var
        value.move< vector<pair<string,string>> > (YY_MOVE (s.value));
        break;

      case 643: // SYMBOL_VEC
      case 713: // change_type_var_list
      case 1474: // vec_str_1
      case 1475: // vec_str
        value.move< vector<string> > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_type.
  parser::by_type::by_type ()
    : type (empty_symbol)
  {}

#if 201103L <= YY_CPLUSPLUS
  parser::by_type::by_type (by_type&& that)
    : type (that.type)
  {
    that.clear ();
  }
#endif

  parser::by_type::by_type (const by_type& that)
    : type (that.type)
  {}

  parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  void
  parser::by_type::clear ()
  {
    type = empty_symbol;
  }

  void
  parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.clear ();
  }

  int
  parser::by_type::type_get () const YY_NOEXCEPT
  {
    return type;
  }


  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_number_type
  parser::by_state::type_get () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.type_get ())
    {
      case 837: // prior_distribution
      case 838: // prior_pdf
        value.YY_MOVE_OR_COPY< PriorDistributions > (YY_MOVE (that.value));
        break;

      case 712: // change_type_arg
        value.YY_MOVE_OR_COPY< SymbolType > (YY_MOVE (that.value));
        break;

      case 716: // expression
      case 719: // expression_or_empty
      case 743: // equation
      case 746: // hand_side
        value.YY_MOVE_OR_COPY< expr_t > (YY_MOVE (that.value));
        break;

      case 1003: // calibration_range
        value.YY_MOVE_OR_COPY< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case 702: // named_var_elem
      case 847: // subsamples_eq_opt
      case 1468: // integer_range_w_inf
        value.YY_MOVE_OR_COPY< pair<string,string> > (YY_MOVE (that.value));
        break;

      case 88: // FLOAT_NUMBER
      case 89: // DATES
      case 137: // INT_NUMBER
      case 234: // NAME
      case 296: // QUOTED_STRING
      case 349: // TEX_NAME
      case 472: // ALPHA
      case 473: // BETA
      case 474: // ABAND
      case 475: // NINV
      case 476: // CMS
      case 477: // NCMS
      case 478: // CNUM
      case 479: // GAMMA
      case 480: // INV_GAMMA
      case 481: // INV_GAMMA1
      case 482: // INV_GAMMA2
      case 483: // NORMAL
      case 484: // UNIFORM
      case 485: // EPS
      case 486: // PDF
      case 487: // FIG
      case 488: // DR
      case 489: // NONE
      case 490: // PRIOR
      case 491: // PRIOR_VARIANCE
      case 492: // HESSIAN
      case 493: // IDENTITY_MATRIX
      case 494: // DIRICHLET
      case 495: // DIAGONAL
      case 496: // OPTIMAL
      case 817: // signed_integer
      case 818: // non_negative_number
      case 819: // signed_number
      case 820: // signed_inf
      case 821: // signed_number_w_inf
      case 839: // date_str
      case 840: // date_expr
      case 873: // list_sub_sampling_option
      case 874: // sub_sampling_options
      case 901: // filename
      case 902: // namespace_qualified_symbol
      case 903: // namespace_qualified_filename
      case 1466: // range
      case 1467: // integer_range
      case 1469: // signed_integer_range
      case 1476: // vec_value_1
      case 1477: // vec_value
      case 1478: // vec_value_list
      case 1479: // vec_of_vec_value
      case 1480: // vec_value_1_w_inf
      case 1481: // vec_value_w_inf
      case 1482: // symbol
      case 1483: // number
        value.YY_MOVE_OR_COPY< string > (YY_MOVE (that.value));
        break;

      case 862: // prior_eq_opt
      case 867: // options_eq_opt
        value.YY_MOVE_OR_COPY< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case 1470: // vec_int_number
      case 1471: // vec_int_elem
      case 1472: // vec_int_1
      case 1473: // vec_int
        value.YY_MOVE_OR_COPY< vector<int> > (YY_MOVE (that.value));
        break;

      case 703: // named_var_1
      case 704: // named_var
        value.YY_MOVE_OR_COPY< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case 643: // SYMBOL_VEC
      case 713: // change_type_var_list
      case 1474: // vec_str_1
      case 1475: // vec_str
        value.YY_MOVE_OR_COPY< vector<string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.type_get ())
    {
      case 837: // prior_distribution
      case 838: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (that.value));
        break;

      case 712: // change_type_arg
        value.move< SymbolType > (YY_MOVE (that.value));
        break;

      case 716: // expression
      case 719: // expression_or_empty
      case 743: // equation
      case 746: // hand_side
        value.move< expr_t > (YY_MOVE (that.value));
        break;

      case 1003: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case 702: // named_var_elem
      case 847: // subsamples_eq_opt
      case 1468: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (that.value));
        break;

      case 88: // FLOAT_NUMBER
      case 89: // DATES
      case 137: // INT_NUMBER
      case 234: // NAME
      case 296: // QUOTED_STRING
      case 349: // TEX_NAME
      case 472: // ALPHA
      case 473: // BETA
      case 474: // ABAND
      case 475: // NINV
      case 476: // CMS
      case 477: // NCMS
      case 478: // CNUM
      case 479: // GAMMA
      case 480: // INV_GAMMA
      case 481: // INV_GAMMA1
      case 482: // INV_GAMMA2
      case 483: // NORMAL
      case 484: // UNIFORM
      case 485: // EPS
      case 486: // PDF
      case 487: // FIG
      case 488: // DR
      case 489: // NONE
      case 490: // PRIOR
      case 491: // PRIOR_VARIANCE
      case 492: // HESSIAN
      case 493: // IDENTITY_MATRIX
      case 494: // DIRICHLET
      case 495: // DIAGONAL
      case 496: // OPTIMAL
      case 817: // signed_integer
      case 818: // non_negative_number
      case 819: // signed_number
      case 820: // signed_inf
      case 821: // signed_number_w_inf
      case 839: // date_str
      case 840: // date_expr
      case 873: // list_sub_sampling_option
      case 874: // sub_sampling_options
      case 901: // filename
      case 902: // namespace_qualified_symbol
      case 903: // namespace_qualified_filename
      case 1466: // range
      case 1467: // integer_range
      case 1469: // signed_integer_range
      case 1476: // vec_value_1
      case 1477: // vec_value
      case 1478: // vec_value_list
      case 1479: // vec_of_vec_value
      case 1480: // vec_value_1_w_inf
      case 1481: // vec_value_w_inf
      case 1482: // symbol
      case 1483: // number
        value.move< string > (YY_MOVE (that.value));
        break;

      case 862: // prior_eq_opt
      case 867: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case 1470: // vec_int_number
      case 1471: // vec_int_elem
      case 1472: // vec_int_1
      case 1473: // vec_int
        value.move< vector<int> > (YY_MOVE (that.value));
        break;

      case 703: // named_var_1
      case 704: // named_var
        value.move< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case 643: // SYMBOL_VEC
      case 713: // change_type_var_list
      case 1474: // vec_str_1
      case 1475: // vec_str
        value.move< vector<string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.type_get ())
    {
      case 837: // prior_distribution
      case 838: // prior_pdf
        value.move< PriorDistributions > (that.value);
        break;

      case 712: // change_type_arg
        value.move< SymbolType > (that.value);
        break;

      case 716: // expression
      case 719: // expression_or_empty
      case 743: // equation
      case 746: // hand_side
        value.move< expr_t > (that.value);
        break;

      case 1003: // calibration_range
        value.move< pair<expr_t,expr_t> > (that.value);
        break;

      case 702: // named_var_elem
      case 847: // subsamples_eq_opt
      case 1468: // integer_range_w_inf
        value.move< pair<string,string> > (that.value);
        break;

      case 88: // FLOAT_NUMBER
      case 89: // DATES
      case 137: // INT_NUMBER
      case 234: // NAME
      case 296: // QUOTED_STRING
      case 349: // TEX_NAME
      case 472: // ALPHA
      case 473: // BETA
      case 474: // ABAND
      case 475: // NINV
      case 476: // CMS
      case 477: // NCMS
      case 478: // CNUM
      case 479: // GAMMA
      case 480: // INV_GAMMA
      case 481: // INV_GAMMA1
      case 482: // INV_GAMMA2
      case 483: // NORMAL
      case 484: // UNIFORM
      case 485: // EPS
      case 486: // PDF
      case 487: // FIG
      case 488: // DR
      case 489: // NONE
      case 490: // PRIOR
      case 491: // PRIOR_VARIANCE
      case 492: // HESSIAN
      case 493: // IDENTITY_MATRIX
      case 494: // DIRICHLET
      case 495: // DIAGONAL
      case 496: // OPTIMAL
      case 817: // signed_integer
      case 818: // non_negative_number
      case 819: // signed_number
      case 820: // signed_inf
      case 821: // signed_number_w_inf
      case 839: // date_str
      case 840: // date_expr
      case 873: // list_sub_sampling_option
      case 874: // sub_sampling_options
      case 901: // filename
      case 902: // namespace_qualified_symbol
      case 903: // namespace_qualified_filename
      case 1466: // range
      case 1467: // integer_range
      case 1469: // signed_integer_range
      case 1476: // vec_value_1
      case 1477: // vec_value
      case 1478: // vec_value_list
      case 1479: // vec_of_vec_value
      case 1480: // vec_value_1_w_inf
      case 1481: // vec_value_w_inf
      case 1482: // symbol
      case 1483: // number
        value.move< string > (that.value);
        break;

      case 862: // prior_eq_opt
      case 867: // options_eq_opt
        value.move< tuple<string,string,string,string> > (that.value);
        break;

      case 1470: // vec_int_number
      case 1471: // vec_int_elem
      case 1472: // vec_int_1
      case 1473: // vec_int
        value.move< vector<int> > (that.value);
        break;

      case 703: // named_var_1
      case 704: // named_var
        value.move< vector<pair<string,string>> > (that.value);
        break;

      case 643: // SYMBOL_VEC
      case 713: // change_type_var_list
      case 1474: // vec_str_1
      case 1475: // vec_str
        value.move< vector<string> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
#if defined __GNUC__ && ! defined __clang__ && ! defined __ICC && __GNUC__ * 100 + __GNUC_MINOR__ <= 408
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
#endif
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 43 "DynareBison.yy" // lalr1.cc:788
{
  // Initialize the locations' filenames to the filename maintained by the lexer
  yyla.location.begin.filename = yyla.location.end.filename = &(driver.lexer->filename);
}

#line 1203 "DynareBison.cc" // lalr1.cc:788

    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << '\n';

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case 837: // prior_distribution
      case 838: // prior_pdf
        yylhs.value.emplace< PriorDistributions > ();
        break;

      case 712: // change_type_arg
        yylhs.value.emplace< SymbolType > ();
        break;

      case 716: // expression
      case 719: // expression_or_empty
      case 743: // equation
      case 746: // hand_side
        yylhs.value.emplace< expr_t > ();
        break;

      case 1003: // calibration_range
        yylhs.value.emplace< pair<expr_t,expr_t> > ();
        break;

      case 702: // named_var_elem
      case 847: // subsamples_eq_opt
      case 1468: // integer_range_w_inf
        yylhs.value.emplace< pair<string,string> > ();
        break;

      case 88: // FLOAT_NUMBER
      case 89: // DATES
      case 137: // INT_NUMBER
      case 234: // NAME
      case 296: // QUOTED_STRING
      case 349: // TEX_NAME
      case 472: // ALPHA
      case 473: // BETA
      case 474: // ABAND
      case 475: // NINV
      case 476: // CMS
      case 477: // NCMS
      case 478: // CNUM
      case 479: // GAMMA
      case 480: // INV_GAMMA
      case 481: // INV_GAMMA1
      case 482: // INV_GAMMA2
      case 483: // NORMAL
      case 484: // UNIFORM
      case 485: // EPS
      case 486: // PDF
      case 487: // FIG
      case 488: // DR
      case 489: // NONE
      case 490: // PRIOR
      case 491: // PRIOR_VARIANCE
      case 492: // HESSIAN
      case 493: // IDENTITY_MATRIX
      case 494: // DIRICHLET
      case 495: // DIAGONAL
      case 496: // OPTIMAL
      case 817: // signed_integer
      case 818: // non_negative_number
      case 819: // signed_number
      case 820: // signed_inf
      case 821: // signed_number_w_inf
      case 839: // date_str
      case 840: // date_expr
      case 873: // list_sub_sampling_option
      case 874: // sub_sampling_options
      case 901: // filename
      case 902: // namespace_qualified_symbol
      case 903: // namespace_qualified_filename
      case 1466: // range
      case 1467: // integer_range
      case 1469: // signed_integer_range
      case 1476: // vec_value_1
      case 1477: // vec_value
      case 1478: // vec_value_list
      case 1479: // vec_of_vec_value
      case 1480: // vec_value_1_w_inf
      case 1481: // vec_value_w_inf
      case 1482: // symbol
      case 1483: // number
        yylhs.value.emplace< string > ();
        break;

      case 862: // prior_eq_opt
      case 867: // options_eq_opt
        yylhs.value.emplace< tuple<string,string,string,string> > ();
        break;

      case 1470: // vec_int_number
      case 1471: // vec_int_elem
      case 1472: // vec_int_1
      case 1473: // vec_int
        yylhs.value.emplace< vector<int> > ();
        break;

      case 703: // named_var_1
      case 704: // named_var
        yylhs.value.emplace< vector<pair<string,string>> > ();
        break;

      case 643: // SYMBOL_VEC
      case 713: // change_type_var_list
      case 1474: // vec_str_1
      case 1475: // vec_str
        yylhs.value.emplace< vector<string> > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 117:
#line 318 "DynareBison.yy" // lalr1.cc:919
    { driver.dsample(yystack_[1].value.as < string > ()); }
#line 1433 "DynareBison.cc" // lalr1.cc:919
    break;

  case 118:
#line 320 "DynareBison.yy" // lalr1.cc:919
    { driver.dsample(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 1439 "DynareBison.cc" // lalr1.cc:919
    break;

  case 119:
#line 323 "DynareBison.yy" // lalr1.cc:919
    { driver.rplot(); }
#line 1445 "DynareBison.cc" // lalr1.cc:919
    break;

  case 120:
#line 325 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_trend(); }
#line 1451 "DynareBison.cc" // lalr1.cc:919
    break;

  case 121:
#line 326 "DynareBison.yy" // lalr1.cc:919
    { driver.end_trend_var(yystack_[3].value.as < expr_t > ()); }
#line 1457 "DynareBison.cc" // lalr1.cc:919
    break;

  case 122:
#line 330 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[0].value.as < string > ()); }
#line 1463 "DynareBison.cc" // lalr1.cc:919
    break;

  case 123:
#line 332 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[0].value.as < string > ()); }
#line 1469 "DynareBison.cc" // lalr1.cc:919
    break;

  case 124:
#line 334 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[0].value.as < string > ()); }
#line 1475 "DynareBison.cc" // lalr1.cc:919
    break;

  case 125:
#line 336 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1481 "DynareBison.cc" // lalr1.cc:919
    break;

  case 126:
#line 338 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1487 "DynareBison.cc" // lalr1.cc:919
    break;

  case 127:
#line 340 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(false, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1493 "DynareBison.cc" // lalr1.cc:919
    break;

  case 128:
#line 343 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_trend(); }
#line 1499 "DynareBison.cc" // lalr1.cc:919
    break;

  case 129:
#line 344 "DynareBison.yy" // lalr1.cc:919
    { driver.end_trend_var(yystack_[3].value.as < expr_t > ()); }
#line 1505 "DynareBison.cc" // lalr1.cc:919
    break;

  case 130:
#line 348 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[0].value.as < string > ()); }
#line 1511 "DynareBison.cc" // lalr1.cc:919
    break;

  case 131:
#line 350 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[0].value.as < string > ()); }
#line 1517 "DynareBison.cc" // lalr1.cc:919
    break;

  case 132:
#line 352 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[0].value.as < string > ()); }
#line 1523 "DynareBison.cc" // lalr1.cc:919
    break;

  case 133:
#line 354 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1529 "DynareBison.cc" // lalr1.cc:919
    break;

  case 134:
#line 356 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1535 "DynareBison.cc" // lalr1.cc:919
    break;

  case 135:
#line 358 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_trend_var(true, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1541 "DynareBison.cc" // lalr1.cc:919
    break;

  case 137:
#line 362 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_trend(); }
#line 1547 "DynareBison.cc" // lalr1.cc:919
    break;

  case 138:
#line 363 "DynareBison.yy" // lalr1.cc:919
    { driver.end_nonstationary_var(false, yystack_[3].value.as < expr_t > ()); }
#line 1553 "DynareBison.cc" // lalr1.cc:919
    break;

  case 139:
#line 364 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_trend(); }
#line 1559 "DynareBison.cc" // lalr1.cc:919
    break;

  case 140:
#line 365 "DynareBison.yy" // lalr1.cc:919
    { driver.end_nonstationary_var(true, yystack_[3].value.as < expr_t > ()); }
#line 1565 "DynareBison.cc" // lalr1.cc:919
    break;

  case 141:
#line 368 "DynareBison.yy" // lalr1.cc:919
    { driver.var_model(); }
#line 1571 "DynareBison.cc" // lalr1.cc:919
    break;

  case 142:
#line 369 "DynareBison.yy" // lalr1.cc:919
    { driver.var_model(); }
#line 1577 "DynareBison.cc" // lalr1.cc:919
    break;

  case 143:
#line 373 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_var_endogenous(yystack_[0].value.as < string > ()); }
#line 1583 "DynareBison.cc" // lalr1.cc:919
    break;

  case 144:
#line 375 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_var_endogenous(yystack_[0].value.as < string > ()); }
#line 1589 "DynareBison.cc" // lalr1.cc:919
    break;

  case 145:
#line 377 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_var_endogenous(yystack_[0].value.as < string > ()); }
#line 1595 "DynareBison.cc" // lalr1.cc:919
    break;

  case 151:
#line 389 "DynareBison.yy" // lalr1.cc:919
    { driver.trend_component_model(); }
#line 1601 "DynareBison.cc" // lalr1.cc:919
    break;

  case 157:
#line 401 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_pac_model(); }
#line 1607 "DynareBison.cc" // lalr1.cc:919
    break;

  case 158:
#line 401 "DynareBison.yy" // lalr1.cc:919
    { driver.pac_model(); }
#line 1613 "DynareBison.cc" // lalr1.cc:919
    break;

  case 166:
#line 415 "DynareBison.yy" // lalr1.cc:919
    { driver.var_expectation_model(); }
#line 1619 "DynareBison.cc" // lalr1.cc:919
    break;

  case 169:
#line 424 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("variable", yystack_[0].value.as < string > ()); }
#line 1625 "DynareBison.cc" // lalr1.cc:919
    break;

  case 170:
#line 425 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_model(); }
#line 1631 "DynareBison.cc" // lalr1.cc:919
    break;

  case 171:
#line 426 "DynareBison.yy" // lalr1.cc:919
    {
                                 driver.var_expectation_model_expression = yystack_[0].value.as < expr_t > ();
                                 driver.reset_data_tree();
                               }
#line 1640 "DynareBison.cc" // lalr1.cc:919
    break;

  case 172:
#line 431 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("auxiliary_model_name", yystack_[0].value.as < string > ()); }
#line 1646 "DynareBison.cc" // lalr1.cc:919
    break;

  case 173:
#line 433 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("horizon", yystack_[0].value.as < string > ()); }
#line 1652 "DynareBison.cc" // lalr1.cc:919
    break;

  case 174:
#line 435 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("horizon", "[ " + yystack_[0].value.as < pair<string,string> > ().first + ' ' + yystack_[0].value.as < pair<string,string> > ().second + " ]"); }
#line 1658 "DynareBison.cc" // lalr1.cc:919
    break;

  case 175:
#line 437 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("model_name", yystack_[0].value.as < string > ()); }
#line 1664 "DynareBison.cc" // lalr1.cc:919
    break;

  case 176:
#line 439 "DynareBison.yy" // lalr1.cc:919
    { driver.var_expectation_model_discount = yystack_[0].value.as < expr_t > (); }
#line 1670 "DynareBison.cc" // lalr1.cc:919
    break;

  case 177:
#line 442 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_VAR_restrictions(); }
#line 1676 "DynareBison.cc" // lalr1.cc:919
    break;

  case 178:
#line 443 "DynareBison.yy" // lalr1.cc:919
    { driver.end_VAR_restrictions(yystack_[6].value.as < string > ()); }
#line 1682 "DynareBison.cc" // lalr1.cc:919
    break;

  case 181:
#line 451 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_exclusion_restriction(yystack_[2].value.as < string > ()); }
#line 1688 "DynareBison.cc" // lalr1.cc:919
    break;

  case 182:
#line 453 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation_final(yystack_[3].value.as < string > ()); }
#line 1694 "DynareBison.cc" // lalr1.cc:919
    break;

  case 183:
#line 455 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation_final(""); }
#line 1700 "DynareBison.cc" // lalr1.cc:919
    break;

  case 184:
#line 457 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_covariance_number_restriction(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 1706 "DynareBison.cc" // lalr1.cc:919
    break;

  case 185:
#line 459 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_covariance_pair_restriction(yystack_[10].value.as < string > (), yystack_[8].value.as < string > (), yystack_[4].value.as < string > (), yystack_[2].value.as < string > ()); }
#line 1712 "DynareBison.cc" // lalr1.cc:919
    break;

  case 186:
#line 463 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ()); }
#line 1718 "DynareBison.cc" // lalr1.cc:919
    break;

  case 187:
#line 465 "DynareBison.yy" // lalr1.cc:919
    {
                                  driver.multiply_arg2_by_neg_one();
                                  driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ());
                                }
#line 1727 "DynareBison.cc" // lalr1.cc:919
    break;

  case 188:
#line 470 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ()); }
#line 1733 "DynareBison.cc" // lalr1.cc:919
    break;

  case 189:
#line 474 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_eq_or_crosseq(yystack_[0].value.as < expr_t > ()); }
#line 1739 "DynareBison.cc" // lalr1.cc:919
    break;

  case 190:
#line 476 "DynareBison.yy" // lalr1.cc:919
    {
                                       expr_t one = driver.add_non_negative_constant("1");
                                       driver.add_VAR_restriction_eq_or_crosseq(driver.add_divide(one, yystack_[0].value.as < expr_t > ()));
                                     }
#line 1748 "DynareBison.cc" // lalr1.cc:919
    break;

  case 191:
#line 483 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_coeff(yystack_[3].value.as < string > (), "", yystack_[1].value.as < string > ()); }
#line 1754 "DynareBison.cc" // lalr1.cc:919
    break;

  case 192:
#line 488 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ()); }
#line 1760 "DynareBison.cc" // lalr1.cc:919
    break;

  case 193:
#line 490 "DynareBison.yy" // lalr1.cc:919
    {
                                       driver.multiply_arg2_by_neg_one();
                                       driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ());
                                     }
#line 1769 "DynareBison.cc" // lalr1.cc:919
    break;

  case 194:
#line 495 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_equation_or_crossequation(yystack_[0].value.as < string > ()); }
#line 1775 "DynareBison.cc" // lalr1.cc:919
    break;

  case 195:
#line 499 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_eq_or_crosseq(yystack_[0].value.as < expr_t > ()); }
#line 1781 "DynareBison.cc" // lalr1.cc:919
    break;

  case 196:
#line 501 "DynareBison.yy" // lalr1.cc:919
    {
                                            expr_t one = driver.add_non_negative_constant("1");
                                            driver.add_VAR_restriction_eq_or_crosseq(driver.add_divide(one, yystack_[0].value.as < expr_t > ()));
                                          }
#line 1790 "DynareBison.cc" // lalr1.cc:919
    break;

  case 197:
#line 508 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_coeff(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 1796 "DynareBison.cc" // lalr1.cc:919
    break;

  case 200:
#line 516 "DynareBison.yy" // lalr1.cc:919
    { driver.add_VAR_restriction_exclusion_equation(yystack_[3].value.as < string > ()); }
#line 1802 "DynareBison.cc" // lalr1.cc:919
    break;

  case 201:
#line 520 "DynareBison.yy" // lalr1.cc:919
    { driver.run_var_estimation(); }
#line 1808 "DynareBison.cc" // lalr1.cc:919
    break;

  case 206:
#line 532 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[0].value.as < string > ()); }
#line 1814 "DynareBison.cc" // lalr1.cc:919
    break;

  case 207:
#line 534 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[0].value.as < string > ()); }
#line 1820 "DynareBison.cc" // lalr1.cc:919
    break;

  case 208:
#line 536 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[0].value.as < string > ()); }
#line 1826 "DynareBison.cc" // lalr1.cc:919
    break;

  case 209:
#line 538 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1832 "DynareBison.cc" // lalr1.cc:919
    break;

  case 210:
#line 540 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1838 "DynareBison.cc" // lalr1.cc:919
    break;

  case 211:
#line 542 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1844 "DynareBison.cc" // lalr1.cc:919
    break;

  case 212:
#line 544 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1850 "DynareBison.cc" // lalr1.cc:919
    break;

  case 213:
#line 546 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1856 "DynareBison.cc" // lalr1.cc:919
    break;

  case 214:
#line 548 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1862 "DynareBison.cc" // lalr1.cc:919
    break;

  case 215:
#line 550 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1868 "DynareBison.cc" // lalr1.cc:919
    break;

  case 216:
#line 552 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1874 "DynareBison.cc" // lalr1.cc:919
    break;

  case 217:
#line 554 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_nonstationary_var(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1880 "DynareBison.cc" // lalr1.cc:919
    break;

  case 223:
#line 570 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), yystack_[0].value.as < string > () }; }
#line 1886 "DynareBison.cc" // lalr1.cc:919
    break;

  case 224:
#line 573 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<pair<string,string>> > () = vector<pair<string, string>>{yystack_[0].value.as < pair<string,string> > ()}; }
#line 1892 "DynareBison.cc" // lalr1.cc:919
    break;

  case 225:
#line 575 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<pair<string,string>> > () = vector<pair<string, string>>{yystack_[0].value.as < pair<string,string> > ()}; }
#line 1898 "DynareBison.cc" // lalr1.cc:919
    break;

  case 226:
#line 577 "DynareBison.yy" // lalr1.cc:919
    {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 1907 "DynareBison.cc" // lalr1.cc:919
    break;

  case 227:
#line 582 "DynareBison.yy" // lalr1.cc:919
    {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 1916 "DynareBison.cc" // lalr1.cc:919
    break;

  case 228:
#line 588 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > (); }
#line 1922 "DynareBison.cc" // lalr1.cc:919
    break;

  case 229:
#line 589 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > (); }
#line 1928 "DynareBison.cc" // lalr1.cc:919
    break;

  case 230:
#line 593 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[0].value.as < string > ()); }
#line 1934 "DynareBison.cc" // lalr1.cc:919
    break;

  case 231:
#line 595 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[0].value.as < string > ()); }
#line 1940 "DynareBison.cc" // lalr1.cc:919
    break;

  case 232:
#line 597 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[0].value.as < string > ()); }
#line 1946 "DynareBison.cc" // lalr1.cc:919
    break;

  case 233:
#line 599 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1952 "DynareBison.cc" // lalr1.cc:919
    break;

  case 234:
#line 601 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1958 "DynareBison.cc" // lalr1.cc:919
    break;

  case 235:
#line 603 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1964 "DynareBison.cc" // lalr1.cc:919
    break;

  case 236:
#line 605 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1970 "DynareBison.cc" // lalr1.cc:919
    break;

  case 237:
#line 607 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1976 "DynareBison.cc" // lalr1.cc:919
    break;

  case 238:
#line 609 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1982 "DynareBison.cc" // lalr1.cc:919
    break;

  case 239:
#line 611 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1988 "DynareBison.cc" // lalr1.cc:919
    break;

  case 240:
#line 613 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1994 "DynareBison.cc" // lalr1.cc:919
    break;

  case 241:
#line 615 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_endogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2000 "DynareBison.cc" // lalr1.cc:919
    break;

  case 242:
#line 619 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[0].value.as < string > ()); }
#line 2006 "DynareBison.cc" // lalr1.cc:919
    break;

  case 243:
#line 621 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[0].value.as < string > ()); }
#line 2012 "DynareBison.cc" // lalr1.cc:919
    break;

  case 244:
#line 623 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[0].value.as < string > ()); }
#line 2018 "DynareBison.cc" // lalr1.cc:919
    break;

  case 245:
#line 625 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2024 "DynareBison.cc" // lalr1.cc:919
    break;

  case 246:
#line 627 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2030 "DynareBison.cc" // lalr1.cc:919
    break;

  case 247:
#line 629 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2036 "DynareBison.cc" // lalr1.cc:919
    break;

  case 248:
#line 631 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2042 "DynareBison.cc" // lalr1.cc:919
    break;

  case 249:
#line 633 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2048 "DynareBison.cc" // lalr1.cc:919
    break;

  case 250:
#line 635 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2054 "DynareBison.cc" // lalr1.cc:919
    break;

  case 251:
#line 637 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2060 "DynareBison.cc" // lalr1.cc:919
    break;

  case 252:
#line 639 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2066 "DynareBison.cc" // lalr1.cc:919
    break;

  case 253:
#line 641 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2072 "DynareBison.cc" // lalr1.cc:919
    break;

  case 254:
#line 645 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[0].value.as < string > ()); }
#line 2078 "DynareBison.cc" // lalr1.cc:919
    break;

  case 255:
#line 647 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[0].value.as < string > ()); }
#line 2084 "DynareBison.cc" // lalr1.cc:919
    break;

  case 256:
#line 649 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[0].value.as < string > ()); }
#line 2090 "DynareBison.cc" // lalr1.cc:919
    break;

  case 257:
#line 651 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2096 "DynareBison.cc" // lalr1.cc:919
    break;

  case 258:
#line 653 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2102 "DynareBison.cc" // lalr1.cc:919
    break;

  case 259:
#line 655 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2108 "DynareBison.cc" // lalr1.cc:919
    break;

  case 260:
#line 657 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2114 "DynareBison.cc" // lalr1.cc:919
    break;

  case 261:
#line 659 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2120 "DynareBison.cc" // lalr1.cc:919
    break;

  case 262:
#line 661 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2126 "DynareBison.cc" // lalr1.cc:919
    break;

  case 263:
#line 663 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2132 "DynareBison.cc" // lalr1.cc:919
    break;

  case 264:
#line 665 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2138 "DynareBison.cc" // lalr1.cc:919
    break;

  case 265:
#line 667 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_exogenous_det(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2144 "DynareBison.cc" // lalr1.cc:919
    break;

  case 266:
#line 671 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[0].value.as < string > ()); }
#line 2150 "DynareBison.cc" // lalr1.cc:919
    break;

  case 267:
#line 673 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[0].value.as < string > ()); }
#line 2156 "DynareBison.cc" // lalr1.cc:919
    break;

  case 268:
#line 675 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[0].value.as < string > ()); }
#line 2162 "DynareBison.cc" // lalr1.cc:919
    break;

  case 269:
#line 677 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2168 "DynareBison.cc" // lalr1.cc:919
    break;

  case 270:
#line 679 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2174 "DynareBison.cc" // lalr1.cc:919
    break;

  case 271:
#line 681 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2180 "DynareBison.cc" // lalr1.cc:919
    break;

  case 272:
#line 683 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2186 "DynareBison.cc" // lalr1.cc:919
    break;

  case 273:
#line 685 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2192 "DynareBison.cc" // lalr1.cc:919
    break;

  case 274:
#line 687 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2198 "DynareBison.cc" // lalr1.cc:919
    break;

  case 275:
#line 689 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2204 "DynareBison.cc" // lalr1.cc:919
    break;

  case 276:
#line 691 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2210 "DynareBison.cc" // lalr1.cc:919
    break;

  case 277:
#line 693 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_parameter(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2216 "DynareBison.cc" // lalr1.cc:919
    break;

  case 278:
#line 697 "DynareBison.yy" // lalr1.cc:919
    { driver.add_predetermined_variable(yystack_[0].value.as < string > ()); }
#line 2222 "DynareBison.cc" // lalr1.cc:919
    break;

  case 279:
#line 699 "DynareBison.yy" // lalr1.cc:919
    { driver.add_predetermined_variable(yystack_[0].value.as < string > ()); }
#line 2228 "DynareBison.cc" // lalr1.cc:919
    break;

  case 280:
#line 701 "DynareBison.yy" // lalr1.cc:919
    { driver.add_predetermined_variable(yystack_[0].value.as < string > ()); }
#line 2234 "DynareBison.cc" // lalr1.cc:919
    break;

  case 281:
#line 705 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[0].value.as < string > ()); }
#line 2240 "DynareBison.cc" // lalr1.cc:919
    break;

  case 282:
#line 707 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[0].value.as < string > ()); }
#line 2246 "DynareBison.cc" // lalr1.cc:919
    break;

  case 283:
#line 709 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[0].value.as < string > ()); }
#line 2252 "DynareBison.cc" // lalr1.cc:919
    break;

  case 284:
#line 711 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2258 "DynareBison.cc" // lalr1.cc:919
    break;

  case 285:
#line 713 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2264 "DynareBison.cc" // lalr1.cc:919
    break;

  case 286:
#line 715 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_model_local_variable(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2270 "DynareBison.cc" // lalr1.cc:919
    break;

  case 287:
#line 719 "DynareBison.yy" // lalr1.cc:919
    { driver.change_type(yystack_[3].value.as < SymbolType > (), yystack_[1].value.as < vector<string> > ()); }
#line 2276 "DynareBison.cc" // lalr1.cc:919
    break;

  case 288:
#line 723 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < SymbolType > () = SymbolType::parameter; }
#line 2282 "DynareBison.cc" // lalr1.cc:919
    break;

  case 289:
#line 725 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < SymbolType > () = SymbolType::endogenous; }
#line 2288 "DynareBison.cc" // lalr1.cc:919
    break;

  case 290:
#line 727 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < SymbolType > () = SymbolType::exogenous; }
#line 2294 "DynareBison.cc" // lalr1.cc:919
    break;

  case 291:
#line 729 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < SymbolType > () = SymbolType::exogenousDet; }
#line 2300 "DynareBison.cc" // lalr1.cc:919
    break;

  case 292:
#line 733 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = vector<string>{yystack_[0].value.as < string > ()}; }
#line 2306 "DynareBison.cc" // lalr1.cc:919
    break;

  case 293:
#line 735 "DynareBison.yy" // lalr1.cc:919
    {
                         yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
                         yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                       }
#line 2315 "DynareBison.cc" // lalr1.cc:919
    break;

  case 294:
#line 740 "DynareBison.yy" // lalr1.cc:919
    {
                         yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
                         yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                       }
#line 2324 "DynareBison.cc" // lalr1.cc:919
    break;

  case 295:
#line 747 "DynareBison.yy" // lalr1.cc:919
    { driver.periods(yystack_[1].value.as < string > ()); }
#line 2330 "DynareBison.cc" // lalr1.cc:919
    break;

  case 296:
#line 749 "DynareBison.yy" // lalr1.cc:919
    { driver.periods(yystack_[1].value.as < string > ()); }
#line 2336 "DynareBison.cc" // lalr1.cc:919
    break;

  case 297:
#line 752 "DynareBison.yy" // lalr1.cc:919
    { driver.init_param(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2342 "DynareBison.cc" // lalr1.cc:919
    break;

  case 298:
#line 755 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > ();}
#line 2348 "DynareBison.cc" // lalr1.cc:919
    break;

  case 299:
#line 757 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_expression_variable(yystack_[0].value.as < string > ()); }
#line 2354 "DynareBison.cc" // lalr1.cc:919
    break;

  case 300:
#line 759 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 2360 "DynareBison.cc" // lalr1.cc:919
    break;

  case 301:
#line 761 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2366 "DynareBison.cc" // lalr1.cc:919
    break;

  case 302:
#line 763 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2372 "DynareBison.cc" // lalr1.cc:919
    break;

  case 303:
#line 765 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2378 "DynareBison.cc" // lalr1.cc:919
    break;

  case 304:
#line 767 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2384 "DynareBison.cc" // lalr1.cc:919
    break;

  case 305:
#line 769 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2390 "DynareBison.cc" // lalr1.cc:919
    break;

  case 306:
#line 771 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2396 "DynareBison.cc" // lalr1.cc:919
    break;

  case 307:
#line 773 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2402 "DynareBison.cc" // lalr1.cc:919
    break;

  case 308:
#line 775 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2408 "DynareBison.cc" // lalr1.cc:919
    break;

  case 309:
#line 777 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2414 "DynareBison.cc" // lalr1.cc:919
    break;

  case 310:
#line 779 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2420 "DynareBison.cc" // lalr1.cc:919
    break;

  case 311:
#line 781 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2426 "DynareBison.cc" // lalr1.cc:919
    break;

  case 312:
#line 783 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 2432 "DynareBison.cc" // lalr1.cc:919
    break;

  case 313:
#line 785 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2438 "DynareBison.cc" // lalr1.cc:919
    break;

  case 314:
#line 787 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 2444 "DynareBison.cc" // lalr1.cc:919
    break;

  case 315:
#line 789 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2450 "DynareBison.cc" // lalr1.cc:919
    break;

  case 316:
#line 791 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2456 "DynareBison.cc" // lalr1.cc:919
    break;

  case 317:
#line 793 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 2462 "DynareBison.cc" // lalr1.cc:919
    break;

  case 318:
#line 795 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 2468 "DynareBison.cc" // lalr1.cc:919
    break;

  case 319:
#line 797 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 2474 "DynareBison.cc" // lalr1.cc:919
    break;

  case 320:
#line 799 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 2480 "DynareBison.cc" // lalr1.cc:919
    break;

  case 321:
#line 801 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 2486 "DynareBison.cc" // lalr1.cc:919
    break;

  case 322:
#line 803 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 2492 "DynareBison.cc" // lalr1.cc:919
    break;

  case 323:
#line 805 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 2498 "DynareBison.cc" // lalr1.cc:919
    break;

  case 324:
#line 807 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 2504 "DynareBison.cc" // lalr1.cc:919
    break;

  case 325:
#line 809 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 2510 "DynareBison.cc" // lalr1.cc:919
    break;

  case 326:
#line 811 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 2516 "DynareBison.cc" // lalr1.cc:919
    break;

  case 327:
#line 813 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 2522 "DynareBison.cc" // lalr1.cc:919
    break;

  case 328:
#line 815 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2528 "DynareBison.cc" // lalr1.cc:919
    break;

  case 329:
#line 817 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2534 "DynareBison.cc" // lalr1.cc:919
    break;

  case 330:
#line 818 "DynareBison.yy" // lalr1.cc:919
    { driver.push_external_function_arg_vector_onto_stack(); }
#line 2540 "DynareBison.cc" // lalr1.cc:919
    break;

  case 331:
#line 819 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), false); }
#line 2546 "DynareBison.cc" // lalr1.cc:919
    break;

  case 332:
#line 821 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2552 "DynareBison.cc" // lalr1.cc:919
    break;

  case 333:
#line 823 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 2558 "DynareBison.cc" // lalr1.cc:919
    break;

  case 334:
#line 825 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2564 "DynareBison.cc" // lalr1.cc:919
    break;

  case 335:
#line 827 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 2570 "DynareBison.cc" // lalr1.cc:919
    break;

  case 336:
#line 829 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 2576 "DynareBison.cc" // lalr1.cc:919
    break;

  case 337:
#line 831 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2582 "DynareBison.cc" // lalr1.cc:919
    break;

  case 338:
#line 833 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_inf_constant(); }
#line 2588 "DynareBison.cc" // lalr1.cc:919
    break;

  case 339:
#line 837 "DynareBison.yy" // lalr1.cc:919
    { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2594 "DynareBison.cc" // lalr1.cc:919
    break;

  case 340:
#line 839 "DynareBison.yy" // lalr1.cc:919
    { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2600 "DynareBison.cc" // lalr1.cc:919
    break;

  case 341:
#line 843 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2606 "DynareBison.cc" // lalr1.cc:919
    break;

  case 342:
#line 844 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2612 "DynareBison.cc" // lalr1.cc:919
    break;

  case 343:
#line 848 "DynareBison.yy" // lalr1.cc:919
    { driver.end_initval(false); }
#line 2618 "DynareBison.cc" // lalr1.cc:919
    break;

  case 344:
#line 850 "DynareBison.yy" // lalr1.cc:919
    { driver.end_initval(true); }
#line 2624 "DynareBison.cc" // lalr1.cc:919
    break;

  case 345:
#line 854 "DynareBison.yy" // lalr1.cc:919
    { driver.initval_file(yystack_[2].value.as < string > ()); }
#line 2630 "DynareBison.cc" // lalr1.cc:919
    break;

  case 346:
#line 858 "DynareBison.yy" // lalr1.cc:919
    { driver.end_endval(false); }
#line 2636 "DynareBison.cc" // lalr1.cc:919
    break;

  case 347:
#line 860 "DynareBison.yy" // lalr1.cc:919
    { driver.end_endval(true); }
#line 2642 "DynareBison.cc" // lalr1.cc:919
    break;

  case 350:
#line 867 "DynareBison.yy" // lalr1.cc:919
    { driver.init_val(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2648 "DynareBison.cc" // lalr1.cc:919
    break;

  case 351:
#line 870 "DynareBison.yy" // lalr1.cc:919
    { driver.end_histval(false); }
#line 2654 "DynareBison.cc" // lalr1.cc:919
    break;

  case 352:
#line 872 "DynareBison.yy" // lalr1.cc:919
    { driver.end_histval(true); }
#line 2660 "DynareBison.cc" // lalr1.cc:919
    break;

  case 355:
#line 879 "DynareBison.yy" // lalr1.cc:919
    { driver.hist_val(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2666 "DynareBison.cc" // lalr1.cc:919
    break;

  case 356:
#line 882 "DynareBison.yy" // lalr1.cc:919
    { driver.histval_file(yystack_[2].value.as < string > ()); }
#line 2672 "DynareBison.cc" // lalr1.cc:919
    break;

  case 357:
#line 885 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_epilogue(); }
#line 2678 "DynareBison.cc" // lalr1.cc:919
    break;

  case 358:
#line 886 "DynareBison.yy" // lalr1.cc:919
    { driver.end_epilogue(); }
#line 2684 "DynareBison.cc" // lalr1.cc:919
    break;

  case 361:
#line 893 "DynareBison.yy" // lalr1.cc:919
    { driver.add_epilogue_variable(yystack_[0].value.as < string > ()); }
#line 2690 "DynareBison.cc" // lalr1.cc:919
    break;

  case 362:
#line 894 "DynareBison.yy" // lalr1.cc:919
    { driver.add_epilogue_equal(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2696 "DynareBison.cc" // lalr1.cc:919
    break;

  case 363:
#line 897 "DynareBison.yy" // lalr1.cc:919
    { }
#line 2702 "DynareBison.cc" // lalr1.cc:919
    break;

  case 366:
#line 904 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_substitute_flags(yystack_[0].value.as < string > ()); }
#line 2708 "DynareBison.cc" // lalr1.cc:919
    break;

  case 367:
#line 906 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_add_flags(yystack_[0].value.as < string > ()); }
#line 2714 "DynareBison.cc" // lalr1.cc:919
    break;

  case 368:
#line 908 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_substitute_libs(yystack_[0].value.as < string > ()); }
#line 2720 "DynareBison.cc" // lalr1.cc:919
    break;

  case 369:
#line 910 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_add_libs(yystack_[0].value.as < string > ()); }
#line 2726 "DynareBison.cc" // lalr1.cc:919
    break;

  case 370:
#line 912 "DynareBison.yy" // lalr1.cc:919
    { driver.compilation_setup_compiler(yystack_[0].value.as < string > ()); }
#line 2732 "DynareBison.cc" // lalr1.cc:919
    break;

  case 371:
#line 915 "DynareBison.yy" // lalr1.cc:919
    { driver.block(); }
#line 2738 "DynareBison.cc" // lalr1.cc:919
    break;

  case 374:
#line 918 "DynareBison.yy" // lalr1.cc:919
    { driver.byte_code(); }
#line 2744 "DynareBison.cc" // lalr1.cc:919
    break;

  case 375:
#line 919 "DynareBison.yy" // lalr1.cc:919
    { driver.use_dll(); }
#line 2750 "DynareBison.cc" // lalr1.cc:919
    break;

  case 376:
#line 920 "DynareBison.yy" // lalr1.cc:919
    { driver.no_static();}
#line 2756 "DynareBison.cc" // lalr1.cc:919
    break;

  case 377:
#line 921 "DynareBison.yy" // lalr1.cc:919
    { driver.differentiate_forward_vars_all(); }
#line 2762 "DynareBison.cc" // lalr1.cc:919
    break;

  case 378:
#line 922 "DynareBison.yy" // lalr1.cc:919
    { driver.differentiate_forward_vars_some(); }
#line 2768 "DynareBison.cc" // lalr1.cc:919
    break;

  case 381:
#line 925 "DynareBison.yy" // lalr1.cc:919
    { driver.linear_decomposition(); }
#line 2774 "DynareBison.cc" // lalr1.cc:919
    break;

  case 382:
#line 926 "DynareBison.yy" // lalr1.cc:919
    { driver.balanced_growth_test_tol(yystack_[0].value.as < string > ()); }
#line 2780 "DynareBison.cc" // lalr1.cc:919
    break;

  case 385:
#line 933 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_model(); }
#line 2786 "DynareBison.cc" // lalr1.cc:919
    break;

  case 386:
#line 934 "DynareBison.yy" // lalr1.cc:919
    { driver.end_model(); }
#line 2792 "DynareBison.cc" // lalr1.cc:919
    break;

  case 387:
#line 935 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_model(); }
#line 2798 "DynareBison.cc" // lalr1.cc:919
    break;

  case 388:
#line 936 "DynareBison.yy" // lalr1.cc:919
    { driver.end_model(); }
#line 2804 "DynareBison.cc" // lalr1.cc:919
    break;

  case 393:
#line 946 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2810 "DynareBison.cc" // lalr1.cc:919
    break;

  case 394:
#line 948 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > ()); }
#line 2816 "DynareBison.cc" // lalr1.cc:919
    break;

  case 395:
#line 950 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2822 "DynareBison.cc" // lalr1.cc:919
    break;

  case 396:
#line 952 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > ()); }
#line 2828 "DynareBison.cc" // lalr1.cc:919
    break;

  case 399:
#line 960 "DynareBison.yy" // lalr1.cc:919
    { driver.add_equation_tags(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2834 "DynareBison.cc" // lalr1.cc:919
    break;

  case 400:
#line 962 "DynareBison.yy" // lalr1.cc:919
    { driver.add_equation_tags(yystack_[0].value.as < string > (), ""); }
#line 2840 "DynareBison.cc" // lalr1.cc:919
    break;

  case 401:
#line 966 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > ();}
#line 2846 "DynareBison.cc" // lalr1.cc:919
    break;

  case 402:
#line 968 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_variable(yystack_[0].value.as < string > ()); }
#line 2852 "DynareBison.cc" // lalr1.cc:919
    break;

  case 403:
#line 970 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::endogenous, yystack_[1].value.as < string > ()); }
#line 2858 "DynareBison.cc" // lalr1.cc:919
    break;

  case 404:
#line 972 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::exogenous, yystack_[1].value.as < string > ()); }
#line 2864 "DynareBison.cc" // lalr1.cc:919
    break;

  case 405:
#line 974 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::parameter, yystack_[1].value.as < string > ()); }
#line 2870 "DynareBison.cc" // lalr1.cc:919
    break;

  case 406:
#line 976 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 2876 "DynareBison.cc" // lalr1.cc:919
    break;

  case 407:
#line 978 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2882 "DynareBison.cc" // lalr1.cc:919
    break;

  case 408:
#line 980 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2888 "DynareBison.cc" // lalr1.cc:919
    break;

  case 409:
#line 982 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2894 "DynareBison.cc" // lalr1.cc:919
    break;

  case 410:
#line 984 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2900 "DynareBison.cc" // lalr1.cc:919
    break;

  case 411:
#line 986 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2906 "DynareBison.cc" // lalr1.cc:919
    break;

  case 412:
#line 988 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2912 "DynareBison.cc" // lalr1.cc:919
    break;

  case 413:
#line 990 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2918 "DynareBison.cc" // lalr1.cc:919
    break;

  case 414:
#line 992 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2924 "DynareBison.cc" // lalr1.cc:919
    break;

  case 415:
#line 994 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2930 "DynareBison.cc" // lalr1.cc:919
    break;

  case 416:
#line 996 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2936 "DynareBison.cc" // lalr1.cc:919
    break;

  case 417:
#line 998 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2942 "DynareBison.cc" // lalr1.cc:919
    break;

  case 418:
#line 1000 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_expectation(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2948 "DynareBison.cc" // lalr1.cc:919
    break;

  case 419:
#line 1002 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_var_expectation(yystack_[1].value.as < string > ()); }
#line 2954 "DynareBison.cc" // lalr1.cc:919
    break;

  case 420:
#line 1004 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_pac_expectation(yystack_[1].value.as < string > ()); }
#line 2960 "DynareBison.cc" // lalr1.cc:919
    break;

  case 421:
#line 1006 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 2966 "DynareBison.cc" // lalr1.cc:919
    break;

  case 422:
#line 1008 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2972 "DynareBison.cc" // lalr1.cc:919
    break;

  case 423:
#line 1010 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 2978 "DynareBison.cc" // lalr1.cc:919
    break;

  case 424:
#line 1012 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_diff(yystack_[1].value.as < expr_t > ()); }
#line 2984 "DynareBison.cc" // lalr1.cc:919
    break;

  case 425:
#line 1014 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < string > (), "1"); }
#line 2990 "DynareBison.cc" // lalr1.cc:919
    break;

  case 426:
#line 1016 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 2996 "DynareBison.cc" // lalr1.cc:919
    break;

  case 427:
#line 1018 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < vector<int> > ()); }
#line 3002 "DynareBison.cc" // lalr1.cc:919
    break;

  case 428:
#line 1020 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3008 "DynareBison.cc" // lalr1.cc:919
    break;

  case 429:
#line 1022 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3014 "DynareBison.cc" // lalr1.cc:919
    break;

  case 430:
#line 1024 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 3020 "DynareBison.cc" // lalr1.cc:919
    break;

  case 431:
#line 1026 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 3026 "DynareBison.cc" // lalr1.cc:919
    break;

  case 432:
#line 1028 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 3032 "DynareBison.cc" // lalr1.cc:919
    break;

  case 433:
#line 1030 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 3038 "DynareBison.cc" // lalr1.cc:919
    break;

  case 434:
#line 1032 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 3044 "DynareBison.cc" // lalr1.cc:919
    break;

  case 435:
#line 1034 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 3050 "DynareBison.cc" // lalr1.cc:919
    break;

  case 436:
#line 1036 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 3056 "DynareBison.cc" // lalr1.cc:919
    break;

  case 437:
#line 1038 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 3062 "DynareBison.cc" // lalr1.cc:919
    break;

  case 438:
#line 1040 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 3068 "DynareBison.cc" // lalr1.cc:919
    break;

  case 439:
#line 1042 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 3074 "DynareBison.cc" // lalr1.cc:919
    break;

  case 440:
#line 1044 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 3080 "DynareBison.cc" // lalr1.cc:919
    break;

  case 441:
#line 1046 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3086 "DynareBison.cc" // lalr1.cc:919
    break;

  case 442:
#line 1048 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3092 "DynareBison.cc" // lalr1.cc:919
    break;

  case 443:
#line 1049 "DynareBison.yy" // lalr1.cc:919
    { driver.push_external_function_arg_vector_onto_stack(); }
#line 3098 "DynareBison.cc" // lalr1.cc:919
    break;

  case 444:
#line 1050 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), true); }
#line 3104 "DynareBison.cc" // lalr1.cc:919
    break;

  case 445:
#line 1052 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3110 "DynareBison.cc" // lalr1.cc:919
    break;

  case 446:
#line 1054 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 3116 "DynareBison.cc" // lalr1.cc:919
    break;

  case 447:
#line 1056 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3122 "DynareBison.cc" // lalr1.cc:919
    break;

  case 448:
#line 1058 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 3128 "DynareBison.cc" // lalr1.cc:919
    break;

  case 449:
#line 1060 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 3134 "DynareBison.cc" // lalr1.cc:919
    break;

  case 450:
#line 1062 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < expr_t > () = driver.add_steady_state(yystack_[1].value.as < expr_t > ()); }
#line 3140 "DynareBison.cc" // lalr1.cc:919
    break;

  case 451:
#line 1066 "DynareBison.yy" // lalr1.cc:919
    { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3146 "DynareBison.cc" // lalr1.cc:919
    break;

  case 452:
#line 1068 "DynareBison.yy" // lalr1.cc:919
    { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3152 "DynareBison.cc" // lalr1.cc:919
    break;

  case 453:
#line 1072 "DynareBison.yy" // lalr1.cc:919
    { driver.declare_and_init_model_local_variable(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3158 "DynareBison.cc" // lalr1.cc:919
    break;

  case 454:
#line 1074 "DynareBison.yy" // lalr1.cc:919
    { driver.end_shocks(false); }
#line 3164 "DynareBison.cc" // lalr1.cc:919
    break;

  case 455:
#line 1075 "DynareBison.yy" // lalr1.cc:919
    { driver.end_shocks(true); }
#line 3170 "DynareBison.cc" // lalr1.cc:919
    break;

  case 459:
#line 1084 "DynareBison.yy" // lalr1.cc:919
    { driver.add_stderr_shock(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3176 "DynareBison.cc" // lalr1.cc:919
    break;

  case 460:
#line 1086 "DynareBison.yy" // lalr1.cc:919
    { driver.add_var_shock(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3182 "DynareBison.cc" // lalr1.cc:919
    break;

  case 461:
#line 1088 "DynareBison.yy" // lalr1.cc:919
    { driver.add_covar_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3188 "DynareBison.cc" // lalr1.cc:919
    break;

  case 462:
#line 1090 "DynareBison.yy" // lalr1.cc:919
    { driver.add_correl_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3194 "DynareBison.cc" // lalr1.cc:919
    break;

  case 463:
#line 1094 "DynareBison.yy" // lalr1.cc:919
    { driver.add_det_shock(yystack_[7].value.as < string > (), false); }
#line 3200 "DynareBison.cc" // lalr1.cc:919
    break;

  case 464:
#line 1097 "DynareBison.yy" // lalr1.cc:919
    {driver.begin_svar_identification();}
#line 3206 "DynareBison.cc" // lalr1.cc:919
    break;

  case 465:
#line 1098 "DynareBison.yy" // lalr1.cc:919
    { driver.end_svar_identification(); }
#line 3212 "DynareBison.cc" // lalr1.cc:919
    break;

  case 468:
#line 1106 "DynareBison.yy" // lalr1.cc:919
    { driver.combine_lag_and_restriction(yystack_[2].value.as < string > ()); }
#line 3218 "DynareBison.cc" // lalr1.cc:919
    break;

  case 469:
#line 1108 "DynareBison.yy" // lalr1.cc:919
    { driver.add_constants_exclusion(); }
#line 3224 "DynareBison.cc" // lalr1.cc:919
    break;

  case 470:
#line 1110 "DynareBison.yy" // lalr1.cc:919
    { driver.add_restriction_equation_nbr(yystack_[1].value.as < string > ());}
#line 3230 "DynareBison.cc" // lalr1.cc:919
    break;

  case 471:
#line 1112 "DynareBison.yy" // lalr1.cc:919
    {driver.add_restriction_equal();}
#line 3236 "DynareBison.cc" // lalr1.cc:919
    break;

  case 473:
#line 1115 "DynareBison.yy" // lalr1.cc:919
    { driver.add_upper_cholesky(); }
#line 3242 "DynareBison.cc" // lalr1.cc:919
    break;

  case 474:
#line 1117 "DynareBison.yy" // lalr1.cc:919
    { driver.add_lower_cholesky(); }
#line 3248 "DynareBison.cc" // lalr1.cc:919
    break;

  case 475:
#line 1121 "DynareBison.yy" // lalr1.cc:919
    { driver.add_restriction_in_equation(yystack_[3].value.as < string > ()); }
#line 3254 "DynareBison.cc" // lalr1.cc:919
    break;

  case 476:
#line 1123 "DynareBison.yy" // lalr1.cc:919
    { driver.add_restriction_in_equation(yystack_[3].value.as < string > ()); }
#line 3260 "DynareBison.cc" // lalr1.cc:919
    break;

  case 477:
#line 1127 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_svar_restriction_symbols(yystack_[0].value.as < string > ()); }
#line 3266 "DynareBison.cc" // lalr1.cc:919
    break;

  case 478:
#line 1129 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_svar_restriction_symbols(yystack_[0].value.as < string > ()); }
#line 3272 "DynareBison.cc" // lalr1.cc:919
    break;

  case 479:
#line 1132 "DynareBison.yy" // lalr1.cc:919
    {driver.check_restriction_expression_constant(yystack_[0].value.as < expr_t > ());}
#line 3278 "DynareBison.cc" // lalr1.cc:919
    break;

  case 483:
#line 1141 "DynareBison.yy" // lalr1.cc:919
    { driver.add_positive_restriction_element(yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3284 "DynareBison.cc" // lalr1.cc:919
    break;

  case 484:
#line 1143 "DynareBison.yy" // lalr1.cc:919
    { driver.add_positive_restriction_element(yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3290 "DynareBison.cc" // lalr1.cc:919
    break;

  case 485:
#line 1145 "DynareBison.yy" // lalr1.cc:919
    { driver.add_negative_restriction_element(yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3296 "DynareBison.cc" // lalr1.cc:919
    break;

  case 486:
#line 1147 "DynareBison.yy" // lalr1.cc:919
    { driver.add_positive_restriction_element(yystack_[7].value.as < expr_t > (),yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3302 "DynareBison.cc" // lalr1.cc:919
    break;

  case 487:
#line 1151 "DynareBison.yy" // lalr1.cc:919
    { driver.add_svar_global_identification_check(); }
#line 3308 "DynareBison.cc" // lalr1.cc:919
    break;

  case 488:
#line 1155 "DynareBison.yy" // lalr1.cc:919
    { driver.markov_switching(); }
#line 3314 "DynareBison.cc" // lalr1.cc:919
    break;

  case 497:
#line 1171 "DynareBison.yy" // lalr1.cc:919
    { driver.svar(); }
#line 3320 "DynareBison.cc" // lalr1.cc:919
    break;

  case 504:
#line 1184 "DynareBison.yy" // lalr1.cc:919
    { driver.end_mshocks(false); }
#line 3326 "DynareBison.cc" // lalr1.cc:919
    break;

  case 505:
#line 1185 "DynareBison.yy" // lalr1.cc:919
    { driver.end_mshocks(true); }
#line 3332 "DynareBison.cc" // lalr1.cc:919
    break;

  case 508:
#line 1193 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[0].value.as < string > ()); }
#line 3338 "DynareBison.cc" // lalr1.cc:919
    break;

  case 509:
#line 1195 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[0].value.as < string > ()); }
#line 3344 "DynareBison.cc" // lalr1.cc:919
    break;

  case 510:
#line 1197 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 3350 "DynareBison.cc" // lalr1.cc:919
    break;

  case 511:
#line 1199 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 3356 "DynareBison.cc" // lalr1.cc:919
    break;

  case 512:
#line 1201 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 3362 "DynareBison.cc" // lalr1.cc:919
    break;

  case 513:
#line 1203 "DynareBison.yy" // lalr1.cc:919
    { driver.add_period(yystack_[0].value.as < string > ()); }
#line 3368 "DynareBison.cc" // lalr1.cc:919
    break;

  case 514:
#line 1206 "DynareBison.yy" // lalr1.cc:919
    { driver.do_sigma_e(); }
#line 3374 "DynareBison.cc" // lalr1.cc:919
    break;

  case 515:
#line 1209 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[1].value.as < expr_t > ()); }
#line 3380 "DynareBison.cc" // lalr1.cc:919
    break;

  case 516:
#line 1211 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[1].value.as < expr_t > ()); }
#line 3386 "DynareBison.cc" // lalr1.cc:919
    break;

  case 517:
#line 1213 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[1].value.as < expr_t > ()); }
#line 3392 "DynareBison.cc" // lalr1.cc:919
    break;

  case 518:
#line 1215 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[0].value.as < string > ()); }
#line 3398 "DynareBison.cc" // lalr1.cc:919
    break;

  case 519:
#line 1217 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[0].value.as < string > ()); }
#line 3404 "DynareBison.cc" // lalr1.cc:919
    break;

  case 520:
#line 1219 "DynareBison.yy" // lalr1.cc:919
    { driver.add_value(yystack_[0].value.as < string > ()); }
#line 3410 "DynareBison.cc" // lalr1.cc:919
    break;

  case 521:
#line 1223 "DynareBison.yy" // lalr1.cc:919
    { driver.end_of_row(); }
#line 3416 "DynareBison.cc" // lalr1.cc:919
    break;

  case 522:
#line 1225 "DynareBison.yy" // lalr1.cc:919
    { driver.end_of_row(); }
#line 3422 "DynareBison.cc" // lalr1.cc:919
    break;

  case 523:
#line 1229 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row(yystack_[1].value.as < expr_t > ()); }
#line 3428 "DynareBison.cc" // lalr1.cc:919
    break;

  case 524:
#line 1231 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row_const(yystack_[0].value.as < string > ()); }
#line 3434 "DynareBison.cc" // lalr1.cc:919
    break;

  case 525:
#line 1233 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row(yystack_[1].value.as < expr_t > ()); }
#line 3440 "DynareBison.cc" // lalr1.cc:919
    break;

  case 526:
#line 1235 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row_const(yystack_[0].value.as < string > ()); }
#line 3446 "DynareBison.cc" // lalr1.cc:919
    break;

  case 527:
#line 1237 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row(yystack_[1].value.as < expr_t > ()); }
#line 3452 "DynareBison.cc" // lalr1.cc:919
    break;

  case 528:
#line 1239 "DynareBison.yy" // lalr1.cc:919
    { driver.add_to_row_const(yystack_[0].value.as < string > ()); }
#line 3458 "DynareBison.cc" // lalr1.cc:919
    break;

  case 529:
#line 1243 "DynareBison.yy" // lalr1.cc:919
    { driver.steady(); }
#line 3464 "DynareBison.cc" // lalr1.cc:919
    break;

  case 530:
#line 1245 "DynareBison.yy" // lalr1.cc:919
    { driver.steady(); }
#line 3470 "DynareBison.cc" // lalr1.cc:919
    break;

  case 541:
#line 1263 "DynareBison.yy" // lalr1.cc:919
    { driver.check(); }
#line 3476 "DynareBison.cc" // lalr1.cc:919
    break;

  case 542:
#line 1265 "DynareBison.yy" // lalr1.cc:919
    { driver.check(); }
#line 3482 "DynareBison.cc" // lalr1.cc:919
    break;

  case 547:
#line 1277 "DynareBison.yy" // lalr1.cc:919
    { driver.model_info(); }
#line 3488 "DynareBison.cc" // lalr1.cc:919
    break;

  case 548:
#line 1279 "DynareBison.yy" // lalr1.cc:919
    { driver.model_info(); }
#line 3494 "DynareBison.cc" // lalr1.cc:919
    break;

  case 552:
#line 1288 "DynareBison.yy" // lalr1.cc:919
    { driver.perfect_foresight_setup(); }
#line 3500 "DynareBison.cc" // lalr1.cc:919
    break;

  case 553:
#line 1290 "DynareBison.yy" // lalr1.cc:919
    { driver.perfect_foresight_setup(); }
#line 3506 "DynareBison.cc" // lalr1.cc:919
    break;

  case 558:
#line 1302 "DynareBison.yy" // lalr1.cc:919
    { driver.perfect_foresight_solver(); }
#line 3512 "DynareBison.cc" // lalr1.cc:919
    break;

  case 559:
#line 1304 "DynareBison.yy" // lalr1.cc:919
    { driver.perfect_foresight_solver(); }
#line 3518 "DynareBison.cc" // lalr1.cc:919
    break;

  case 623:
#line 1377 "DynareBison.yy" // lalr1.cc:919
    { driver.gmm_estimation(); }
#line 3524 "DynareBison.cc" // lalr1.cc:919
    break;

  case 624:
#line 1379 "DynareBison.yy" // lalr1.cc:919
    { driver.gmm_estimation(); }
#line 3530 "DynareBison.cc" // lalr1.cc:919
    break;

  case 636:
#line 1398 "DynareBison.yy" // lalr1.cc:919
    { driver.smm_estimation(); }
#line 3536 "DynareBison.cc" // lalr1.cc:919
    break;

  case 637:
#line 1400 "DynareBison.yy" // lalr1.cc:919
    { driver.smm_estimation(); }
#line 3542 "DynareBison.cc" // lalr1.cc:919
    break;

  case 653:
#line 1423 "DynareBison.yy" // lalr1.cc:919
    { driver.prior_posterior_function(true); }
#line 3548 "DynareBison.cc" // lalr1.cc:919
    break;

  case 654:
#line 1427 "DynareBison.yy" // lalr1.cc:919
    { driver.prior_posterior_function(false); }
#line 3554 "DynareBison.cc" // lalr1.cc:919
    break;

  case 659:
#line 1439 "DynareBison.yy" // lalr1.cc:919
    { driver.simul(); }
#line 3560 "DynareBison.cc" // lalr1.cc:919
    break;

  case 660:
#line 1441 "DynareBison.yy" // lalr1.cc:919
    { driver.simul(); }
#line 3566 "DynareBison.cc" // lalr1.cc:919
    break;

  case 665:
#line 1453 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function(); }
#line 3572 "DynareBison.cc" // lalr1.cc:919
    break;

  case 672:
#line 1467 "DynareBison.yy" // lalr1.cc:919
    { driver.stoch_simul(); }
#line 3578 "DynareBison.cc" // lalr1.cc:919
    break;

  case 673:
#line 1469 "DynareBison.yy" // lalr1.cc:919
    { driver.stoch_simul(); }
#line 3584 "DynareBison.cc" // lalr1.cc:919
    break;

  case 674:
#line 1471 "DynareBison.yy" // lalr1.cc:919
    { driver.stoch_simul(); }
#line 3590 "DynareBison.cc" // lalr1.cc:919
    break;

  case 675:
#line 1473 "DynareBison.yy" // lalr1.cc:919
    { driver.stoch_simul(); }
#line 3596 "DynareBison.cc" // lalr1.cc:919
    break;

  case 734:
#line 1541 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_symbol_list(yystack_[0].value.as < string > ()); }
#line 3602 "DynareBison.cc" // lalr1.cc:919
    break;

  case 735:
#line 1543 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_symbol_list(yystack_[0].value.as < string > ()); }
#line 3608 "DynareBison.cc" // lalr1.cc:919
    break;

  case 736:
#line 1545 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_symbol_list(yystack_[0].value.as < string > ()); }
#line 3614 "DynareBison.cc" // lalr1.cc:919
    break;

  case 738:
#line 1550 "DynareBison.yy" // lalr1.cc:919
    { driver.add_in_symbol_list(":"); }
#line 3620 "DynareBison.cc" // lalr1.cc:919
    break;

  case 739:
#line 1554 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3626 "DynareBison.cc" // lalr1.cc:919
    break;

  case 740:
#line 1556 "DynareBison.yy" // lalr1.cc:919
    {
                   yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                   yylhs.value.as < string > ().insert(0, "-");
                 }
#line 3635 "DynareBison.cc" // lalr1.cc:919
    break;

  case 741:
#line 1560 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3641 "DynareBison.cc" // lalr1.cc:919
    break;

  case 742:
#line 1563 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3647 "DynareBison.cc" // lalr1.cc:919
    break;

  case 743:
#line 1564 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3653 "DynareBison.cc" // lalr1.cc:919
    break;

  case 744:
#line 1568 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3659 "DynareBison.cc" // lalr1.cc:919
    break;

  case 745:
#line 1570 "DynareBison.yy" // lalr1.cc:919
    {
                 yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                 yylhs.value.as < string > ().insert(0, "-");
               }
#line 3668 "DynareBison.cc" // lalr1.cc:919
    break;

  case 746:
#line 1574 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3674 "DynareBison.cc" // lalr1.cc:919
    break;

  case 747:
#line 1578 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "Inf"; }
#line 3680 "DynareBison.cc" // lalr1.cc:919
    break;

  case 748:
#line 1580 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "-Inf"; }
#line 3686 "DynareBison.cc" // lalr1.cc:919
    break;

  case 749:
#line 1582 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "Inf"; }
#line 3692 "DynareBison.cc" // lalr1.cc:919
    break;

  case 750:
#line 1585 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3698 "DynareBison.cc" // lalr1.cc:919
    break;

  case 751:
#line 1586 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3704 "DynareBison.cc" // lalr1.cc:919
    break;

  case 752:
#line 1589 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params(); }
#line 3710 "DynareBison.cc" // lalr1.cc:919
    break;

  case 753:
#line 1592 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3716 "DynareBison.cc" // lalr1.cc:919
    break;

  case 754:
#line 1594 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3722 "DynareBison.cc" // lalr1.cc:919
    break;

  case 757:
#line 1601 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.type = 1;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 3731 "DynareBison.cc" // lalr1.cc:919
    break;

  case 758:
#line 1606 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 3740 "DynareBison.cc" // lalr1.cc:919
    break;

  case 759:
#line 1611 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.type = 3;
                    driver.estim_params.name = yystack_[2].value.as < string > ();
                    driver.estim_params.name2 = yystack_[0].value.as < string > ();
                  }
#line 3750 "DynareBison.cc" // lalr1.cc:919
    break;

  case 760:
#line 1617 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = "dsge_prior_weight";
                  }
#line 3759 "DynareBison.cc" // lalr1.cc:919
    break;

  case 761:
#line 1624 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 3767 "DynareBison.cc" // lalr1.cc:919
    break;

  case 762:
#line 1628 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 3776 "DynareBison.cc" // lalr1.cc:919
    break;

  case 763:
#line 1633 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.init_val = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 3787 "DynareBison.cc" // lalr1.cc:919
    break;

  case 764:
#line 1640 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.init_val = yystack_[0].value.as < expr_t > ();
                  }
#line 3795 "DynareBison.cc" // lalr1.cc:919
    break;

  case 765:
#line 1644 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[0].value.as < expr_t > ();
                  }
#line 3805 "DynareBison.cc" // lalr1.cc:919
    break;

  case 766:
#line 1652 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.mean = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[0].value.as < expr_t > ();
                  }
#line 3814 "DynareBison.cc" // lalr1.cc:919
    break;

  case 767:
#line 1657 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.mean = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[0].value.as < expr_t > ();
                  }
#line 3824 "DynareBison.cc" // lalr1.cc:919
    break;

  case 768:
#line 1663 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.mean = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[0].value.as < expr_t > ();
                  }
#line 3835 "DynareBison.cc" // lalr1.cc:919
    break;

  case 769:
#line 1670 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.estim_params.mean = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.jscale = yystack_[0].value.as < expr_t > ();
                  }
#line 3847 "DynareBison.cc" // lalr1.cc:919
    break;

  case 770:
#line 1680 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params_init(); }
#line 3853 "DynareBison.cc" // lalr1.cc:919
    break;

  case 771:
#line 1682 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params_init(true); }
#line 3859 "DynareBison.cc" // lalr1.cc:919
    break;

  case 772:
#line 1684 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params_init(true); }
#line 3865 "DynareBison.cc" // lalr1.cc:919
    break;

  case 773:
#line 1688 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3871 "DynareBison.cc" // lalr1.cc:919
    break;

  case 774:
#line 1690 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3877 "DynareBison.cc" // lalr1.cc:919
    break;

  case 775:
#line 1694 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.estim_params.type = 1;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 3887 "DynareBison.cc" // lalr1.cc:919
    break;

  case 776:
#line 1700 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.estim_params.type = 3;
                        driver.estim_params.name = yystack_[5].value.as < string > ();
                        driver.estim_params.name2 = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 3898 "DynareBison.cc" // lalr1.cc:919
    break;

  case 777:
#line 1707 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.estim_params.type = 2;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 3908 "DynareBison.cc" // lalr1.cc:919
    break;

  case 778:
#line 1715 "DynareBison.yy" // lalr1.cc:919
    { driver.estimated_params_bounds(); }
#line 3914 "DynareBison.cc" // lalr1.cc:919
    break;

  case 779:
#line 1718 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3920 "DynareBison.cc" // lalr1.cc:919
    break;

  case 780:
#line 1720 "DynareBison.yy" // lalr1.cc:919
    { driver.add_estimated_params_element(); }
#line 3926 "DynareBison.cc" // lalr1.cc:919
    break;

  case 781:
#line 1724 "DynareBison.yy" // lalr1.cc:919
    {
                          driver.estim_params.type = 1;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 3937 "DynareBison.cc" // lalr1.cc:919
    break;

  case 782:
#line 1731 "DynareBison.yy" // lalr1.cc:919
    {
                          driver.estim_params.type = 3;
                          driver.estim_params.name = yystack_[7].value.as < string > ();
                          driver.estim_params.name2 = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 3949 "DynareBison.cc" // lalr1.cc:919
    break;

  case 783:
#line 1739 "DynareBison.yy" // lalr1.cc:919
    {
                          driver.estim_params.type = 2;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 3960 "DynareBison.cc" // lalr1.cc:919
    break;

  case 784:
#line 1748 "DynareBison.yy" // lalr1.cc:919
    { driver.osr_params_bounds(); }
#line 3966 "DynareBison.cc" // lalr1.cc:919
    break;

  case 785:
#line 1751 "DynareBison.yy" // lalr1.cc:919
    { driver.add_osr_params_element(); }
#line 3972 "DynareBison.cc" // lalr1.cc:919
    break;

  case 786:
#line 1753 "DynareBison.yy" // lalr1.cc:919
    { driver.add_osr_params_element(); }
#line 3978 "DynareBison.cc" // lalr1.cc:919
    break;

  case 787:
#line 1757 "DynareBison.yy" // lalr1.cc:919
    {
                    driver.osr_params.name = yystack_[5].value.as < string > ();
                    driver.osr_params.low_bound = yystack_[3].value.as < expr_t > ();
                    driver.osr_params.up_bound = yystack_[1].value.as < expr_t > ();
                  }
#line 3988 "DynareBison.cc" // lalr1.cc:919
    break;

  case 788:
#line 1765 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 3994 "DynareBison.cc" // lalr1.cc:919
    break;

  case 789:
#line 1767 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4000 "DynareBison.cc" // lalr1.cc:919
    break;

  case 790:
#line 1769 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4006 "DynareBison.cc" // lalr1.cc:919
    break;

  case 791:
#line 1771 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4012 "DynareBison.cc" // lalr1.cc:919
    break;

  case 792:
#line 1773 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4018 "DynareBison.cc" // lalr1.cc:919
    break;

  case 793:
#line 1775 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4024 "DynareBison.cc" // lalr1.cc:919
    break;

  case 794:
#line 1777 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4030 "DynareBison.cc" // lalr1.cc:919
    break;

  case 795:
#line 1779 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::dirichlet; }
#line 4036 "DynareBison.cc" // lalr1.cc:919
    break;

  case 796:
#line 1781 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 4042 "DynareBison.cc" // lalr1.cc:919
    break;

  case 797:
#line 1785 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 4048 "DynareBison.cc" // lalr1.cc:919
    break;

  case 798:
#line 1787 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4054 "DynareBison.cc" // lalr1.cc:919
    break;

  case 799:
#line 1789 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4060 "DynareBison.cc" // lalr1.cc:919
    break;

  case 800:
#line 1791 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4066 "DynareBison.cc" // lalr1.cc:919
    break;

  case 801:
#line 1793 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4072 "DynareBison.cc" // lalr1.cc:919
    break;

  case 802:
#line 1795 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4078 "DynareBison.cc" // lalr1.cc:919
    break;

  case 803:
#line 1797 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4084 "DynareBison.cc" // lalr1.cc:919
    break;

  case 804:
#line 1799 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 4090 "DynareBison.cc" // lalr1.cc:919
    break;

  case 805:
#line 1802 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4096 "DynareBison.cc" // lalr1.cc:919
    break;

  case 806:
#line 1804 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4102 "DynareBison.cc" // lalr1.cc:919
    break;

  case 807:
#line 1806 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + '+' + yystack_[0].value.as < string > (); }
#line 4108 "DynareBison.cc" // lalr1.cc:919
    break;

  case 808:
#line 1810 "DynareBison.yy" // lalr1.cc:919
    { driver.set_time(yystack_[2].value.as < string > ()); }
#line 4114 "DynareBison.cc" // lalr1.cc:919
    break;

  case 809:
#line 1814 "DynareBison.yy" // lalr1.cc:919
    { driver.estimation_data(); }
#line 4120 "DynareBison.cc" // lalr1.cc:919
    break;

  case 819:
#line 1831 "DynareBison.yy" // lalr1.cc:919
    { driver.set_subsamples(yystack_[4].value.as < pair<string,string> > ().first, yystack_[4].value.as < pair<string,string> > ().second); }
#line 4126 "DynareBison.cc" // lalr1.cc:919
    break;

  case 820:
#line 1835 "DynareBison.yy" // lalr1.cc:919
    { driver.copy_subsamples(yystack_[3].value.as < pair<string,string> > ().first, yystack_[3].value.as < pair<string,string> > ().second, yystack_[1].value.as < pair<string,string> > ().first, yystack_[1].value.as < pair<string,string> > ().second); }
#line 4132 "DynareBison.cc" // lalr1.cc:919
    break;

  case 821:
#line 1839 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), "" }; }
#line 4138 "DynareBison.cc" // lalr1.cc:919
    break;

  case 822:
#line 1841 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[3].value.as < string > (), "" }; }
#line 4144 "DynareBison.cc" // lalr1.cc:919
    break;

  case 823:
#line 1843 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[5].value.as < string > (), yystack_[3].value.as < string > () }; }
#line 4150 "DynareBison.cc" // lalr1.cc:919
    break;

  case 826:
#line 1850 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4156 "DynareBison.cc" // lalr1.cc:919
    break;

  case 827:
#line 1851 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior(yystack_[7].value.as < string > (), ""); }
#line 4162 "DynareBison.cc" // lalr1.cc:919
    break;

  case 828:
#line 1852 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4168 "DynareBison.cc" // lalr1.cc:919
    break;

  case 829:
#line 1853 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior(yystack_[9].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4174 "DynareBison.cc" // lalr1.cc:919
    break;

  case 830:
#line 1854 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4180 "DynareBison.cc" // lalr1.cc:919
    break;

  case 831:
#line 1855 "DynareBison.yy" // lalr1.cc:919
    { driver.set_joint_prior(yystack_[7].value.as < vector<string> > ()); }
#line 4186 "DynareBison.cc" // lalr1.cc:919
    break;

  case 832:
#line 1856 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4192 "DynareBison.cc" // lalr1.cc:919
    break;

  case 833:
#line 1857 "DynareBison.yy" // lalr1.cc:919
    { driver.set_std_prior(yystack_[8].value.as < string > (), ""); }
#line 4198 "DynareBison.cc" // lalr1.cc:919
    break;

  case 834:
#line 1858 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4204 "DynareBison.cc" // lalr1.cc:919
    break;

  case 835:
#line 1859 "DynareBison.yy" // lalr1.cc:919
    { driver.set_std_prior(yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4210 "DynareBison.cc" // lalr1.cc:919
    break;

  case 836:
#line 1860 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4216 "DynareBison.cc" // lalr1.cc:919
    break;

  case 837:
#line 1861 "DynareBison.yy" // lalr1.cc:919
    { driver.set_corr_prior(yystack_[10].value.as < string > (), yystack_[8].value.as < string > (), ""); }
#line 4222 "DynareBison.cc" // lalr1.cc:919
    break;

  case 838:
#line 1862 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4228 "DynareBison.cc" // lalr1.cc:919
    break;

  case 839:
#line 1863 "DynareBison.yy" // lalr1.cc:919
    { driver.set_corr_prior(yystack_[12].value.as < string > (), yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4234 "DynareBison.cc" // lalr1.cc:919
    break;

  case 864:
#line 1899 "DynareBison.yy" // lalr1.cc:919
    { driver.copy_prior(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                               get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 4241 "DynareBison.cc" // lalr1.cc:919
    break;

  case 865:
#line 1904 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[2].value.as < string > (), "", "" }; }
#line 4247 "DynareBison.cc" // lalr1.cc:919
    break;

  case 866:
#line 1906 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4253 "DynareBison.cc" // lalr1.cc:919
    break;

  case 867:
#line 1908 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[3].value.as < string > (), "", "" }; }
#line 4259 "DynareBison.cc" // lalr1.cc:919
    break;

  case 868:
#line 1910 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4265 "DynareBison.cc" // lalr1.cc:919
    break;

  case 869:
#line 1912 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "" }; }
#line 4271 "DynareBison.cc" // lalr1.cc:919
    break;

  case 870:
#line 1914 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > () }; }
#line 4277 "DynareBison.cc" // lalr1.cc:919
    break;

  case 871:
#line 1918 "DynareBison.yy" // lalr1.cc:919
    { driver.set_options(yystack_[6].value.as < string > (), ""); }
#line 4283 "DynareBison.cc" // lalr1.cc:919
    break;

  case 872:
#line 1920 "DynareBison.yy" // lalr1.cc:919
    { driver.set_options(yystack_[8].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 4289 "DynareBison.cc" // lalr1.cc:919
    break;

  case 873:
#line 1922 "DynareBison.yy" // lalr1.cc:919
    { driver.set_std_options(yystack_[7].value.as < string > (), ""); }
#line 4295 "DynareBison.cc" // lalr1.cc:919
    break;

  case 874:
#line 1924 "DynareBison.yy" // lalr1.cc:919
    { driver.set_std_options(yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 4301 "DynareBison.cc" // lalr1.cc:919
    break;

  case 875:
#line 1926 "DynareBison.yy" // lalr1.cc:919
    { driver.set_corr_options(yystack_[9].value.as < string > (), yystack_[7].value.as < string > (), ""); }
#line 4307 "DynareBison.cc" // lalr1.cc:919
    break;

  case 876:
#line 1928 "DynareBison.yy" // lalr1.cc:919
    { driver.set_corr_options(yystack_[11].value.as < string > (), yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 4313 "DynareBison.cc" // lalr1.cc:919
    break;

  case 882:
#line 1941 "DynareBison.yy" // lalr1.cc:919
    { driver.copy_prior(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                                 get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 4320 "DynareBison.cc" // lalr1.cc:919
    break;

  case 883:
#line 1946 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[2].value.as < string > (), "", "" }; }
#line 4326 "DynareBison.cc" // lalr1.cc:919
    break;

  case 884:
#line 1948 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4332 "DynareBison.cc" // lalr1.cc:919
    break;

  case 885:
#line 1950 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[3].value.as < string > (), "", "" }; }
#line 4338 "DynareBison.cc" // lalr1.cc:919
    break;

  case 886:
#line 1952 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4344 "DynareBison.cc" // lalr1.cc:919
    break;

  case 887:
#line 1954 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "" }; }
#line 4350 "DynareBison.cc" // lalr1.cc:919
    break;

  case 888:
#line 1956 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > () }; }
#line 4356 "DynareBison.cc" // lalr1.cc:919
    break;

  case 889:
#line 1960 "DynareBison.yy" // lalr1.cc:919
    { driver.run_estimation(); }
#line 4362 "DynareBison.cc" // lalr1.cc:919
    break;

  case 890:
#line 1962 "DynareBison.yy" // lalr1.cc:919
    { driver.run_estimation(); }
#line 4368 "DynareBison.cc" // lalr1.cc:919
    break;

  case 891:
#line 1964 "DynareBison.yy" // lalr1.cc:919
    { driver.run_estimation(); }
#line 4374 "DynareBison.cc" // lalr1.cc:919
    break;

  case 892:
#line 1966 "DynareBison.yy" // lalr1.cc:919
    { driver.run_estimation(); }
#line 4380 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1014:
#line 2095 "DynareBison.yy" // lalr1.cc:919
    { driver.optim_options_string(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4386 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1015:
#line 2097 "DynareBison.yy" // lalr1.cc:919
    { driver.optim_options_num(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4392 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1018:
#line 2105 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "'', ''" + yystack_[0].value.as < string > () + "''"; }
#line 4398 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1019:
#line 2107 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "''," + yystack_[0].value.as < string > (); }
#line 4404 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1020:
#line 2110 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4410 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1021:
#line 2112 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 4416 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1022:
#line 2116 "DynareBison.yy" // lalr1.cc:919
    { driver.sampling_options_string(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4422 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1023:
#line 2118 "DynareBison.yy" // lalr1.cc:919
    { driver.sampling_options_num(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4428 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1024:
#line 2120 "DynareBison.yy" // lalr1.cc:919
    { driver.sampling_options_vec_str(yystack_[2].value.as < string > (), yystack_[0].value.as < vector<string> > ()); }
#line 4434 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1025:
#line 2122 "DynareBison.yy" // lalr1.cc:919
    { driver.sampling_options_string(yystack_[4].value.as < string > (), '(' + yystack_[1].value.as < string > () + ')'); }
#line 4440 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1028:
#line 2129 "DynareBison.yy" // lalr1.cc:919
    { driver.check_varobs(); }
#line 4446 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1030:
#line 2132 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 4452 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1031:
#line 2134 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 4458 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1032:
#line 2136 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 4464 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1033:
#line 2139 "DynareBison.yy" // lalr1.cc:919
    { driver.check_varexobs(); }
#line 4470 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1035:
#line 2142 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 4476 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1036:
#line 2144 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 4482 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1037:
#line 2146 "DynareBison.yy" // lalr1.cc:919
    { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 4488 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1038:
#line 2149 "DynareBison.yy" // lalr1.cc:919
    { driver.set_trends(); }
#line 4494 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1041:
#line 2155 "DynareBison.yy" // lalr1.cc:919
    { driver.set_trend_element(yystack_[4].value.as < string > (), yystack_[2].value.as < expr_t > ()); }
#line 4500 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1042:
#line 2157 "DynareBison.yy" // lalr1.cc:919
    { driver.set_unit_root_vars(); }
#line 4506 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1043:
#line 2159 "DynareBison.yy" // lalr1.cc:919
    { driver.optim_weights(); }
#line 4512 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1044:
#line 2162 "DynareBison.yy" // lalr1.cc:919
    { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4518 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1045:
#line 2164 "DynareBison.yy" // lalr1.cc:919
    { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4524 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1046:
#line 2166 "DynareBison.yy" // lalr1.cc:919
    { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4530 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1047:
#line 2168 "DynareBison.yy" // lalr1.cc:919
    { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4536 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1048:
#line 2171 "DynareBison.yy" // lalr1.cc:919
    { driver.set_osr_params(); }
#line 4542 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1058:
#line 2188 "DynareBison.yy" // lalr1.cc:919
    { driver.run_osr(); }
#line 4548 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1059:
#line 2190 "DynareBison.yy" // lalr1.cc:919
    { driver.run_osr(); }
#line 4554 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1060:
#line 2192 "DynareBison.yy" // lalr1.cc:919
    { driver.run_osr(); }
#line 4560 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1061:
#line 2194 "DynareBison.yy" // lalr1.cc:919
    {driver.run_osr(); }
#line 4566 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1062:
#line 2198 "DynareBison.yy" // lalr1.cc:919
    { driver.run_dynatype(yystack_[2].value.as < string > ()); }
#line 4572 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1063:
#line 2200 "DynareBison.yy" // lalr1.cc:919
    { driver.run_dynatype(yystack_[3].value.as < string > ()); }
#line 4578 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1064:
#line 2204 "DynareBison.yy" // lalr1.cc:919
    { driver.run_dynasave(yystack_[2].value.as < string > ()); }
#line 4584 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1065:
#line 2206 "DynareBison.yy" // lalr1.cc:919
    { driver.run_dynasave(yystack_[3].value.as < string > ()); }
#line 4590 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1066:
#line 2210 "DynareBison.yy" // lalr1.cc:919
    { driver.run_load_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 4596 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1067:
#line 2214 "DynareBison.yy" // lalr1.cc:919
    { driver.run_save_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 4602 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1068:
#line 2218 "DynareBison.yy" // lalr1.cc:919
    { driver.run_identification(); }
#line 4608 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1069:
#line 2220 "DynareBison.yy" // lalr1.cc:919
    { driver.run_identification(); }
#line 4614 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1106:
#line 2264 "DynareBison.yy" // lalr1.cc:919
    { driver.run_model_comparison(); }
#line 4620 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1107:
#line 2266 "DynareBison.yy" // lalr1.cc:919
    { driver.run_model_comparison(); }
#line 4626 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1108:
#line 2269 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4632 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1109:
#line 2270 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4638 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1110:
#line 2273 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4644 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1111:
#line 2275 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + "." + yystack_[0].value.as < string > (); }
#line 4650 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1112:
#line 2278 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4656 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1113:
#line 2279 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4662 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1114:
#line 2283 "DynareBison.yy" // lalr1.cc:919
    { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 4668 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1115:
#line 2285 "DynareBison.yy" // lalr1.cc:919
    { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 4674 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1116:
#line 2289 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 4680 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1117:
#line 2291 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4686 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1118:
#line 2293 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 4692 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1119:
#line 2295 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4698 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1120:
#line 2297 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 4704 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1121:
#line 2299 "DynareBison.yy" // lalr1.cc:919
    { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4710 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1122:
#line 2302 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_planner_objective(); }
#line 4716 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1123:
#line 2303 "DynareBison.yy" // lalr1.cc:919
    { driver.end_planner_objective(yystack_[0].value.as < expr_t > ()); }
#line 4722 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1125:
#line 2306 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_model(); }
#line 4728 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1126:
#line 2308 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_model(); }
#line 4734 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1127:
#line 2312 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_policy(); }
#line 4740 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1128:
#line 2314 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_policy(); }
#line 4746 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1129:
#line 2316 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_policy(); }
#line 4752 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1130:
#line 2318 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_policy(); }
#line 4758 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1131:
#line 2322 "DynareBison.yy" // lalr1.cc:919
    { driver.add_ramsey_constraints_statement(); }
#line 4764 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1134:
#line 2330 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_constraint_add_less(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 4770 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1135:
#line 2332 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_constraint_add_greater(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 4776 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1136:
#line 2334 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_constraint_add_less_equal(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 4782 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1137:
#line 2336 "DynareBison.yy" // lalr1.cc:919
    { driver.ramsey_constraint_add_greater_equal(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 4788 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1138:
#line 2340 "DynareBison.yy" // lalr1.cc:919
    { driver.evaluate_planner_objective(); }
#line 4794 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1139:
#line 2344 "DynareBison.yy" // lalr1.cc:919
    { driver.discretionary_policy(); }
#line 4800 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1140:
#line 2346 "DynareBison.yy" // lalr1.cc:919
    { driver.discretionary_policy(); }
#line 4806 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1141:
#line 2348 "DynareBison.yy" // lalr1.cc:919
    { driver.discretionary_policy(); }
#line 4812 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1142:
#line 2350 "DynareBison.yy" // lalr1.cc:919
    { driver.discretionary_policy(); }
#line 4818 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1158:
#line 2381 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_dynamic_model(false); }
#line 4824 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1159:
#line 2383 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_dynamic_model(true); }
#line 4830 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1160:
#line 2387 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_static_model(false); }
#line 4836 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1161:
#line 2389 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_static_model(true); }
#line 4842 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1162:
#line 2393 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_original_model(false); }
#line 4848 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1163:
#line 2395 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_original_model(true); }
#line 4854 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1164:
#line 2399 "DynareBison.yy" // lalr1.cc:919
    { driver.write_latex_steady_state_model(); }
#line 4860 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1165:
#line 2403 "DynareBison.yy" // lalr1.cc:919
    {driver.shock_decomposition(); }
#line 4866 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1166:
#line 2405 "DynareBison.yy" // lalr1.cc:919
    { driver.shock_decomposition(); }
#line 4872 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1167:
#line 2407 "DynareBison.yy" // lalr1.cc:919
    { driver.shock_decomposition(); }
#line 4878 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1168:
#line 2409 "DynareBison.yy" // lalr1.cc:919
    { driver.shock_decomposition(); }
#line 4884 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1169:
#line 2413 "DynareBison.yy" // lalr1.cc:919
    {driver.realtime_shock_decomposition(); }
#line 4890 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1170:
#line 2415 "DynareBison.yy" // lalr1.cc:919
    { driver.realtime_shock_decomposition(); }
#line 4896 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1171:
#line 2417 "DynareBison.yy" // lalr1.cc:919
    { driver.realtime_shock_decomposition(); }
#line 4902 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1172:
#line 2419 "DynareBison.yy" // lalr1.cc:919
    { driver.realtime_shock_decomposition(); }
#line 4908 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1173:
#line 2423 "DynareBison.yy" // lalr1.cc:919
    {driver.plot_shock_decomposition(); }
#line 4914 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1174:
#line 2425 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomposition(); }
#line 4920 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1175:
#line 2427 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomposition(); }
#line 4926 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1176:
#line 2429 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomposition(); }
#line 4932 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1177:
#line 2433 "DynareBison.yy" // lalr1.cc:919
    {driver.initial_condition_decomposition(); }
#line 4938 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1178:
#line 2435 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomposition(); }
#line 4944 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1179:
#line 2437 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomposition(); }
#line 4950 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1180:
#line 2439 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomposition(); }
#line 4956 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1181:
#line 2443 "DynareBison.yy" // lalr1.cc:919
    { driver.squeeze_shock_decomposition(); }
#line 4962 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1182:
#line 2445 "DynareBison.yy" // lalr1.cc:919
    { driver.squeeze_shock_decomposition(); }
#line 4968 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1202:
#line 2474 "DynareBison.yy" // lalr1.cc:919
    { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 4974 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1203:
#line 2476 "DynareBison.yy" // lalr1.cc:919
    { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 4980 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1210:
#line 2490 "DynareBison.yy" // lalr1.cc:919
    { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 4986 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1211:
#line 2492 "DynareBison.yy" // lalr1.cc:919
    { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 4992 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1262:
#line 2550 "DynareBison.yy" // lalr1.cc:919
    { driver.sbvar(); }
#line 4998 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1263:
#line 2552 "DynareBison.yy" // lalr1.cc:919
    { driver.sbvar(); }
#line 5004 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1280:
#line 2576 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_variance_decomposition(); }
#line 5010 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1281:
#line 2578 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_variance_decomposition(); }
#line 5016 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1298:
#line 2602 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_forecast(); }
#line 5022 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1299:
#line 2604 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_forecast(); }
#line 5028 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1316:
#line 2628 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_irf(); }
#line 5034 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1317:
#line 2630 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_irf(); }
#line 5040 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1318:
#line 2632 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_irf(); }
#line 5046 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1319:
#line 2634 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_irf(); }
#line 5052 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1326:
#line 2648 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_compute_probabilities(); }
#line 5058 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1327:
#line 2650 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_compute_probabilities(); }
#line 5064 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1338:
#line 2668 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_compute_mdd(); }
#line 5070 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1339:
#line 2670 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_compute_mdd(); }
#line 5076 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1349:
#line 2687 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_simulation(); }
#line 5082 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1350:
#line 2689 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_simulation(); }
#line 5088 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1388:
#line 2734 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_estimation(); }
#line 5094 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1389:
#line 2736 "DynareBison.yy" // lalr1.cc:919
    { driver.ms_estimation(); }
#line 5100 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1390:
#line 2740 "DynareBison.yy" // lalr1.cc:919
    { driver.dynare_sensitivity(); }
#line 5106 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1391:
#line 2742 "DynareBison.yy" // lalr1.cc:919
    { driver.dynare_sensitivity(); }
#line 5112 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1510:
#line 2884 "DynareBison.yy" // lalr1.cc:919
    { driver.end_homotopy();}
#line 5118 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1513:
#line 2891 "DynareBison.yy" // lalr1.cc:919
    { driver.homotopy_val(yystack_[5].value.as < string > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ());}
#line 5124 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1514:
#line 2893 "DynareBison.yy" // lalr1.cc:919
    { driver.homotopy_val(yystack_[3].value.as < string > (), nullptr, yystack_[1].value.as < expr_t > ());}
#line 5130 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1515:
#line 2896 "DynareBison.yy" // lalr1.cc:919
    {driver.forecast();}
#line 5136 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1516:
#line 2897 "DynareBison.yy" // lalr1.cc:919
    {driver.forecast();}
#line 5142 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1517:
#line 2898 "DynareBison.yy" // lalr1.cc:919
    {driver.forecast();}
#line 5148 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1518:
#line 2899 "DynareBison.yy" // lalr1.cc:919
    {driver.forecast();}
#line 5154 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1526:
#line 2914 "DynareBison.yy" // lalr1.cc:919
    { driver.conditional_forecast(); }
#line 5160 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1534:
#line 2929 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_conditional_forecast(); }
#line 5166 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1535:
#line 2931 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_conditional_forecast(yystack_[3].value.as < string > ()); }
#line 5172 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1536:
#line 2935 "DynareBison.yy" // lalr1.cc:919
    { driver.conditional_forecast_paths(); }
#line 5178 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1539:
#line 2943 "DynareBison.yy" // lalr1.cc:919
    { driver.add_det_shock(yystack_[7].value.as < string > (), true); }
#line 5184 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1540:
#line 2946 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_steady_state_model(); }
#line 5190 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1541:
#line 2947 "DynareBison.yy" // lalr1.cc:919
    { driver.reset_data_tree(); }
#line 5196 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1544:
#line 2955 "DynareBison.yy" // lalr1.cc:919
    { driver.add_steady_state_model_equal(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5202 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1545:
#line 2957 "DynareBison.yy" // lalr1.cc:919
    { driver.add_steady_state_model_equal_multiple(yystack_[1].value.as < expr_t > ()); }
#line 5208 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1546:
#line 2961 "DynareBison.yy" // lalr1.cc:919
    { driver.calib_smoother(); }
#line 5214 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1547:
#line 2963 "DynareBison.yy" // lalr1.cc:919
    { driver.calib_smoother(); }
#line 5220 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1548:
#line 2965 "DynareBison.yy" // lalr1.cc:919
    { driver.calib_smoother(); }
#line 5226 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1549:
#line 2967 "DynareBison.yy" // lalr1.cc:919
    { driver.calib_smoother(); }
#line 5232 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1565:
#line 2990 "DynareBison.yy" // lalr1.cc:919
    { driver.end_generate_irfs(); }
#line 5238 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1566:
#line 2992 "DynareBison.yy" // lalr1.cc:919
    { driver.end_generate_irfs(); }
#line 5244 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1567:
#line 2994 "DynareBison.yy" // lalr1.cc:919
    { driver.end_generate_irfs(); }
#line 5250 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1568:
#line 2996 "DynareBison.yy" // lalr1.cc:919
    { driver.end_generate_irfs(); }
#line 5256 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1575:
#line 3012 "DynareBison.yy" // lalr1.cc:919
    { driver.add_generate_irfs_element(yystack_[3].value.as < string > ()); }
#line 5262 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1576:
#line 3016 "DynareBison.yy" // lalr1.cc:919
    { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 5268 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1577:
#line 3018 "DynareBison.yy" // lalr1.cc:919
    { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 5274 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1578:
#line 3022 "DynareBison.yy" // lalr1.cc:919
    { driver.extended_path(); }
#line 5280 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1579:
#line 3024 "DynareBison.yy" // lalr1.cc:919
    { driver.extended_path(); }
#line 5286 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1588:
#line 3040 "DynareBison.yy" // lalr1.cc:919
    { driver.model_diagnostics(); }
#line 5292 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1589:
#line 3044 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<expr_t,expr_t> > () = { yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > () }; }
#line 5298 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1590:
#line 3046 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<expr_t,expr_t> > () = { driver.add_non_negative_constant("0"), driver.add_inf_constant() }; }
#line 5304 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1591:
#line 3048 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<expr_t,expr_t> > () = { driver.add_uminus(driver.add_inf_constant()), driver.add_non_negative_constant("0") }; }
#line 5310 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1592:
#line 3052 "DynareBison.yy" // lalr1.cc:919
    { driver.end_moment_calibration(); }
#line 5316 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1595:
#line 3060 "DynareBison.yy" // lalr1.cc:919
    { driver.add_moment_calibration_item(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "0", yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5322 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1596:
#line 3062 "DynareBison.yy" // lalr1.cc:919
    { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5328 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1597:
#line 3064 "DynareBison.yy" // lalr1.cc:919
    { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5334 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1598:
#line 3068 "DynareBison.yy" // lalr1.cc:919
    { driver.end_irf_calibration(); }
#line 5340 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1599:
#line 3070 "DynareBison.yy" // lalr1.cc:919
    { driver.end_irf_calibration(); }
#line 5346 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1602:
#line 3078 "DynareBison.yy" // lalr1.cc:919
    { driver.add_irf_calibration_item(yystack_[5].value.as < string > (), "1", yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5352 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1603:
#line 3080 "DynareBison.yy" // lalr1.cc:919
    { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5358 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1604:
#line 3082 "DynareBison.yy" // lalr1.cc:919
    { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5364 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1605:
#line 3086 "DynareBison.yy" // lalr1.cc:919
    { driver.smoother2histval(); }
#line 5370 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1606:
#line 3088 "DynareBison.yy" // lalr1.cc:919
    { driver.smoother2histval(); }
#line 5376 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1614:
#line 3103 "DynareBison.yy" // lalr1.cc:919
    { driver.end_shock_groups("default"); }
#line 5382 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1615:
#line 3105 "DynareBison.yy" // lalr1.cc:919
    {driver.end_shock_groups(yystack_[5].value.as < string > ());}
#line 5388 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1618:
#line 3112 "DynareBison.yy" // lalr1.cc:919
    { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 5394 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1619:
#line 3113 "DynareBison.yy" // lalr1.cc:919
    { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 5400 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1620:
#line 3116 "DynareBison.yy" // lalr1.cc:919
    {driver.add_shock_group_element(yystack_[0].value.as < string > ());}
#line 5406 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1621:
#line 3117 "DynareBison.yy" // lalr1.cc:919
    {driver.add_shock_group_element(yystack_[0].value.as < string > ());}
#line 5412 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1622:
#line 3118 "DynareBison.yy" // lalr1.cc:919
    {driver.add_shock_group_element(yystack_[0].value.as < string > ());}
#line 5418 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1623:
#line 3122 "DynareBison.yy" // lalr1.cc:919
    { driver.end_init2shocks("default"); }
#line 5424 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1624:
#line 3124 "DynareBison.yy" // lalr1.cc:919
    {driver.end_init2shocks(yystack_[5].value.as < string > ());}
#line 5430 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1627:
#line 3131 "DynareBison.yy" // lalr1.cc:919
    { driver.add_init2shocks(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5436 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1628:
#line 3132 "DynareBison.yy" // lalr1.cc:919
    { driver.add_init2shocks(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5442 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1629:
#line 3135 "DynareBison.yy" // lalr1.cc:919
    {
                                       if (yystack_[0].value.as < string > () == "0")
                                         driver.warning("dr_algo option is now deprecated, and may be removed in a future version of Dynare");
                                       else
                                         driver.error("dr_algo=1 option is no longer supported");
                                     }
#line 5453 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1630:
#line 3141 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("solve_algo", yystack_[0].value.as < string > ()); }
#line 5459 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1631:
#line 3142 "DynareBison.yy" // lalr1.cc:919
    {
                                             if (yystack_[0].value.as < string > () == "0")
                                               driver.warning("simul_algo option is now deprecated, and may be removed in a future version of Dynare");
                                             else
                                               driver.error("simul_algo=1 option is no longer supported");
                                           }
#line 5470 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1632:
#line 3148 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("stack_solve_algo", yystack_[0].value.as < string > ()); }
#line 5476 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1633:
#line 3149 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("simul.robust_lin_solve", "true"); }
#line 5482 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1634:
#line 3150 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("endogenous_terminal_period", "true"); }
#line 5488 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1635:
#line 3151 "DynareBison.yy" // lalr1.cc:919
    { driver.linear(); }
#line 5494 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1636:
#line 3152 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("order", yystack_[0].value.as < string > ()); }
#line 5500 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1637:
#line 3153 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("replic", yystack_[0].value.as < string > ()); }
#line 5506 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1638:
#line 3154 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("drop", yystack_[0].value.as < string > ()); }
#line 5512 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1639:
#line 3155 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ar", yystack_[0].value.as < string > ()); }
#line 5518 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1640:
#line 3156 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nocorr", "true"); }
#line 5524 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1641:
#line 3157 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nofunctions", "true"); }
#line 5530 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1642:
#line 3158 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nomoments", "true"); }
#line 5536 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1643:
#line 3159 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf", yystack_[0].value.as < string > ()); }
#line 5542 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1644:
#line 3160 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("irf_shocks"); }
#line 5548 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1645:
#line 3161 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("hp_filter", yystack_[0].value.as < string > ()); }
#line 5554 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1646:
#line 3162 "DynareBison.yy" // lalr1.cc:919
    {
                                         driver.warning("The 'hp_ngrid' option is deprecated. It has been superseded by the 'filtered_theoretical_moments_grid' option.");
                                         driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ());
                                       }
#line 5563 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1647:
#line 3166 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ()); }
#line 5569 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1648:
#line 3167 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("one_sided_hp_filter", yystack_[0].value.as < string > ()); }
#line 5575 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1649:
#line 3168 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("periods", yystack_[0].value.as < string > ()); }
#line 5581 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1650:
#line 3169 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ep.periods", yystack_[0].value.as < string > ()); }
#line 5587 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1651:
#line 3170 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ep.stochastic.order", yystack_[0].value.as < string > ()); }
#line 5593 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1652:
#line 3171 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ep.stochastic.hybrid_order", "2"); }
#line 5599 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1653:
#line 3172 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("steady.maxit", yystack_[0].value.as < string > ()); }
#line 5605 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1654:
#line 3173 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("simul.maxit", yystack_[0].value.as < string > ()); }
#line 5611 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1655:
#line 3174 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bandpass.indicator", "true"); }
#line 5617 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1656:
#line 3176 "DynareBison.yy" // lalr1.cc:919
    {
                      driver.option_num("bandpass.indicator", "true");
                      driver.option_vec_int("bandpass.passband", yystack_[0].value.as < vector<int> > ());
                    }
#line 5626 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1657:
#line 3181 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dp.maxit", yystack_[0].value.as < string > ()); }
#line 5632 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1658:
#line 3182 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("osr.maxit", yystack_[0].value.as < string > ()); }
#line 5638 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1659:
#line 3183 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("osr.tolf", yystack_[0].value.as < string > ()); }
#line 5644 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1660:
#line 3184 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dynatol.f", yystack_[0].value.as < string > ()); }
#line 5650 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1661:
#line 3185 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dynatol.x", yystack_[0].value.as < string > ()); }
#line 5656 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1662:
#line 3186 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("solve_tolf", yystack_[0].value.as < string > ()); }
#line 5662 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1663:
#line 3187 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 5668 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1664:
#line 3188 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 5674 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1665:
#line 3190 "DynareBison.yy" // lalr1.cc:919
    { driver.cutoff(yystack_[0].value.as < string > ()); }
#line 5680 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1666:
#line 3191 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("markowitz", yystack_[0].value.as < string > ()); }
#line 5686 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1667:
#line 3192 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("minimal_solving_periods", yystack_[0].value.as < string > ()); }
#line 5692 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1668:
#line 3193 "DynareBison.yy" // lalr1.cc:919
    { driver.mfs(yystack_[0].value.as < string > ()); }
#line 5698 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1670:
#line 3195 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("simul_replic", yystack_[0].value.as < string > ()); }
#line 5704 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1671:
#line 3196 "DynareBison.yy" // lalr1.cc:919
    { driver.error("'simul_seed' option is no longer supported; use 'set_dynare_seed' command instead"); }
#line 5710 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1672:
#line 3197 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("qz_criterium", yystack_[0].value.as < string > ()); }
#line 5716 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1673:
#line 3198 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("qz_zero_threshold", yystack_[0].value.as < string > ()); }
#line 5722 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1674:
#line 3199 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("file", yystack_[0].value.as < string > ()); }
#line 5728 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1675:
#line 3200 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("pac.model_name", yystack_[0].value.as < string > ()); }
#line 5734 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1676:
#line 3201 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("pac.aux_model_name", yystack_[0].value.as < string > ()); }
#line 5740 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1677:
#line 3202 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("pac.discount", yystack_[0].value.as < string > ()); }
#line 5746 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1678:
#line 3203 "DynareBison.yy" // lalr1.cc:919
    { driver.begin_pac_growth(); }
#line 5752 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1679:
#line 3203 "DynareBison.yy" // lalr1.cc:919
    { driver.set_pac_growth(yystack_[0].value.as < expr_t > ()); }
#line 5758 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1680:
#line 3204 "DynareBison.yy" // lalr1.cc:919
    { driver.set_pac_steady_state_growth(yystack_[0].value.as < string > ()); }
#line 5764 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1681:
#line 3205 "DynareBison.yy" // lalr1.cc:919
    { driver.set_pac_steady_state_growth(yystack_[0].value.as < string > ()); }
#line 5770 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1682:
#line 3207 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("var.model_name", yystack_[0].value.as < string > ()); }
#line 5776 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1683:
#line 3208 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("var.order", yystack_[0].value.as < string > ()); }
#line 5782 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1684:
#line 3209 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("series", yystack_[0].value.as < string > ()); }
#line 5788 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1685:
#line 3210 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("datafile", yystack_[0].value.as < string > ()); }
#line 5794 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1686:
#line 3211 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("var_estimation.datafile", yystack_[0].value.as < string > ()); }
#line 5800 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1687:
#line 3212 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("var_estimation.model_name", yystack_[0].value.as < string > ()); }
#line 5806 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1688:
#line 3213 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_str("var.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 5812 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1689:
#line 3214 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("dirname", yystack_[0].value.as < string > ()); }
#line 5818 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1690:
#line 3215 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("huge_number", yystack_[0].value.as < string > ()); }
#line 5824 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1691:
#line 3217 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 5830 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1692:
#line 3219 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 5836 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1693:
#line 3221 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("trend_component.name", yystack_[0].value.as < string > ()); }
#line 5842 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1694:
#line 3222 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_str("trend_component.targets", yystack_[0].value.as < vector<string> > ()); }
#line 5848 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1695:
#line 3223 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_str("trend_component.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 5854 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1696:
#line 3225 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 5860 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1697:
#line 3227 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 5866 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1698:
#line 3230 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 5872 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1699:
#line 3232 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 5878 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1700:
#line 3235 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("posterior_sampler_options.posterior_sampling_method", yystack_[0].value.as < string > ()); }
#line 5884 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1701:
#line 3236 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("first_obs", yystack_[0].value.as < string > ()); }
#line 5890 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1702:
#line 3237 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("firstobs", yystack_[0].value.as < string > ()); }
#line 5896 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1703:
#line 3238 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("lastobs", yystack_[0].value.as < string > ()); }
#line 5902 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1704:
#line 3239 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("kalman.keep_kalman_algo_if_singularity_is_detected", "true"); }
#line 5908 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1705:
#line 3240 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nobs", yystack_[0].value.as < string > ()); }
#line 5914 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1706:
#line 3241 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shift", yystack_[0].value.as < string > ()); }
#line 5920 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1707:
#line 3242 "DynareBison.yy" // lalr1.cc:919
    { driver.prior_shape = yystack_[0].value.as < PriorDistributions > (); }
#line 5926 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1708:
#line 3243 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode", yystack_[0].value.as < string > ()); }
#line 5932 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1709:
#line 3244 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mean", yystack_[0].value.as < string > ()); }
#line 5938 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1710:
#line 3245 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mean", yystack_[0].value.as < string > ()); }
#line 5944 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1711:
#line 3246 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("truncate", yystack_[0].value.as < string > ()); }
#line 5950 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1712:
#line 3247 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("stdev", yystack_[0].value.as < string > ()); }
#line 5956 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1713:
#line 3248 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("jscale", yystack_[0].value.as < string > ()); }
#line 5962 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1714:
#line 3249 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("init", yystack_[0].value.as < string > ()); }
#line 5968 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1715:
#line 3250 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bounds", yystack_[0].value.as < string > ()); }
#line 5974 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1716:
#line 3251 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("domain", yystack_[0].value.as < string > ()); }
#line 5980 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1717:
#line 3252 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("interval", yystack_[0].value.as < string > ()); }
#line 5986 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1718:
#line 3253 "DynareBison.yy" // lalr1.cc:919
    { driver.set_prior_variance(yystack_[0].value.as < expr_t > ()); }
#line 5992 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1719:
#line 3254 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("variance",yystack_[0].value.as < string > ()); }
#line 5998 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1720:
#line 3255 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("prefilter", yystack_[0].value.as < string > ()); }
#line 6004 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1721:
#line 3256 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("presample", yystack_[0].value.as < string > ()); }
#line 6010 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1722:
#line 3257 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("lik_algo", yystack_[0].value.as < string > ()); }
#line 6016 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1723:
#line 3258 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("lik_init", yystack_[0].value.as < string > ()); }
#line 6022 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1724:
#line 3260 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nograph", "true"); }
#line 6028 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1725:
#line 3262 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nograph", "false"); }
#line 6034 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1726:
#line 3265 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_graph.posterior", "true"); }
#line 6040 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1727:
#line 3267 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_graph.posterior", "false"); }
#line 6046 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1728:
#line 3269 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_graph.plot_shock_decomposition", "true"); }
#line 6052 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1729:
#line 3270 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_graph.shock_decomposition", "true"); }
#line 6058 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1730:
#line 3271 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.init_state", yystack_[0].value.as < string > ()); }
#line 6064 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1731:
#line 3273 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("shock_decomp.forecast_type", "unconditional"); }
#line 6070 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1732:
#line 3275 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("shock_decomp.forecast_type", "conditional"); }
#line 6076 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1733:
#line 3276 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.presample", yystack_[0].value.as < string > ()); }
#line 6082 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1734:
#line 3277 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.forecast", yystack_[0].value.as < string > ()); }
#line 6088 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1735:
#line 3278 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("shock_decomp.save_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 6094 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1736:
#line 3279 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.fast_realtime", yystack_[0].value.as < string > ()); }
#line 6100 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1737:
#line 3280 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nodisplay", "true"); }
#line 6106 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1738:
#line 3281 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.nodisplay", "true"); }
#line 6112 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1739:
#line 3282 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.nodisplay", "true"); }
#line 6118 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1740:
#line 3283 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.init2shocks", "default"); }
#line 6124 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1741:
#line 3284 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.init2shocks", yystack_[0].value.as < string > ()); }
#line 6130 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1742:
#line 3286 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 6136 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1743:
#line 3287 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 6142 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1744:
#line 3289 "DynareBison.yy" // lalr1.cc:919
    { driver.process_graph_format_option(); }
#line 6148 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1745:
#line 3291 "DynareBison.yy" // lalr1.cc:919
    { driver.process_graph_format_option(); }
#line 6154 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1746:
#line 3294 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomp_process_graph_format_option(); }
#line 6160 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1747:
#line 3296 "DynareBison.yy" // lalr1.cc:919
    { driver.initial_condition_decomp_process_graph_format_option(); }
#line 6166 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1748:
#line 3299 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomp_process_graph_format_option(); }
#line 6172 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1749:
#line 3301 "DynareBison.yy" // lalr1.cc:919
    { driver.plot_shock_decomp_process_graph_format_option(); }
#line 6178 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1750:
#line 3303 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("shock_decomp.with_epilogue", "true"); }
#line 6184 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1751:
#line 3304 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.with_epilogue", "true"); }
#line 6190 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1752:
#line 3306 "DynareBison.yy" // lalr1.cc:919
    { driver.add_graph_format("eps"); }
#line 6196 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1753:
#line 3308 "DynareBison.yy" // lalr1.cc:919
    { driver.add_graph_format("fig"); }
#line 6202 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1754:
#line 3310 "DynareBison.yy" // lalr1.cc:919
    { driver.add_graph_format("pdf"); }
#line 6208 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1755:
#line 3312 "DynareBison.yy" // lalr1.cc:919
    { driver.add_graph_format("none"); }
#line 6214 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1758:
#line 3319 "DynareBison.yy" // lalr1.cc:919
    { driver.set_subsample_name_equal_to_date_range(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 6220 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1759:
#line 3321 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar.conf_sig", yystack_[0].value.as < string > ()); }
#line 6226 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1760:
#line 3322 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("forecasts.conf_sig", yystack_[0].value.as < string > ()); }
#line 6232 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1761:
#line 3323 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("conditional_forecast.conf_sig", yystack_[0].value.as < string > ()); }
#line 6238 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1762:
#line 3324 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_conf_sig", yystack_[0].value.as < string > ()); }
#line 6244 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1763:
#line 3325 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_replic", yystack_[0].value.as < string > ()); }
#line 6250 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1764:
#line 3326 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("posterior_max_subsample_draws", yystack_[0].value.as < string > ()); }
#line 6256 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1765:
#line 3327 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_drop", yystack_[0].value.as < string > ()); }
#line 6262 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1766:
#line 3328 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_jscale", yystack_[0].value.as < string > ()); }
#line 6268 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1767:
#line 3330 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_tune_jscale.target", yystack_[0].value.as < string > ()); driver.option_num("mh_tune_jscale.status", "true");}
#line 6274 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1768:
#line 3331 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("mh_tune_jscale.status", "true");}
#line 6280 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1771:
#line 3334 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("posterior_sampler_options.posterior_sampling_method.proposal_distribution", yystack_[0].value.as < string > ()); }
#line 6286 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1772:
#line 3336 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("estimation.moments_posterior_density.indicator", "false"); }
#line 6292 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1773:
#line 3338 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_init_scale", yystack_[0].value.as < string > ()); }
#line 6298 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1774:
#line 3339 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("mode_file", yystack_[0].value.as < string > ()); }
#line 6304 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1775:
#line 3340 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_compute", yystack_[0].value.as < string > ()); }
#line 6310 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1776:
#line 3341 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("mode_compute", yystack_[0].value.as < string > ()); }
#line 6316 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1777:
#line 3342 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_check.status", "true"); }
#line 6322 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1778:
#line 3343 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_check.neighbourhood_size", yystack_[0].value.as < string > ()); }
#line 6328 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1779:
#line 3344 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_check.number_of_points", yystack_[0].value.as < string > ()); }
#line 6334 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1780:
#line 3345 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mode_check.symmetric_plots", yystack_[0].value.as < string > ()); }
#line 6340 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1781:
#line 3346 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("prior_trunc", yystack_[0].value.as < string > ()); }
#line 6346 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1782:
#line 3347 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_mode", yystack_[0].value.as < string > ()); }
#line 6352 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1783:
#line 3348 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_nblck", yystack_[0].value.as < string > ()); }
#line 6358 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1784:
#line 3349 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_mh_file", "true"); }
#line 6364 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1785:
#line 3350 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_results_after_load_mh", "true"); }
#line 6370 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1786:
#line 3351 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("loglinear", "true"); }
#line 6376 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1787:
#line 3352 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("linear_approximation", "true"); }
#line 6382 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1788:
#line 3353 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("logdata", "true"); }
#line 6388 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1789:
#line 3354 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nodiagnostic", "true"); }
#line 6394 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1790:
#line 3355 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bayesian_irf", "true"); }
#line 6400 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1791:
#line 3357 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dsge_var", yystack_[0].value.as < string > ()); }
#line 6406 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1792:
#line 3359 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dsge_var", "Inf"); }
#line 6412 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1793:
#line 3361 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("dsge_var", "NaN"); }
#line 6418 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1794:
#line 3363 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dsge_varlag", yystack_[0].value.as < string > ()); }
#line 6424 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1795:
#line 3364 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("TeX", "true"); }
#line 6430 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1796:
#line 3365 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("forecast", yystack_[0].value.as < string > ()); }
#line 6436 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1797:
#line 3366 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smoother", "true"); }
#line 6442 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1798:
#line 3367 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("moments_varendo", "true"); }
#line 6448 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1799:
#line 3368 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("contemporaneous_correlation", "true"); }
#line 6454 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1800:
#line 3369 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("filtered_vars", "true"); }
#line 6460 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1801:
#line 3370 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("relative_irf", "true"); }
#line 6466 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1802:
#line 3371 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("fast_kalman_filter", "true"); }
#line 6472 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1803:
#line 3372 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("kalman_algo", yystack_[0].value.as < string > ()); }
#line 6478 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1804:
#line 3373 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("kalman_tol", yystack_[0].value.as < string > ()); }
#line 6484 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1805:
#line 3374 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("diffuse_kalman_tol", yystack_[0].value.as < string > ()); }
#line 6490 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1806:
#line 3376 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("mc_marginal_density", "laplace"); }
#line 6496 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1807:
#line 3378 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("mc_marginal_density", "modifiedharmonicmean"); }
#line 6502 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1808:
#line 3380 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("noprint", "false"); }
#line 6508 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1809:
#line 3381 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("noprint", "true"); }
#line 6514 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1810:
#line 3382 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("xls_sheet", yystack_[0].value.as < string > ()); }
#line 6520 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1811:
#line 3383 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("xls_range", yystack_[0].value.as < string > ()); }
#line 6526 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1812:
#line 3384 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("filter_step_ahead", yystack_[0].value.as < vector<int> > ()); }
#line 6532 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1813:
#line 3385 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("convergence.geweke.taper_steps", yystack_[0].value.as < vector<int> > ()); }
#line 6538 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1814:
#line 3386 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("convergence.geweke.geweke_interval",yystack_[0].value.as < string > ()); }
#line 6544 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1815:
#line 3387 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("convergence.rafterylewis.indicator", "true"); }
#line 6550 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1816:
#line 3388 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("convergence.rafterylewis.qrs",yystack_[0].value.as < string > ()); }
#line 6556 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1817:
#line 3389 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("noconstant", "false"); }
#line 6562 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1818:
#line 3390 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("noconstant", "true"); }
#line 6568 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1819:
#line 3391 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("mh_recover", "true"); }
#line 6574 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1820:
#line 3392 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("diffuse_filter", "true"); }
#line 6580 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1821:
#line 3393 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("plot_priors", yystack_[0].value.as < string > ()); }
#line 6586 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1822:
#line 3394 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("aim_solver", "true"); }
#line 6592 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1823:
#line 3395 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("partial_information", "true"); }
#line 6598 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1824:
#line 3396 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("sub_draws",yystack_[0].value.as < string > ());}
#line 6604 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1825:
#line 3397 "DynareBison.yy" // lalr1.cc:919
    { driver.set_planner_discount(yystack_[0].value.as < expr_t > ()); }
#line 6610 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1826:
#line 3398 "DynareBison.yy" // lalr1.cc:919
    { driver.set_planner_discount_latex_name(yystack_[0].value.as < string > ()); }
#line 6616 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1827:
#line 3399 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("sylvester_fp", "true"); }
#line 6622 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1828:
#line 3400 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("sylvester_fp", "false"); }
#line 6628 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1829:
#line 3401 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("sylvester_fixed_point_tol",yystack_[0].value.as < string > ());}
#line 6634 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1830:
#line 3402 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_fp", "true"); }
#line 6640 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1831:
#line 3403 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_db", "true"); }
#line 6646 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1832:
#line 3404 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_srs", "true"); }
#line 6652 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1833:
#line 3405 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_fp", "false"); driver.option_num("lyapunov_db", "false"); driver.option_num("lyapunov_srs", "false");}
#line 6658 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1834:
#line 3406 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_fixed_point_tol",yystack_[0].value.as < string > ());}
#line 6664 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1835:
#line 3407 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lyapunov_doubling_tol",yystack_[0].value.as < string > ());}
#line 6670 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1836:
#line 3408 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_cycle_reduction", "true"); }
#line 6676 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1837:
#line 3409 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_logarithmic_reduction", "true"); }
#line 6682 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1838:
#line 3410 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_cycle_reduction", "false"); driver.option_num("dr_logarithmic_reduction", "false");}
#line 6688 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1839:
#line 3411 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_cycle_reduction_tol",yystack_[0].value.as < string > ());}
#line 6694 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1840:
#line 3412 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_logarithmic_reduction_tol",yystack_[0].value.as < string > ());}
#line 6700 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1841:
#line 3413 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("dr_logarithmic_reduction_maxiter",yystack_[0].value.as < string > ());}
#line 6706 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1842:
#line 3414 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.detail_plot", "true"); }
#line 6712 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1843:
#line 3415 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.detail_plot", "true"); }
#line 6718 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1844:
#line 3416 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.interactive", "true"); }
#line 6724 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1845:
#line 3417 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.screen_shocks", "true"); }
#line 6730 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1846:
#line 3418 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.steadystate", "true"); }
#line 6736 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1847:
#line 3419 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.steadystate", "true"); }
#line 6742 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1848:
#line 3420 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("initial_condition_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 6748 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1849:
#line 3421 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 6754 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1850:
#line 3423 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.type", "qoq"); }
#line 6760 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1851:
#line 3425 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.type", "yoy"); }
#line 6766 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1852:
#line 3427 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.type", "aoa"); }
#line 6772 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1853:
#line 3430 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("initial_condition_decomp.type", "qoq"); }
#line 6778 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1854:
#line 3432 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("initial_condition_decomp.type", "yoy"); }
#line 6784 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1855:
#line 3434 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("initial_condition_decomp.type", "aoa"); }
#line 6790 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1856:
#line 3436 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("initial_condition_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 6796 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1857:
#line 3437 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("initial_condition_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 6802 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1858:
#line 3438 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("plot_shock_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 6808 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1859:
#line 3439 "DynareBison.yy" // lalr1.cc:919
    { driver.option_date("plot_shock_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 6814 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1860:
#line 3440 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.write_xls", "true"); }
#line 6820 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1861:
#line 3441 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.write_xls", "true"); }
#line 6826 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1862:
#line 3442 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.realtime", yystack_[0].value.as < string > ()); }
#line 6832 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1863:
#line 3443 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.vintage", yystack_[0].value.as < string > ()); }
#line 6838 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1864:
#line 3444 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.diff", "true"); }
#line 6844 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1865:
#line 3445 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.diff", "true"); }
#line 6850 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1866:
#line 3446 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.flip", "true"); }
#line 6856 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1867:
#line 3447 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.flip", "true"); }
#line 6862 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1868:
#line 3448 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_tau", yystack_[0].value.as < string > ()); }
#line 6868 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1869:
#line 3449 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_decay", yystack_[0].value.as < string > ()); }
#line 6874 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1870:
#line 3450 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_lambda", yystack_[0].value.as < string > ()); }
#line 6880 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1871:
#line 3451 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_mu", yystack_[0].value.as < string > ()); }
#line 6886 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1872:
#line 3452 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_omega", yystack_[0].value.as < string > ()); }
#line 6892 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1873:
#line 3453 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_flat", "true"); }
#line 6898 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1874:
#line 3454 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_prior_train", yystack_[0].value.as < string > ()); }
#line 6904 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1875:
#line 3455 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("bvar_replic", yystack_[0].value.as < string > ()); }
#line 6910 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1876:
#line 3456 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.stderr_multiples", "true"); }
#line 6916 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1877:
#line 3457 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.diagonal_only", "true"); }
#line 6922 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1878:
#line 3458 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("particle.number_of_particles", yystack_[0].value.as < string > ()); }
#line 6928 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1880:
#line 3460 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.none", "true"); }
#line 6934 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1881:
#line 3461 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.generic", "true"); }
#line 6940 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1882:
#line 3462 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("particle.resampling.threshold", yystack_[0].value.as < string > ()); }
#line 6946 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1883:
#line 3463 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.method.kitagawa", "true"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 6952 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1884:
#line 3464 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "true"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 6958 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1885:
#line 3465 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.method.stratified", "true"); }
#line 6964 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1886:
#line 3466 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.cpf_weights_method.amisanotristani", "true"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "false"); }
#line 6970 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1887:
#line 3467 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.cpf_weights_method.amisanotristani", "false"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "true"); }
#line 6976 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1888:
#line 3468 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("particle.filter_algorithm", yystack_[0].value.as < string > ()); }
#line 6982 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1889:
#line 3469 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("particle.initialization", yystack_[0].value.as < string > ()); }
#line 6988 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1890:
#line 3470 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.proposal_approximation.cubature", "true"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "false");}
#line 6994 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1891:
#line 3471 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "true"); driver.option_num("particle.proposal_approximation.montecarlo", "false");}
#line 7000 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1892:
#line 3472 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "true");}
#line 7006 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1893:
#line 3473 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.distribution_approximation.cubature", "true"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "false");}
#line 7012 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1894:
#line 3474 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "true"); driver.option_num("particle.distribution_approximation.montecarlo", "false");}
#line 7018 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1895:
#line 3475 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "true");}
#line 7024 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1896:
#line 3478 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("identification", yystack_[0].value.as < string > ()); }
#line 7030 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1897:
#line 3479 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("morris", yystack_[0].value.as < string > ()); }
#line 7036 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1898:
#line 3480 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("stab", yystack_[0].value.as < string > ()); }
#line 7042 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1899:
#line 3481 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("redform", yystack_[0].value.as < string > ()); }
#line 7048 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1900:
#line 3482 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pprior", yystack_[0].value.as < string > ()); }
#line 7054 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1901:
#line 3483 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("prior_range", yystack_[0].value.as < string > ()); }
#line 7060 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1902:
#line 3484 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ppost", yystack_[0].value.as < string > ()); }
#line 7066 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1903:
#line 3485 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ilptau", yystack_[0].value.as < string > ()); }
#line 7072 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1904:
#line 3486 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("morris_nliv", yystack_[0].value.as < string > ()); }
#line 7078 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1905:
#line 3487 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("morris_ntra", yystack_[0].value.as < string > ()); }
#line 7084 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1906:
#line 3488 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("Nsam", yystack_[0].value.as < string > ()); }
#line 7090 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1907:
#line 3489 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_redform", yystack_[0].value.as < string > ()); }
#line 7096 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1908:
#line 3490 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_rmse", yystack_[0].value.as < string > ()); }
#line 7102 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1909:
#line 3491 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_stab", yystack_[0].value.as < string > ()); }
#line 7108 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1910:
#line 3492 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("alpha2_stab", yystack_[0].value.as < string > ()); }
#line 7114 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1911:
#line 3493 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("logtrans_redform", yystack_[0].value.as < string > ()); }
#line 7120 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1912:
#line 3494 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("threshold_redform",yystack_[0].value.as < string > ()); }
#line 7126 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1913:
#line 3495 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ksstat_redform", yystack_[0].value.as < string > ()); }
#line 7132 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1914:
#line 3496 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("alpha2_redform", yystack_[0].value.as < string > ()); }
#line 7138 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1915:
#line 3497 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("namendo"); }
#line 7144 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1916:
#line 3498 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("namlagendo"); }
#line 7150 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1917:
#line 3499 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("namexo"); }
#line 7156 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1918:
#line 3500 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("rmse", yystack_[0].value.as < string > ()); }
#line 7162 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1919:
#line 3501 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("lik_only", yystack_[0].value.as < string > ()); }
#line 7168 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1920:
#line 3502 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("var_rmse"); }
#line 7174 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1921:
#line 3503 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pfilt_rmse", yystack_[0].value.as < string > ()); }
#line 7180 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1922:
#line 3504 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("istart_rmse", yystack_[0].value.as < string > ()); }
#line 7186 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1923:
#line 3505 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("alpha_rmse", yystack_[0].value.as < string > ()); }
#line 7192 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1924:
#line 3506 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("alpha2_rmse", yystack_[0].value.as < string > ()); }
#line 7198 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1925:
#line 3508 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 7204 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1926:
#line 3510 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 7210 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1927:
#line 3512 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("neighborhood_width", yystack_[0].value.as < string > ()); }
#line 7216 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1928:
#line 3513 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pvalue_ks", yystack_[0].value.as < string > ()); }
#line 7222 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1929:
#line 3514 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pvalue_corr", yystack_[0].value.as < string > ()); }
#line 7228 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1930:
#line 3515 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("load_ident_files", yystack_[0].value.as < string > ()); }
#line 7234 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1931:
#line 3516 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("useautocorr", yystack_[0].value.as < string > ()); }
#line 7240 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1932:
#line 3517 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("prior_mc", yystack_[0].value.as < string > ()); }
#line 7246 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1933:
#line 3518 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("advanced", yystack_[0].value.as < string > ()); }
#line 7252 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1934:
#line 3519 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("max_dim_cova_group", yystack_[0].value.as < string > ()); }
#line 7258 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1935:
#line 3521 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("homotopy_mode",yystack_[0].value.as < string > ()); }
#line 7264 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1936:
#line 3522 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("homotopy_steps",yystack_[0].value.as < string > ()); }
#line 7270 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1937:
#line 3523 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("homotopy_force_continue",yystack_[0].value.as < string > ()); }
#line 7276 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1938:
#line 3524 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("steadystate.nocheck","true"); }
#line 7282 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1939:
#line 3526 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("controlled_varexo"); }
#line 7288 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1940:
#line 3528 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "prior_mode"); }
#line 7294 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1941:
#line 3530 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "prior_mean"); }
#line 7300 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1942:
#line 3532 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "posterior_mean"); }
#line 7306 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1943:
#line 3534 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "posterior_mode"); }
#line 7312 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1944:
#line 3536 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "posterior_median"); }
#line 7318 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1945:
#line 3538 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "mle_mode"); }
#line 7324 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1946:
#line 3540 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("parameter_set", "calibration"); }
#line 7330 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1947:
#line 3542 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("nodecomposition", "true"); }
#line 7336 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1948:
#line 3543 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("SpectralDensity.trigger", "true"); }
#line 7342 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1949:
#line 3544 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.drop", yystack_[0].value.as < string > ()); }
#line 7348 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1950:
#line 3545 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.mh_replic", yystack_[0].value.as < string > ()); }
#line 7354 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1951:
#line 3547 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.freq",yystack_[0].value.as < string > ()); }
#line 7360 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1952:
#line 3549 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.freq","12"); }
#line 7366 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1953:
#line 3551 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.freq","4"); }
#line 7372 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1954:
#line 3553 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.initial_year",yystack_[0].value.as < string > ()); }
#line 7378 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1955:
#line 3554 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.initial_subperiod",yystack_[0].value.as < string > ()); }
#line 7384 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1956:
#line 3555 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.final_year",yystack_[0].value.as < string > ()); }
#line 7390 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1957:
#line 3556 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.final_subperiod",yystack_[0].value.as < string > ()); }
#line 7396 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1958:
#line 3557 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.data", yystack_[0].value.as < string > ()); }
#line 7402 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1959:
#line 3558 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.vlist",yystack_[0].value.as < string > ()); }
#line 7408 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1960:
#line 3559 "DynareBison.yy" // lalr1.cc:919
    {driver.option_symbol_list("ms.vlistlog"); }
#line 7414 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1961:
#line 3560 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.vlistper",yystack_[0].value.as < string > ()); }
#line 7420 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1962:
#line 3562 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname",yystack_[0].value.as < string > ());
                      }
#line 7429 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1963:
#line 3567 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname","upper_cholesky");
                      }
#line 7438 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1964:
#line 3572 "DynareBison.yy" // lalr1.cc:919
    {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname","lower_cholesky");
                      }
#line 7447 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1965:
#line 3577 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.nlags",yystack_[0].value.as < string > ()); }
#line 7453 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1966:
#line 3578 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.cross_restrictions","true"); }
#line 7459 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1967:
#line 3579 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.contemp_reduced_form","true"); }
#line 7465 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1968:
#line 3580 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.real_pseudo_forecast",yystack_[0].value.as < string > ()); }
#line 7471 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1969:
#line 3581 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.bayesian_prior","false"); }
#line 7477 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1970:
#line 3582 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.dummy_obs",yystack_[0].value.as < string > ()); }
#line 7483 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1971:
#line 3583 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.nstates",yystack_[0].value.as < string > ()); }
#line 7489 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1972:
#line 3584 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxscalesstates",yystack_[0].value.as < string > ()); }
#line 7495 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1973:
#line 3585 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.alpha",yystack_[0].value.as < string > ()); }
#line 7501 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1974:
#line 3586 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.beta",yystack_[0].value.as < string > ()); }
#line 7507 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1975:
#line 3587 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.gsig2_lmdm",yystack_[0].value.as < string > ()); }
#line 7513 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1976:
#line 3589 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.specification","1"); }
#line 7519 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1977:
#line 3591 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.specification","0"); }
#line 7525 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1978:
#line 3593 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.q_diag",yystack_[0].value.as < string > ()); }
#line 7531 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1979:
#line 3594 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.flat_prior",yystack_[0].value.as < string > ()); }
#line 7537 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1980:
#line 3595 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.ncsk",yystack_[0].value.as < string > ()); }
#line 7543 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1981:
#line 3596 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.nstd",yystack_[0].value.as < string > ()); }
#line 7549 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1982:
#line 3597 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.ninv",yystack_[0].value.as < string > ()); }
#line 7555 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1983:
#line 3598 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxparr",yystack_[0].value.as < string > ()); }
#line 7561 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1984:
#line 3599 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxovr",yystack_[0].value.as < string > ()); }
#line 7567 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1985:
#line 3600 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.aband",yystack_[0].value.as < string > ()); }
#line 7573 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1986:
#line 3601 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxap",yystack_[0].value.as < string > ()); }
#line 7579 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1987:
#line 3602 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.apband",yystack_[0].value.as < string > ()); }
#line 7585 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1988:
#line 3603 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indximf",yystack_[0].value.as < string > ()); }
#line 7591 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1989:
#line 3604 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxfore",yystack_[0].value.as < string > ()); }
#line 7597 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1990:
#line 3605 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.foreband",yystack_[0].value.as < string > ()); }
#line 7603 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1991:
#line 3606 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxgforehat",yystack_[0].value.as < string > ()); }
#line 7609 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1992:
#line 3607 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxgimfhat",yystack_[0].value.as < string > ()); }
#line 7615 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1993:
#line 3608 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxestima",yystack_[0].value.as < string > ()); }
#line 7621 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1994:
#line 3609 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.indxgdls",yystack_[0].value.as < string > ()); }
#line 7627 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1995:
#line 3610 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.eq_ms",yystack_[0].value.as < string > ()); }
#line 7633 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1996:
#line 3611 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.cms",yystack_[0].value.as < string > ()); }
#line 7639 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1997:
#line 3612 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.ncms",yystack_[0].value.as < string > ()); }
#line 7645 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1998:
#line 3613 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.eq_cms",yystack_[0].value.as < string > ()); }
#line 7651 "DynareBison.cc" // lalr1.cc:919
    break;

  case 1999:
#line 3614 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.tlindx",yystack_[0].value.as < string > ()); }
#line 7657 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2000:
#line 3615 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.tlnumber",yystack_[0].value.as < string > ()); }
#line 7663 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2001:
#line 3616 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("ms.cnum",yystack_[0].value.as < string > ()); }
#line 7669 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2002:
#line 3617 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("k_order_solver","true"); }
#line 7675 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2003:
#line 3618 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("pruning", "true"); }
#line 7681 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2004:
#line 3619 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.chain",yystack_[0].value.as < string > ()); }
#line 7687 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2005:
#line 3621 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.restrictions",yystack_[0].value.as < string > ()); }
#line 7693 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2006:
#line 3624 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.duration",yystack_[0].value.as < string > ()); }
#line 7699 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2007:
#line 3626 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.duration",yystack_[0].value.as < string > ()); }
#line 7705 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2008:
#line 3628 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_regimes",yystack_[0].value.as < string > ()); }
#line 7711 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2009:
#line 3629 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_lags",yystack_[0].value.as < string > ()); }
#line 7717 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2010:
#line 3630 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("ms.parameters"); }
#line 7723 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2011:
#line 3631 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.coefficients","svar_coefficients"); }
#line 7729 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2012:
#line 3632 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.variances","svar_variances"); }
#line 7735 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2013:
#line 3634 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("ms.equations",yystack_[0].value.as < vector<int> > ()); }
#line 7741 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2014:
#line 3636 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("ms.equations",yystack_[0].value.as < vector<int> > ()); }
#line 7747 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2015:
#line 3638 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("silent_optimizer", "true"); }
#line 7753 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2016:
#line 3639 "DynareBison.yy" // lalr1.cc:919
    {driver.option_symbol_list("instruments"); }
#line 7759 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2017:
#line 3641 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("name", yystack_[0].value.as < string > ()); }
#line 7765 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2018:
#line 3642 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("nargs",yystack_[0].value.as < string > ()); }
#line 7771 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2019:
#line 3644 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("first_deriv_provided", yystack_[0].value.as < string > ()); }
#line 7777 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2020:
#line 3646 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("first_deriv_provided", ""); }
#line 7783 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2021:
#line 3649 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("second_deriv_provided", yystack_[0].value.as < string > ()); }
#line 7789 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2022:
#line 3651 "DynareBison.yy" // lalr1.cc:919
    { driver.external_function_option("second_deriv_provided", ""); }
#line 7795 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2023:
#line 3654 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("filter_covariance","true");}
#line 7801 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2024:
#line 3657 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("filter_decomposition","true");}
#line 7807 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2025:
#line 3660 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smoothed_state_uncertainty","true");}
#line 7813 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2026:
#line 3663 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("selected_variables_only","true");}
#line 7819 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2027:
#line 3666 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("cova_compute",yystack_[0].value.as < string > ());}
#line 7825 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2028:
#line 3668 "DynareBison.yy" // lalr1.cc:919
    {driver.option_str("ms.output_file_tag", yystack_[0].value.as < string > ()); }
#line 7831 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2029:
#line 3669 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.file_tag", yystack_[0].value.as < string > ()); }
#line 7837 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2030:
#line 3670 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.create_init", "false"); }
#line 7843 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2031:
#line 3671 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("ms.simulation_file_tag", yystack_[0].value.as < string > ()); }
#line 7849 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2032:
#line 3673 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.coefficients_prior_hyperparameters",yystack_[0].value.as < string > ()); }
#line 7855 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2033:
#line 3675 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.convergence_starting_value",yystack_[0].value.as < string > ()); }
#line 7861 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2034:
#line 3677 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.convergence_ending_value",yystack_[0].value.as < string > ()); }
#line 7867 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2035:
#line 3679 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.convergence_increment_value",yystack_[0].value.as < string > ()); }
#line 7873 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2036:
#line 3681 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_iterations_starting_value",yystack_[0].value.as < string > ()); }
#line 7879 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2037:
#line 3683 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_iterations_increment_value",yystack_[0].value.as < string > ()); }
#line 7885 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2038:
#line 3685 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_block_iterations",yystack_[0].value.as < string > ()); }
#line 7891 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2039:
#line 3687 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_repeated_optimization_runs",yystack_[0].value.as < string > ()); }
#line 7897 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2040:
#line 3689 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.function_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 7903 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2041:
#line 3691 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.parameter_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 7909 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2042:
#line 3693 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_large_perturbations",yystack_[0].value.as < string > ()); }
#line 7915 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2043:
#line 3695 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_small_perturbations",yystack_[0].value.as < string > ()); }
#line 7921 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2044:
#line 3697 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.number_of_posterior_draws_after_perturbation",yystack_[0].value.as < string > ()); }
#line 7927 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2045:
#line 3699 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.max_number_of_stages",yystack_[0].value.as < string > ()); }
#line 7933 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2046:
#line 3701 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.random_function_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 7939 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2047:
#line 3703 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.random_parameter_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 7945 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2048:
#line 3704 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.thinning_factor",yystack_[0].value.as < string > ()); }
#line 7951 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2049:
#line 3705 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.adaptive_mh_draws",yystack_[0].value.as < string > ()); }
#line 7957 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2050:
#line 3706 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.save_draws","true"); }
#line 7963 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2051:
#line 3707 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.proposal_draws",yystack_[0].value.as < string > ()); }
#line 7969 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2052:
#line 3708 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.use_mean_center","true"); }
#line 7975 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2053:
#line 3709 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.proposal_type",yystack_[0].value.as < string > ()); }
#line 7981 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2054:
#line 3710 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.proposal_lower_bound",yystack_[0].value.as < string > ()); }
#line 7987 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2055:
#line 3711 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.proposal_upper_bound",yystack_[0].value.as < string > ()); }
#line 7993 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2056:
#line 3712 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.parameter_uncertainty","true"); }
#line 7999 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2057:
#line 3713 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.horizon",yystack_[0].value.as < string > ()); }
#line 8005 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2058:
#line 3714 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.filtered_probabilities","true"); }
#line 8011 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2059:
#line 3715 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.real_time_smoothed_probabilities","true"); }
#line 8017 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2060:
#line 3716 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.error_bands","false"); }
#line 8023 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2061:
#line 3717 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.percentiles",yystack_[0].value.as < string > ()); }
#line 8029 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2062:
#line 3718 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.shock_draws",yystack_[0].value.as < string > ()); }
#line 8035 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2063:
#line 3719 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.shocks_per_parameter",yystack_[0].value.as < string > ()); }
#line 8041 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2064:
#line 3720 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.free_parameters",yystack_[0].value.as < string > ()); }
#line 8047 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2065:
#line 3721 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.median","1"); }
#line 8053 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2066:
#line 3722 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("median", yystack_[0].value.as < string > ()); }
#line 8059 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2067:
#line 3723 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.regimes","true"); }
#line 8065 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2068:
#line 3724 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.regime",yystack_[0].value.as < string > ()); }
#line 8071 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2069:
#line 3725 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("ms.forecast_data_obs",yystack_[0].value.as < string > ()); }
#line 8077 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2070:
#line 3726 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("discretionary_tol",yystack_[0].value.as < string > ()); }
#line 8083 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2071:
#line 3727 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("analytic_derivation", "1"); }
#line 8089 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2072:
#line 3728 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("analytic_derivation_mode", yystack_[0].value.as < string > ()); }
#line 8095 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2073:
#line 3729 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("endogenous_prior", "true"); }
#line 8101 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2074:
#line 3730 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("use_univariate_filters_if_singularity_is_detected", yystack_[0].value.as < string > ()); }
#line 8107 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2075:
#line 3732 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8113 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2076:
#line 3733 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8119 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2077:
#line 3735 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8125 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2078:
#line 3737 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8131 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2079:
#line 3739 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("rescale_prediction_error_covariance", "true"); }
#line 8137 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2080:
#line 3740 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("hessian.use_penalized_objective","true"); }
#line 8143 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2081:
#line 3741 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("impulse_responses.plot_threshold", yystack_[0].value.as < string > ()); }
#line 8149 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2082:
#line 3742 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("dr_display_tol", yystack_[0].value.as < string > ()); }
#line 8155 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2083:
#line 3743 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("endo_vars_for_moment_computations_in_estimation", "all_endogenous_variables"); }
#line 8161 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2084:
#line 3744 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("endo_vars_for_moment_computations_in_estimation", "only_observed_variables"); }
#line 8167 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2085:
#line 3745 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_homotopy", "true"); }
#line 8173 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2086:
#line 3747 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("infile", yystack_[0].value.as < string > ()); }
#line 8179 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2087:
#line 3748 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("invars"); }
#line 8185 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2088:
#line 3749 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("period", yystack_[0].value.as < string > ()); }
#line 8191 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2089:
#line 3750 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("outfile", yystack_[0].value.as < string > ()); }
#line 8197 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2090:
#line 3751 "DynareBison.yy" // lalr1.cc:919
    { driver.option_symbol_list("outvars"); }
#line 8203 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2091:
#line 3752 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("lmmcp.status", "true"); }
#line 8209 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2092:
#line 3753 "DynareBison.yy" // lalr1.cc:919
    {driver.option_num("occbin", "true"); }
#line 8215 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2093:
#line 3754 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("function", yystack_[0].value.as < string > ()); }
#line 8221 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2094:
#line 3755 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("sampling_draws",yystack_[0].value.as < string > ()); }
#line 8227 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2095:
#line 3756 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.use_shock_groups","default"); }
#line 8233 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2096:
#line 3757 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("plot_shock_decomp.use_shock_groups", yystack_[0].value.as < string > ()); }
#line 8239 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2097:
#line 3759 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("plot_shock_decomp.colormap",yystack_[0].value.as < string > ()); }
#line 8245 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2098:
#line 3760 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("initial_condition_decomp.colormap",yystack_[0].value.as < string > ()); }
#line 8251 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2099:
#line 3762 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.order", yystack_[0].value.as < string > ()); }
#line 8257 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2100:
#line 3763 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.order", yystack_[0].value.as < string > ()); }
#line 8263 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2101:
#line 3764 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.centered_moments", "true"); }
#line 8269 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2102:
#line 3765 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.centered_moments", "true"); }
#line 8275 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2103:
#line 3767 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("gmm.autolag", yystack_[0].value.as < vector<int> > ()); }
#line 8281 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2104:
#line 3769 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("gmm.autolag", yystack_[0].value.as < vector<int> > ()); }
#line 8287 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2105:
#line 3772 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("smm.autolag", yystack_[0].value.as < vector<int> > ()); }
#line 8293 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2106:
#line 3774 "DynareBison.yy" // lalr1.cc:919
    { driver.option_vec_int("smm.autolag", yystack_[0].value.as < vector<int> > ()); }
#line 8299 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2107:
#line 3776 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.recursive_estimation", "true"); }
#line 8305 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2108:
#line 3777 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.recursive_estimation", "true"); }
#line 8311 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2109:
#line 3778 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.qLag", yystack_[0].value.as < string > ()); }
#line 8317 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2110:
#line 3779 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.qLag", yystack_[0].value.as < string > ()); }
#line 8323 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2111:
#line 3781 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gmm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8329 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2112:
#line 3783 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gmm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8335 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2113:
#line 3785 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gmm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8341 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2114:
#line 3787 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("gmm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8347 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2115:
#line 3790 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("smm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8353 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2116:
#line 3792 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("smm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8359 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2117:
#line 3794 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("smm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8365 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2118:
#line 3796 "DynareBison.yy" // lalr1.cc:919
    { driver.option_str("smm.weighting_matrix", yystack_[0].value.as < string > ()); }
#line 8371 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2119:
#line 3798 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.penalized_estimator", "true"); }
#line 8377 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2120:
#line 3799 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.penalized_estimator", "true"); }
#line 8383 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2121:
#line 3800 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("gmm.verbose", "true"); }
#line 8389 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2122:
#line 3801 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.verbose", "true"); }
#line 8395 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2123:
#line 3803 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.simulation_multiple", yystack_[0].value.as < string > ()); }
#line 8401 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2124:
#line 3804 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.drop", yystack_[0].value.as < string > ()); }
#line 8407 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2125:
#line 3805 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.seed", yystack_[0].value.as < string > ()); }
#line 8413 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2126:
#line 3806 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("smm.bounded_support", "true"); }
#line 8419 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2127:
#line 3808 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.analytical_GIRF", "true"); }
#line 8425 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2128:
#line 3809 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.percent", "true"); }
#line 8431 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2129:
#line 3810 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.ergodic_mean_irf", "true"); }
#line 8437 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2130:
#line 3811 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.EM.drop", yystack_[0].value.as < string > ()); }
#line 8443 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2131:
#line 3812 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.EM.tolf", yystack_[0].value.as < string > ()); }
#line 8449 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2132:
#line 3813 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("irf_opt.EM.iter", yystack_[0].value.as < string > ()); }
#line 8455 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2133:
#line 3816 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_strength", "true"); }
#line 8461 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2134:
#line 3817 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_reducedform", "true"); }
#line 8467 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2135:
#line 3818 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_moments", "true"); }
#line 8473 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2136:
#line 3819 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_minimal", "true"); }
#line 8479 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2137:
#line 3820 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("no_identification_spectrum", "true"); }
#line 8485 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2138:
#line 3821 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("normalize_jacobians", yystack_[0].value.as < string > ()); }
#line 8491 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2139:
#line 3822 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("grid_nbr", yystack_[0].value.as < string > ()); }
#line 8497 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2140:
#line 3823 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("tol_rank", yystack_[0].value.as < string > ()); }
#line 8503 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2141:
#line 3824 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("tol_deriv", yystack_[0].value.as < string > ()); }
#line 8509 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2142:
#line 3825 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("tol_sv", yystack_[0].value.as < string > ()); }
#line 8515 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2143:
#line 3826 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("checks_via_subsets", yystack_[0].value.as < string > ()); }
#line 8521 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2144:
#line 3827 "DynareBison.yy" // lalr1.cc:919
    { driver.option_num("max_dim_subsets_groups", yystack_[0].value.as < string > ()); }
#line 8527 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2145:
#line 3830 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 8533 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2146:
#line 3833 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 8539 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2147:
#line 3836 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), yystack_[0].value.as < string > () }; }
#line 8545 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2148:
#line 3838 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), "Inf" }; }
#line 8551 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2149:
#line 3842 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 8557 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2150:
#line 3844 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = "-(" + yystack_[3].value.as < string > () + ':' + yystack_[1].value.as < string > () + ")"; }
#line 8563 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2151:
#line 3847 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = vector<int>{stoi(yystack_[0].value.as < string > ())}; }
#line 8569 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2152:
#line 3850 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > (); }
#line 8575 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2153:
#line 3852 "DynareBison.yy" // lalr1.cc:919
    {
                 yylhs.value.as < vector<int> > () = vector<int>{};
                 for (int i = stoi(yystack_[2].value.as < string > ()); i <= stoi(yystack_[0].value.as < string > ()); i++)
                   yylhs.value.as < vector<int> > ().push_back(i);
               }
#line 8585 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2154:
#line 3860 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > ();}
#line 8591 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2155:
#line 3862 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > ();}
#line 8597 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2156:
#line 3864 "DynareBison.yy" // lalr1.cc:919
    {
              yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 8606 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2157:
#line 3869 "DynareBison.yy" // lalr1.cc:919
    {
              yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 8615 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2158:
#line 3875 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > (); }
#line 8621 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2159:
#line 3876 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > (); }
#line 8627 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2160:
#line 3880 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = vector<string>{yystack_[0].value.as < string > ()}; }
#line 8633 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2161:
#line 3882 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = vector<string>{yystack_[0].value.as < string > ()}; }
#line 8639 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2162:
#line 3884 "DynareBison.yy" // lalr1.cc:919
    {
              yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 8648 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2163:
#line 3889 "DynareBison.yy" // lalr1.cc:919
    {
              yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 8657 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2164:
#line 3895 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > (); }
#line 8663 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2165:
#line 3896 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > (); }
#line 8669 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2166:
#line 3900 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = '[' + yystack_[0].value.as < string > (); }
#line 8675 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2167:
#line 3902 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = '[' + yystack_[0].value.as < string > (); }
#line 8681 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2168:
#line 3904 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ' ' + yystack_[0].value.as < string > (); }
#line 8687 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2169:
#line 3906 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ' ' + yystack_[0].value.as < string > (); }
#line 8693 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2170:
#line 3910 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ']'; }
#line 8699 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2171:
#line 3912 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ']'; }
#line 8705 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2172:
#line 3916 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 8711 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2173:
#line 3917 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8717 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2174:
#line 3921 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > (); }
#line 8723 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2175:
#line 3922 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8729 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2176:
#line 3926 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = '[' + yystack_[0].value.as < string > (); }
#line 8735 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2177:
#line 3928 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ' ' + yystack_[0].value.as < string > (); }
#line 8741 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2178:
#line 3932 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ']'; }
#line 8747 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2179:
#line 3934 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8753 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2180:
#line 3935 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8759 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2181:
#line 3936 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8765 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2182:
#line 3937 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8771 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2183:
#line 3938 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8777 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2184:
#line 3939 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8783 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2185:
#line 3940 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8789 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2186:
#line 3941 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8795 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2187:
#line 3942 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8801 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2188:
#line 3943 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8807 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2189:
#line 3944 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8813 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2190:
#line 3945 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8819 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2191:
#line 3946 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8825 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2192:
#line 3947 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8831 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2193:
#line 3948 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8837 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2194:
#line 3949 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8843 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2195:
#line 3950 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8849 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2196:
#line 3951 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8855 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2197:
#line 3952 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8861 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2198:
#line 3953 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8867 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2199:
#line 3957 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8873 "DynareBison.cc" // lalr1.cc:919
    break;

  case 2200:
#line 3958 "DynareBison.yy" // lalr1.cc:919
    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 8879 "DynareBison.cc" // lalr1.cc:919
    break;


#line 8883 "DynareBison.cc" // lalr1.cc:919
            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short parser::yypact_ninf_ = -3405;

  const short parser::yytable_ninf_ = -2199;

  const short
  parser::yypact_[] =
  {
    6513,   261,   274, 10869,  -100,    75,   -69,   -42,   -27, 10915,
     496,   -10,    14,   513, 11013,    35,    37,   609,   767,    28,
      68,    56, 11126,   111,   807,   114,   160,   844,   861,   130,
    1022,   151,   206,  1056, 11208,  1059,  1068,   213,   266, -3405,
    1072,   296,   303, 11228, 12890, 12890,   462, -3405, 11445,  1074,
    1077, 12890,   309,  1081, 11247,  1092,   661,  1096,  1102,   305,
    1105, 11271, 11300,  1109, 11319,   308, 11338,   334, 12890, 11531,
   12890, 12890, -3405, -3405, 12890,   321, 11357, 12890,  1114,  1116,
    1121,   428,   434,   463,   499,   504,  1123,   510,  1127, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,   518,  1142,
     520, 11421,  1146,  1148,  1157,  1163,  1166,  1174, -3405,   522,
     454,   542,   507,   545,   568,   593,   619,   628, 11620,   382,
    6013, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405,   325, -3405, -3405,  1104,
   -3405, -3405,  1155, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,   152,   641,
    2936,   651,  3345, -3405,  2618,  2749, -3405,   318, -3405,  1912,
    1395,   934, 12890, -3405,   426,  3311,   316, 12941, 12941, 12890,
    1283, -3405,  7016,  3624,  9253,  6926,  8718,  1309, -3405,  1453,
    1236, 12890,  1404, -3405,  1565,  3827, 12890, 12890,  1292,  1284,
   12890, -3405,   611, 12890,  1334,  1297, 12890,  1095, 12941,  1226,
   -3405,  2979, -3405,  1204,   789,  1141, -3405, -3405, -3405,  1048,
    1171, -3405, 12890,   512,  1564, 12890, 12890, -3405,  5378,  4008,
    4108,  4154,   127,  1305,   805,  9627,  1181,  4282, -3405,   517,
   -3405,  7369,  4457, 12941,   487,  1197, -3405,  1652,  4565, 12988,
    1240,   870, -3405, 12199, -3405,  1536, -3405, -3405,  1554, -3405,
    5478,  4782, -3405,  2423,  4860, -3405,   417, -3405,  7671,  5417,
    1252, -3405,  7317,  5465, -3405,  5495,   250,  5825,   129,  5964,
     189,  6033,   323, 12890, 12890,  6429, -3405,  1198, -3405,   612,
    6473,  6662,  1170, -3405,  1316, -3405,  1333, -3405,  1359, -3405,
     273, -3405,   312,  6329, -3405,  9183,  1206, 12890,  1353, 12890,
   -3405,  9939,  1079, -3405,  2510,  7344, -3405,  3435, -3405, 10141,
   -3405,   704, -3405,  2122, -3405,    87, -3405,  2994,   967,  1161,
   -3405,   903, -3405,  1080,   122,   122,  4840,  7464, -3405,  7370,
    1154, -3405, -3405,  4802, 12890, 10408, 10427, 10146, 10778, -3405,
    1593, -3405,  1602,  1613,  1615,  1617,  1635, -3405,  1653,  1658,
    1660, -3405,  1667,  1672,  1680,  1685, -3405,  1722,  1131, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405,  1708,  1713,  1717, -3405,
    1743,  1153, -3405, -3405, -3405,  1734, -3405,  1762, -3405, -3405,
    1766, -3405, -3405,  1180,  1765, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, 12890, -3405,
   -3405, -3405, -3405, -3405, -3405,  1193, -3405,  1772,  1777,  1780,
    1792,  1796,  1798,  1809,  1811, -3405,   118, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405,  1813,  1815,  1818,
    1826,   165, -3405, -3405, -3405, -3405, -3405, -3405, 12890,   480,
   -3405,  1848,  1836, -3405, -3405, -3405,  1850, -3405,  1851,  1852,
    1855, -3405,  1856, -3405,  1857, -3405,  1285,  1881, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  1291, -3405,  1290,  1296, 10194, -3405,  1873,
    1299, -3405, -3405,  1876,  1882, -3405, -3405, -3405,  1883,  1884,
    1888, -3405, -3405,  1892,  1895,  1898, -3405,  1902,  1904, -3405,
   -3405,  1905,  1913,  1918,  1923,  1928, -3405,  1930,  1934,  1936,
    1938, -3405, -3405, -3405,  1940,  1941,  1942,  1943,  1944,  1947,
    1948,  1949,  1951,  1954,  1958, -3405,  1965, -3405,  1967,  1968,
    1970,  1971,  1972, -3405, -3405,  1979,  1981,  1982,  1984, -3405,
    1986,  1988,  1990,  1997,  1998,  1999,  2000,  2004,  2005,  2006,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  2007,
    2008, -3405,  2011, -3405,  2012,  2018,  2022, -3405, -3405,  2023,
    2028, -3405,  2030,  2035, -3405,  2040, -3405,  2041, -3405, -3405,
   -3405,  2042,  2043,  2045,   169, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, 12890, -3405, 12890,  4485,
   -3405,   177, -3405, 12890, 12890,  9436, -3405,  2068, 12890, 12890,
    9725, -3405,  2069,  1484, -3405,  2066,  2070, -3405, -3405,  1497,
    2102, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,   143,
   10241, -3405,  2104,  2131,  2133,  2134,  2138,  2140,   174, -3405,
     192, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  1567, 10499,
   -3405,  1569,  1570,  2147, 10520, -3405,  2168,  2149,  2150,  2152,
    2158,  2159,  2162,  2165,  2172, -3405, -3405, -3405, -3405, -3405,
    2174,  2176,  2177,  2181,  2183,  2185,  2189,  1616,  2215, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, 10543,  1626,  2202, 10587, -3405,   187,  1630,
    1631,  2207,  9303,  2208, -3405, -3405,  2212,  2214, -3405, -3405,
    2216, -3405,  2217, -3405, -3405,   237, -3405, -3405, -3405,  2218,
    1651,   509, 12941, -3405,  1655,   244, -3405, 12890, -3405,   525,
    1657, 10638, -3405,  2247,  1661,  2251,   514, -3405,  1664,  2262,
   -3405, -3405, 10684, -3405,  1671, 10714,  2933,  2246,  2250,  2253,
    2254, -3405,  2255,  2259,  2265,  2266,  2267, -3405, -3405, -3405,
   -3405, -3405, -3405,  2269,  2271, -3405,  2272,  2274, -3405,   246,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, 12890,
   -3405,   439,  1677, 10330,   722, -3405,  1689, -3405, -3405, -3405,
    1701,  1702,  1703,  1711,  1712,  1714,  9627,  9627,  1715,  1716,
    1718,  1720,  1721,  1725,  1726,  1728,  1729,  1733,  1735,  1736,
    1739,  1742,  1748,  1752,  1754,  1756,  1759,  9627,  3290, -3405,
     -38,   866,  2296, -3405,   259, -3405, -3405, -3405,  2317,  2329,
   -3405,  2336,  2337, -3405, -3405,  2339, -3405,   275, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405,  1688, 12890, 12890,   483, -3405,
   -3405,  1767,  2345,  2346, -3405,  2350,  2351, -3405,  1781,  2372,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405,  2355,  7772, -3405,  2357,  2359,   386, -3405, -3405,   283,
   -3405,  2360,  2362,  2366,  2368,  2373,  1797,  2387, -3405, -3405,
   -3405, -3405, -3405,  4888,   284, -3405,  2379,  2380, -3405,   295,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  2381,  2382,
    2386,  2388,  1812,  2410, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405,  2391,  2392,  2394,
     298, -3405, -3405, -3405, -3405, -3405,   302, -3405, -3405, -3405,
   -3405,  1307,   556, -3405,  2395,  2396,   307, -3405, -3405, -3405,
   -3405, -3405, -3405,  2397,  2399, 12890, -3405,   500,  1677, -3405,
   12890, -3405,   624,  1677, -3405, 12890, -3405,   635,  1677, -3405,
    7411, -3405,  7558, -3405, 12890, -3405, -3405,  2400,  2402,  2403,
    2404,  2405,  2406,   317, -3405,  2408, -3405, -3405, -3405, -3405,
   -3405,  2409,  2412,  2414, -3405,  2415,  2416,  2418, -3405, -3405,
   -3405,  2420,  2422,  1835,  2443, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, 12890, -3405,  2148, -3405,
    1853,  1854,  1858,  2425,  2434,  2436,   331, -3405, -3405, -3405,
   -3405,   839,  2438,  2439,  2440,   333, -3405, -3405, -3405, -3405,
    2442,   337, -3405, -3405, -3405, -3405,  2444,  2445,  2446,  2450,
    2454,  2456,  2459,  2461,  2462,  2463,  2464,  2467,  2472,  2474,
    2475,  2478,  2482,  2485,  2486,  2487,  2491,  2493,  2494,  2495,
    2497,  2501,  2503,  2505,  2507,  2508,  2509,  1935,  2533, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405,  2514,  2516,  2517,  2518,  2519,   343, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, 10756, -3405, 10381,  2521,  1953,
    2522,  2523,  2524,  2529,  2532,  2536,  2538,  2539,  2541,  2545,
   -3405,  2547, -3405,  2548,  2551,  2554,  2562, -3405,  2563,  2570,
    2574,  2577,  2578,  2586,  2592,  2596,  2597,  2599,  2614,  2623,
    2624,  2626,  2627,  2631,  2632,  2634,  2640,  2641,  2642,  2644,
    2645,  2646,  2647,  2648,  2650,  2651,  2553,  2077, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405,  2653, -3405, -3405,  2654,
    2656,  2657,  2659,  2661,  2662,  2663,  2665,  2666,  2667, -3405,
    2670,  2576,  2098, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  2694,
    2100, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405,  2676, -3405,  2677,  2678,  2690,
    2693,  2696,  2698,  2699,  2703,  2706,  2708,  2709,  2710,  2712,
    2713,  2714,  2735,  2119, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  2717,
    2718, -3405,  2719,  2741,  2151, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405,  2722,  2723,  2725,  2727, -3405,  2748,  2155, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  2752,  2160,
   -3405, -3405, -3405, -3405,  2733,  2754,  2163, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405,   188,  2737,  2740,  2744,  2745,  2746,  2747,   373, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405,  2325, -3405, -3405,  2751,
     375, -3405, -3405, -3405, -3405, -3405,  2757,  2759,  2761,  2763,
     381, -3405, -3405, -3405, -3405, -3405,  2773,  2776,   388, -3405,
   -3405, -3405,   391,  2782,  2783, -3405,  2784, -3405,  2785,  2786,
   -3405, -3405,  2789,  2790, -3405, -3405,  2166,  2768, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405,  2793, -3405,  2795, -3405,
    2796,  2798, -3405, -3405, -3405,  2179,  2772, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405,  2182,  2223,  2227,
    2221,   392, -3405,  2802,  2240,  2242,  2244,  2239,  2248,  2249,
    2252,  2241, -3405,  2256,  2257,  2260,  2261, -3405, 10146, 10146,
    2268,  2270,  2283,  2285,  2286,  2287,  2289,  2290,  2292,  2293,
    2294,  2297,  2299,  2310,  2315, 10146,  3834, -3405,    23, -3405,
   -3405,  2316,   220,  2282,   509,  1015,   509,  2758,  1015,  2760,
   12941,  2762,   166,  2767,  2770, 12890, 12890,  2936,  2771,  2774,
     509,  2775,  3345,  2777,  2323,   509,   461, 11640,  2618, -3405,
   12890,  2779,  2804,  2825,   509,   509,  2834,   509,  2835,  1912,
    2333,   509,  2334,  2841,  2849,  1395,  2344,  2352,  2353, -3405,
   12890, 12941,   884,   675,  1236,  1236, 12890,  2852, 11678,   426,
   -3405, 11705, 11724,  2358, -3405, 10146,  2361,  2857,  2604,   509,
   12890,   509,   509,   509,  2858, 12941,   166,   830,   166,  2862,
    2363,   509,  2864,   509,  2866,  2870,   530,   509,   509,   509,
     509,   509,   509,   509,  2872,  2873,  2874,  2875,   930,  2878,
    2880, 12424, 12941,  2881,  2323,  2376,  2376, 12681,  2887,   406,
     509,  1152,  1599,  2889, 12890,  1214,  1325,  2383,  2893,  2894,
     509,   505,  2895,  1745,   509,  2896,   659,  2393,  2899,  2900,
     509,  2905,  7016, 11743,  2859, -3405,  2401, -3405,   647, -3405,
    2992,  2993,  2407, -3405, 10146,  2997,  2998,  2411, -3405, 10146,
    2413,  2915,  2919,  2417,  1453,  2921,  2419,  2424, -3405, 10146,
    2764,  2778,  2791,  2799,  2800,  1404,  2427,  1565, 11762,  2421,
    2429, -3405,   340,  2441, 12941,  2449, -3405, 10146,  1015,  2922,
    2927,   340,  2929,  2930,  8181,  2932,  2941,  2949,   509,   509,
     509,  2960,  2961,  2455,   611,  2457,  2458, 12941,  2460, -3405,
   12890,  2966,  2465,  2466, -3405,  2871, 12890,  9044, -3405,  1120,
   -3405,   509,   509,  2479,  2969,  2483,  2979,  2496,   402, 12941,
    2477,  2484,   509, -3405,  2511,  2513,  2515, -3405,  2520,  2525,
   -3405, 12890, -3405, 12890,  2526, -3405,  2527,  1564,  2528, -3405,
   10146,  2530,  3568, 12890,  3861,   509,  2970,  2995, 12219,   509,
    3002,  3021,   509,  3023,   509,  3025,  3026,  3028,  5378, 11793,
     637,  1677, -3405, -3405, 12890, -3405,  3060, 10823, -3405, -3405,
   -3405,  9627,  9627,  9627,  9627, 12890, 12890,  2801,  2801,  9627,
    9627,  9627,  9627,  9627,  9627,  9627,  9627,  9627,  9627,  9627,
    9627,  9627,  9627,  9627,  9627,  9627,  9627,   340,  3598,  9627,
    9627,  9627,  9627,  9627,  9627,  9627,  9627,  9627,  9627,  9627,
    2552, 12890,  2535, -3405, -3405, -3405,  3029,   517,  2558,   509,
     509,  3031,   509,  3038,  7369,  2559,  2560,  3125,   170,  2564,
   -3405,  2565,  1503,  3040, 12890, 12890, 11813,  1652, 12890,  2566,
   -3405, 12890, 12890,   509,   509, 10146,   346,   503, -3405, -3405,
   12199,  2567, 12941,  2537, 12941,  2555,  3061,  2568,  1536, 12890,
    4585, -3405,  3126,  1554,  2569,   509,  2323,  5478, 11851,  3069,
    3070,  3077,  2323, 11935,  2423,  2573, 10146,  2891,   417,  2598,
    7671, 12024, 10146, 10146, 10146, 10146,  2600, -3405,  3104,   509,
    7317, 12070, -3405, -3405,   643,  1677, -3405, -3405,   683,  1677,
   -3405, -3405,   732,  1677, -3405, -3405, 12890, -3405, -3405, 12890,
   -3405, -3405, -3405, -3405, 12890, 10146, 12890, 12890,  3106,  1198,
    2601, 12941,  1298,  3110,  3111,  1097,  1236,  1236, 12890,  3112,
   12108,   612,  2903, -3405,  2607,  2609,  2610, 12890,  3118,  2630,
     273, 12127,  3190,  3231,  3233, -3405,  3235,   396, -3405, -3405,
   -3405, -3405, -3405, -3405, 12890,  2630,  2630,   312,  2664, 12941,
    6329,  2668,  3176,  3178,  3179,  3180,  3181,  3182,  3183,  3185,
    3187,  3188,  3206,  3213,  3214,   509,  3227,  2729,   509,   509,
    2700,  2720,  2726,  3240,  3242,  2736,   509,  3245,   509,   509,
     509,   509,   509,  2739,  9183, 12941, 12890,  1236,  1236,  3249,
    1206,  2750,  2753, -3405, 12890,  2781, 12890,  2787,   394,  3251,
    3255,  3258,  3264, 12941,  3265,  2788,  3266,   563,  3267,  3289,
    3292,  3293,  3295,   509,   509,  3298,  3299,  3300,  3302,  3303,
    3304,   509,  3305,  3309,  3310,  3313,  3314,  3319,  3320,  3321,
    3322,  3323,  3324,  3325,  3335,  3350,  3353,  3354,  3355,  3357,
    2376,  9939,  2851, -3405,  3360, 12941,  3362, 12941, 12941,  2376,
    3363,  3364,  2376,  1015,  3365,  2510, 12146,  3435,  2861,   158,
     509,   509,   509,  3366,   509,  3369,  3370,   509,   509,  3371,
    3372,  3373,  3375,   509,   509, 10141,  2869,  3377,  3378,  3379,
     704,  2876,  3380,  1015,  1015,  3384,  2122,  2882,    87,  2883,
    3387,  2994,  2884,  2831,    71,  2898,  2904,   486, -3405,  2738,
    2780,  3388,   322,  3403,  3407,  1161,  2907, -3405,   557, -3405,
     166,   903,  2908, 13007,  3410, 13007, 13007,  1080,  2909, 12941,
    3412,   122,  2910,  2911,  3420,  3421,   166,  3422, 12478,  3425,
    3433, 12165,  4840,  3434,   166,  3437, 12633, 12197,  7464,  2931,
   12890, 12890, -3405,  3423, 12890,  2935,  1236, 12890, 12890, -3405,
   13026, 12890, 12890, -3405, 12560, 10146, 10146, 10146, 10146,  3177,
    3177, 10146, 10146, 10146, 10146, 10146, 10146, 10146, 10146, 10146,
   10146, 10146, 10146, 10146, 10146, 10146,  3676, 10146, 10146, 10146,
   10146, 10146, 10146, 10146, 10146, 10146, 10146, 10146, -3405,  2937,
    1558,  2938,   304, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405,   523, -3405,   185, -3405, -3405, -3405, -3405, -3405,
    2939, -3405,  2942, -3405, -3405, -3405, -3405,  2946, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  7627, -3405,
    7646, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, 12890, -3405, -3405, -3405, -3405,  3306, -3405,
    2945, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,   792,
   -3405,  3184,  3184, -3405, -3405, -3405,  7668, -3405, -3405,  7688,
   -3405,  7731, -3405,  5220, 12890, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405,   792, -3405, -3405, -3405,
   -3405, 12890, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,   516,   577, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405,   843,   191, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405,  3297, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405,  3316, -3405, -3405, -3405, -3405,
   -3405, -3405,  7750, 12890, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  5829,  3534,  2950,  3554, 12890, 10146, -3405,
    2288, 12890, 10146, -3405,  6340, 10286, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  2364, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  7861, 12507, -3405, -3405,  3470,  3472,  2964,
   12890,  2967, -3405,  1089, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, 12890,  2971, -3405,  3564,    57,  2972, 12890,
   -3405,  9627,  3545,   150, -3405,  3549,  2977, -3405, -3405,  9627,
   -3405, -3405, -3405, 12890, -3405, 12941, -3405, -3405, -3405, -3405,
    1173, -3405,   509,  2976, -3405, -3405,  3348, -3405,  1048, -3405,
     272,   201,  3553, -3405,   572, -3405, -3405,  3690, -3405, 12890,
    6893, 10146, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  7945,
    1677, -3405, -3405, -3405,  3331, -3405, -3405,  2488,  2531,  3740,
    3805,  2983,  2984,  4030,  4268,  4483,  4597,  4768,  4796,  4906,
    4926,  5119,  5168,  5267,  5537,  2724,  5599,  5643,   349,   790,
    5727,  2985, -3405,  2556,  2556,   863,   863,   863,   863,   836,
     836,  2801,  2801,  3234, -3405, -3405,  9627,  2987, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, 12890, 12890,
   10146,   271, -3405,   487, -3405, -3405, -3405, -3405, -3405, -3405,
    7965, -3405,  8007, -3405, -3405,  8034,  2988, -3405, -3405,  5774,
     386,  3001,   449, 10146, -3405, -3405, -3405, -3405, 12890, -3405,
   12890, -3405, -3405, -3405,   210,  3005, -3405, 10146, -3405, -3405,
   -3405, -3405, -3405, -3405,  8086, -3405, -3405, -3405, -3405, -3405,
    8138, -3405, 12890,  3970, -3405, -3405, -3405, -3405, -3405,  8222,
    7912,  8925, 10090, 10306, -3405, -3405, -3405, -3405, -3405,  8264,
    9627,  9627,  1677, -3405, -3405,  1677, -3405, -3405,  1677, -3405,
   -3405, -3405, -3405,  9627, -3405,  3970, -3405, -3405,  3000, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,   792, -3405,
    3184,  3184, -3405, -3405, -3405,  8311, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,   481,   164, -3405, -3405, -3405,  8344, -3405,
   12890, 12890, 12890,  3580, 12338,   839,  3008, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
     930,   581, -3405, -3405, -3405, 10736, 10736, 10736, -3405, -3405,
   10736, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405,  3184,  3184, -3405, -3405, -3405, -3405,  3009, -3405,
    3027, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, 12890, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405,  9627, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405,  8363, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  3517,  3518,  3030, -3405, -3405,  3032, -3405,
   12890,   376, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405,  3596,  3045, -3405, -3405, -3405, -3405, -3405, -3405,  3018,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  8406, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405,  8448, -3405,  1387,  3621,  3044, -3405,
   -3405,   132,  3640,  3046,  3042,  3047,  3644,  3050, -3405,  3048,
    2756,  2797,  6068,  6227,  6277,  6298,  6366,  6691,  6937,  6970,
    7056,  7096,  7161,  7631,  7891,  7989,  8071,   827,   966, -3405,
    3075,  3075,  1069,  1069,  1069,  1069,   954,   954,  3177,  3177,
    3234, 10146,  3629,  3630,  3631,   397, -3405, -3405, -3405, -3405,
    1529,  3058,  3633,  3569,  3057, -3405, -3405,   145, -3405, -3405,
   12890, -3405, -3405, -3405, 12890, -3405, -3405,   824,  3572,  3059,
   -3405,   398, -3405, -3405, -3405, -3405, 10804,   399,   858, -3405,
   -3405,  1015, -3405,   328, -3405, -3405,  3661, -3405,   411,  3663,
   -3405,   418, -3405, -3405,   647, -3405, 10146,  3667,  2902, 10146,
    3670, 11231, -3405,  3079, 10362, 10146, -3405, -3405,  3080,   221,
    3086, -3405, -3405,  3655, 10850,  3095, 10146, -3405, 10895,  3096,
     148,  3691,  3604,  3697, 10942,  8159,  3453,  2871,  9627,  9627,
   -3405, 11243,   907, -3405,   419,  9303, -3405,  3105, -3405,  3572,
     531,   148,  1006, 12890, -3405,  1015,  3108,   646,  3113, 10146,
   -3405, 11490, -3405, -3405, -3405,  9627,  9627, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  3454, -3405, -3405,  9627, -3405,  9627, -3405,
   -3405,  3114,  3290,   424, 12890,  3684,  3687, 11661, 10146,   506,
   -3405, 12890, -3405, -3405, -3405,  3116, -3405,   503, -3405, 10146,
   -3405,  8254,   942,  1049,  3693, -3405, 11748, -3405, -3405,  1088,
   -3405, -3405, -3405, -3405, -3405, -3405,  8333,  8469, -3405, -3405,
   -3405,  3290,   534,   429, -3405,  3465, -3405,    65, -3405, -3405,
   12890, -3405, -3405, -3405, -3405, -3405,  9627, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, 10457,  3119,  3120,  3121,  3127,
   -3405,  3128,    90,  1117,  8602, -3405,  3723,  3131, -3405, -3405,
     526, -3405,   159, 10146, -3405, -3405, -3405,  3706,  3708,  3709,
    3710,  3732,  3734,  3735,  3738,  3739,   430, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, 12890,  3160,
    1236, 12890,  3161,  3326, 12890,  3162,  3664, 10146, 10146, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, 10146, -3405, 10146, -3405,  3970,   431,
    2729,   509,  1015,  1558,  3171,  3750,  3751,   436, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  1558,
    3198, -3405,  3686, -3405, -3405, -3405, -3405, -3405,  3174,   441,
   12539,   792, -3405,  3200, -3405, -3405, -3405, -3405, -3405,   893,
    3297, -3405,   433,  3316, -3405,  3970,  3806,  3808,  3809, -3405,
   10146, 10146, 11919, 10146, -3405, -3405,  3217, 12071,  1558,  3218,
     401, 10146,  3220, -3405, 12142,  3221, -3405, -3405, -3405, 10146,
    3222, 12890, -3405, 12890,  3224, 12890, -3405, -3405,  1156, 12331,
   -3405, -3405, 12941, -3405,  9171, -3405,   469,  3226,  3228,   282,
     389,  3216,  3800, -3405, -3405,  3229, -3405, 12408, -3405,  8640,
    8684,   437,  2965,  3090,  9627,  9627, -3405,  8484, 10146, 10146,
   -3405, 12481,  3230, -3405, 12988,  8729, -3405, -3405, -3405, 10146,
   -3405, -3405, 12890, 12890, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405,  3290, -3405, -3405, -3405, -3405, 12890,   172,  3334,   339,
   -3405, -3405, 12890, -3405,  3337, -3405,  2376, -3405, 12493,  1015,
    2376,   509,  2780,  1015,  2376,  2356,  2376,  2376,  1387,  3236,
    3237,  3728,  3184,  3238, 13045, -3405,  3239, 12595, -3405,  8822,
    8862,  3143,  3248, 10146, -3405, -3405, -3405, -3405, -3405, -3405,
    1015, 10146,  1529,  3243,   442,  1529, -3405,  3742,  3744,  3232,
    3530, -3405,  3246,   299,  3241, -3405, -3405, -3405, -3405, -3405,
   -3405,  3594, -3405, -3405, -3405, 10146, 10146, 10146,  3270, 12532,
   -3405, 12544, -3405, -3405,   443,  1529,  3250,  3822, 12611, -3405,
   -3405, -3405,  3340, -3405,  3843,  3845, -3405,  8536,  3550,  9627,
   -3405, -3405, -3405,  3254,  3548, -3405, -3405,   340,  3850,   340,
    3854,  1015, -3405, -3405, -3405, -3405,   269, -3405,  9627,  9627,
    8992,  3290, -3405, 12666, 12751, -3405, -3405,  9398, -3405, 12791,
    8579,   761,  8621, 10971,  3352,  3262,  3263,  3772,  3268, -3405,
    8663,  3562,  9666,  3776,  3376, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405,  3269,  3271,  3042,
    3272,  3291, -3405,  3307, -3405, -3405, 10146, 10146,  3970, -3405,
    3970, -3405, -3405,  3277,   444, -3405,  3315,  3777,   459,  1558,
    3312,   432,  3892, -3405,   445,  3905, -3405,  3912, 10146, -3405,
   -3405,  3336,   447,  1558,  3333, -3405, 10146,   148,   148, 12890,
   -3405,  3615, -3405, 12803, -3405,   459,  3347,   148, -3405,   148,
   -3405,  3349,  3367,  9022,  9151, -3405, -3405, -3405,  3374, -3405,
   12890, -3405,   765,  1677, -3405, -3405,  3382,  3361,  3383,   631,
    1459, 12890, 12890,  3386, -3405, 12890, -3405,  3617, -3405,  9765,
    9888,  3389,  4291,  3927,  9666, -3405,  3948,  3872,  3867, 13064,
    3520, 12614,  3869,  9203,  9284, -3405,  3391,  3880, -3405, 10146,
     471, -3405,   450,  1529,  3392,  3949,  1147,  3594, -3405,   670,
   10146, 12815, -3405,  3394,   453,  1529,  3208,  3395,  3416,  3672,
   -3405, -3405,   473,   340,  3429,  3431, -3405, -3405, -3405, -3405,
   -3405,   793,  1677, -3405, -3405, -3405, 12890, -3405,   515,  3352,
    3352, 10146, 10146,  3971,  3390,  3484,  3675, -3405,  3442,  3444,
   12890, 10098, -3405,  4291, -3405, 12890,  3977,  3042,  3381, -3405,
   -3405,  3440, -3405, -3405, -3405, -3405, -3405,  9357,   521, -3405,
   10146, -3405,  3448,   455,  1558,  3449, -3405, -3405, -3405,  3982,
    4042, -3405, -3405,  3471,   456, -3405, -3405, -3405, -3405, -3405,
    3473, -3405, -3405,  1677, -3405, -3405,  4065, -3405, -3405, -3405,
    4046,  4047,  2263,  2263, 12890,  3567,  3477,  3484, -3405, -3405,
   12890, 12890,  4072,  3479,  9666,   215, -3405, 12890,  3635,  3989,
   -3405, 10146, -3405,  9444, -3405,  3496,   465,  1529, 10146, 10146,
   -3405,  3497, -3405, -3405, 12890,   515,   515,  3499,  3498,  3502,
     760,  1481, 12890, -3405,  4091,  4096,  4011, 12890,  3505, 12890,
   -3405,   290, -3405, -3405,  9590, -3405, -3405,  3508,   466, -3405,
    4102, -3405,  4103, -3405, -3405,  4084, 12890, -3405,   515,  3567,
    3567, 10146, 10146,  3510,  4021,  4023,  3515,  4111, -3405, -3405,
   -3405, -3405, -3405,  3519, 10146,  4027,   452,  4114, -3405,  4095,
    4097,  2263,  2263, 12890,  3521,  3527, -3405,  4038, -3405,  3970,
    3531, 12890,  3532,  4041,   515,   515,  8682, -3405, -3405,  3533,
   -3405,  4129, -3405,  3535, -3405, -3405, -3405, -3405, 12890, -3405,
    3537,  3540, -3405
  };

  const unsigned short
  parser::yydefact_[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2179,
       0,     0,     0,     0,     0,     0,     0,  1122,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1028,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2180,
    2181,  2183,  2182,  2184,  2185,  2186,  2187,  2188,  2189,  2190,
    2191,  2192,  2193,  2194,  2195,  2197,  2196,  2198,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   464,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,    47,    48,    90,    92,     5,    33,    35,    34,
     115,    36,    26,     6,     7,     8,     4,     9,    10,    11,
      17,    13,    14,    15,    16,   106,    32,   116,    12,    18,
      84,    85,    86,    87,    19,    20,    21,    22,    56,   107,
     108,   111,   112,   109,   110,    23,    88,    24,    27,    29,
      28,    51,    30,    31,    39,    40,     0,    37,    38,     0,
      41,    42,     0,    25,    43,    45,    44,    46,    49,    50,
      52,    53,    54,    69,    70,    71,    55,    57,    58,    59,
      60,    61,    62,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    63,    64,    65,    99,    97,    98,    96,    95,
      94,    93,    66,    67,    68,    81,    83,    82,    89,   100,
      91,   101,   102,   103,   104,   105,   113,   114,     0,     0,
       0,     0,     0,  1546,     0,     0,   736,     0,   541,     0,
       0,     0,     0,  1177,     0,     0,     0,     0,     0,     0,
       0,   889,     0,     0,     0,     0,     0,     0,  1578,     0,
       0,     0,     0,  1515,     0,     0,     0,     0,     0,     0,
       0,  1068,     0,     0,     0,     0,     0,     0,     0,     0,
     385,     0,  1109,     0,  1116,     0,  1108,   547,   551,     0,
       0,  1588,     0,     0,     0,     0,     0,  1058,     0,     0,
       0,     0,   268,     0,     0,     0,     0,     0,   552,     0,
     558,     0,     0,     0,     0,     0,  1165,     0,     0,     0,
       0,     0,   659,     0,  1605,     0,  1540,   529,     0,   672,
       0,     0,  1169,     0,     0,  1125,     0,  1127,     0,     0,
       0,  1139,     0,     0,  1138,     0,     0,     0,   232,     0,
     244,     0,   256,     0,     0,     0,   280,     0,  1173,     0,
       0,     0,   283,  1158,     0,  1160,     0,  1162,     0,  1164,
       0,   157,     0,     0,  1390,     0,     0,     0,     0,     0,
    1262,     0,     0,  1316,     0,     0,  1280,     0,  1388,     0,
    1349,     0,  1338,     0,  1326,     0,  1298,     0,     0,     0,
     357,     0,   487,     0,     0,     0,     0,     0,  1181,     0,
       0,     1,     3,     0,     0,     0,     0,     0,     0,  1202,
       0,  1873,     0,     0,     0,     0,     0,  1817,     0,     0,
       0,  1818,     0,     0,     0,     0,  1190,  1201,     0,  1191,
    1196,  1194,  1197,  1195,  1192,  1193,  1198,  1199,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1210,     0,     0,     0,  1204,
    1209,     0,  1206,  1205,  1207,     0,  1800,     0,  1786,  1820,
       0,  2024,  2025,     0,  1551,  1554,  1557,  1555,  1556,  1552,
    1559,  1563,  1564,  1553,  1560,  1562,  1558,  1561,     0,  1548,
     734,   288,   289,   290,   291,     0,  1938,     0,     0,     0,
       0,     0,     0,     0,     0,   545,     0,   544,   533,   538,
     540,   537,   546,   534,   535,   536,   539,     0,     0,     0,
       0,     0,  1527,  1530,  1529,  1531,  1532,  1533,     0,     0,
    1537,     0,     0,  1860,  1847,  1843,     0,  1867,     0,     0,
       0,  1738,     0,  1865,     0,  1751,     0,  1495,  1502,  1508,
    1503,  1509,  1497,  1498,  1504,  1496,  1500,  1501,  1499,  1505,
    1506,  1507,  1179,     0,   117,     0,     0,     0,   349,     0,
       0,  1822,  2071,     0,     0,  1790,  2015,  1947,     0,     0,
       0,  2083,  2084,     0,     0,     0,  2073,     0,     0,  1704,
    1725,     0,     0,     0,     0,     0,  1802,     0,     0,     0,
       0,  1784,  1785,  1788,     0,     0,     0,     0,     0,     0,
       0,  1768,     0,     0,     0,  1819,     0,  1777,     0,     0,
       0,     0,     0,  1798,  1799,     0,     0,     0,     0,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2080,  2079,  1737,  1789,  1724,  1726,  1727,  1876,  1877,     0,
       0,  1823,     0,  1772,     0,  1793,     0,  1801,  1797,     0,
       0,  1795,     0,     0,  2023,     0,  2026,     0,  2127,  2128,
    2129,     0,     0,     0,     0,   894,   947,   953,   974,   933,
     962,   977,   895,   996,   997,   896,   960,   897,  1001,  1003,
     898,   899,   900,   901,   902,   903,   904,   905,   906,   907,
     908,   984,   909,   910,   911,   912,  1002,   999,  1000,   913,
     914,   915,   916,   917,   919,   918,   920,   921,   922,   923,
     924,   925,   926,   928,   929,   931,   932,   934,   935,   936,
     937,   938,   939,   930,   940,   941,   942,   943,   944,   945,
     946,   978,   979,   981,   980,   948,   949,   950,   951,   952,
     954,   955,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,  1012,  1013,   987,   988,   989,   990,   993,   991,
     992,   994,   995,   927,   998,   956,   957,   958,   959,   961,
     973,   975,   976,   982,  1005,  1004,   983,   985,   986,  1006,
    1007,  1008,  1009,  1010,  1011,   891,     0,   760,     0,     0,
     754,     0,   758,     0,     0,     0,   780,     0,     0,     0,
       0,   774,     0,     0,  1652,     0,     0,  2091,  2092,     0,
    1581,  1582,  1583,  1584,  1585,  1586,  1587,   805,   806,     0,
       0,   786,     0,     0,     0,     0,     0,     0,     0,   365,
       0,  1519,  1521,  1523,  1524,  1525,  1522,  1517,     0,     0,
     354,     0,     0,     0,     0,  1511,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2133,  2134,  2135,  2136,  2137,
       0,     0,     0,     0,     0,     0,     0,     0,  1071,  1105,
    1080,  1072,  1079,  1083,  1085,  1086,  1087,  1089,  1092,  1084,
    1088,  1078,  1081,  1074,  1073,  1075,  1076,  1077,  1082,  1090,
    1091,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1102,  1103,  1104,     0,     0,     0,     0,  1600,     0,     0,
       0,     0,     0,     0,   371,   374,     0,   377,  1635,   381,
       0,   376,     0,   375,   384,     0,   379,   372,   373,     0,
       0,     0,     0,  1106,  1118,     0,   550,     0,   507,     0,
       0,     0,  1593,     0,     0,     0,     0,  1574,     0,  1570,
    1571,  1572,     0,  1040,     0,     0,     0,     0,     0,     0,
       0,  2002,     0,     0,     0,     0,     0,  1640,  1641,  1642,
    1809,  1808,  2003,     0,     0,  1669,     0,     0,  1051,     0,
    1050,   678,   679,   680,   681,   682,   683,   684,   685,   687,
     688,   692,   693,   703,   704,   705,   706,  1052,  1053,  1054,
     707,   709,   708,   710,   711,  1056,   716,   689,   690,   691,
    1055,   727,   686,   694,   712,   713,   714,   715,   719,   720,
     721,   722,   723,   724,   701,   702,   717,   718,  1057,   725,
     726,   695,   696,   697,   698,   699,   700,  1060,  1048,     0,
     221,   266,   274,     0,     0,   271,     0,   295,   743,   742,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1123,   406,
     402,  1110,     0,  1534,     0,   555,   556,   557,     0,     0,
    1787,     0,     0,  2085,  1634,     0,  1633,     0,   561,   569,
     562,   570,   566,   565,   573,   574,   563,   564,   567,   576,
     575,   568,   571,   572,   119,     0,     0,     0,     0,   457,
     458,     0,     0,     0,  1729,  2095,     0,  1750,     0,  1447,
    1449,  1454,  1453,  1452,  1455,  1456,  1457,  1448,  1450,  1451,
    1167,     0,     0,  1617,     0,     0,     0,   663,   664,     0,
     662,     0,     0,     0,     0,     0,     0,  1608,  1609,  1610,
    1611,  1612,  1613,     0,     0,   532,     0,  1655,  1948,     0,
     728,   677,   733,   732,   729,   730,   731,   674,     0,     0,
       0,     0,     0,  1459,  1461,  1463,  1462,  1466,  1467,  1468,
    1469,  1470,  1471,  1460,  1464,  1465,  1171,     0,     0,     0,
       0,  1149,  1150,  1151,  1152,  1155,     0,  1154,  1156,  1157,
    1129,     0,     0,  1133,     0,     0,     0,  1144,  1145,  1147,
    1146,  1141,  1042,     0,     0,     0,   136,   230,   238,   235,
       0,   218,   242,   250,   247,     0,   219,   254,   262,   259,
       0,  1032,     0,  1037,     0,   220,   278,     0,     0,     0,
       0,     0,     0,     0,   167,     0,  1861,  1844,  1845,  1846,
    1842,     0,     0,     0,  1866,     0,     0,     0,  1739,  1728,
    1864,  1740,     0,     0,  1473,  1491,  1476,  1492,  1493,  1477,
    1478,  1479,  1480,  1481,  1483,  1482,  1487,  1488,  1484,  1485,
    1486,  1489,  1490,  1474,  1475,  1175,     0,   222,   281,   286,
       0,     0,     0,     0,     0,     0,     0,   147,   148,   149,
     150,     0,     0,     0,     0,     0,   153,   154,   155,   156,
       0,     0,   203,   204,   205,  1687,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1393,  1440,
    1426,  1427,  1428,  1429,  1430,  1442,  1431,  1432,  1433,  1434,
    1435,  1437,  1436,  1441,  1443,  1394,  1395,  1396,  1397,  1398,
    1399,  1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,
    1409,  1418,  1410,  1411,  1419,  1421,  1420,  1412,  1413,  1422,
    1414,  1415,  1416,  1417,  1423,  1424,  1425,  1438,  1439,  1444,
    1445,     0,     0,     0,     0,     0,     0,   811,   812,   813,
     814,   815,   816,   817,   818,     0,  1626,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1966,     0,  1967,     0,     0,     0,     0,  1969,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1261,     0,  1212,  1258,
    1213,  1214,  1215,  1216,  1217,  1218,  1219,  1220,  1221,  1222,
    1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,
    1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,
    1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,  1257,  1259,     0,  2056,  2067,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2065,  2058,
       0,  1315,     0,  1300,  1301,  1302,  1309,  1303,  1304,  1305,
    1306,  1307,  1308,  1310,  1311,  1313,  1312,  1318,  2060,  1279,
       0,  1264,  1265,  1266,  1272,  1276,  1277,  1267,  1268,  1269,
    1270,  1271,  1273,  1275,  1274,     0,  2030,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1387,     0,  1357,  1358,  1359,  1352,  1353,  1354,
    1355,  1356,  1360,  1361,  1362,  1363,  1364,  1365,  1366,  1367,
    1368,  1369,  1370,  1351,  1371,  1372,  1373,  1374,  1375,  1376,
    1377,  1378,  1379,  1380,  1381,  1382,  1383,  1384,  1385,     0,
       0,  2050,     0,  1348,     0,  1343,  1342,  1340,  1341,  1344,
    1345,  1346,     0,     0,     0,     0,  2052,  1337,     0,  1328,
    1329,  1330,  1334,  1335,  1331,  1332,  1333,  2059,  1325,     0,
    1320,  1321,  1322,  1323,     0,  1297,     0,  1282,  1283,  1284,
    1289,  1294,  1295,  1286,  1287,  1288,  1290,  1291,  1293,  1292,
    1285,     0,     0,     0,     0,     0,     0,     0,     0,   490,
     491,   493,   492,   494,   495,   496,     0,  2011,  2012,     0,
       0,   499,   503,   500,   501,   502,     0,     0,  2020,  2022,
       0,   667,   668,   669,   670,   671,     0,     0,     0,   656,
     657,   658,     0,     0,     0,  2102,     0,  2108,     0,     0,
    2120,  2122,     0,     0,  2126,   640,     0,   639,   591,   587,
     595,   605,   577,   609,   610,   578,   579,   612,   613,   614,
     580,   581,   582,   583,   584,   585,   588,   586,   589,   590,
     592,   593,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   621,   622,   611,   594,   606,   607,   608,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     615,   616,   617,   618,   619,   620,     0,  2101,     0,  2107,
       0,     0,  2119,  2121,   627,     0,   626,   628,   629,   630,
     631,   632,   633,   634,   635,  1182,   830,     0,     0,     0,
       0,     0,   825,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   338,     0,     0,     0,     0,   337,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   300,   299,  1110,
     821,   883,   826,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   735,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1538,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,     0,     0,     0,   348,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   757,     0,   753,   341,   756,
       0,     0,     0,   779,     0,     0,     0,     0,   773,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   785,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   353,     0,     0,     0,     0,  1512,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1601,
       0,     0,     0,     0,   128,     0,     0,     0,   391,     0,
     392,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1120,     0,   551,     0,     0,     0,   506,     0,     0,
    1594,     0,  1565,     0,     0,  1573,     0,     0,     0,  1039,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     267,   272,   269,   277,     0,   224,     0,     0,   228,   226,
     296,     0,     0,     0,     0,     0,     0,   422,   421,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   403,   404,   405,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     456,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1616,     0,     0,     0,     0,     0,     0,   522,   746,   528,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1543,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1132,     0,     0,
       0,     0,   139,   137,   231,   236,   233,   241,   243,   248,
     245,   253,   255,   260,   257,   265,     0,  1029,  1030,     0,
    1034,  1035,   279,   170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   282,   284,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1678,     0,     0,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1625,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   120,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   467,     0,
       0,     0,     0,     0,     0,     0,     0,   361,     0,   360,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   820,     0,     0,     0,     0,     0,     0,   864,
       0,     0,     0,   882,     0,     0,     0,     0,     0,   313,
     312,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   297,     0,
       0,     0,     0,  1869,  1870,  1871,  1872,  1868,  1874,  1685,
    1701,  2151,     0,  1692,     0,  1691,  1720,  1721,  1810,  1811,
       0,  1200,     0,  1875,  1759,  1796,  1208,     0,  1812,  1805,
    1946,  1940,  1941,  1943,  1942,  1944,  1945,  1547,     0,  1550,
       0,   292,  1935,  1936,  1937,  1662,  1666,  1653,  1673,  1630,
     543,   542,  1761,     0,  1649,  1637,  1528,  1526,     0,  1536,
       0,  1848,  1853,  1854,  1855,  1752,  1754,  1753,  1755,     0,
    1746,  1856,  1857,  2098,  1742,  1178,     0,  1494,  1064,     0,
    1062,     0,   346,     0,     0,  1639,  1700,  1690,  1771,  1760,
    1839,  1840,  1841,  1689,  1699,  1698,     0,  1744,  1697,  1696,
    1643,     0,  2081,  1803,  1804,  1722,  1723,  1831,  1833,  1830,
    1832,  1834,  1835,  1762,  1765,  1773,  1766,  1767,  1782,  1783,
    1763,  1764,   749,     0,     0,   751,   750,  1778,  1780,  1779,
    1775,  1776,  1774,  1824,  1813,     0,     0,  1814,  1816,  2076,
    2075,  2077,  2078,  1878,  1879,  1881,  1880,  1882,  1883,  1885,
    1884,  1886,  1887,  1889,  1888,  1890,  1891,  1892,  1893,  1894,
    1895,     0,  1636,  1821,  1781,  1792,  1791,  1794,  1828,  1827,
    1829,  2074,  1836,  1837,  1838,     0,  2027,  2130,  2131,  2132,
     893,   890,     0,     0,   752,   797,   798,   800,   801,   803,
     799,   802,   804,   342,     0,     0,     0,     0,     0,   778,
       0,     0,     0,   770,     0,     0,  1651,  1650,  1579,  1580,
     807,   808,   784,     0,   370,   367,   366,   369,   368,   364,
     363,  1520,  1516,     0,     0,   351,   741,     0,     0,     0,
       0,     0,  1510,     0,  2072,  1930,  1934,  1933,  1932,  1931,
    1925,  1926,  1901,  2138,  2139,  2140,  2141,  2142,  2143,  2144,
    1069,  1070,   343,     0,     0,  1598,     0,     0,     0,     0,
    1066,     0,   400,     0,   398,     0,     0,   389,   390,     0,
     394,   382,  1665,     0,  1668,     0,   383,   387,  1806,  1807,
       0,  1117,     0,     0,   549,   548,     0,   504,     0,  1592,
       0,     0,     0,  1566,     0,  1569,  1038,     0,  1043,     0,
       0,     0,  1046,  2082,  1629,  1638,  1663,  1664,  1645,  1646,
    1647,  1659,  1658,  1672,  1670,  1631,  1671,  1049,  1059,     0,
     273,   270,   275,   225,     0,   229,   227,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   401,   415,   416,   411,   412,   413,   414,   407,
     408,   410,   409,   417,  1124,  1111,     0,     0,   554,   553,
    1660,  1661,  1654,  1667,  1632,   560,   559,  1067,     0,     0,
       0,     0,   454,     0,  1732,  1731,  1730,  2096,  2097,  1166,
       0,  1446,     0,  1622,  1614,     0,     0,   744,   745,     0,
       0,     0,     0,     0,   526,   661,   660,  2086,     0,  2089,
       0,  2088,  1606,  1607,     0,     0,  1542,     0,   531,   530,
    1648,  1656,   676,   673,     0,  1734,  1736,  1733,  1735,  1170,
       0,  1458,     0,  1825,  1826,  1148,  1126,  1153,  1128,     0,
       0,     0,     0,     0,  1131,  1657,  2070,  1143,  1140,     0,
       0,     0,   237,   234,   239,   249,   246,   251,   261,   258,
     263,  1031,  1036,     0,   175,   176,   169,   172,   173,   174,
     168,   166,  1849,  1850,  1851,  1852,  1862,  1863,     0,  1748,
    1858,  1859,  1741,  1743,  1174,     0,  1472,   285,  1159,  1161,
    1163,  1682,  1683,     0,     0,  1688,   146,   141,     0,   145,
       0,     0,     0,     0,     0,     0,     0,  1693,  1694,  1695,
     152,   151,  1686,   202,   201,  1896,  1897,  1898,  1899,  1900,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
       0,     0,  1912,  1913,  1914,     0,     0,     0,  1918,  1919,
       0,  1921,  1922,  1923,  1924,  1927,  1928,  1929,  1391,  1392,
    1674,  1684,  1702,  1703,  1705,   810,   809,  1623,     0,  1627,
       0,   177,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,
    1959,     0,  1961,  1962,  1963,  1964,  1965,  1968,  1970,  1971,
    1972,  1973,  1974,  1985,  1982,  1996,  1997,  2001,  1975,  1978,
    1979,  1980,  1981,  1983,  1984,  1986,  1987,  1988,  1989,  1990,
    1991,  1992,  1993,  1994,  1995,  1998,  1999,  2000,  2032,  1260,
    1263,     0,  2068,  2028,  2057,  2031,  2029,  2061,  2063,  2062,
    2064,  2066,  2048,  1314,  1317,     0,  1278,  1281,  1976,  1977,
    2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,
    2043,  2044,  2045,  2046,  2047,  1386,  1389,  1949,  1950,  2049,
    1347,  1350,  2053,  2055,  2054,  2051,  1336,  1339,  1324,  1327,
    2069,  1296,  1299,     0,     0,     0,   473,   474,     0,   466,
       0,     0,  2175,  2005,  2004,  2006,  2007,  2008,  2009,   489,
     488,     0,     0,   359,  2014,  2013,   498,   497,  1113,  1112,
    2017,  2018,  2019,  2021,   666,   665,  2093,  2094,   655,   653,
     654,  2124,  2100,  2106,  2105,  2110,  2116,  2117,  2115,  2118,
    2123,  2125,   636,     0,   638,  2099,  2104,  2103,  2109,  2112,
    2113,  2111,  2114,   623,     0,   625,     0,     0,     0,   824,
     819,     0,     0,     0,   865,     0,     0,     0,   883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   298,
     310,   311,   306,   307,   308,   309,   301,   302,   304,   303,
     305,     0,     0,     0,     0,     0,   878,   879,   880,   881,
       0,   884,   828,     0,  2151,  2152,  2154,     0,  2158,  2156,
       0,  1203,  1211,  1549,     0,   287,   293,     0,     0,     0,
    1756,     0,  1180,  1065,  1063,   350,     0,     0,     0,   747,
     748,     0,  2166,     0,  2170,  2168,     0,  1016,     0,     0,
    1026,     0,   892,   759,   341,   755,   341,     0,     0,     0,
       0,     0,   777,     0,     0,     0,  1518,   822,   885,   832,
       0,   739,   740,     0,     0,     0,     0,  1514,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     386,     0,     0,  1114,     0,     0,  1107,     0,  1119,     0,
       0,     0,     0,     0,  1575,     0,     0,     0,     0,     0,
    1044,     0,  1061,   276,   223,     0,     0,   439,   440,   419,
     420,   423,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   449,   424,     0,   437,   438,     0,   446,     0,   448,
     450,     0,   451,     0,     0,     0,     0,     0,     0,     0,
    1168,     0,  1619,  1621,  1618,     0,   527,   521,   514,     0,
     524,     0,     0,     0,     0,  1541,     0,   675,  1172,     0,
    1130,  1134,  1135,  1136,  1137,  1142,     0,     0,   240,   252,
     264,   171,     0,     0,  1176,     0,  2160,     0,  2162,  2164,
       0,   142,   143,  1675,  1677,  1676,     0,  1680,  1681,   159,
     158,  2176,  2178,  2177,   738,   737,     0,     0,     0,     0,
    1628,     0,     0,     0,     0,  1319,     0,     0,   469,   465,
       0,  2173,     0,     0,   358,   637,   624,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   853,   854,   862,
     860,   855,   858,   857,   863,   861,   859,   856,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   326,
     327,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   336,   324,   325,     0,   333,     0,   335,   339,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   841,   842,
     850,   848,   843,   846,   845,   851,   849,   847,   844,     0,
       0,  2155,     0,  2159,  2157,  2145,   294,  1939,   513,     0,
       0,     0,  1747,     0,  1745,  1644,  2167,  2171,  2169,     0,
       0,  1769,     0,     0,  1770,   342,     0,     0,     0,   761,
       0,     0,     0,     0,   775,   771,     0,     0,     0,     0,
       0,     0,     0,   356,     0,     0,   345,  1590,  1591,     0,
       0,     0,  2146,     0,     0,     0,   399,   397,     0,     0,
     393,   378,     0,   380,     0,  1121,     0,     0,     0,     0,
       0,     0,     0,  1577,  1567,     0,  1041,     0,  1047,     0,
       0,     0,     0,     0,     0,     0,   444,     0,     0,     0,
     460,     0,     0,  1620,     0,     0,   525,  2087,  2090,     0,
    1544,  2016,     0,     0,  2148,  2147,  1749,  2161,  2163,  2165,
     144,  1679,  1915,  1916,  1917,  1920,     0,     0,     0,     0,
     180,  1960,     0,   470,     0,  2010,     0,  2174,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1758,     0,     0,   866,     0,     0,   884,     0,
       0,     0,     0,     0,   331,  1715,  1713,  1714,   877,   871,
       0,     0,     0,     0,     0,     0,  2153,     0,     0,   509,
       0,   823,   887,   836,     0,  1757,   347,  1014,  1015,  1017,
    1022,     0,  1023,  1024,  1027,   341,   341,   341,     0,     0,
     783,     0,   772,   787,     0,     0,   886,   834,     0,   352,
    1513,   344,     0,  1602,     0,     0,  1599,     0,   132,     0,
     396,   453,  1115,     0,     0,   505,  1595,     0,     0,     0,
       0,     0,  1568,  1045,   441,   442,     0,   425,     0,     0,
       0,   452,  1535,     0,     0,   459,   455,     0,   523,     0,
       0,   208,     0,     0,     0,     0,     0,     0,     0,   179,
       0,   124,     0,     0,   468,  2172,   362,  1706,  1710,  1712,
    1719,  1708,  1717,   788,   789,   791,   792,   794,   790,   793,
     795,   796,  1707,  1716,  1711,   852,   831,     0,     0,   867,
       0,     0,   885,     0,   328,   329,     0,     0,   340,  1709,
    1718,   840,   827,     0,     0,   512,   508,     0,     0,     0,
       0,     0,     0,  1020,     0,   765,   762,   766,     0,   781,
     776,     0,     0,     0,     0,   355,     0,     0,     0,     0,
     129,   130,   135,     0,   388,     0,     0,     0,  2149,     0,
    1576,     0,     0,     0,     0,   418,   462,   461,     0,  1545,
       0,   140,   206,   214,   211,   138,     0,     0,     0,     0,
       0,     0,     0,     0,   178,     0,   121,   122,   127,     0,
       0,     0,   479,     0,   480,   481,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   872,     0,     0,   511,     0,
       0,   520,     0,     0,   888,   838,     0,     0,  1025,     0,
     341,     0,   873,     0,     0,     0,     0,     0,     0,   131,
     133,   395,     0,     0,     0,     0,   426,   427,   445,   447,
    1615,   207,   212,   209,   217,  1624,     0,   183,     0,     0,
       0,     0,     0,     0,     0,     0,   123,   125,     0,     0,
       0,     0,   471,     0,   482,     0,     0,   869,     0,   868,
     887,     0,   886,   332,   334,   829,   510,     0,     0,  1539,
       0,   519,     0,     0,     0,     0,  1018,  1019,  1021,     0,
     767,   782,   833,     0,     0,  1589,  1603,  1604,   134,   463,
       0,  1596,  1597,   213,   210,   215,     0,  2200,  2199,   194,
       0,     0,   195,   196,     0,     0,     0,   181,   199,   126,
       0,     0,     0,     0,     0,     0,   478,     0,     0,     0,
     517,     0,   518,     0,   875,     0,     0,     0,   341,   341,
     874,     0,  2150,   216,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   198,     0,     0,     0,     0,     0,     0,
     476,     0,   870,   888,     0,   516,   837,     0,     0,   763,
     768,   835,     0,   192,   193,     0,     0,   182,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   472,   477,
     475,   515,   876,     0,     0,     0,     0,     0,   188,     0,
       0,   189,   190,     0,     0,     0,   483,     0,   839,   769,
       0,     0,     0,     0,     0,     0,     0,   484,   485,     0,
     197,     0,   184,     0,   186,   187,   200,   486,     0,   191,
       0,     0,   185
  };

  const short
  parser::yypgoto_[] =
  {
   -3405, -3405,  4055, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405,  1860, -3405, -3405,
    1839, -3405, -3405, -3405,  1093, -3405, -3405,  1893, -3405, -3405,
   -3405, -3405,   412, -3405, -2331, -3405, -3405, -2187, -3405, -3405,
      60, -3405, -3405,  1861,   451, -3405, -3405, -3405, -3405, -3405,
    -924, -3405,  -355, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405,   701, -3405, -3405, -2001, -3405, -3405,
   -3405,  -283,  -586, -3405,  1384,  -861, -3405, -3405, -3405, -3405,
    1700, -3405, -3405, -3405,  2157,  2109, -3405, -3405, -3405, -3405,
     755, -1985, -3405,   769,  1755, -3405, -3405, -1976, -3405,  1244,
   -1132,  -307, -3405, -3405, -3405,  1737, -3405, -3405, -3405,    62,
      77, -3405,   194, -3405, -3405, -3405,  1730, -3405, -3405,  1727,
   -3405,  1358,   778, -3405,   254, -3405,  1250, -3405, -3405,  -265,
   -3405, -3405,  2314, -3405, -3405,  2132, -3405, -3405,  -251, -3405,
   -3405,  -237,  -396, -3405,  1709, -3405, -3405,  1732, -3405, -3405,
   -3405,  3835,  1746, -3405, -3405,  2026, -3405, -3405,  1753, -3405,
   -3405,  -236,  2014,   183, -1760, -2015,  2367,  -739, -3405, -1207,
   -3405, -3405,  3450, -3405, -3405, -3367, -3405,  1477,  -823, -3405,
   -3405,  3451, -3405, -3405,  3424, -3405, -3247, -3405, -1661, -3405,
   -3405, -3405,  1885, -3405, -3405,  3840, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3404,   457, -3405,   482, -3405,
    3846, -3405, -2294,   640, -3405,  3842, -3405, -3405,  2264,   605,
   -3405,   240, -3405,   606, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  3308, -3405, -3405, -3405, -3405, -3405,  2145,
   -3405, -3405, -3405, -3405, -3405, -3405,  2204, -3405, -3405,   -94,
    1656,  -600, -3405,  2186, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405,  3054, -3405, -3405, -3405,  2017, -3405,  2052, -3405,  -320,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
    -155,  2432, -3405, -3405,  2431, -3405, -3405,  1880, -3405, -3405,
    1866, -3405, -3405,  1833, -3405, -3405,  1870, -3405, -3405,  1843,
   -3405, -3405,  1841, -3405, -3405,  1871, -3405, -3405,  1859, -3405,
   -3405,  1957, -3405,  2105, -3405,  2088, -3405,  2032, -3405,  2426,
   -3405, -3405, -3405,  3480, -3405, -3405,  2312, -3405, -3405,  2435,
   -3405, -3405, -3405,  3807, -3405, -3405, -3405,  2121, -3405,  2471,
   -3405, -3405,  2245, -3405,  1489,  -965, -3405, -3405,  2330, -3405,
   -3405, -3052, -3405, -3405,  3405, -3405,  1530,  -932, -3405,  2135,
   -3405, -3405,   626, -1166,  2153, -3405,   614, -1443, -3405,  -149,
   -3405, -3405, -3405, -3405, -3405,  -188,  -160, -3405,  -252, -3405,
   -3405, -3405,  -118,   -83, -3405, -3405, -3405, -3405,   335, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  -212, -3405, -3405, -3405, -3405, -3405, -3405,
    -209, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405,    88, -3405, -3405, -3405,  -173,  -152,  -248, -3405, -3405,
   -3405,  -169, -3405, -3405,  -224, -3405, -3405, -3405, -3405, -2998,
   -2898, -2894, -3405, -3405, -2855, -2853, -3405, -3405, -3405, -2843,
   -2811, -3405, -3405,  -225,  -244, -3405,  -269,  -197, -3405, -3405,
    -281, -3405, -3405, -3405, -3405, -3405, -3405,   -12, -3405, -3405,
   -3405, -3405, -3405,    45, -3405, -3405,  -274, -3405, -1654, -2285,
    1838, -3405,  -259, -3405,  -358, -3405, -3405, -3405, -3405, -3405,
    -111, -3405, -3405, -3405, -3405,  -240,  -166, -3405, -3405, -3405,
   -3405,  -165, -3405, -3405, -3405, -3405,  -233, -3405,  -164, -3405,
   -3405, -3405, -3405,  -246,  -253, -3405, -3405,  -157,  -154,  -120,
   -3405,  -257, -3405,  -150, -3405,  -167,    61,  -163,  -156,  -148,
   -3405, -3405, -3405, -3405,  -147,  -139, -3405,  -239,  -137,   -50,
    -132, -3405,  -301, -3405,   -48,   -40,  -131,  -114,  -113,   -37,
     -24,   -14,    29, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405,  -170,  -127, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  -354,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405,  -338,  -330, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405,   131,  -262, -3405,
   -3405, -3405,  -367,  -357,  -351,  -349,  -329, -3405, -3405, -3405,
   -3405, -3405,  -328,  -323,  -319, -3405,  -317, -3405, -3405, -3405,
    -308,  -275,  -267, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
    -372, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,   -64,
    -297, -3405, -3405, -3405, -3405, -3405,  -112,  -104,   -79, -3405,
     149,   156, -3405,  -222,  -263, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
    -198, -3405, -3405, -3405, -3405, -3405, -3405, -3405,  -254,  -217,
    -250, -3405, -3405,  -211,   -93,   -67,   -55,  -399,   -51,   -22,
   -3405, -3405,  -256,  -322, -3405, -3405, -3405, -3405, -3405,    59,
   -3405,   -60,   -58, -3405, -3405, -3405, -3405, -3405, -3405,  -194,
    -183, -3405, -3405,  -286,  -204, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405,    64,    73,    76,    83,
      85,   100, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405,
   -3405, -3405, -3405, -3405, -3405, -3405, -3405, -3405, -1538, -2416,
   -3405, -1664, -3405, -2162, -3405, -1529, -3405,   601, -3405, -2365,
       0, -2773
  };

  const short
  parser::yydefgoto_[] =
  {
      -1,   130,   131,   132,   133,   134,  3201,  3910,   135,  2851,
    3867,   136,  3041,  3040,   137,  3088,  1336,  1337,   138,  1345,
    1346,   139,  1341,  2337,  2338,   140,  1283,  1284,  3053,   141,
    3572,  3779,  3780,  4179,  4180,  4181,  4008,  4009,  4010,  4147,
    4148,   142,  1351,  1352,  3900,   143,   144,   145,   146,   147,
    2155,  1074,  1075,   367,   369,   371,   321,   375,   381,   148,
     515,  2630,   149,   150,  3685,  2589,  3639,  3688,   151,   152,
     153,   587,   588,   154,   869,   870,   155,   156,  1726,  2508,
    2509,  3271,   157,   858,   859,   954,   955,   158,   942,  3455,
    2097,  2098,  2853,  2854,  2099,  2202,  3503,  2100,   159,  1148,
    1149,  1150,   160,   418,  2497,  2498,  3912,  4154,  3914,  4155,
    4023,  4024,  4025,   161,   162,  1718,  1719,   163,  1730,  1731,
     164,   969,  3669,   165,  4040,  2236,  2237,   166,  1194,   525,
     167,   526,   527,   168,   965,   966,   169,  1114,  1177,   170,
    1127,  1178,  1765,   171,  1835,  1836,   172,  1766,  1767,   173,
     174,  1748,  1749,   175,  1179,  1180,   176,  1740,  1741,   177,
    1199,  1235,  1201,  3565,  3566,  2819,  1887,  2715,  2716,  2717,
     178,   819,   820,   821,  2785,  3689,   179,   830,   831,   180,
     825,   826,   181,   850,   851,  3932,  2786,   848,   849,   182,
     183,  1446,  1447,   184,   185,   186,  1851,   187,  2591,  3660,
    2539,  3699,  3974,  3960,  4115,  3647,  3648,  3596,  3597,   188,
     189,   190,  3365,  3366,   191,   192,   193,   694,   695,  3407,
    3408,  3963,  3964,  3410,  3411,   194,   373,  1270,   195,   374,
    1272,   196,   982,   983,   197,   198,   985,   199,  1009,  1010,
     200,   201,   202,   203,   204,   205,   897,   898,   206,   304,
    1888,  3280,  3454,   305,   207,   325,  2200,   208,   209,   210,
    1242,  1243,   211,   212,  1246,  1247,  1230,  1231,  1236,  1248,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   456,
     457,   458,   222,   480,   481,   223,  1506,  1507,   224,  1589,
    1590,   225,  1695,  1696,   226,  1571,  1572,   227,  1688,  1689,
     228,  1677,  1678,   229,  1663,  1664,   230,  1622,  1623,   231,
     232,  1387,  1388,  1158,  1159,  1212,  1213,  1303,  1304,   566,
     567,   233,   874,   875,   234,   860,   861,   235,   541,   542,
     236,   237,   549,   550,   238,  1193,  2250,  2251,   239,   493,
     494,   240,   978,   979,   976,   977,  2881,   241,   839,   840,
     242,  3710,   243,   971,   972,   244,   936,   937,   245,  1186,
    1187,   246,  1172,  1173,  2982,   247,  1455,  1456,  1011,  1012,
    1013,  1130,  1131,  1132,   956,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1202,  1026,   842,
     843,   844,   529,  1133,  1203,  1249,  1027,  1028,  1134,  1135,
     530,  1029,   957,   531,  1137,   958,  1030,  1031,  1032,  1033,
    1034,  1448,  2339,  2340,  2341,  2342,  3093,  2343,  1338,  1339,
    1449,   459,  1353,  1354,  1340,  1773,  1774,   460,  1347,  1348,
    1349,  1036,   707,   708,   461,  1450,  1451,   709,  1452,  3649,
    3650,  3651,  3652,  3601,  3653,  3654,  3367,  3368,  3369,  3655,
    3656,  3657,  3606,   462,   463,   712,   713,  1037,   715,  1305,
    1163,  1164,  1165,  1218,  1219,  1220,  1221,  1038,   568,  1306,
    1307,   569,  1308,  1039,   570,  1309,  1166,   571,  3390,  3391,
    1852,   482,   718,   545,   719,   720,   721,   722,   723,   724,
    1780,   726,   727,   728,   729,  1781,  1782,   732,   733,   734,
     735,  1783,   737,   738,   739,   740,  1784,  1138,  1785,   743,
     744,   745,   746,  1041,   483,   749,   750,  1042,   499,  1043,
     754,   755,   756,   500,   960,  1044,  1045,   464,   465,   503,
     761,   762,   763,   764,   466,   467,   767,   504,  1790,  1046,
    1047,   772,  1238,  1233,  1048,  1049,  1794,  1795,  1796,  1050,
    1051,  1052,  1053,  1310,   572,  1311,  1312,  1313,   573,   574,
    1314,  1315,   575,   576,   577,  1316,  1317,   578,  1318,  1319,
    1320,  1321,   579,  1322,   580,   468,   469,   470,   471,   472,
     473,   474,   484,  1054,  1055,   784,   785,   786,   787,   788,
     789,   790,   791,   792,  1405,  1406,  1407,  1408,  1409,   911,
    1411,  1412,  1413,  1414,  1415,  1416,  1417,  1418,  1419,  1420,
    1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,  1430,
    1431,  1432,  1433,   912,  1434,  1435,  1436,   913,   914,   915,
     916,   917,   533,   534,   535,   536,   546,   505,   793,  1206,
    1665,  1666,  1510,  1511,  1512,  1513,  1514,  1515,  1516,  1517,
    1518,  1519,  1520,  1521,  1522,  1523,  1524,  1525,  1526,  1527,
    1528,  1529,  1530,  1639,  1531,  1532,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1056,  1057,
    1720,  1721,  1722,  1723,  1724,  1725,  1733,  1734,  1735,  1803,
    1239,  1742,  1743,  1744,  1745,   795,   506,   507,  1804,   799,
    1573,  1574,  1642,  1575,  1555,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,
    1576,  1670,  1671,  1682,  1683,  1684,  1685,  1686,  1577,  1578,
    1579,  1693,  1598,  1580,  1581,  1582,  1583,  3658,  1585,  1586,
    1710,  1250,   800,   920,   801,   802,   803,   804,   805,  1059,
    1060,  1806,  1807,  1141,  1188,  1189,  1190,  1191,  1192,  1142,
    1143,  1750,  1751,  1168,  1169,   581,  1837,  1808,  1838,  1809,
    1839,  1810,  1840,  1811,  1841,  1812,  1842,  1813,  1843,  1814,
    1844,  1815,  1816,  1817,  1818,  1819,  1061,  1062,  1063,  1064,
    1065,  1066,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,  2609,  2848,  3059,  3731,  3375,  3376,
    2604,  2605,  3084,  3085,  2726,  3262,  3582,  3263,  3121,  3122,
    1889,  4139
  };

  const short
  parser::yytable_[] =
  {
     248,  1954,   968,   256,  2089,  1584,  2230,  2038,  2061,   256,
     933,  2125,  2393,  1259,   256,  1264,  2220,  1269,  1707,   748,
     698,   498,   256,   903,   705,   866,   747,  2784,   711,   497,
     496,  1834,   730,   768,   306,   909,   919,  1400,  1237,   741,
     901,  1410,  1627,   256,   256,   322,   908,   710,   256,  1732,
     532,   256,  1628,   910,   256,  1232,  2827,  1437,  1629,  1234,
    1630,   256,   256,   701,   256,  1438,   256,  1224,   256,   368,
     370,   372,  1217,  1440,   376,   714,   256,   382,  1115,  1222,
    1631,  1632,  1008,  1195,   697,   845,  1633,   863,  1205,  1161,
    1634,   501,  1635,  1323,  1128,   904,   846,   479,   502,   703,
     543,  1636,   782,   706,   899,  1215,   731,   736,   742,   758,
     528,   256,  2857,  1162,  1200,   751,   759,  1204,   752,  1136,
     704,  2858,   757,   696,   760,   765,  1395,   907,   256,  1216,
     248,  1136,   900,   766,  1637,   769,  1399,  3266,  1403,  1439,
     771,   775,  1638,  1389,   980,   783,  1643,  1391,  1509,  1225,
    2159,  1394,   753,  1595,   699,  1401,  1404,  1597,   776,   777,
     796,   725,  1402,  1701,  1139,  1692,  1035,  3687,   797,  1929,
    1393,  1392,  2941,   585,   586,  1324,  1139,   939,  1775,  1775,
    1786,  1786,  1129,  3098,  3099,  1593,   255,   981,  3379,   700,
    1596,  1681,   265,   798,  1129,  1699,  1599,   273,  1396,   528,
    1702,  3447,  1776,  1776,   940,   285,  1703,  1040,   794,  1594,
    3786,   964,   807,  1669,   808,  3547,  1935,  1771,  1771,  1700,
    2022,  2969,   770,   437,   773,  2055,   319,   320,  2028,  1777,
    1777,   327,   774,  1453,   332,   778,  3377,   338,  2090,  1145,
    1454,  2970,  3403,  2057,   351,   354,  1625,   359,   779,   363,
    2618,   365,  3463,  1626,  1058,   510,  1801,  1801,   780,   380,
     716,   508,   551,  1788,  1788,   510,  4189,   306,   306,   589,
    1789,  1789,   864,   510,   822,   827,   832,  1768,  1768,  1078,
     905,   852,  3374,  2661,  2662,   510,   868,   871,  2106,  2660,
     876,  -865,  -867,   589,   405,  2113,   938,  2148,   306,  1802,
    1802,   781,  2685,  2601,  2689,   306,  1787,  1787,  1769,  1769,
    2207,   429,   973,  2687,  1600,   984,   986,   717,  3598,   510,
     510,  1071,  3374,  3461,  1704,  1111,  2214,   510,  1079,   865,
    2724,   806,   510,   306,  2240,  2253,   809,   906,   510,  1174,
    1601,  4189,   495,  1770,  1770,   810,  2257,  1954,   811,  2268,
    1705,   510,  1602,  2270,   510,   812,  1603,   813,  2280,   510,
     702,  3768,  1706,   510,  2603,   510,  1708,  1257,  2309,  1262,
    -869,  1267,   814,  1271,  1273,  1276,  1791,  1791,  1792,  1792,
     510,  1328,  2330,  1397,  2347,  1604,  1793,  1793,  2350,  1797,
    1797,   547,  1140,  1355,  2390,  1709,   433,  1457,   249,  1459,
    3496,  3397,  1798,  1798,  1140,   510,  3991,  1746,  3908,  3728,
    1078,   251,  1799,  1799,  1778,  1778,  1078,  1117,  3599,  3432,
    1253,  3954,  3600,   918,  2505,  1160,  2511,  3401,  2684,   510,
    2688,  1117,  2517,  1850,  1853,  1857,  1861,  2239,  1893,  2521,
    1398,  1214,  2521,  2544,    39,   552,   553,  3095,  3643,  3671,
    3671,  3972,   554,   583,  3371,  1800,  1800,   555,   556,  1079,
    3548,  3602,  3680,  3603,  1078,  1079,  2727,  2728,  1167,  3683,
    3722,  1779,  1779,  3604,  1078,  3745,  1072,  2816,  1258,  3966,
    3671,  3798,  3813,  1390,  1223,  1805,  1805,  3822,  3886,  1508,
    1820,  1820,  3828,  3643,  3643,  3822,  4047,  1624,  3822,  1821,
    1821,  3643,  1822,  1822,  3643,  3605,  3822,  3822,  1919,  1823,
    1823,  1824,  1824,  1079,  1772,  1772,  3643,  3822,   557,  1227,
    3828,  1078,  4108,  1079,  4108,  2045,  1825,  1825,  2620,  1333,
    1146,  3152,  3545,   323,  1146,  1334,  2045,  1078,  1263,   558,
    4137,  3707,  3708,  3904,  3905,   257,  3459,  1078,  1937,  1938,
    3777,  3856,  2219,  1146,  2992,  3258,  1591,  2868,  1640,  1078,
    1667,  1078,  1679,  1592,  1690,  1641,  1697,  1668,  1342,  1680,
    1079,  1691,   448,  1698,  3373,  3752,   260,   508,  3829,   559,
     560,   974,  4044,  2124,  2233,  2234,  1079,   589,  2697,  4138,
     511,  1078,  3011,  1078,  2116,   544,  1079,  1078,  3018,   324,
    3727,  3508,   261,  4137,  1078,  2869,  3829,  -443,  1079,  1078,
    1079,  1560,  3254,  2201,   841,   592,   877,   593,   262,   862,
    2698,  2699,  2734,  2735,  1343,  2276,  3272,   902,  3255,  3218,
    3778,  1285,  1286,   266,  2755,   267,  1287,  1288,  1289,  4113,
    1079,  3466,  1079,  1290,  1291,  3399,  1079,  3219,  2493,  1292,
    1293,  4124,  4138,  1079,  1563,  3070,  3071,  2775,  1079,   268,
    3374,  3069,  2117,  3764,  1116,  1078,  1569,  1687,  -330,  1078,
     561,  3765,  1268,   280,  2201,   512,   513,   514,  1116,   274,
    2775,   275,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   282,  4078,  3441,  1294,  1747,  3400,  3442,  2762,  2763,
    2712,  3906,   281,  3769,  1079,  3735,  2152,  2153,  1079,   258,
     259,  2233,  2234,   610,   611,  1295,  3142,  3143,  2494,  3840,
    2495,  2496,   341,  2817,  2818,  1078,  2189,  2190,  2191,  2192,
    2193,  2194,  2195,  2196,  2197,  2198,   975,  2199,   975,  2764,
    2621,  2622,  2623,  2624,  2625,  2626,   286,   617,  2776,   289,
      39,  1228,  1229,  4198,  1930,  1296,  1297,  1659,   620,  2233,
    2234,   878,  1073,  2157,  1073,   295,  1862,  3546,  1254,  2233,
    2234,  2776,  3610,  3543,  1079,  2777,  2778,  2779,  2151,  2046,
    1241,  2507,   539,  3663,  3372,  3709,   298,  3163,  3448,  3777,
    3598,  4199,  4119,   438,   290,   562,   975,  3787,  2777,  2778,
    2779,  1936,  3549,  2602,  2971,  2023,  2024,   489,  2025,   822,
    2056,  2029,  1863,  2030,  2031,   827,  2233,  2234,  2035,  2036,
     832,  4208,  2091,  3378,  1073,  1864,   563,   548,  2058,  3404,
    1147,  3498,  2233,  2234,  1147,  3464,  3275,  1865,  1866,  2285,
     852,   299,  2233,  2234,  2700,   662,  1298,   311,  3524,  4190,
     664,  1299,  3294,  1147,  2233,  2234,  2233,  2234,  2111,   871,
    3307, -2198, -2198,   670,   876,   508,   879,   880,  3634,  3778,
     975,    39,   967,  2107,   490,  3321,   539,  1867,   967,  1660,
    2114,  3857,  2149,  1335,  3401,  2736,  2233,  2234,   881,   674,
    3599,  2780,  2286,  2287,  3600,  2208,   250,  2290,  2291,   508,
     312,  3198,  2294,  2295,  2233,  2234,  2602,  3462,   540,   252,
    3207,  2215,  4045,  3210,  2780,  4057,  4058,  3877,  1155,  2241,
    2254,  1078,  1344,   589,  4220,  4064,   938,  4065,  3153,  3154,
     315,  2258,  1111,  3602,  2269,  3603,  2493,   316,  2271,   346,
   -2198,   681,   360,  2281,   333,  3604,    39,  3661,   508,  1661,
     584,  3664,   306,  2310,   882,   883,   377,  2115,  1073,  3120,
     434,   973,  3274,  2289,  2713,  2714,  3677,  2331,   364,  2348,
    1079,  1078,   984,  2351,  2293,  2132,  2910,  3605,  3293,  2391,
    2990,  1156,  3042,   508,  2991,  3497,  3306,  2781,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,  3636,  1078,  2506,
    2781,  2512,  1300,  2725,  4079,  4080,  2494,  2518,  2495,  2496,
    1079,  2235,  3045,   430,  2522,  3878,   884,  2523,  2545,  3879,
    1868,  1869,  3096,  3644,  3672,  3674,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  3681,    39,  2712,
    1881,  1882,  1883,  1884,  3684,  3723,   564,  1079,   565,  2150,
    3746,  1301,   389,  2156,  2156,  3766,  3799,  3814,  3841,   390,
    3083,  3048,  3823,  3887,  1073,  3830,  1111,  1111,  3953,  3971,
    4036,  4048,    39,  4053,  3519,  2332,  4112,  4241,   420,  4123,
     508,  4165,  4171,  1078,  4039,  3164,  3165,  1111,   391,  2333,
    4003,  4197,  4223,  3874,  4072,  4109,  4110,  4129,  4110,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,  1886,   508,
    3436,    39,  4133,  2816,   392,  1073,  2217,  2218,  2993,   393,
    2782,   422,  1079,  4209,  4210,   396,  2594,   269,   270,  2597,
    2655,  2656,  2657,   399,  2658,   402,  4161,   419,   508,  2203,
    2204,  2205,  1174,  2782,  3785,   435,    39,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2197,  2198,   421,  2199,  3837,
     423,  2859,   962,  2252,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   424,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,  2584,  2585,  2586,   962,  2587,   436,  3869,  1560,  3562,
    2913,  2197,  2198,  2916,  2199,  1078,  2233,  2234,   425,   885,
     886,   887,   888,   889,   890,   891,   892,   893,   894,   895,
     896,  2334,  1302,   276,   277,  2284,  2195,  2196,  2197,  2198,
    2288,  2199,  1441,  1442,   426,  2292,  2652,  2653,  2654,  1073,
    2298,  1563,  2301,   427,  2302,  3815,  1277,  2655,  2656,  2657,
    1073,  2658,  1073,    39,  1079,   439,  2233,  2234,  1073,  1443,
    1444,   548,  1885,  1662,  1570,   475,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,  2655,  2656,  2657,   590,  2658,
    2659,   833,    39,  2713,  2714,   847,  2322,   872,  1073,  2824,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,  2585,
    2586,    39,  2587,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2584,  2585,  2586,   873,  2587,  3824,  3567,  3568,  2158,   934,
    3569,  2335,  2738,  2739,  2740,    39,   935,  1073,   959,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   941,  2817,
    3729,   677,  4203,  4204,  3854,   967,  1073,    39,  2233,  2234,
    1073,   278,   279,  3686,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,  1712,   961,  4228,  3499,   302,  1073,   537,
     970,   538,  1076,  4116,  2745,  2746,  2747,  3730,  1445,  1077,
    1714,   287,   288,  4242,  1278,  1457,  1112,  2395,  1727,  1728,
    2336,  1729,  2583,  2584,  2585,  2586,  1151,  2587,  1279,   302,
    3667,  4254,  4255,  3635,  1175,  2686,  2577,  2578,  2579,  2580,
    2581,  2582,  2583,  2584,  2585,  2586,  1241,  2587,   291,   292,
    3587,  3588,  3589,  3590,  3591,  3592,  3593,  3594,  2994,   853,
     854,   855,   856,   857,  3675,   293,   294,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2197,  2198,  1176,  2199,  1329,
    3843,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
    2233,  2234,  1330,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  3721,  2199,  2748,  2749,  2750,  1280,  1331,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   834,
     454,   455,  2655,  2656,  2657,  1332,  2658,  1458,  3757,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,  1556,   600,
    1281,  1711,  3637,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,  3587,  3645,  3589,  3646,  3591,  3592,  3593,  3594,
    1736,  1737,  1738,  1739,  1846,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,  1894,  4042,   296,   297,   490,   516,
     539,  1181,  1182,  1895,   517,   518,   519,   610,   611,  4054,
    3063,  3064,  3065,  1713,  1896,   498,  1897,  2134,  1898,  3595,
    3362,  3363,  3364,   497,   496,  3758,  2272,  2273,  2274,  2275,
     300,   301,   540,   307,   308,   520,  1899,   448,  1714,  1715,
    1716,  1717,   309,   310,  3211,   835,   313,   314,   328,   329,
     532,   330,   331,  1282,  1900,   334,   335,   521,   539,  1901,
     522,  1902,  3581,  3437,  3761,   449,   339,   340,  1903,  2857,
     342,   343,  3068,  1904,  3243,  3244,   344,   345,  2858,   347,
     348,  1905,  1152,   355,   356,   501,  1906,   479,   383,   384,
     385,   386,   502,  3781,  2860,   387,   388,   394,   395,   748,
     698,   397,   398,  1907,   705,   543,   747,  1908,   711,  1909,
     528,   836,   730,   768,  1910,   963,   400,   401,  1911,   741,
     406,   407,   408,   409,  1912,  2911,  2912,   710,   866,  1913,
    3870,   410,   411,  1183,  1184,  1914,  2599,   412,   413,   662,
     414,   415,  1185,   701,   664,   903,  1918,  3456,   416,   417,
    4166,   667,   668,  2741,  2742,   714,  1917,   909,   919,   837,
     838,  3595,   901,  1915,   697,  2758,  2759,  1916,   908,  1920,
     539,  2974,  2975,  1921,  3965,   910,  3967,  2651,  1922,   703,
     845,  1923,   782,   706,  4081,  4082,   731,   736,   742,   758,
     863,   846,  3986,  1924,  3988,   751,   759,  1925,   752,  1926,
     704,  2683,   757,   696,   760,   765,  4211,  4212,  4229,  4230,
    1927,   524,  1928,   766,  1931,   769,  1932,   904,  1153,  1933,
     771,   775,  4140,  4141,   450,   783,   899,  1934,  2722,  1940,
     306,  1154,   753,  2732,   699,  2608,  2610,  1941,   776,   777,
     796,   725,  1008,  3561,  3563,  3282,  3283,   256,   797,   907,
    2631,  1942,  1943,  1944,   900,   490,  1945,  1946,  1947,  3043,
    3044,  1948,  1949,  3046,  3047,  1950,  1951,  3049,  3050,   700,
    2650,   306,  1952,   798,  1955,  1956,  2663,  1957,   256,  3802,
    3027,   256,   256,  1958,  1959,  1960,  2958,   980,   794,  1961,
    2678,  1568,   807,  1962,   808,   306,  1963,  1232,  1155,  1964,
    2821,  1234,   770,  1965,   773,  1966,  1967,  2965,  1224,  1161,
    2831,  1110,   774,  1217,  1968,   778,  3402,  3405,  3008,  1969,
    1222,  2721,   306,  2844,  1970,  1205,  1035,   306,   779,  1971,
     981,  1972,  1136,  1162,  2744,  1973,   495,  1974,   780,  1975,
     716,  1976,  1977,  1978,  1979,  1980,  1215,  3835,  1981,  1982,
    1983,  1200,  1984,   256,  1204,  1985,  1400,   516,  1136,  1986,
    1410,  1156,   517,   518,   519,  1323,  1987,  1040,  1988,  1989,
    1216,  1990,  1991,  1992,  2897,   864,  1437,  1139,  4130,  4120,
    1993,   781,  1994,  1995,  1438,  1996,  1584,  1997,   256,  1998,
    1225,  1999,  1440,   520,   306,  1129,   547,   717,  2000,  2001,
    2002,  2003,   905,  1139,   306,  2004,  2005,  2006,  2007,  2008,
    1108,   806,  2009,  2010,  1058,   521,   809,   306,   522,  2011,
    2846,  1129,  1707,  2012,  2013,   810,  2855,  1111,   811,  2014,
    2628,  2015,   865,  1568,   528,   812,  2016,   813,  1627,   306,
     702,  2017,  2018,  2019,  2020,  1395,  2021,  1324,  1628,  2034,
    2039,  2880,   814,  2882,  1629,  1399,  1630,  1403,  1439,   906,
    2040,  2666,  1389,  2891,  2669,  2671,  1391,  2041,   306,  1732,
    1394,  2042,  1834,  2043,  1401,  1404,  1631,  1632,  2997,   256,
    2999,  1402,  1633,  2044,  2156,  2049,  1634,  2156,  1635,  1393,
    1392,  1111,  1111,  1111,  1111,  2921,  2922,  1636,  4200,  1111,
    1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,
    1111,  1111,  1111,  1111,  1111,  1111,  1111,  1396,  1509,  1111,
    1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,
    1637,  2955,  2050,  1595,  2051,  2052,  2772,  1597,  1638,  2053,
     523,  2054,  1643,  2059,  2062,   918,  2063,  3062,  2064,  2067,
    2068,  2069,  3992,  2070,  2977,  2978,   256,  1453,  2983,  2071,
    2072,  2983,  2986,  2073,  1454,  1593,  2074,  1701,  1692,   524,
    1596,  2813,   306,  2075,   306,  2076,  1599,  2077,  2078,   256,
    2252,  2239,  2079,  3520,  2080,  3102,  2081,  3915,   256,  1594,
    2082,  3918,  2083,   256,  1681,  3922,  2084,  3933,  3934,  1699,
     544,   256,  2086,  2087,  1702,  1140,  2092,  2093,  2094,  2101,
    1703,   256,  1669,  2102,  1775,  2103,  1786,  2104,  2105,  2108,
    1775,  3140,  1786,  1700,  1157,  1117,  3051,  2109,  2121,  3052,
    2112,  1140,  2123,  2118,  3054,  2122,  3056,  3057,  1776,  3159,
    2126,   306,  1625,  2127,  1776,  1160,  2130,  2135,  3072,  1626,
     256,  2136,  1073,  1771,  2137,  2138,  2139,  3081,  1117,  1771,
    2140,  3089,  2909,  2160,  2216,  1777,  2141,  2142,  2143,  3419,
    2144,  1777,  2145,  2146,  3097,  2147,  2161,  2162,  2163,   306,
    1355,  3203,  1214,  3205,  3206,  3557,  2164,  2165,  1167,  2166,
    2169,  2170,  1801,  2171,  1600,  2172,  2173,  2206,  1801,  1788,
    2174,  2175,  1397,  2176,  2177,  1788,  1789,  2220,  2178,   841,
    2179,  2180,  1789,  1768,  2181,   306,  3141,  2182,  2209,  1768,
    1601,  3396,   862,  2183,  3148,  1223,  3150,  2184,  1704,  2185,
    2210,  2186,  1602,   306,  2187,  1802,  1603,  2211,  2212,  2980,
    2213,  1802,  1787,  2221,  1769,  3425,  2222,  2223,  1787,   902,
    1769,  2224,  2225,  2227,  1705,  3286,  2228,  2226,  2231,  1398,
    2232,  2242,  3004,  2243,  3299,  1604,  1706,  2244,  2248,  2245,
    1708,  3014,  3312,  2247,  2246,   306,  3020,   306,   306,  1770,
    2255,  2256,  2259,  2260,  3029,  1770,   256,  2261,  2263,  2262,
    2393,  2264,  2265,  2266,  3039,  2267,  2278,  2279,  2282,  1709,
    2283,  2303,  1390,  2304,  2305,  2306,  2307,  2308,   448,  2311,
    2312,  2320,  1791,  2313,  1792,  2314,  2315,  2316,  1791,  2317,
    1792,  2318,  1793,  2319,  2321,  1797,  2327,  2323,  1793,  2324,
    2325,  1797,  2125,  3075,  2326,  2328,   449,  2329,  1798,  2344,
    2345,  2346,  2089,  2349,  1798,  2352,  2353,  2354,  1799,   306,
    1778,  2355,  3402,  1208,  1799,  2356,  1778,  2357,   306,  1508,
    2358,   256,  2359,  2360,  2361,  2362,   306,   256,  2363,  3475,
    3317,  3318,  1116,  2364,  1853,  2365,  2366,  3322,  3323,  2367,
    3325,  3326,  3327,  2368,  3329,  3473,  2369,  2370,  2371,  2507,
    3438,  1800,  2372,  1624,  2373,  2374,  2375,  1800,  2376,  2559,
    2560,   968,  2377,  2061,  2378,  1116,  2379,  1779,  2380,  2381,
    2382,  2383,  3476,  1779,  2384,  2385,  2576,  2386,  2387,  2388,
    2389,  1805,  2396,  2398,  2399,  2400,  1820,  1805,  1110,  2397,
    2401,  2038,  1820,  2402,  2441,  1821,  1591,  2403,  1822,  2404,
    2405,  1821,  2406,  1592,  1822,  1823,  2407,  1824,  2408,  2409,
    1772,  1823,  2410,  1824,  1640,  2411,  1772,  2455,   510,  1667,
    3386,  1641,  1825,  2412,  2413,  1679,  1668,  1690,  1825,  3215,
    1697,  2414,  1680,   256,  1691,  2415,  1560,  1698,  2416,  2417,
    2577,  2578,  2579,  2580,  2581,  2582,  2673,  2418,  2585,  2586,
    1209,  2587,  3676,  2419,  3678,   450,   510,  2420,  2421,   510,
    2422,   510,  1154,   448,   589,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,  2584,  2585,  2586,  2423,  2587,  3538,  1562,  1563,
    3539,   256,  1109,  3540,  2424,  2425,   490,  2426,  2427,   485,
     486,   449,  2428,  2429,  1210,  2430,  1672,  1673,  1674,  1675,
    1676,  2431,  2432,  2433,  3303,  2434,  2435,  2436,  2437,  2438,
    3314,  2439,  2440,  2442,  2443,  2444,  3733,  2445,  2446,  2783,
    2447,  2230,  2448,  2449,  2450,  2790,  2451,  2452,  2453,  1155,
    2794,  2454,  1110,  1110,  2456,  2457,  2458,  2459,  2460,  2461,
    2803,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,
    2586,  2462,  2587,  1110,  2463,  2476,   487,  2464,  2823,  2465,
    2466,  3453,   510,  3413,  2467,  3493,   964,  2468,  2994,  2469,
    2470,  2471,   488,  2472,  2473,  2474,  2475,  3417,  2477,  2478,
    2479,  3420,  2480,  2482,  2483,   832,  2484,  2481,  2485,  2486,
     508,  2487,  1156,  2488,  2490,  2491,  2489,  3617,  2499,  2492,
    1954,  2500,  2531,   510,  3430,  2501,  2502,  2503,  2504,  2532,
     871,  1557,  2510,  2538,   489,  2537,  3387,  2540,  2513,  3923,
    2514,  2887,  2515,  2890,  2516,  3924,  3925,  3926,  3927,  3928,
    3929,  2167,  2168,   589,  2519,  1558,  1559,  2520,  3618,   938,
    3930,  1111,  1954,  2524,  2525,  2526,  2527,  2528,  3931,  1111,
    2529,  2530,  2188,   256,  2533,   306,  2534,  2535,  2541,  2536,
     306,  2542,  2543,  2546,  3398,  2189,  2190,  2191,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,  2547,  2199,  2548,  2549,  3469,
    2550,   490,  2554,  2551,  2552,  2596,  2553,  2598,   452,  2600,
    2676,  2555,  2556,  3817,  2606,  2557,  2558,  2607,  2612,   510,
    2773,  2613,  2615,  2561,  2617,  2562,  2632,  3607,  2189,  2190,
    2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,  2563,  2199,
    2564,  2565,  2566,  2592,  2567,  2568,  2989,  2569,  2570,  2571,
    3838,  2633,  2572,  3842,  2573,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  3691,  2199,  2574,  1111,   440,   441,   442,
    2575,  2590,  2634,   443,   444,   445,   446,  3023,  3505,  3506,
    2602,  2637,  2639,  3030,  3031,  3032,  3033,  2641,  2644,  2643,
     510,   447,  3513,    39,  2133,  3513,  2645,   943,  2647,  2664,
     944,   448,   454,   455,  2675,  2682,  2648,  2649,   256,  2690,
     256,  2693,  2672,  2695,   510,  2674,  3055,  2696,  2691,  2708,
    2709,  2710,  2711,   945,   510,  2718,  3888,  2719,  2723,   449,
     510,  1078,   256,  2725,  2733,  1211,  2743,   946,  2751,   510,
    2752,  2753,  2757,  2761,  1560,  1561,  2766,  2767,  2765,   510,
    1111,  1111,  2769,  2787,  2788,  2774,  3452,   947,  2791,  2792,
    3917,  2789,  2796,  1111,  3921,  2793,  2797,  2795,  2800,  2825,
    2804,  2798,  1862,  2801,  2826,  1157,  2828,  2829,  2802,  2832,
    1079,  2810,  2814,  2815,  2805,   510,  1562,  1563,  2833,  1564,
    1565,  3949,  1566,  1567,  1568,  2820,  2834,  2806,  3552,  1569,
    3553,  3554,  3555,  2822,  3558,  2807,  2808,  2838,  2839,  2840,
    1570,  2842,  2843,  2847,  2845,  2852,  2864,  2894,  1863,  2849,
    2850,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,
    2198,  1864,  2199,  2871,  2863,   256,   256,   256,  2865,  2872,
     256,  2914,  2895,  1865,  1866,   491,   492,   948,   949,  2899,
    2867,  3889,  3990,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2584,  2585,  2586,  2117,  2587,  2875,   950,  2876,  2900,  2877,
    2902,   256,  2904,  2905,  2878,  2906,  2957,    39,  2962,  2879,
    2883,  2884,  2886,  1867,  2888,  2964,  2968,  2976,   450,   451,
    2956,  3522,  2998,  3523,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,  2584,  2585,  2586,  3946,  2587,  2954,  3007,  3001,  2199,
    3000,  1111,  2959,  2966,  2967,  3529,  3015,  3016,  2972,  2973,
    2984,  2996,  3002,  3009,  3017,   510,   452,   453,  3022,  4041,
     951,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
    3024,  3035,  3026,  3058,  3034,  3061,  4041,  3066,  3067,  3073,
     952,  3078,  3077,  3079,  3080,  3082,  3330,  3331,  3332,  3333,
     256,  3090,  3334,  3335,  3336,  3337,  3338,  3339,  3340,  3341,
    3342,  3343,  3344,  3345,  3346,  3347,  3348,  3083,  3350,  3351,
    3352,  3353,  3354,  3355,  3356,  3357,  3358,  3359,  3360,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  3947,
    2587,  4111,  3091,   510,  3092,  1557,  3094,  4117,  3101,  1109,
     454,   455,  3104,  3105,   510,  3106,  3107,  3108,  3109,  3110,
    3111,  3968,  3112,  4111,  3113,  3114,  1868,  1869,  2110,  1558,
    1559,   953,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  3115,  3573,  3125,  1881,  1882,  1883,  1884,
    3116,  3117,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,
    2197,  2198,   508,  2199,  3119,  3126,   440,   441,   442,  4162,
    3253,  3127,   443,   444,   445,   446,  3120,  3128,   476,  3129,
    3665,  3130,  3132,  3138,  3666,  3260,  3144,   510,  3155,   477,
     447,  3976,  3156,   509,  3146,  3157,   589,  3147,   510,  3607,
     448,  3158,  3160,  3162,  3166,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   832,  3149,  3167,  3261,   449,  3168,
    3169,  3151,  3170,  3161,   871,  3173,  3174,  3175,   589,  3176,
    3177,  3178,  3180,  3580,   938,   478,  3181,  3182,  1111,  1111,
    3183,  3184,   510,  1109,  1109,  1111,  3185,  3186,  3187,  3188,
    3189,  3190,  3191,  3732,  2579,  2580,  2581,  2582,  2583,  2584,
    2585,  2586,  3192,  2587,  1109,  1111,  1111,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2197,  2198,  3193,  2199,  3418,
    3194,  3195,  3196,  3421,  3197,  3200,  1111,  3202,  1111,  3204,
    3208,  3209,  3212,  3223,   256,  3217,  3225,  3226,  3229,  3230,
    3231,  3753,  3232,  3236,  3237,  3238,  3239,  3242,  1560,  1561,
    3241,  3245,   510,   510,  3250,  3264,  3247,  3249,  3252,   510,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,
    3267,  2587,  3256,  2238,  3268,    39,  4004,  3281,  3257,  3287,
    3770,  3270,  3277,  3285,  3289,  3290,  1111,  3291,  3292,  3295,
    1562,  1563,  3300,  1564,  1565,   510,  1566,  1567,  1568,  1694,
    3301,  3305,  1890,   510,  3308,  2587,  3316,  2045,  1885,  3320,
     510,  3388,  3361,  3370,  1570,  3414,  3381,   450,   451,  3380,
    3382,  3389,  3471,  3406,  3415,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,  2584,  2585,  2586,  3416,  2587,  3431,  3800,  3432,
    3433,  3803,  3409,  3435,  3806,  3440,  3446,  3439,  3443,  2889,
    3449,  3450,  3458,  3459,  3465,   452,   453,  3474,  3872,  3479,
    3480,  3501, -2199,  3504,  3515,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,  2584,  2585,  2586,  3518,  2587,  4073,  4074,  3525,
    3542,  3556,  3560,  3570,  3576,  3577,  1078,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,  3583,  2587,  2201,
    3834,  3507,  3608,  3571,  3578,   508,  3579,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2197,  2198,  3747,  2199,  3584,
    3609,  3611,  3612, -2198,  3521,  3614,  3615,  1862,  3613,  3616,
    3640,  3641,  3642,  3659,  -866,  1079,  3374,  3662,  3526,  3668,
    3670,  3864,  3679,  3865,  3682,  3868,  4134,  4135,  3690,   454,
     455,  3693,   306,  3695,  1111,  3698,  3701,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,  3700,  2587,  3703,
    3706,  3712,  3711,  1863,  1111,  1111,  1557,   510,  3713,  3716,
    3741,  3725,  3734,  1110,  1174,  3748,  1864,  3736,  3749,  3744,
    3754,  3767,  3901,  3901,  3759,  3772,  3773,  3774,  1865,  1866,
    1558,  1559,  3776,  3775,  3783,  3784,  1457,  3789,  4173,  3790,
    3791,  3792,  3911,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    39,  3793,  3940,  3794,  3795,  3943,  1867,  3796,
    3797,  3801,  3804,  3807,  3808,  3819,  3805,  1110,  1110,  1110,
    1110,  3820,  3821,  3826,  3827,  1110,  1110,  1110,  1110,  1110,
    1110,  1110,  1110,  1110,  1110,  1110,  1110,  1110,  1110,  1110,
    1110,  1110,  1110,  3825,  3836,  1110,  1110,  1110,  1110,  1110,
    1110,  1110,  1110,  1110,  1110,  1110,  4125,  3845,    39,  3846,
    3847,  3852,  3880,  3855,  3859,  3861,  3863,  3981,  3866,  1111,
    3875,  3881,  3876,  3882,  3896,  3907,  3913,  3427,   508,  3955,
    3936,  3956,  3957,  3937,  3938,  3941,  3958,  3952,  1111,  1111,
    3962,  3959,  3961,  -868,  3977,  3973,  3978,  1174,  3984,  3982,
    4002,  3987,  4002,  1457,  3985,  3989,  4007,  4011,  4012,  4013,
    4017,  4018,  4014,  4026,  4038,  4027,  2917,  2918,  2919,  2920,
    4028,  4035,  4029,  4030,  2923,  2924,  2925,  2926,  2927,  2928,
    2929,  2930,  2931,  2932,  2933,  2934,  2935,  2936,  2937,  2938,
    2939,  2940,  4031,  4046,  2943,  2944,  2945,  2946,  2947,  2948,
    2949,  2950,  2951,  2952,  2953,   582,  4049,  4043,  4032,  1560,
    1561,  1868,  1869,  4050,  4060,  4037,  4087,  1870,  1871,  1872,
    1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  4055,  4059,
    4052,  1881,  1882,  1883,  1884,  2189,  2190,  2191,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,  4066,  2199,  4063,  4092,  4095,
    4071,  1562,  1563,  1588,  1564,  1565,  4076,  1566,  1567,  4096,
    4099,  4083,  4084,  4067,  1569,  4086,  3831,  4106,  4070,  4102,
    -870,  4128,  4144,  4146,  4149,  1570,  4075,  4077,  4157,  4098,
    4085,  4101,  4158,  4168,  4090,  4105,  4145,  4114,  4122,  4126,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   508,
    4127,    39,  3638,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2584,  2585,  2586,  4131,  2587,  4132,  4136,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,  4150,  2587,  4151,
    4152,  4159,  4164,  4169,  4167,  4156,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,  4170,  4174,  4175,  4176,  4172,
    3692,  4178,  4182,  4186,  4187,  4192,  3697,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2197,  2198,  3704,  2199,  4193,
    4196,  4201,  4214,  4206,  4177,  4205,  4207,  4215,  4216,  4218,
    4184,  4185,  4222,  4224,  4225,  4226,  4233,  4156,  4234,   508,
    4235,  4236,  4237,  4238,  4240,  4243,  4244,  4247,  4245,  3279,
    3737,  3279,  3279,  4248,  4202,  4249,  4252,  4250,  4253,  4257,
    4258,  4259,  4213,  4261,  4262,   432,  3100,  4217,  3559,  4219,
    3086,  3909,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,
    2197,  2198,  3060,  2199,  3434,  1069,  4227,  4183,  3273,  3751,
    3724,  3103,  2809,  1885,  3902,  2866,  3717,  3509,  4094,  4191,
    3755,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,
    2586,  4188,  2587,   256,  3259,  3269,  3460,  3726,  3276,  4062,
    3517,  4251,    39,  2640,  2942,  2874,   510,  3315,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  4260,  2587,
    1752,  2593,  2238,  2595,  3304,  2238,  2995,  3288,   815,  2027,
    3284,  3012,  3424,  1849,  2048,  3145,  2033,  2614,  1860,  3951,
    3935,  1856,  2619,  3818,  3788,  3839,  2770,  4118,  2841,  3844,
    2129,  2635,  2636,  2907,  2638,  2870,  2277,  3037,  2642,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,  3809,  3810,
    3025,  3199,  3349,  3216,  3251,  3213,  2677,  3246,  2679,  2680,
    2681,  3248,  2981,   508,  3235,  3811,  3468,  3812,  2692,  2611,
    2694,  3139,    39,  2616,  2701,  2702,  2703,  2704,  2705,  2706,
    2707,  3240,  3021,  3076,  2066,  2238,  1939,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,  2737,  2587,  2811,
    2646,  3006,  2885,  3467,  2799,  2667,  2120,  2754,  2756,  3444,
    3897,  2760,  3319,  3003,  2985,     0,  3477,  2768,    39,  2629,
    3903,  3848,  3849,  3920,  3851,     0,     0,     0,     0,     0,
       0,     0,  3858,     0,     0,     0,     0,     0,     0,     0,
    3862,     0,     0,     0,     0,     0,  4246,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2197,  2198,     0,  2199,     0,
       0,     0,     0,     0,     0,  2238,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2835,  2836,  2837,     0,  3893,
    3894,  3478,     0,     0,     0,     0,     0,     0,     0,     0,
    3899,     0,     0,     0,  1109,     0,     0,     0,  2861,  2862,
       0,   867,     0,     0,     0,     0,     0,     0,  2588,  2873,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
       0,     0,  2893,     0,     0,  2892,  2898,  1110,   508,  2901,
       0,  2903,     0,     0,  3948,  1110,    39,     0,     0,     0,
       0,     0,  3950,     0,     0,     0,     0,     0,  1109,  1109,
    1109,  1109,   816,     0,     0,     0,  1109,  1109,  1109,  1109,
    1109,  1109,  1109,  1109,  1109,  1109,  1109,  1109,  1109,  1109,
    1109,  1109,  1109,  1109,  2026,     0,  1109,  1109,  1109,  1109,
    1109,  1109,  1109,  1109,  1109,  1109,  1109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2960,  2961,     0,  2963,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
    2987,  2988,     0,     0,  2238,     0,  3445,     0,     0,     0,
       0,     0,  1110,  4022,  3451,     0,   508,     0,     0,     0,
       0,     0,  3010,     0,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,  3036,  4033,  4034,     0,
       0,     0,  1067,     0,  3005,  2189,  2190,  2191,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,     0,  2199,     0,     0,  4051,
       0,     0,     0,     0,     0,     0,  3481,  4056,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  4091,  2586,     0,  2587,
       0,    39,     0,     0,     0,     0,  1110,  1110,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1110,
       0,  3502,     0,     0,     0,     0,     0,     0,     0,    39,
    2559,  2560,     0,     0,     0,  4093,     0,     0,     0,     0,
       0,     0,  3118,     0,     0,  3123,  3124,     0,     0,     0,
    4107,     0,     0,  3131,     0,  3133,  3134,  3135,  3136,  3137,
       0,     0,  1068,     0,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,     0,     0,     0,     0,     0,     0,
    3171,  3172,  4142,  4143,     0,     0,   817,     0,  3179,     0,
       0,     0,  3358,     0,     0,  3536,  3537,     0,  1070,    39,
       0,     0,     0,     0,     0,     0,     0,     0,  3541,     0,
       0,  4163,     0,     0,     0,   818,     0,     0,     0,    39,
    2238,     0,     0,     0,     0,     0,     0,  3220,  3221,  3222,
       0,  3224,     0,   508,  3227,  3228,     0,     0,     0,     0,
    3233,  3234,     0,   591,     0,     0,     0,     0,     0,  1847,
    2238,  2238,     0,   596,     0,  4022,     0,  1110,   598,     0,
       0,     0,  4194,     0,     0,     0,     0,     0,     0,  3265,
    2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,
       0,  2199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   601,   602,     0,   448,     0,     0,     0,   603,
     604,   605,     0,  1753,     0,     0,     0,     0,     0,     0,
       0,   508,  4231,  4232,  3482,     0,     0,     0,  1848,     0,
     607,     0,     0,   449,     0,  4239,  1113,     0,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,     0,     0,
       0,     0,   610,   611,     0,     0,  3574,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,     0,     0,     0,
       0,   613,   614,   615,  2189,  2190,  2191,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,     0,  2199,     0,     0,     0,     0,
       0,     0,     0,     0,   488,   623,   624,     0,   625,   626,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   641,   642,    39,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,     0,     0,     0,
    2987,  2988,   450,     0,   662,     0,     0,     0,     0,   664,
       0,     0,  2238,  2238,    39,     0,     0,   667,   668,     0,
     669,  1144,  1754,     0,  1110,  1110,     0,     0,     0,     0,
       0,  1110,     0,     0,     0,     0,     0,     0,     0,   672,
       0,     0,    39,     0,     0,     0,     0,     0,   674,  3483,
       0,  1110,  1110,     0,     0,     0,     0,     0,   523,     0,
       0,     0,     0,     0,     0,     0,   677,     0,     0,     0,
       0,     0,  1110,     0,  1110,  2189,  2190,  2191,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,     0,  2199,   524,     0,     0,
       0,     0,     0,   679,   680,     0,     0,     0,     0,     0,
     681,     0,     0,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,     0,  2199,     0,     0,     0,     0,     0,
       0,     0,     0,  3718,  3719,     0,     0,     0,     0,  1170,
       0,     0,  1110,     0,   454,   455,     0,     0,  1109,     0,
       0,     0,     0,     0,     0,     0,  1109,     0,     0,     0,
    3739,  3740,  2249,     0,     0,     0,     0,     0,     0,  3457,
       0,     0,     0,  3484,     0,     0,     0,     0,     0,     0,
       0,  3742,     0,  3743,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,     0,  2199,     0,     0,     0,     0,     0,
       0,  3771,     0,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  1109,  2199,     0,     0,     0,   683,     0,
       0,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,     0,     0,     0,     0,     0,     0,  2238,     0,  2238,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
    1110,   591,     0,     0,   593,     0,     0,     0,     0,     0,
       0,   596,     0,     0,     0,   987,   598,     0,     0,     0,
    1110,  1110,     0,     0,   686,     0,     0,  1109,  1109,     0,
       0,     0,     0,     0,  3485,     0,     0,     0,     0,     0,
    1109,     0,     0,     0,     0,     0,  1207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   603,   604,   605,
     988,   989,  3486,     0,     0,     0,     0,     0,     0,     0,
    1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,
       0,  2238,   688,   689,   690,   691,   692,   693,   508,     0,
       0,   990,     0,     0,     0,     0,     0,     0,     0,   991,
       0,   591,     0,     0,   593,     0,     0,  2238,  2238,     0,
     610,   611,   612,     0,   597,   987,     0,     0,     0,  3890,
    3891,   992,   993,   994,  1226,     0,  2189,  2190,  2191,  2192,
    2193,  2194,  2195,  2196,  2197,  2198,   508,  2199,     0,   613,
     614,   615,     0,     0,     0,  1110,     0,     0,     0,   995,
       0,     0,     0,     0,     0,  2249,     0,   603,   604,   605,
     988,   989,     0,     0,  1110,  1110,   508,     0,     0,     0,
       0,     0,  3487,     0,   996,  2189,  2190,  2191,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,     0,  2199,     0,  1109,     0,
       0,     0,  3488,     0,     0,     0,     0,     0,     0,   991,
       0,     0,     0,   644,     0,     0,     0,     0,     0,     0,
     610,   611,   612,     0,     0,     0,     0,     0,     0,     0,
       0,   992,   993,   994,     0,  1196,     0,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,   613,
     614,   615,   662,   997,  3983,   998,     0,   664,  2238,     0,
     999,  1000,     0,     0,     0,   667,   668,     0,   669,     0,
     670,     0,   488,  3993,  3994,     0,     0,     0,     0,     0,
       0,    39,   671,   539,  2189,  2190,  2191,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,  1001,  2199,     0,     0,     0,     0,
       0,     0,     0,  1002,     0,  1003,   523,     0,     0,     0,
       0,     0,     0,   644,   677,   540,  1004,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1005,  1006,  1007,    39,
       0,     0,     0,     0,     0,   524,     0,     0,     0,     0,
       0,   679,   680,     0,     0,     0,     0,     0,   681,     0,
       0,     0,   662,   997,     0,   998,     0,   664,     0,    39,
     999,  1000,     0,     0,     0,   667,   668,     0,     0,     0,
     670,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   671,   539,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1001,  3489,     0,     0,  2238,     0,
    2238,     0,     0,  1002,     0,  1003,   523,     0,     0,     0,
       0,     0,     0,     0,   677,   540,  1004,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1005,  1006,  1007,     0,
       0,     0,     0,     0,     0,   524,     0,     0,     0,     0,
       0,   679,   680,     0,  3490,  1109,  1109,     0,   681,     0,
       0,     0,  1109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2238,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1109,  1109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1197,     0,     0,     0,
       0,     0,     0,  1109,  3395,  1109,   683,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1255,     0,     0,     0,
       0,     0,     0,     0,  2238,     0,     0,     0,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,     0,     0,
       0,     0,     0,  3491,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1109,  2189,  2190,  2191,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,     0,  2199,  1198,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   683,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,  2189,  2190,  2191,  2192,
    2193,  2194,  2195,  2196,  2197,  2198,     0,  2199,     0,     0,
     688,   689,   690,   691,   692,   693,     0,     0,  3816,  2238,
       0,     0,     0,   431,     0,  1260,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     1,     2,     0,
    2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,
       0,  2199,     0,     0,     0,     0,  2238,     0,     0,  2238,
       0,     0,     3,     4,     5,     6,     7,     0,     0,    39,
       8,  1240,     0,     0,     0,     0,     0,     9,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    10,    11,    12,
       0,     0,     0,    13,  1265,    14,    15,    16,    17,    18,
       0,  1109,     0,     0,     0,     0,     0,     0,    19,    20,
     688,   689,   690,   691,   692,   693,     0,    21,     0,  1251,
       0,  1109,  1109,    22,  2189,  2190,  2191,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,     0,  2199,     0,     0,     0,    23,
      24,    25,    26,     0,     0,     0,     0,     0,     0,  1252,
       0,    27,     0,    28,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2238,    30,  3919,     0,
    2238,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,
    2586,     0,  2587,     0,     0,     0,    31,     0,     0,     0,
       0,     0,     0,  3492,    32,     0,     0,  2238,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    33,
      34,    35,    36,     0,     0,    37,  2577,  2578,  2579,  2580,
    2581,  2582,  2583,  2584,  2585,  2586,    38,  2587,     0,     0,
       0,     0,     0,     0,     0,     0,  1109,     0,     0,     0,
       0,     0,     0,     0,     0,  3494,     0,    39,  2238,     0,
       0,     0,    40,     0,     0,  1109,  1109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    39,     0,     0,
       0,     0,    41,     0,    42,     0,    43,    44,     0,     0,
       0,     0,     0,     0,     0,    45,     0,     0,    46,  3495,
      47,    48,     0,     0,     0,    49,    50,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,     0,     0,     0,
       0,     0,    51,    52,     0,  2238,    53,    54,    55,     0,
      56,    57,     0,     0,     0,     0,    58,     0,     0,    59,
       0,     0,     0,     0,    60,    61,     0,     0,     0,     0,
      62,     0,  2238,     0,    63,    64,    65,     0,     0,    66,
       0,    67,     0,     0,    68,     0,     0,     0,     0,     0,
      69,    70,    71,  3500,    72,    73,    74,     0,    75,    76,
      77,    78,    79,    80,  1350,     0,    81,     0,     0,     0,
       0,     0,     0,    82,    83,     0,     0,     0,     0,    84,
       0,     0,     0,     0,     0,     0,     0,  2238,     0,     0,
       0,     0,     0,  2238,     0,     0,     0,     0,     0,     0,
    3516,     0,     0,     0,     0,     0,     0,     0,     0,  2238,
       0,     0,    85,    86,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,  2584,  2585,  2586,     0,  2587,    87,     0,  1256,
       0,     0,    88,  -764,     0,  2238,     0,     0,     0,     0,
    1274,     0,     0,     0,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   508,     0,     0,     1,     2,     0,
       0,     0,     0,     0,     0,   108,     0,     0,     0,   109,
     110,     0,     0,   111,   112,     0,   113,   114,   115,   116,
     117,   118,     3,     4,     5,     6,     7,     0,     0,   119,
       8,     0,     0,    39,   120,   121,   122,     9,     0,     0,
       0,     0,   123,     0,     0,     0,     0,    10,    11,    12,
       0,     0,     0,    13,     0,    14,    15,    16,    17,    18,
       0,     0,     0,     0,   124,   125,     0,     0,    19,    20,
       0,     0,     0,     0,     0,   126,   127,    21,  1261,     0,
       0,     0,     0,    22,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,  2584,  2585,  2586,     0,  2587,     0,     0,     0,    23,
      24,    25,    26,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,    28,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   128,     0,   129,    30,     0,     0,
       0,     0,     0,    39,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,  2584,  2585,  2586,     0,  2587,    31,  1266,     0,     0,
       0,     0,     0,     0,    32,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,  2584,  2585,  2586,     0,  2587,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    39,     0,    33,
      34,    35,    36,  1326,  3619,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    38,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,     0,
       0,     0,     0,     0,     0,     0,     0,    39,     0,     0,
       0,     0,    40,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2584,  2585,  2586,     0,  2587,     0,     0,     0,     0,     0,
       0,     0,    41,     0,    42,     0,    43,    44,     0,     0,
       0,     0,     0,     0,     0,    45,     0,     0,    46,     0,
      47,    48,     0,     0,     0,    49,    50,     0,     0,     0,
       0,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
       0,     0,    51,    52,     0,     0,    53,    54,    55,     0,
      56,    57,     0,     0,     0,     0,    58,     0,     0,    59,
       0,     0,     0,     0,    60,    61,     0,     0,     0,     0,
      62,     0,     0,     0,    63,    64,    65,     0,     0,    66,
       0,    67,     0,     0,    68,     0,     0,     0,     0,     0,
      69,    70,    71,  3620,    72,    73,    74,     0,    75,    76,
      77,    78,    79,    80,     0,     0,    81,     0,     0,     0,
       0,     0,     0,    82,    83,     0,    39,     0,     0,    84,
       0,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
       0,     0,     0,  3621,     0,     0,     0,     0,     0,     0,
       0,     0,    85,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3622,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,     0,     0,     0,    87,     0,     0,
       0,     0,    88,   823,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3422,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,     0,     0,     0,     0,     0,     0,
       0,     0,  3623,     0,     0,     0,     0,     0,     0,   591,
     592,     0,   593,   594,     0,   595,     0,     0,     0,   596,
       0,     0,   597,     0,   598,   108,     0,     0,     0,   109,
     110,     0,     0,   111,   112,     0,   113,   114,   115,   116,
     117,   118,   599,     0,     0,     0,     0,     0,     0,   119,
     600,   447,     0,     0,   120,   121,   122,     0,   601,   602,
       0,   448,   123,  1275,     0,   603,   604,   605,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,
       0,     0,     0,   606,   124,   125,   607,   485,   486,   608,
       0,     0,     0,   609,     0,   126,   127,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   478,  1325,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   610,   611,
     612,     0,     0,     0,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,   128,     0,   129,   613,   614,   615,
      39,   616,   617,   618,   487,     0,     0,     0,     0,     0,
       0,     0,   619,   620,     0,     0,     0,   621,   622,     0,
     488,   623,   624,     0,   625,   626,     0,     0,     0,     0,
       0,     0,     0,     0,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,     0,     0,   637,   638,   639,   640,
     641,   642,     0,     0,     0,     0,     0,     0,     0,     0,
     643,   644,   489,   645,   646,   647,   648,   649,   650,     0,
     651,   652,     0,     0,   653,   654,     0,     0,     0,   655,
       0,     0,     0,   656,   657,   658,     0,     0,     0,   659,
       0,   660,     0,     0,   661,     0,   824,     0,   450,   451,
     662,     0,   663,     0,     0,   664,   665,   666,     0,     0,
       0,     0,     0,   667,   668,     0,   669,     0,   670,     0,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,
     671,  2587,     0,     0,     0,   672,   452,   453,     0,     0,
     673,     0,     0,     0,   674,     0,  1327,     0,     0,     0,
       0,     0,     0,     0,   523,   675,   676,     0,     0,     0,
     591,     0,   677,   593,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,  2584,  2585,  2586,   987,  2587,     0,  3624,   678,     0,
       0,     0,     0,   524,     0,     0,     0,     0,     0,   679,
     680,     0,     0,     0,     0,     0,   681,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,     0,
       0,   682,     0,     0,     0,     0,   603,   604,   605,   988,
     989,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     454,   455,     0,     0,     0,   508,     0,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,     0,   991,  1227,
       0,   508,     0,     0,     0,     0,     0,     0,     0,   610,
     611,   612,     0,     0,     0,     0,     0,     0,     0,     0,
     992,   993,   994,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2584,  2585,  2586,     0,  2587,     0,     0,     0,   613,   614,
     615,     0,  2296,     0,     0,     0,     0,   591,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   596,     0,     0,
       0,     0,   598,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2584,  2585,  2586,  1244,  2587,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   683,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   601,   602,     0,   448,
    1118,  1119,   644,   603,   604,   605,     0,     0,     0,     0,
       0,     0,   684,   491,   492,     0,  1120,  3470,     0,   685,
       0,     0,   521,     0,   607,  1121,     0,   449,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  1122,  2587,
       0,   662,   997,     0,   998,     0,   664,     0,     0,   999,
    1000,     0,     0,     0,   667,   668,   610,   611,    39,   670,
     686,   687,     0,  3625,     0,     0,     0,     0,     0,     0,
       0,   671,   539,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1001,    39,   613,   614,   615,     0,  2299,
       0,     0,  1002,     0,  1003,   523,  3626,  1123,     0,     0,
       0,     0,  1000,   677,   540,  1004,     0,     0,   488,   623,
     624,     0,   625,   626,     0,  1005,  1006,  1007,   688,   689,
     690,   691,   692,   693,   524,    39,     0,     0,     0,     0,
     679,   680,     0,     0,     0,  1001,     0,   681,   641,   642,
       0,  1228,     0,     0,  1245,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   591,     0,     0,   593,   508,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   987,     0,
    1124,     0,     0,     0,  1125,     0,   524,  3384,  1126,     0,
       0,     0,  3627,     0,     0,     0,   450,     0,   662,     0,
       0,     0,     0,   664,     0,     0,     0,     0,     0,   508,
       0,   667,   668,     0,   669,     0,  1826,     0,     0,     0,
     603,   604,   605,   988,   989,     0,     0,     0,     0,   508,
       0,     0,  3628,   672,     0,   837,   838,     0,     0,     0,
       0,     0,   674,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   523,     0,     0,     0,     0,     0,     0,     0,
     677,     0,   991,  1227,     0,     0,     0,     0,     0,     0,
       0,     0,   508,   610,   611,   612,     0,     0,     0,     0,
       0,   524,    39,     0,   992,   993,   994,   679,   680,     0,
       0,   508,     0,     0,   681,   683,     0,  3629,     0,     0,
       0,     0,   613,   614,   615,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,     0,     0,   454,   455,
       0,  2229,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    39,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   644,     0,     0,     0,
      39,     0,     0,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    39,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   508,     0,     0,   662,   997,     0,   998,     0,
     664,     0,    39,   999,  1000,     0,     0,     0,   667,   668,
       0,     0,     0,   670,     0,     0,     0,     0,     0,   688,
     689,   690,   691,   692,   693,   671,   539,     0,     0,     0,
       0,     0,   683,     0,     0,     0,     0,  1001,     0,     0,
       0,     0,     0,     0,     0,    39,  1002,     0,  1003,   523,
       0,     0,     0,     0,     0,     0,     0,   677,   540,  1004,
       0,     0,     0,     0,    39,     0,     0,     0,  1587,  1005,
    1006,  1007,     0,     0,     0,     0,   508,     0,   524,     0,
       0,     0,     0,     0,   679,   680,    39,     0,     0,     0,
       0,   681,     0,     0,  1845,  1228,   508,     0,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,   686,  2587,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
       0,     0,     0,     0,     0,  2297,     0,     0,  3511,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1171,     0,
       0,     0,     0,     0,  1827,  1828,  1829,  1830,  1831,  1832,
    1833,     0,     0,     0,     0,  3511,   688,   689,   690,   691,
     692,   693,     0,     0,     0,    39,     0,     0,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   508,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   683,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    39,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   508,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    39,
       0,     0,  2300,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    39,     0,     0,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,     0,     0,     0,     0,    39,     0,
       0,  3383,     0,   508,     0,     0,     0,  3630,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,
    3385,     0,     0,   688,   689,   690,   691,   692,   693,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,
    2587,     0,  3392,     0,     0,   508,     0,     0,  2830,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3393,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   508,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,  3394,  2577,  2578,  2579,  2580,
    2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,     0,     0,
       0,     0,     0,     0,  3412,  3550,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   508,    39,     0,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    39,   508,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,
       0,     0,     0,     0,     0,     0,     0,   302,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    39,   508,
       0,     0,     0,     0,     0,  3426,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   508,     0,  3631,     0,     0,
       0,     0,     0,     0,     0,    39,  2189,  2190,  2191,  2192,
    2193,  2194,  2195,  2196,  2197,  2198,  3531,  2199,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,  3979,     0,  3472,
       0,     0,     0,     0,     0,     0,     0,    39,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3510,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
    4000,     0,     0,     0,     0,  3632,     0,     0,     0,     0,
      39,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,
    2586,  3512,  2587,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,  4000,     0,     0,     0,     0,     0,  3514,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,  4015,     0,     0,  3633,    39,     0,
    2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,
    3527,  2199,     0,   508,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   828,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3528,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,     0,     0,     0,  3715,     0,     0,     0,     0,
       0,     0,     0,    39,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,     0,    39,  2189,  2190,  2191,  2192,
    2193,  2194,  2195,  2196,  2197,  2198,  3530,  2199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    39,     0,     0,
    3756,     0,     0,     0,     0,     0,     0,     0,  3535,     0,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,  3544,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,     0,     0,     0,  3762,
       0,     0,     0,     0,     0,     0,     0,     0,  3551,  2189,
    2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,     0,
    2199,     0,     0,     0,     0,     0,     0,  3575,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2197,  2198,     0,  2199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   829,     0,
    3585,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
       0,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,
    2198,     0,  2199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3586,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,     0,  2856,     0,  3763,  2577,  2578,  2579,  2580,
    2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,  3892,     0,
       0,     0,  1078,     0,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,     0,     0,     0,     0,     0,     0,
    3980,  1079,     0,     0,     0,     0,     0,   592,   877,   593,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  1080,
    2587,     0,     0,  4001,     0,     0,     0,   600,     0,     0,
       0,     0,  1081,     0,     0,     0,     0,     0,   448,     0,
    3873,     0,     0,     0,  1082,  1083,     0,     0,  3782,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  1078,
    2587,     0,     0,     0,     0,  4005,   449,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,  3884,     0,     0,     0,
       0,     0,     0,     0,     0,   610,   611,     0,     0,     0,
     816,     0,     0,     0,     0,     0,     0,  4016,  1079,     0,
       0,  1356,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,
    2585,  2586,     0,  2587,     0,     0,  4256,     0,     0,   617,
    3885,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     620,     0,     0,   878,     0,     0,  1080,   488,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1081,
       0,   627,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1082,  1083,     0,     0,  3898,     0,     0,   642,  2189,
    2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,   489,
    2199,  1078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    39,     0,     0,  1084,  2189,
    2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,     0,
    2199,     0,     0,     0,     0,   450,     0,   662,     0,  1085,
       0,     0,   664,     0,     0,     0,     0,  1086,  1087,     0,
    1079,     0,     0,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,     0,  1101,  1102,  1103,
    1104,  1105,  1106,   452,   453,     0,     0,  3998,  3944,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1080,     0,
       0,     0,     0,   823,     0,     0,     0,    39,     0,     0,
       0,  1081,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,  2032,     0,     0,  3945,     0,
       0,     0,     0,     0,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,  1084,   882,    39,  2189,  2190,
    2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,     0,  2199,
       0,     0,     0,     0,   817,     0,  1085,     0,     0,     0,
       0,     0,     0,     0,  1086,  1087,     0,     0,     0,  3532,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,   818,  1101,  1102,  1103,  1104,  1105,  1106,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,
       0,  2587,     0,     0,  1357,  1358,  1359,  1360,   884,  1361,
    1362,  1363,  1364,  1365,  1366,  1367,  1368,  1369,  1370,  1371,
    1372,  1373,  1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,
    1382,  1383,    39,     0,     0,     0,     0,     0,  3995,     0,
       0,     0,     0,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,     0,     0,     0,     0,     0,  1084,  4068,     0,
      39,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,
    2586,     0,  2587,     0,     0,     0,     0,     0,  1085,  1107,
       0,  2095,     0,  2096,  1171,     0,  1086,  1087,     0,     0,
       0,     0,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1078,  1101,  1102,  1103,  1104,
    1105,  1106,     0,     0,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,  2584,  2585,  2586,  1078,  2587,     0,     0,     0,  1384,
    1385,  1386,     0,     0,  1079,     0,   824,     0,     0,     0,
       0,     0,   828,     0,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,  2037,  1862,     0,  4069,     0,     0,
       0,     0,  1080,  1079,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1081,  1107,     0,  2095,     0,
    2096,     0,     0,     0,     0,     0,     0,  1082,  1083,     0,
       0,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,
    2586,  1863,  2587,     0,     0,     0,     0,     0,     0,  4103,
       0,     0,     0,  1078,  1864,     0,     0,     0,     0,     0,
       0,    39,     0,     0,     0,     0,  1865,  1866,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
       0,     0,     0,     0,  1862,     0,     0,     0,     0,     0,
      39,     0,  1079,     0,     0,     0,  1867,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,     0,     0,     0,
    4104,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1863,     0,     0,     0,     0,     0,     0,     0,  1107,     0,
    2095,     0,  2096,  1864,     0,     0,     0,     0,     0,    39,
       0,     0,     0,     0,     0,  1865,  1866,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1078,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,     0,
       0,  1084,     0,     0,   448,     0,     0,     0,     0,    39,
       0,     0,     0,  4160,     0,  1867,     0,     0,     0,     0,
       0,     0,  1085,     0,     0,     0,     0,  1862,     0,     0,
    1086,  1087,     0,     0,     0,  1079,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,   478,
    1101,  1102,  1103,  1104,  1105,  1106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   829,     0,     0,     0,  4019,
    4020,     0,     0,  1863,     0,  1870,  1871,  1872,  1873,  1874,
    1875,  1876,  1877,  1878,  1879,  1880,  1864,     0,     0,  1881,
    1882,  1883,  1884,     0,     0,     0,     0,     0,  1865,  1866,
    4195,     0,     0,     0,     0,     0,     0,     0,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,  1867,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,     0,  1868,  1869,
       0,     0,     0,     0,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,     0,     0,     0,  1881,  1882,
    1883,  1884,     0,     0,     0,     0,  1078,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   448,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,     0,     0,     0,
    4021,     0,     0,     0,     0,     0,     0,  1862,     0,     0,
       0,     0,     0,     0,  1078,  1079,  4221,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,     0,     0,     0,
       0,     0,     0,  1953,     0,     0,     0,     0,     0,     0,
       0,     0,  1107,  1863,     0,  1862,     0,     0,     0,     0,
       0,  1868,  1869,  1079,     0,     0,  1864,  1870,  1871,  1872,
    1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1865,  1866,
       0,  1881,  1882,  1883,  1884,     0,     0,     0,     0,     0,
    2047,  1885,     0,     0,     0,     0,     0,     0,     0,  4088,
       0,  1863,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,   828,  1864,     0,     0,     0,  1867,     0,
       0,     0,     0,     0,     0,     0,  1865,  1866,     0,     0,
       0,     0,     0,     0,     0,  3423,     0,     0,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
      39,  2154,     0,     0,     0,     0,  1867,     0,  1460,  1461,
    1462,  1463,  1464,  1465,  1466,  1467,  1468,     0,     0,     0,
    1469,  1470,  1471,  1472,  1473,  1474,  1475,  1476,  1477,   828,
    1885,  1478,  1479,  1480,  1481,  1482,  1483,  1484,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,  3696,  2394,     0,     0,     0,  1485,  1486,  1487,  1488,
    1489,     0,  4089,  1490,  1491,  1492,  1493,  1494,  1495,  1496,
    1497,  1498,  1499,  1500,  1501,  1854,     0,     0,  1502,  1503,
    1504,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1858,    39,     0,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,     0,
       0,  1868,  1869,     0,     0,     0,     0,  1870,  1871,  1872,
    1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,   508,     0,
       0,  1881,  1882,  1883,  1884,   454,   455,     0,     0,     0,
      39,     0,     0,     0,  1855,     0,     0,     0,     0,     0,
    1505,     0,     0,  1885,     0,     0,     0,     0,     0,  1868,
    1869,     0,     0,  1859,     0,  1870,  1871,  1872,  1873,  1874,
    1875,  1876,  1877,  1878,  1879,  1880,     0,     0,     0,  1881,
    1882,  1883,  1884,     0,    39,     0,     0,     0,  2060,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,  2065,
    1460,  1461,  1462,  1463,  1464,     0,    39,     0,     0,     0,
       0,     0,     0,  1470,  1471,  1472,     0,     0,     0,     0,
    1477,  1605,  2085,  1478,  1479,    39,   829,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,     0,  1485,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4153,     0,     0,     0,  2088,     0,     0,     0,
       0,    39,     0,     0,     0,  1560,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,     0,     0,     0,     0,
       0,    39,   829,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2584,  2585,  2586,     0,  2587,     0,     0,  2119,  1563,     0,
       0,     0,  1606,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,  1505,    39,  3533,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1885,  1615,  1616,  1617,  1618,  1619,  1620,
    1621,     0,     0,  2128,    39,     0,     0,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    39,     0,     0,
       0,     0,     0,  2131,     0,     0,     0,     0,     0,     0,
       0,  1885,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    39,     0,     0,     0,  2392,     0,     0,     0,     0,
       0,     0,     0,     0,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    39,  3673,     0,     0,     0,     0,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    39,  3702,
       0,     0,     0,     0,     0,     0,     0,  1890,  1891,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    39,     0,
    3534,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3705,     0,     0,     0,     0,     0,
      39,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      39,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,  3714,    39,     0,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,     0,     0,     0,     0,    39,     0,
    4006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    39,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    39,     0,     0,     0,     0,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    39,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    39,
       0,     0,     0,     0,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    39,     0,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    39,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,  1892,     0,
       0,     0,     0,     0,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,     0,     0,     0,     0,     0,     0,
       0,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      39,     0,     0,     0,     0,     0,     0,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,  3564,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,     0,     0,     0,
       0,     0,     0,     0,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    39,     0,     0,     0,     0,     0,     0,  2915,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    39,     0,     0,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   302,    39,     0,     0,     0,     0,
       0,     0,     0,   253,   254,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    39,     0,     0,     0,     0,     0,   263,
     264,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    39,     0,     0,     0,     0,     0,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,     0,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,
    2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,
       0,  2199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    39,     0,   271,   272,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    39,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,     0,     0,
       0,     0,     0,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,     0,     0,     0,    39,     0,     0,     0,     0,
     283,   284,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,     0,     0,
       0,     0,     0,   303,    39,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   317,   318,    39,  3694,     0,  2577,  2578,  2579,
    2580,  2581,  2582,  2583,  2584,  2585,  2586,  3720,  2587,     0,
       0,   336,   337,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    39,     0,     0,   349,   350,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,     0,     0,     0,    39,
       0,     0,     0,     0,   352,   353,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,   357,   358,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    39,     0,     0,
       0,     0,   361,   362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,   378,   379,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,     0,     0,     0,     0,     0,    39,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    39,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,
       0,     0,     0,     0,     0,   403,   404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    39,     0,     0,     0,     0,
     326,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,     0,     0,     0,  3738,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,  2584,  2585,  2586,     0,  2587,     0,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    39,
       0,     0,     0,     0,     0,     0,   366,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,     0,   448,     0,     0,     0,    39,     0,
       0,     0,     0,     0,   428,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,  2627,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    39,  3750,  2577,  2578,  2579,  2580,
    2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,     0,     0,
       0,     0,  2665,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    39,     0,     0,     0,     0,     0,     0,  2668,
    1118,  1119,     0,     0,     0,     0,  2896,     0,     0,     0,
       0,    39,     0,     0,     0,     0,  1120,     0,  2670,     0,
       0,     0,   521,     0,     0,  1121,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,  2771,  1122,     0,
       0,     0,  3760,     0,     0,     0,     0,     0,     0,    39,
       0,     0,     0,     0,     0,     0,  2812,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,  1078,     0,     0,     0,
       0,    39,     0,     0,     0,     0,     0,  2908,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1123,     0,     0,
       0,     0,  1000,    39,     0,     0,     0,  2979,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,
       0,     0,     0,     0,   539,  1079,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1001,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3013,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   302,     0,     0,     0,     0,
    1124,     0,     0,     0,  1125,     0,   524,     0,  1126,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,
    2587,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,  2720,     0,  3850,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,   837,   838,     0,     0,  3019,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,  3427,  3428,    39,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3028,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,  3831,  3832,
       0,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
    3328,     0,    39,     0,  3038,  3853,     0,     0,  2189,  2190,
    2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,     0,  2199,
       0,  2233,  2234,     0,     0,     0,     0,     0,     0,     0,
       0,    39,     0,     0,     0,  3942,     0,     0,     0,     0,
       0,     0,  3074,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4100,     0,     0,     0,     0,     0,
       0,  3087,     0,    39,   302,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3860,     0,     0,     0,
    3214,     0,     0,     0,    39,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,  2584,  2585,  2586,     0,  2587,     0,     0,  3302,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    39,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3313,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    39,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,
    2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,
       0,  2587,     0,     0,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    39,     0,     0,     0,  2577,
    2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,   302,
    2587,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,  2585,
    2586,     0,  2587,     0,     0,     0,     0,     0,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,     0,
       0,  3296,     0,  3297,  3298,  3871,     0,   302,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,  3429,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,
       0,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,  3833,
       0,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,     0,  3883,  2577,  2578,  2579,  2580,  2581,  2582,  2583,
    2584,  2585,  2586,     0,  2587,     0,     0,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    39,  3895,  3309,     0,  3310,  3311,
       0,     0,     0,     0,     0,     0,     0,  3916,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,     0,  2587,
       0,     0,     0,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,  2729,  2730,  2731,    39,  3969,     0,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  3970,  2587,
    2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,
       0,  2199,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,
    2585,  2586,     0,  2587,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   302,     0,     0,
       0,    39,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3975,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    39,
       0,     0,     0,     0,  1171,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,  3278,     0,     0,     0,     0,     0,     0,
    3996,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3997,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,     0,     0,     0,  3999,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4061,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4121,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,  3324,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,  3939,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,  4097
  };

  const short
  parser::yycheck_[] =
  {
       0,   587,   309,     3,   936,   404,  1172,   830,   869,     9,
     293,   976,  1455,   368,    14,   370,  1148,   372,   417,   272,
     272,   254,    22,   292,   272,   284,   272,  2028,   272,   254,
     254,   427,   272,   272,    34,   292,   292,   395,   358,   272,
     292,   395,   409,    43,    44,    45,   292,   272,    48,   421,
     259,    51,   409,   292,    54,   356,  2071,   395,   409,   356,
     409,    61,    62,   272,    64,   395,    66,   353,    68,    69,
      70,    71,   353,   395,    74,   272,    76,    77,   329,   353,
     409,   409,   318,   348,   272,   279,   409,   284,   350,   337,
     409,   254,   409,   379,   331,   292,   279,   252,   254,   272,
     260,   409,   272,   272,   292,   353,   272,   272,   272,   272,
     259,   111,  2097,   337,   350,   272,   272,   350,   272,   331,
     272,  2097,   272,   272,   272,   272,   395,   292,   128,   353,
     130,   343,   292,   272,   409,   272,   395,  2502,   395,   395,
     272,   272,   409,   395,   314,   272,   409,   395,   401,   353,
    1074,   395,   272,   407,   272,   395,   395,   407,   272,   272,
     272,   272,   395,   417,   331,   415,   318,  3414,   272,    51,
     395,   395,  2187,   267,   268,   379,   343,   297,   426,   427,
     426,   427,   331,  2345,  2346,   407,     3,   314,  2604,   272,
     407,   413,     9,   272,   343,   417,   407,    14,   395,   348,
     417,    51,   426,   427,   298,    22,   417,   318,   272,   407,
      51,   305,   272,   411,   272,    51,    51,   426,   427,   417,
      51,    51,   272,    71,   272,    51,    43,    44,    51,   426,
     427,    48,   272,   396,    51,   272,    51,    54,    51,   333,
     396,    71,    51,    51,    61,    62,   409,    64,   272,    66,
    1914,    68,    51,   409,   318,   255,   426,   427,   272,    76,
     272,    51,   262,   426,   427,   265,    51,   267,   268,   269,
     426,   427,   284,   273,   274,   275,   276,   426,   427,    88,
     292,   281,   137,  1944,  1945,   285,   286,   287,    51,  1943,
     290,    71,    71,   293,   111,    51,   296,    51,   298,   426,
     427,   272,  1966,   137,  1968,   305,   426,   427,   426,   427,
      51,   128,   312,  1967,   407,   315,   316,   272,  3316,   319,
     320,   321,   137,    51,   417,   325,    51,   327,   137,   284,
    1994,   272,   332,   333,    51,    51,   272,   292,   338,   339,
     407,    51,   254,   426,   427,   272,    51,   933,   272,    51,
     417,   351,   407,    51,   354,   272,   407,   272,    51,   359,
     272,   296,   417,   363,  1902,   365,   417,   367,    51,   369,
      71,   371,   272,   373,   374,   375,   426,   427,   426,   427,
     380,   381,    51,   395,    51,   407,   426,   427,    51,   426,
     427,   260,   331,   393,    51,   417,    71,   397,   137,   399,
      51,  2686,   426,   427,   343,   405,   137,   285,    69,  3461,
      88,   137,   426,   427,   426,   427,    88,   329,  3316,   137,
     170,  3825,  3316,   292,    51,   337,    51,    51,  1966,   429,
    1968,   343,    51,   433,   434,   435,   436,  1176,   438,    51,
     395,   353,    51,    51,   234,    19,    20,    51,    51,    51,
      51,  3855,    26,   137,   150,   426,   427,    31,    32,   137,
     296,  3316,    51,  3316,    88,   137,  1995,  1996,   337,    51,
      51,   426,   427,  3316,    88,    51,   349,   137,   349,  3846,
      51,    51,    51,   395,   353,   426,   427,    51,    51,   401,
     426,   427,    51,    51,    51,    51,    51,   409,    51,   426,
     427,    51,   426,   427,    51,  3316,    51,    51,   508,   426,
     427,   426,   427,   137,   426,   427,    51,    51,    92,   102,
      51,    88,    51,   137,    51,   393,   426,   427,    67,   256,
      47,   137,    51,    71,    47,   262,   393,    88,   349,   113,
      88,   393,   394,   371,   372,   645,   275,    88,   548,    69,
     460,   150,    69,    47,    51,    69,   407,   155,   409,    88,
     411,    88,   413,   407,   415,   409,   417,   411,   256,   413,
     137,   415,    55,   417,    51,    69,   645,    51,   137,   153,
     154,    69,   150,    69,   393,   394,   137,   587,    58,   137,
     272,    88,  2256,    88,    69,   260,   137,    88,  2262,   137,
      69,   330,   644,    88,    88,   203,   137,   645,   137,    88,
     137,   524,   541,   651,   279,     4,     5,     6,   645,   284,
      90,    91,   216,   217,   312,    69,    69,   292,   557,   471,
     540,    19,    20,   137,   129,   645,    24,    25,    26,  4043,
     137,    69,   137,    31,    32,   129,   137,   489,   460,    37,
      38,  4055,   137,   137,   567,  2316,  2317,    10,   137,   645,
     137,  2315,   969,   129,   329,    88,   579,   580,   645,    88,
     244,   137,   349,   645,   651,   357,   358,   359,   343,   644,
      10,   644,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   645,    71,   646,    92,   583,   129,   650,    49,    50,
     129,   539,   644,   648,   137,    69,  1071,  1072,   137,   644,
     645,   393,   394,   112,   113,   113,  2387,  2388,   540,   296,
     542,   543,    71,   393,   394,    88,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   234,   398,   234,    90,
     289,   290,   291,   292,   293,   294,   645,   146,   111,   645,
     234,   344,   345,  4167,   646,   153,   154,    63,   157,   393,
     394,   160,   645,    51,   645,   645,   129,   296,   528,   393,
     394,   111,   650,  3068,   137,   138,   139,   140,   349,   646,
     234,   234,   275,   648,   490,   647,   645,   234,   648,   460,
    3798,  4168,  4049,   651,   644,   379,   234,   648,   138,   139,
     140,   646,   648,   647,   644,   646,   816,   206,   818,   819,
     646,   644,   175,   823,   824,   825,   393,   394,   828,   829,
     830,    71,   645,   648,   645,   188,   410,   357,   646,   648,
     357,    51,   393,   394,   357,   644,  2510,   200,   201,   349,
     850,   645,   393,   394,   324,   244,   244,   644,   648,   644,
     249,   249,  2526,   357,   393,   394,   393,   394,   962,   869,
    2534,   651,   651,   262,   874,    51,   265,   266,    51,   540,
     234,   234,   357,   646,   273,  2546,   275,   240,   357,   185,
     646,   490,   646,   620,    51,   489,   393,   394,   287,   288,
    3798,   254,  1257,  1258,  3798,   646,   645,  1262,  1263,    51,
     644,  2440,  1267,  1268,   393,   394,   647,   645,   307,   645,
    2449,   646,   490,  2452,   254,  3977,  3978,   645,   316,   646,
     646,    88,   620,   933,   644,  3987,   936,  3989,   544,   545,
     644,   646,   942,  3798,   646,  3798,   460,   644,   646,   644,
     651,   340,   644,   646,   645,  3798,   234,  3373,    51,   255,
     644,  3377,   962,   646,   353,   354,   645,   967,   645,   647,
     645,   971,  2510,   349,   393,   394,   648,   646,   644,   646,
     137,    88,   982,   646,   349,   985,   349,  3798,  2526,   646,
     644,   379,   349,    51,   648,   646,  2534,   350,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    51,    88,   646,
     350,   646,   410,   647,   393,   394,   540,   646,   542,   543,
     137,   645,   349,   651,   646,   646,   425,   646,   646,   650,
     393,   394,   646,   646,   646,   646,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   646,   234,   129,
     413,   414,   415,   416,   646,   646,   640,   137,   642,  1069,
     646,   459,   644,  1073,  1074,   646,   646,   646,   645,   645,
     647,   349,   646,   646,   645,   644,  1086,  1087,   646,   646,
     646,   646,   234,   646,   645,   256,   646,   645,   644,   646,
      51,   646,   646,    88,   645,   542,   543,  1107,   645,   270,
     349,   646,   646,   644,   349,   644,   645,   644,   645,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   437,    51,
      51,   234,   349,   137,   645,   645,  1146,  1147,   645,   645,
     503,   644,   137,   393,   394,   645,  1895,   644,   645,  1898,
     485,   486,   487,   645,   489,   645,   645,   645,    51,   303,
     304,   305,  1172,   503,   648,    71,   234,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   645,   398,   296,
     645,    71,    51,  1193,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   645,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    51,   398,    71,    71,   524,   648,
    2154,   395,   396,  2157,   398,    88,   393,   394,   645,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   412,   640,   644,   645,  1255,   393,   394,   395,   396,
    1260,   398,    56,    57,   645,  1265,   382,   383,   384,   645,
    1270,   567,  1272,   645,  1274,  3640,    78,   485,   486,   487,
     645,   489,   645,   234,   137,   644,   393,   394,   645,    83,
      84,   357,   645,   589,   590,   644,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   485,   486,   487,    35,   489,
     645,    12,   234,   393,   394,    89,  1326,    35,   645,  2068,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   395,
     396,   234,   398,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    79,   398,  3659,  3126,  3127,   646,    35,
    3130,   532,   220,   221,   222,   234,    79,   645,   174,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   172,   393,
     394,   306,  4175,  4176,  3698,   357,   645,   234,   393,   394,
     645,   644,   645,  3414,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   272,   645,  4208,   646,   296,   645,    44,
     269,    46,   137,   296,   230,   231,   232,  3462,   242,   644,
     547,   644,   645,  4226,   256,  1455,   275,  1457,   555,   556,
     621,   558,   393,   394,   395,   396,   269,   398,   270,   296,
     646,  4244,  4245,   646,   234,   645,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   234,   398,   644,   645,
     103,   104,   105,   106,   107,   108,   109,   110,  2237,    95,
      96,    97,    98,    99,   646,   644,   645,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   647,   398,   349,
    3682,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     393,   394,   226,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   646,   398,   230,   231,   232,   360,   226,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   126,
     374,   375,   485,   486,   487,   226,   489,   234,   646,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   529,    44,
     412,   644,   646,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   103,   104,   105,   106,   107,   108,   109,   110,
     560,   561,   562,   563,   490,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    71,  3959,   644,   645,   273,   115,
     275,   135,   136,    71,   120,   121,   122,   112,   113,  3973,
     382,   383,   384,   522,    71,  1918,    71,   986,    71,   302,
     132,   133,   134,  1918,  1918,   646,   389,   390,   391,   392,
     644,   645,   307,   644,   645,   151,    71,    55,   547,   548,
     549,   550,   644,   645,  2453,   262,   644,   645,   644,   645,
    1929,   644,   645,   525,    71,   644,   645,   173,   275,    71,
     176,    71,  3261,   644,   646,    83,   644,   645,    71,  3724,
     644,   645,   645,    71,  2483,  2484,   644,   645,  3724,   644,
     645,    71,   100,   644,   645,  1918,    71,  1912,   644,   645,
     644,   645,  1918,   646,   644,   644,   645,   644,   645,  2022,
    2022,   644,   645,    51,  2022,  1935,  2022,   646,  2022,    71,
    1929,   328,  2022,  2022,    71,   644,   644,   645,    71,  2022,
     644,   645,   644,   645,    51,  2150,  2151,  2022,  2057,   646,
     644,   644,   645,   267,   268,    71,  1900,   644,   645,   244,
     644,   645,   276,  2022,   249,  2084,    51,   644,   644,   645,
    4114,   257,   258,   224,   225,  2022,   646,  2084,  2084,   376,
     377,   302,  2084,    71,  2022,    90,    91,    71,  2084,   646,
     275,   338,   339,    71,  3845,  2084,  3847,  1941,    71,  2022,
    2044,    71,  2022,  2022,   395,   396,  2022,  2022,  2022,  2022,
    2057,  2044,  3877,    71,  3879,  2022,  2022,    71,  2022,    71,
    2022,  1965,  2022,  2022,  2022,  2022,   395,   396,  4209,  4210,
      71,   327,    71,  2022,    71,  2022,    71,  2084,   236,    71,
    2022,  2022,  4079,  4080,   242,  2022,  2084,    71,  1992,    51,
    1900,   249,  2022,  1997,  2022,  1905,  1906,    71,  2022,  2022,
    2022,  2022,  2148,  3120,  3121,  2515,  2516,  1917,  2022,  2084,
    1920,    71,    71,    71,  2084,   273,    71,    71,    71,  2284,
    2285,   646,    51,  2288,  2289,   644,   646,  2292,  2293,  2022,
    1940,  1941,   646,  2022,    71,   646,  1946,    71,  1948,  3610,
    2270,  1951,  1952,    71,    71,    71,  2207,  2127,  2022,    71,
    1960,   574,  2022,    71,  2022,  1965,    71,  2268,   316,    71,
    2064,  2268,  2022,    71,  2022,    71,    71,  2214,  2264,  2227,
    2074,   325,  2022,  2264,    71,  2022,  2725,  2726,  2253,    71,
    2264,  1991,  1992,  2087,    71,  2257,  2148,  1997,  2022,    71,
    2127,    71,  2214,  2227,  2004,    71,  1918,    71,  2022,    71,
    2022,    71,    71,    71,    71,    71,  2264,  3671,    71,    71,
      71,  2257,    71,  2023,  2257,    71,  2384,   115,  2240,    71,
    2384,   379,   120,   121,   122,  2321,    71,  2148,    71,    71,
    2264,    71,    71,    71,  2138,  2057,  2384,  2214,  4063,  4050,
      71,  2022,    71,    71,  2384,    71,  2455,    71,  2058,    71,
    2264,    71,  2384,   151,  2064,  2214,  1935,  2022,    71,    71,
      71,    71,  2084,  2240,  2074,    71,    71,    71,    71,    71,
     325,  2022,    71,    71,  2148,   173,  2022,  2087,   176,    71,
    2090,  2240,  2491,    71,    71,  2022,  2096,  2097,  2022,    71,
    1917,    71,  2057,   574,  2253,  2022,    71,  2022,  2475,  2109,
    2022,    71,    71,    71,    71,  2384,    71,  2321,  2475,    51,
      51,  2121,  2022,  2123,  2475,  2384,  2475,  2384,  2384,  2084,
     646,  1948,  2384,  2133,  1951,  1952,  2384,    71,  2138,  2511,
    2384,    71,  2538,   646,  2384,  2384,  2475,  2475,  2242,  2149,
    2244,  2384,  2475,    51,  2154,    51,  2475,  2157,  2475,  2384,
    2384,  2161,  2162,  2163,  2164,  2165,  2166,  2475,  4169,  2169,
    2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,
    2180,  2181,  2182,  2183,  2184,  2185,  2186,  2384,  2441,  2189,
    2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,  2199,
    2475,  2201,    71,  2457,    71,    71,  2023,  2457,  2475,    71,
     298,    71,  2475,   646,   645,  2084,   646,  2311,    71,    51,
      71,    71,  3886,    71,  2224,  2225,  2226,  2390,  2228,    71,
      71,  2231,  2232,    71,  2390,  2457,    71,  2491,  2488,   327,
    2457,  2058,  2242,    71,  2244,    71,  2457,    71,    71,  2249,
    2250,  2990,    71,  2992,    71,  2349,    71,  3786,  2258,  2457,
      71,  3790,   646,  2263,  2486,  3794,    51,  3796,  3797,  2491,
    1935,  2271,   646,    71,  2491,  2214,   646,   646,    71,    71,
    2491,  2281,  2480,    71,  2532,    71,  2532,    71,    71,    71,
    2538,  2385,  2538,  2491,   642,  2207,  2296,   646,    51,  2299,
     645,  2240,    51,   646,  2304,   644,  2306,  2307,  2532,  2403,
     646,  2311,  2475,    51,  2538,  2227,   645,    71,  2318,  2475,
    2320,    71,   645,  2532,    71,    71,    71,  2327,  2240,  2538,
      71,  2331,  2149,   644,   646,  2532,    71,    71,    71,    51,
      71,  2538,    71,    71,  2344,    71,   645,   645,   645,  2349,
    2350,  2445,  2264,  2447,  2448,  3094,   645,   645,  2227,   645,
     645,   645,  2532,   645,  2457,   645,   645,    71,  2538,  2532,
     645,   645,  2384,   645,   645,  2538,  2532,  3509,   645,  2044,
     645,   645,  2538,  2532,   645,  2385,  2386,   645,    71,  2538,
    2457,  2674,  2057,   645,  2394,  2264,  2396,   645,  2491,   645,
      71,   645,  2457,  2403,   645,  2532,  2457,    71,    71,  2226,
      71,  2538,  2532,   646,  2532,    51,    71,    71,  2538,  2084,
    2538,    71,    71,    51,  2491,  2519,    71,   646,    71,  2384,
      71,    71,  2249,    71,  2528,  2457,  2491,    71,    51,    71,
    2491,  2258,  2536,   646,    71,  2445,  2263,  2447,  2448,  2532,
      71,    71,    71,    71,  2271,  2538,  2456,    71,   646,    71,
    3903,    51,    71,    71,  2281,    71,    71,    71,    71,  2491,
      71,    71,  2384,    71,    71,    71,    71,    71,    55,    71,
      71,   646,  2532,    71,  2532,    71,    71,    71,  2538,    71,
    2538,    71,  2532,    71,    51,  2532,    71,   349,  2538,   646,
     646,  2538,  3467,  2320,   646,    71,    83,    71,  2532,    71,
      71,    71,  3444,    71,  2538,    71,    71,    71,  2532,  2519,
    2532,    71,  3261,   100,  2538,    71,  2538,    71,  2528,  2441,
      71,  2531,    71,    71,    71,    71,  2536,  2537,    71,    51,
    2540,  2541,  2207,    71,  2544,    71,    71,  2547,  2548,    71,
    2550,  2551,  2552,    71,  2554,  2910,    71,    71,    71,   234,
    2843,  2532,    71,  2475,    71,    71,    71,  2538,    71,  1868,
    1869,  2878,    71,  3434,    71,  2240,    71,  2532,    71,    71,
      71,   646,    51,  2538,    51,    71,  1885,    71,    71,    71,
      71,  2532,    71,    71,    71,    71,  2532,  2538,   942,   646,
      71,  3424,  2538,    71,    51,  2532,  2457,    71,  2532,    71,
      71,  2538,    71,  2457,  2538,  2532,    71,  2532,    71,    71,
    2532,  2538,    71,  2538,  2475,    71,  2538,    51,  2628,  2480,
    2630,  2475,  2532,    71,    71,  2486,  2480,  2488,  2538,  2456,
    2491,    71,  2486,  2643,  2488,    71,   524,  2491,    71,    71,
     387,   388,   389,   390,   391,   392,  1955,    71,   395,   396,
     237,   398,  3401,    71,  3403,   242,  2666,    71,    71,  2669,
      71,  2671,   249,    55,  2674,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    71,   398,  3042,   566,   567,
    3045,  2691,   325,  3048,    71,    71,   273,    71,    71,    81,
      82,    83,    71,    71,   281,    71,   584,   585,   586,   587,
     588,    71,    71,    71,  2531,    71,    71,    71,    71,    71,
    2537,    71,    71,   646,    71,    71,  3465,    71,    71,  2028,
      71,  3897,    71,    71,    71,  2034,    71,    71,    71,   316,
    2039,    71,  1086,  1087,   646,    51,   646,    71,    71,    71,
    2049,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    71,   398,  1107,    71,   646,   148,    71,  2067,    71,
      71,  2865,  2772,  2773,    71,    51,  2870,    71,  3517,    71,
      71,    71,   164,    71,    71,    71,    51,  2787,    71,    71,
      71,  2791,    51,    71,    71,  2795,    71,   646,    71,    51,
      51,   646,   379,    51,    71,    51,   646,    51,    71,   646,
    3396,    71,   646,  2813,  2814,    71,    71,    71,    71,    51,
    2820,   311,    71,    51,   206,   646,  2643,   645,    71,   473,
      71,  2130,    71,  2132,    71,   479,   480,   481,   482,   483,
     484,  1086,  1087,  2843,    71,   335,   336,    71,    51,  2849,
     494,  2851,  3438,    71,    71,    71,    71,    71,   502,  2859,
      71,    71,  1107,  2863,    71,  2865,    71,    71,   645,    71,
    2870,   644,   651,    71,  2691,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   645,   398,   645,   644,  2889,
     651,   273,   651,   645,   645,   137,   644,   137,   280,   137,
     296,   645,   645,  3642,   137,   645,   645,   137,   137,  2909,
      51,   137,   137,   645,   137,   645,   137,  3316,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   645,   398,
     645,   645,   645,   651,   645,   645,  2235,   645,   645,   645,
    3679,   137,   645,  3682,   645,   389,   390,   391,   392,   393,
     394,   395,   396,    51,   398,   645,  2956,    21,    22,    23,
     645,   645,   137,    27,    28,    29,    30,  2266,  2968,  2969,
     647,   137,   137,  2272,  2273,  2274,  2275,   644,   137,   645,
    2980,    45,  2982,   234,    51,  2985,   137,     8,   644,   137,
      11,    55,   374,   375,   137,   137,   644,   644,  2998,   137,
    3000,   137,   644,   137,  3004,   644,  2305,   137,   645,   137,
     137,   137,   137,    34,  3014,   137,    51,   137,   137,    83,
    3020,    88,  3022,   647,   137,   602,   137,    48,   645,  3029,
     137,   137,   137,   137,   524,   525,   137,   137,   645,  3039,
    3040,  3041,   137,    51,    51,   644,  2863,    68,    51,    51,
    3789,   644,   137,  3053,  3793,   644,   137,   644,   137,   137,
     296,   644,   129,   644,   137,   642,   137,   137,   644,   137,
     137,   644,   651,   644,   296,  3075,   566,   567,   137,   569,
     570,  3820,   572,   573,   574,   644,   137,   296,  3088,   579,
    3090,  3091,  3092,   644,  3094,   296,   296,   137,   137,   644,
     590,   644,   644,   137,   644,   234,   137,   137,   175,   644,
     644,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   188,   398,   646,   645,  3125,  3126,  3127,   645,   645,
    3130,    71,   137,   200,   201,   517,   518,   158,   159,   137,
     644,    51,  3881,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,  3460,   398,   644,   177,   644,   137,   644,
     137,  3161,   137,   137,   644,   137,   137,   234,   137,   644,
     644,   644,   644,   240,   644,   137,    51,   137,   242,   243,
     645,  2998,   645,  3000,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    51,   398,   644,    71,   137,   398,
     645,  3201,   644,   644,   644,  3022,   137,   137,   644,   644,
     644,   644,   644,   644,   137,  3215,   280,   281,   645,  3958,
     241,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     349,   137,   644,   137,   644,   644,  3985,   137,   137,   137,
     271,   644,   349,   644,   644,   137,  2555,  2556,  2557,  2558,
    3260,    71,  2561,  2562,  2563,  2564,  2565,  2566,  2567,  2568,
    2569,  2570,  2571,  2572,  2573,  2574,  2575,   647,  2577,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  2587,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    51,
     398,  4040,    71,  3303,    71,   311,    71,  4046,   644,   942,
     374,   375,   644,   137,  3314,   137,   137,   137,   137,   137,
     137,    51,   137,  4062,   137,   137,   393,   394,   961,   335,
     336,   352,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   137,  3161,   645,   413,   414,   415,   416,
     137,   137,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    51,   398,   137,   645,    21,    22,    23,  4108,
     539,   645,    27,    28,    29,    30,   647,   137,    33,   137,
    3380,   645,   137,   644,  3384,   647,   137,  3387,   137,    44,
      45,    51,   137,   644,   644,   137,  3396,   644,  3398,  3798,
      55,   137,   137,   137,   137,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,  3424,   644,   137,   647,    83,   137,
     137,   644,   137,   645,  3434,   137,   137,   137,  3438,   137,
     137,   137,   137,  3260,  3444,   100,   137,   137,  3448,  3449,
     137,   137,  3452,  1086,  1087,  3455,   137,   137,   137,   137,
     137,   137,   137,  3463,   389,   390,   391,   392,   393,   394,
     395,   396,   137,   398,  1107,  3475,  3476,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   137,   398,  2788,
     137,   137,   137,  2792,   137,   644,  3496,   137,  3498,   137,
     137,   137,   137,   137,  3504,   644,   137,   137,   137,   137,
     137,  3511,   137,   644,   137,   137,   137,   137,   524,   525,
     644,   137,  3522,  3523,   137,   137,   644,   644,   644,  3529,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     137,   398,   644,  1176,   137,   234,  3901,   137,   644,   137,
    3550,   644,   644,   644,   644,   644,  3556,   137,   137,   137,
     566,   567,   137,   569,   570,  3565,   572,   573,   574,   575,
     137,   137,   149,  3573,   137,   398,   645,   393,   645,   644,
    3580,   275,   645,   645,   590,    51,   644,   242,   243,   650,
     644,   646,  2891,   296,   644,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    51,   398,   137,  3608,   137,
     646,  3611,   296,   646,  3614,    51,    71,   646,   646,    51,
      71,   644,   646,   275,    71,   280,   281,   296,  3722,   646,
     646,   646,   398,   646,   646,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   644,   398,  4002,  4003,   644,
     650,    71,   644,   644,   137,   137,    88,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    71,   398,   651,
    3670,  2970,    51,   646,   644,    51,   644,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,  3504,   398,   644,
     646,    51,   646,   651,  2993,    51,   646,   129,   651,   651,
      71,    71,    71,   645,    71,   137,   137,   650,  3007,   137,
     651,  3711,    51,  3713,    51,  3715,  4071,  4072,    51,   374,
     375,    51,  3722,   644,  3724,   645,    71,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   651,   398,   644,
     644,   137,    51,   175,  3744,  3745,   311,  3747,    51,   296,
     296,   646,   644,  2097,  3754,    71,   188,   644,    71,   645,
     644,   296,  3762,  3763,    71,   646,   646,   646,   200,   201,
     335,   336,   644,   646,    51,   644,  3776,    71,  4133,    71,
      71,    71,  3782,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   234,    71,  3804,    71,    71,  3807,   240,    71,
      71,   651,   651,   651,   150,   644,   490,  2161,  2162,  2163,
    2164,    71,    71,   137,   650,  2169,  2170,  2171,  2172,  2173,
    2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,
    2184,  2185,  2186,   645,   644,  2189,  2190,  2191,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,  2199,   648,    51,   234,    51,
      51,   644,   646,   645,   644,   644,   644,  3867,   644,  3869,
     644,    71,   644,   644,   644,   541,   539,   149,    51,   137,
     644,   137,   650,   646,   646,   646,   356,   644,  3888,  3889,
     296,   645,   651,    71,    51,   645,    51,  3897,   644,   349,
    3900,    51,  3902,  3903,   356,    51,   554,   645,   645,   137,
    3910,   349,   644,   137,   137,   539,  2161,  2162,  2163,  2164,
     651,   644,   651,   651,  2169,  2170,  2171,  2172,  2173,  2174,
    2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,
    2185,  2186,   651,    51,  2189,  2190,  2191,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,  2199,   644,    51,   645,   651,   524,
     525,   393,   394,    51,   349,   650,   349,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   645,  3979,
     644,   413,   414,   415,   416,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   646,   398,   650,    71,    51,
    4000,   566,   567,   568,   569,   570,   645,   572,   573,   137,
     490,  4011,  4012,   646,   579,  4015,   149,   137,   644,   150,
      71,   349,    51,   539,   349,   590,   644,   644,    51,  4029,
     644,  4031,   651,    51,   645,   644,   646,   645,   644,   644,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    51,
     644,   234,  3361,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   644,   398,   644,  4076,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   645,   398,   645,
    4090,   651,   644,    51,   645,  4095,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   644,    51,    71,    71,   646,
    3419,   554,   645,    51,   645,   490,  3425,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,  3436,   398,   150,
     644,   644,    51,   645,  4144,   646,   644,    51,   137,   644,
    4150,  4151,   644,    51,    51,    71,   646,  4157,   137,    51,
     137,   646,    51,   644,   137,    51,    71,   646,    71,  2513,
    3469,  2515,  2516,   646,  4174,   137,   644,   646,   137,   646,
      51,   646,  4182,   646,   644,   130,  2347,  4187,  3095,  4189,
    2330,  3779,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,  2309,   398,  2820,    51,  4206,  4147,  2508,  3508,
    3455,  2350,  2055,   645,  3763,  2106,  3447,  2973,  4024,  4157,
    3519,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,  4154,   398,  4233,  2497,  2505,  2878,  3459,  2511,  3985,
    2990,  4241,   234,  1929,   646,  2113,  4246,  2538,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,  4258,   398,
     425,  1894,  1895,  1896,  2532,  1898,  2240,  2521,   644,   819,
    2517,  2257,  2795,   433,   850,  2390,   825,  1910,   436,  3822,
    3798,   435,  1915,  3643,  3583,  3680,  2022,  4047,  2084,  3683,
     982,  1924,  1925,  2148,  1927,  2109,  1242,  2280,  1931,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  3617,  3618,
    2268,  2441,   646,  2457,  2491,  2455,  1959,  2486,  1961,  1962,
    1963,  2488,  2227,    51,  2475,  3634,   646,  3636,  1971,  1907,
    1973,  2384,   234,  1912,  1977,  1978,  1979,  1980,  1981,  1982,
    1983,  2480,  2264,  2321,   874,  1988,   549,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,  2000,   398,  2057,
    1935,  2250,  2127,  2884,  2044,  1949,   971,  2010,  2011,  2849,
    3754,  2014,  2544,  2248,  2231,    -1,   646,  2020,   234,  1918,
    3776,  3690,  3691,  3792,  3693,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3701,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3709,    -1,    -1,    -1,    -1,    -1,  4233,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
      -1,    -1,    -1,    -1,    -1,  2068,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2078,  2079,  2080,    -1,  3748,
    3749,   646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3759,    -1,    -1,    -1,  2097,    -1,    -1,    -1,  2101,  2102,
      -1,   644,    -1,    -1,    -1,    -1,    -1,    -1,   644,  2112,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,  2135,    -1,    -1,   644,  2139,  2851,    51,  2142,
      -1,  2144,    -1,    -1,  3813,  2859,   234,    -1,    -1,    -1,
      -1,    -1,  3821,    -1,    -1,    -1,    -1,    -1,  2161,  2162,
    2163,  2164,    47,    -1,    -1,    -1,  2169,  2170,  2171,  2172,
    2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,
    2183,  2184,  2185,  2186,    69,    -1,  2189,  2190,  2191,  2192,
    2193,  2194,  2195,  2196,  2197,  2198,  2199,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2209,  2210,    -1,  2212,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
    2233,  2234,    -1,    -1,  2237,    -1,  2851,    -1,    -1,    -1,
      -1,    -1,  2956,  3912,  2859,    -1,    51,    -1,    -1,    -1,
      -1,    -1,  2255,    -1,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,  2279,  3946,  3947,    -1,
      -1,    -1,   644,    -1,    69,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,    -1,    -1,  3968,
      -1,    -1,    -1,    -1,    -1,    -1,   646,  3976,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,   234,    -1,    -1,    -1,    -1,  3040,  3041,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3053,
      -1,  2956,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,
    4019,  4020,    -1,    -1,    -1,  4024,    -1,    -1,    -1,    -1,
      -1,    -1,  2365,    -1,    -1,  2368,  2369,    -1,    -1,    -1,
    4039,    -1,    -1,  2376,    -1,  2378,  2379,  2380,  2381,  2382,
      -1,    -1,   644,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2413,  2414,  4081,  4082,    -1,    -1,   301,    -1,  2421,    -1,
      -1,    -1,  4091,    -1,    -1,  3040,  3041,    -1,   644,   234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3053,    -1,
      -1,  4110,    -1,    -1,    -1,   330,    -1,    -1,    -1,   234,
    2453,    -1,    -1,    -1,    -1,    -1,    -1,  2460,  2461,  2462,
      -1,  2464,    -1,    51,  2467,  2468,    -1,    -1,    -1,    -1,
    2473,  2474,    -1,     3,    -1,    -1,    -1,    -1,    -1,    47,
    2483,  2484,    -1,    13,    -1,  4154,    -1,  3201,    18,    -1,
      -1,    -1,  4161,    -1,    -1,    -1,    -1,    -1,    -1,  2502,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    53,    -1,    55,    -1,    -1,    -1,    59,
      60,    61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    51,  4211,  4212,   646,    -1,    -1,    -1,   116,    -1,
      80,    -1,    -1,    83,    -1,  4224,   644,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,    -1,
      -1,    -1,   112,   113,    -1,    -1,  3201,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,
      -1,   141,   142,   143,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   164,   165,   166,    -1,   168,   169,
      -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,   195,   234,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,
    2713,  2714,   242,    -1,   244,    -1,    -1,    -1,    -1,   249,
      -1,    -1,  2725,  2726,   234,    -1,    -1,   257,   258,    -1,
     260,   644,   262,    -1,  3448,  3449,    -1,    -1,    -1,    -1,
      -1,  3455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,
      -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,   288,   646,
      -1,  3475,  3476,    -1,    -1,    -1,    -1,    -1,   298,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   306,    -1,    -1,    -1,
      -1,    -1,  3496,    -1,  3498,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   327,    -1,    -1,
      -1,    -1,    -1,   333,   334,    -1,    -1,    -1,    -1,    -1,
     340,    -1,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3448,  3449,    -1,    -1,    -1,    -1,   644,
      -1,    -1,  3556,    -1,   374,   375,    -1,    -1,  2851,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2859,    -1,    -1,    -1,
    3475,  3476,   647,    -1,    -1,    -1,    -1,    -1,    -1,  2872,
      -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3496,    -1,  3498,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,    -1,    -1,    -1,    -1,
      -1,  3556,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,  2956,   398,    -1,    -1,    -1,   488,    -1,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,    -1,    -1,    -1,  2990,    -1,  2992,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
    3724,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    -1,    -1,    -1,
    3744,  3745,    -1,    -1,   564,    -1,    -1,  3040,  3041,    -1,
      -1,    -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,
    3053,    -1,    -1,    -1,    -1,    -1,   644,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,
      62,    63,   646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
      -1,  3094,   622,   623,   624,   625,   626,   627,    51,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
      -1,     3,    -1,    -1,     6,    -1,    -1,  3120,  3121,    -1,
     112,   113,   114,    -1,    16,    17,    -1,    -1,    -1,  3744,
    3745,   123,   124,   125,   644,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    51,   398,    -1,   141,
     142,   143,    -1,    -1,    -1,  3869,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,   647,    -1,    59,    60,    61,
      62,    63,    -1,    -1,  3888,  3889,    51,    -1,    -1,    -1,
      -1,    -1,   646,    -1,   176,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,    -1,  3201,    -1,
      -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,   101,
      -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,    -1,
     112,   113,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   123,   124,   125,    -1,   127,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   141,
     142,   143,   244,   245,  3869,   247,    -1,   249,  3261,    -1,
     252,   253,    -1,    -1,    -1,   257,   258,    -1,   260,    -1,
     262,    -1,   164,  3888,  3889,    -1,    -1,    -1,    -1,    -1,
      -1,   234,   274,   275,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   286,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   295,    -1,   297,   298,    -1,    -1,    -1,
      -1,    -1,    -1,   205,   306,   307,   308,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   318,   319,   320,   234,
      -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,
      -1,   333,   334,    -1,    -1,    -1,    -1,    -1,   340,    -1,
      -1,    -1,   244,   245,    -1,   247,    -1,   249,    -1,   234,
     252,   253,    -1,    -1,    -1,   257,   258,    -1,    -1,    -1,
     262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   646,    -1,    -1,  3401,    -1,
    3403,    -1,    -1,   295,    -1,   297,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   306,   307,   308,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   318,   319,   320,    -1,
      -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,
      -1,   333,   334,    -1,   646,  3448,  3449,    -1,   340,    -1,
      -1,    -1,  3455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3465,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3475,  3476,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,    -1,
      -1,    -1,    -1,  3496,   644,  3498,   488,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3517,    -1,    -1,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,    -1,
      -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3556,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,   458,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   488,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,    -1,    -1,
     622,   623,   624,   625,   626,   627,    -1,    -1,  3641,  3642,
      -1,    -1,    -1,     0,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    -1,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,    -1,    -1,    -1,    -1,  3679,    -1,    -1,  3682,
      -1,    -1,    39,    40,    41,    42,    43,    -1,    -1,   234,
      47,   644,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    66,
      -1,    -1,    -1,    70,    51,    72,    73,    74,    75,    76,
      -1,  3724,    -1,    -1,    -1,    -1,    -1,    -1,    85,    86,
     622,   623,   624,   625,   626,   627,    -1,    94,    -1,   644,
      -1,  3744,  3745,   100,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,    -1,    -1,    -1,   116,
     117,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,   644,
      -1,   128,    -1,   130,   131,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3789,   144,  3791,    -1,
    3793,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,    -1,    -1,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,   646,   171,    -1,    -1,  3820,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,
     197,   198,   199,    -1,    -1,   202,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   213,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3869,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   646,    -1,   234,  3881,    -1,
      -1,    -1,   239,    -1,    -1,  3888,  3889,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,
      -1,    -1,   259,    -1,   261,    -1,   263,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,   275,   646,
     277,   278,    -1,    -1,    -1,   282,   283,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,
      -1,    -1,   309,   310,    -1,  3958,   313,   314,   315,    -1,
     317,   318,    -1,    -1,    -1,    -1,   323,    -1,    -1,   326,
      -1,    -1,    -1,    -1,   331,   332,    -1,    -1,    -1,    -1,
     337,    -1,  3985,    -1,   341,   342,   343,    -1,    -1,   346,
      -1,   348,    -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,
     357,   358,   359,   646,   361,   362,   363,    -1,   365,   366,
     367,   368,   369,   370,    55,    -1,   373,    -1,    -1,    -1,
      -1,    -1,    -1,   380,   381,    -1,    -1,    -1,    -1,   386,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4040,    -1,    -1,
      -1,    -1,    -1,  4046,    -1,    -1,    -1,    -1,    -1,    -1,
     646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4062,
      -1,    -1,   419,   420,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   454,    -1,   644,
      -1,    -1,   459,   644,    -1,  4108,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    51,    -1,    -1,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,
     527,    -1,    -1,   530,   531,    -1,   533,   534,   535,   536,
     537,   538,    39,    40,    41,    42,    43,    -1,    -1,   546,
      47,    -1,    -1,   234,   551,   552,   553,    54,    -1,    -1,
      -1,    -1,   559,    -1,    -1,    -1,    -1,    64,    65,    66,
      -1,    -1,    -1,    70,    -1,    72,    73,    74,    75,    76,
      -1,    -1,    -1,    -1,   581,   582,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,   592,   593,    94,   644,    -1,
      -1,    -1,    -1,   100,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,    -1,    -1,    -1,   116,
     117,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   128,    -1,   130,   131,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   641,    -1,   643,   144,    -1,    -1,
      -1,    -1,    -1,   234,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,   163,   644,    -1,    -1,
      -1,    -1,    -1,    -1,   171,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,   196,
     197,   198,   199,    51,   646,   202,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   213,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,
      -1,    -1,   239,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   259,    -1,   261,    -1,   263,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,   275,    -1,
     277,   278,    -1,    -1,    -1,   282,   283,    -1,    -1,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,   309,   310,    -1,    -1,   313,   314,   315,    -1,
     317,   318,    -1,    -1,    -1,    -1,   323,    -1,    -1,   326,
      -1,    -1,    -1,    -1,   331,   332,    -1,    -1,    -1,    -1,
     337,    -1,    -1,    -1,   341,   342,   343,    -1,    -1,   346,
      -1,   348,    -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,
     357,   358,   359,   646,   361,   362,   363,    -1,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,    -1,    -1,    -1,
      -1,    -1,    -1,   380,   381,    -1,   234,    -1,    -1,   386,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   419,   420,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   646,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,    -1,    -1,   454,    -1,    -1,
      -1,    -1,   459,    47,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   644,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,    -1,     6,     7,    -1,     9,    -1,    -1,    -1,    13,
      -1,    -1,    16,    -1,    18,   522,    -1,    -1,    -1,   526,
     527,    -1,    -1,   530,   531,    -1,   533,   534,   535,   536,
     537,   538,    36,    -1,    -1,    -1,    -1,    -1,    -1,   546,
      44,    45,    -1,    -1,   551,   552,   553,    -1,    52,    53,
      -1,    55,   559,   644,    -1,    59,    60,    61,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,    -1,    -1,    77,   581,   582,    80,    81,    82,    83,
      -1,    -1,    -1,    87,    -1,   592,   593,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   644,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,   113,
     114,    -1,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,   641,    -1,   643,   141,   142,   143,
     234,   145,   146,   147,   148,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   156,   157,    -1,    -1,    -1,   161,   162,    -1,
     164,   165,   166,    -1,   168,   169,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,    -1,   190,   191,   192,   193,
     194,   195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     204,   205,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,   215,    -1,    -1,   218,   219,    -1,    -1,    -1,   223,
      -1,    -1,    -1,   227,   228,   229,    -1,    -1,    -1,   233,
      -1,   235,    -1,    -1,   238,    -1,   330,    -1,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,    -1,   262,    -1,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     274,   398,    -1,    -1,    -1,   279,   280,   281,    -1,    -1,
     284,    -1,    -1,    -1,   288,    -1,   644,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,   299,   300,    -1,    -1,    -1,
       3,    -1,   306,     6,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    17,   398,    -1,   646,   322,    -1,
      -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,   333,
     334,    -1,    -1,    -1,    -1,    -1,   340,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
      -1,   355,    -1,    -1,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     374,   375,    -1,    -1,    -1,    51,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,   101,   102,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,
     113,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     123,   124,   125,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,    -1,    -1,   141,   142,
     143,    -1,    51,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    13,    -1,    -1,
      -1,    -1,    18,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   176,   398,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   488,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    53,    -1,    55,
     151,   152,   205,    59,    60,    61,    -1,    -1,    -1,    -1,
      -1,    -1,   516,   517,   518,    -1,   167,   644,    -1,   523,
      -1,    -1,   173,    -1,    80,   176,    -1,    83,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   189,   398,
      -1,   244,   245,    -1,   247,    -1,   249,    -1,    -1,   252,
     253,    -1,    -1,    -1,   257,   258,   112,   113,   234,   262,
     564,   565,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,   234,   141,   142,   143,    -1,    51,
      -1,    -1,   295,    -1,   297,   298,   646,   248,    -1,    -1,
      -1,    -1,   253,   306,   307,   308,    -1,    -1,   164,   165,
     166,    -1,   168,   169,    -1,   318,   319,   320,   622,   623,
     624,   625,   626,   627,   327,   234,    -1,    -1,    -1,    -1,
     333,   334,    -1,    -1,    -1,   286,    -1,   340,   194,   195,
      -1,   344,    -1,    -1,   347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,     6,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,
     321,    -1,    -1,    -1,   325,    -1,   327,    51,   329,    -1,
      -1,    -1,   646,    -1,    -1,    -1,   242,    -1,   244,    -1,
      -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    51,
      -1,   257,   258,    -1,   260,    -1,   262,    -1,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    -1,    -1,    -1,    51,
      -1,    -1,   646,   279,    -1,   376,   377,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     306,    -1,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,   112,   113,   114,    -1,    -1,    -1,    -1,
      -1,   327,   234,    -1,   123,   124,   125,   333,   334,    -1,
      -1,    51,    -1,    -1,   340,   488,    -1,   646,    -1,    -1,
      -1,    -1,   141,   142,   143,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,   374,   375,
      -1,    69,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,
     234,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,   244,   245,    -1,   247,    -1,
     249,    -1,   234,   252,   253,    -1,    -1,    -1,   257,   258,
      -1,    -1,    -1,   262,    -1,    -1,    -1,    -1,    -1,   622,
     623,   624,   625,   626,   627,   274,   275,    -1,    -1,    -1,
      -1,    -1,   488,    -1,    -1,    -1,    -1,   286,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   234,   295,    -1,   297,   298,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   306,   307,   308,
      -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,   644,   318,
     319,   320,    -1,    -1,    -1,    -1,    51,    -1,   327,    -1,
      -1,    -1,    -1,    -1,   333,   334,   234,    -1,    -1,    -1,
      -1,   340,    -1,    -1,   644,   344,    51,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   564,   398,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,    -1,    -1,    -1,   644,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,    -1,    -1,   610,   611,   612,   613,   614,   615,
     616,    -1,    -1,    -1,    -1,    51,   622,   623,   624,   625,
     626,   627,    -1,    -1,    -1,   234,    -1,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    51,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   488,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,
      -1,    -1,   644,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   234,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,   234,    -1,
      -1,   644,    -1,    51,    -1,    -1,    -1,   646,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
     644,    -1,    -1,   622,   623,   624,   625,   626,   627,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,    -1,   644,    -1,    -1,    51,    -1,    -1,   137,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   644,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   234,    -1,    -1,   644,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,    -1,    -1,
      -1,    -1,    -1,    -1,   644,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,   234,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   234,    51,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   234,    51,
      -1,    -1,    -1,    -1,    -1,   644,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    51,    -1,   646,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   234,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   644,   398,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,   644,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   644,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      51,    -1,    -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,
     234,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   644,   398,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    51,    -1,    -1,    -1,    -1,    -1,   644,    -1,
      -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    51,    -1,    -1,   646,   234,    -1,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     644,   398,    -1,    51,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   644,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,    -1,   646,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   234,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,   234,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   644,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   234,    -1,    -1,
     646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   644,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   234,    -1,    -1,   644,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,   646,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   644,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,    -1,    -1,    -1,    -1,    -1,    -1,   644,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,    -1,
     644,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   644,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    69,    -1,   646,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,   644,    -1,
      -1,    -1,    88,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     644,   137,    -1,    -1,    -1,    -1,    -1,     4,     5,     6,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   175,
     398,    -1,    -1,   644,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,   188,    -1,    -1,    -1,    -1,    -1,    55,    -1,
      69,    -1,    -1,    -1,   200,   201,    -1,    -1,   646,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    88,
     398,    -1,    -1,    -1,    -1,   644,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   646,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,   113,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    -1,   644,   137,    -1,
      -1,   128,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,   398,    -1,    -1,   644,    -1,    -1,   146,
     646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     157,    -1,    -1,   160,    -1,    -1,   175,   164,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   188,
      -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   200,   201,    -1,    -1,   646,    -1,    -1,   195,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   206,
     398,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,   364,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,    -1,    -1,    -1,    -1,   242,    -1,   244,    -1,   385,
      -1,    -1,   249,    -1,    -1,    -1,    -1,   393,   394,    -1,
     137,    -1,    -1,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   280,   281,    -1,    -1,    69,   646,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,    -1,
      -1,    -1,    -1,    47,    -1,    -1,    -1,   234,    -1,    -1,
      -1,   188,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   200,   201,    69,    -1,    -1,   646,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   364,   353,   234,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,    -1,    -1,    -1,   301,    -1,   385,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   393,   394,    -1,    -1,    -1,   644,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   330,   413,   414,   415,   416,   417,   418,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,    -1,    -1,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   234,    -1,    -1,    -1,    -1,    -1,   646,    -1,
      -1,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,    -1,    -1,    -1,   364,   646,    -1,
     234,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,    -1,    -1,    -1,    -1,    -1,   385,   645,
      -1,   647,    -1,   649,   296,    -1,   393,   394,    -1,    -1,
      -1,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    88,   413,   414,   415,   416,
     417,   418,    -1,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    88,   398,    -1,    -1,    -1,   576,
     577,   578,    -1,    -1,   137,    -1,   330,    -1,    -1,    -1,
      -1,    -1,    47,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    69,   129,    -1,   646,    -1,    -1,
      -1,    -1,   175,   137,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   188,   645,    -1,   647,    -1,
     649,    -1,    -1,    -1,    -1,    -1,    -1,   200,   201,    -1,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   175,   398,    -1,    -1,    -1,    -1,    -1,    -1,   646,
      -1,    -1,    -1,    88,   188,    -1,    -1,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,    -1,   200,   201,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,    -1,
     234,    -1,   137,    -1,    -1,    -1,   240,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,    -1,    -1,
     646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   645,    -1,
     647,    -1,   649,   188,    -1,    -1,    -1,    -1,    -1,   234,
      -1,    -1,    -1,    -1,    -1,   200,   201,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
      -1,   364,    -1,    -1,    55,    -1,    -1,    -1,    -1,   234,
      -1,    -1,    -1,   646,    -1,   240,    -1,    -1,    -1,    -1,
      -1,    -1,   385,    -1,    -1,    -1,    -1,   129,    -1,    -1,
     393,   394,    -1,    -1,    -1,   137,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   100,
     413,   414,   415,   416,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   330,    -1,    -1,    -1,   393,
     394,    -1,    -1,   175,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   188,    -1,    -1,   413,
     414,   415,   416,    -1,    -1,    -1,    -1,    -1,   200,   201,
     646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,    -1,
      -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,   393,   394,
      -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,   413,   414,
     415,   416,    -1,    -1,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    55,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,
     554,    -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,
      -1,    -1,    -1,    -1,    88,   137,   646,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   645,   175,    -1,   129,    -1,    -1,    -1,    -1,
      -1,   393,   394,   137,    -1,    -1,   188,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   200,   201,
      -1,   413,   414,   415,   416,    -1,    -1,    -1,    -1,    -1,
      69,   645,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   554,
      -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   234,    47,   188,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   200,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
     234,    51,    -1,    -1,    -1,    -1,   240,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,    -1,    -1,    -1,
     461,   462,   463,   464,   465,   466,   467,   468,   469,    47,
     645,   472,   473,   474,   475,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,
      -1,    69,    51,    -1,    -1,    -1,   497,   498,   499,   500,
     501,    -1,   554,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,    47,    -1,    -1,   519,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    47,   234,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
      -1,   393,   394,    -1,    -1,    -1,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    51,    -1,
      -1,   413,   414,   415,   416,   374,   375,    -1,    -1,    -1,
     234,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
     591,    -1,    -1,   645,    -1,    -1,    -1,    -1,    -1,   393,
     394,    -1,    -1,   116,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,   413,
     414,   415,   416,    -1,   234,    -1,    -1,    -1,    69,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    69,
     449,   450,   451,   452,   453,    -1,   234,    -1,    -1,    -1,
      -1,    -1,    -1,   462,   463,   464,    -1,    -1,    -1,    -1,
     469,   470,    69,   472,   473,   234,   330,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,   497,    -1,
      -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   554,    -1,    -1,    -1,    69,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,   524,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,
      -1,   234,   330,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,    -1,    69,   567,    -1,
      -1,    -1,   571,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   591,   234,   644,   594,   595,   596,   597,   598,
     599,   600,   601,   645,   603,   604,   605,   606,   607,   608,
     609,    -1,    -1,    69,   234,    -1,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   234,    -1,    -1,
      -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   645,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   234,    -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   234,    69,    -1,    -1,    -1,    -1,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   234,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,   150,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   234,    -1,
     644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,    -1,
     234,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     234,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    69,   234,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,    -1,    -1,    -1,   234,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,    -1,
      -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,
      -1,    -1,    -1,    -1,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,    -1,   234,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   234,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   234,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     234,    -1,    -1,    -1,    -1,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   650,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   234,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   234,    -1,    -1,    -1,    -1,    -1,    -1,   646,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   296,   234,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   644,   645,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,   644,
     645,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   234,    -1,   644,   645,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,    -1,
      -1,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,
     644,   645,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,    -1,    -1,
      -1,    -1,    -1,   645,   234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   644,   645,   234,   644,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   644,   398,    -1,
      -1,   644,   645,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   234,    -1,    -1,   644,   645,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    -1,    -1,    -1,   234,
      -1,    -1,    -1,    -1,   644,   645,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,
      -1,    -1,    -1,   644,   645,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,
      -1,    -1,   644,   645,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,
      -1,   644,   645,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,    -1,    -1,    -1,    -1,   644,   645,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,
     645,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,   644,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,    -1,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   234,
      -1,    -1,    -1,    -1,    -1,    -1,   645,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,    -1,    55,    -1,    -1,    -1,   234,    -1,
      -1,    -1,    -1,    -1,   644,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   644,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   234,   644,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,    -1,    -1,
      -1,    -1,   644,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   234,    -1,    -1,    -1,    -1,    -1,    -1,   644,
     151,   152,    -1,    -1,    -1,    -1,   137,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,    -1,   167,    -1,   644,    -1,
      -1,    -1,   173,    -1,    -1,   176,    -1,    -1,    -1,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,   644,   189,    -1,
      -1,    -1,   644,    -1,    -1,    -1,    -1,    -1,    -1,   234,
      -1,    -1,    -1,    -1,    -1,    -1,   644,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,    88,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,    -1,    -1,   644,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   248,    -1,    -1,
      -1,    -1,   253,   234,    -1,    -1,    -1,   644,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,    -1,    -1,    -1,   275,   137,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   644,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   296,    -1,    -1,    -1,    -1,
     321,    -1,    -1,    -1,   325,    -1,   327,    -1,   329,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   137,    -1,   644,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   234,    -1,    -1,   376,   377,    -1,    -1,   644,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   149,   150,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   644,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   149,   150,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     150,    -1,   234,    -1,   644,   644,    -1,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,   393,   394,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,   150,    -1,    -1,    -1,    -1,
      -1,    -1,   644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   150,    -1,    -1,    -1,    -1,    -1,
      -1,   644,    -1,   234,   296,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   644,    -1,    -1,    -1,
     644,    -1,    -1,    -1,   234,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,    -1,    -1,   644,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   644,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,    -1,    -1,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   234,    -1,    -1,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   296,
     398,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,    -1,
      -1,   493,    -1,   495,   496,   644,    -1,   296,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,   644,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   234,   644,   493,    -1,   495,   496,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   644,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   234,   644,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   644,   398,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,   398,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,
      -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   644,    -1,    -1,    -1,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,
      -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,    -1,
      -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,
     644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   644,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,    -1,    -1,    -1,   644,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   644,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   644,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490
  };

  const unsigned short
  parser::yystos_[] =
  {
       0,    14,    15,    39,    40,    41,    42,    43,    47,    54,
      64,    65,    66,    70,    72,    73,    74,    75,    76,    85,
      86,    94,   100,   116,   117,   118,   119,   128,   130,   131,
     144,   163,   171,   196,   197,   198,   199,   202,   213,   234,
     239,   259,   261,   263,   264,   272,   275,   277,   278,   282,
     283,   309,   310,   313,   314,   315,   317,   318,   323,   326,
     331,   332,   337,   341,   342,   343,   346,   348,   351,   357,
     358,   359,   361,   362,   363,   365,   366,   367,   368,   369,
     370,   373,   380,   381,   386,   419,   420,   454,   459,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   522,   526,
     527,   530,   531,   533,   534,   535,   536,   537,   538,   546,
     551,   552,   553,   559,   581,   582,   592,   593,   641,   643,
     653,   654,   655,   656,   657,   660,   663,   666,   670,   673,
     677,   681,   693,   697,   698,   699,   700,   701,   711,   714,
     715,   720,   721,   722,   725,   728,   729,   734,   739,   750,
     754,   765,   766,   769,   772,   775,   779,   782,   785,   788,
     791,   795,   798,   801,   802,   805,   808,   811,   822,   828,
     831,   834,   841,   842,   845,   846,   847,   849,   861,   862,
     863,   866,   867,   868,   877,   880,   883,   886,   887,   889,
     892,   893,   894,   895,   896,   897,   900,   906,   909,   910,
     911,   914,   915,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   934,   937,   940,   943,   946,   949,   952,   955,
     958,   961,   962,   973,   976,   979,   982,   983,   986,   990,
     993,   999,  1002,  1004,  1007,  1010,  1013,  1017,  1482,   137,
     645,   137,   645,   644,   645,   815,  1482,   645,   644,   645,
     645,   644,   645,   644,   645,   815,   137,   645,   645,   644,
     645,   644,   645,   815,   644,   644,   644,   645,   644,   645,
     645,   644,   645,   644,   645,   815,   645,   644,   645,   645,
     644,   644,   645,   644,   645,   645,   644,   645,   645,   645,
     644,   645,   296,   645,   901,   905,  1482,   644,   645,   644,
     645,   644,   644,   644,   645,   644,   644,   644,   645,   815,
     815,   708,  1482,    71,   137,   907,   645,   815,   644,   645,
     644,   645,   815,   645,   644,   645,   644,   645,   815,   644,
     645,    71,   644,   645,   644,   645,   644,   644,   645,   644,
     645,   815,   644,   645,   815,   644,   645,   644,   645,   815,
     644,   644,   645,   815,   644,   815,   645,   705,  1482,   706,
    1482,   707,  1482,   878,   881,   709,  1482,   645,   644,   645,
     815,   710,  1482,   644,   645,   644,   645,   644,   645,   644,
     645,   645,   645,   645,   644,   645,   645,   644,   645,   645,
     644,   645,   645,   644,   645,   815,   644,   645,   644,   645,
     644,   645,   644,   645,   644,   645,   644,   645,   755,   645,
     644,   645,   644,   645,   645,   645,   645,   645,   644,   815,
     651,     0,   654,    71,   645,    71,    71,    71,   651,   644,
      21,    22,    23,    27,    28,    29,    30,    45,    55,    83,
     242,   243,   280,   281,   374,   375,   931,   932,   933,  1073,
    1079,  1086,  1105,  1106,  1179,  1180,  1186,  1187,  1227,  1228,
    1229,  1230,  1231,  1232,  1233,   644,    33,    44,   100,   932,
     935,   936,  1133,  1166,  1234,    81,    82,   148,   164,   206,
     273,   517,   518,   991,   992,  1073,  1086,  1105,  1158,  1170,
    1175,  1179,  1180,  1181,  1189,  1289,  1358,  1359,    51,   644,
    1482,   272,   357,   358,   359,   712,   115,   120,   121,   122,
     151,   173,   176,   298,   327,   781,   783,   784,  1021,  1044,
    1052,  1055,  1062,  1284,  1285,  1286,  1287,    44,    46,   275,
     307,   980,   981,  1028,  1040,  1135,  1288,  1289,   357,   984,
     985,  1482,    19,    20,    26,    31,    32,    92,   113,   153,
     154,   244,   379,   410,   640,   642,   971,   972,  1120,  1123,
    1126,  1129,  1206,  1210,  1211,  1214,  1215,  1216,  1219,  1224,
    1226,  1427,   644,   137,   644,   901,   901,   723,   724,  1482,
      35,     3,     4,     6,     7,     9,    13,    16,    18,    36,
      44,    52,    53,    59,    60,    61,    77,    80,    83,    87,
     112,   113,   114,   141,   142,   143,   145,   146,   147,   156,
     157,   161,   162,   165,   166,   168,   169,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   190,   191,   192,
     193,   194,   195,   204,   205,   207,   208,   209,   210,   211,
     212,   214,   215,   218,   219,   223,   227,   228,   229,   233,
     235,   238,   244,   246,   249,   250,   251,   257,   258,   260,
     262,   274,   279,   284,   288,   299,   300,   306,   322,   333,
     334,   340,   355,   488,   516,   523,   564,   565,   622,   623,
     624,   625,   626,   627,   869,   870,  1021,  1027,  1030,  1034,
    1035,  1062,  1073,  1077,  1078,  1079,  1083,  1084,  1085,  1089,
    1105,  1106,  1107,  1108,  1109,  1110,  1119,  1125,  1134,  1136,
    1137,  1138,  1139,  1140,  1141,  1142,  1143,  1144,  1145,  1146,
    1147,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,  1160,  1161,  1162,  1163,  1164,  1165,  1166,  1167,
    1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
    1191,  1192,  1193,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
    1203,  1204,  1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,
    1243,  1244,  1245,  1290,  1351,  1357,  1358,  1359,  1360,  1361,
    1404,  1406,  1407,  1408,  1409,  1410,  1411,  1413,  1414,  1448,
    1449,  1450,  1451,  1452,  1453,   644,    47,   301,   330,   823,
     824,   825,  1482,    47,   330,   832,   833,  1482,    47,   330,
     829,   830,  1482,    12,   126,   262,   328,   376,   377,  1000,
    1001,  1040,  1041,  1042,  1043,  1421,  1422,    89,   839,   840,
     835,   836,  1482,    95,    96,    97,    98,    99,   735,   736,
     977,   978,  1040,  1109,  1119,  1125,  1134,   644,  1482,   726,
     727,  1482,    35,    79,   974,   975,  1482,     5,   160,   265,
     266,   287,   353,   354,   425,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   898,   899,  1027,
    1028,  1030,  1040,  1108,  1109,  1119,  1125,  1153,  1165,  1173,
    1189,  1251,  1275,  1279,  1280,  1281,  1282,  1283,  1289,  1404,
    1405,  1454,  1455,  1456,  1457,  1458,  1459,  1460,  1461,  1462,
    1463,  1464,  1465,   723,    35,    79,  1008,  1009,  1482,  1171,
     901,   172,   740,     8,    11,    34,    48,    68,   158,   159,
     177,   241,   271,   352,   737,   738,  1026,  1054,  1057,   174,
    1176,   645,    51,   644,   901,   786,   787,   357,   753,   773,
     269,  1005,  1006,  1482,    69,   234,   996,   997,   994,   995,
    1235,  1236,   884,   885,  1482,   888,  1482,    17,    62,    63,
      93,   101,   123,   124,   125,   151,   176,   245,   247,   252,
     253,   286,   295,   297,   308,   318,   319,   320,   813,   890,
     891,  1020,  1021,  1022,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1040,  1048,  1049,  1053,
    1058,  1059,  1060,  1061,  1062,  1078,  1083,  1109,  1119,  1125,
    1142,  1165,  1169,  1171,  1177,  1178,  1191,  1192,  1196,  1197,
    1201,  1202,  1203,  1204,  1235,  1236,  1340,  1341,  1351,  1411,
    1412,  1448,  1449,  1450,  1451,  1452,  1453,   644,   644,    51,
     644,  1482,   349,   645,   703,   704,   137,   644,    88,   137,
     175,   188,   200,   201,   364,   385,   393,   394,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   413,   414,   415,   416,   417,   418,   645,   746,   818,
     902,  1482,   275,   644,   789,   790,  1040,  1073,   151,   152,
     167,   176,   189,   248,   321,   325,   329,   792,   793,  1021,
    1023,  1024,  1025,  1045,  1050,  1051,  1055,  1056,  1159,  1177,
    1178,  1415,  1421,  1422,   644,   901,    47,   357,   751,   752,
     753,   269,   100,   236,   249,   316,   379,   642,   965,   966,
    1073,  1079,  1086,  1112,  1113,  1114,  1128,  1289,  1425,  1426,
     644,   296,  1014,  1015,  1482,   234,   647,   790,   793,   806,
     807,   135,   136,   267,   268,   276,  1011,  1012,  1416,  1417,
    1418,  1419,  1420,   987,   780,   781,   127,   378,   458,   812,
     813,   814,  1039,  1046,  1158,  1290,  1291,   644,   100,   237,
     281,   602,   967,   968,  1073,  1079,  1086,  1112,  1115,  1116,
    1117,  1118,  1128,  1289,  1425,  1426,   644,   102,   344,   345,
     918,   919,  1194,  1195,  1352,   813,   920,   921,  1194,  1352,
     644,   234,   912,   913,   176,   347,   916,   917,   921,  1047,
    1403,   644,   644,   170,   528,    51,   644,  1482,   349,   704,
      51,   644,  1482,   349,   704,    51,   644,  1482,   349,   704,
     879,  1482,   882,  1482,    51,   644,  1482,    78,   256,   270,
     360,   412,   525,   678,   679,    19,    20,    24,    25,    26,
      31,    32,    37,    38,    92,   113,   153,   154,   244,   249,
     410,   459,   640,   969,   970,  1111,  1121,  1122,  1124,  1127,
    1205,  1207,  1208,  1209,  1212,  1213,  1217,  1218,  1220,  1221,
    1222,  1223,  1225,  1425,  1426,   644,    51,   644,  1482,   349,
     226,   226,   226,   256,   262,   620,   668,   669,  1070,  1071,
    1076,   674,   256,   312,   620,   671,   672,  1080,  1081,  1082,
      55,   694,   695,  1074,  1075,  1482,   128,   421,   422,   423,
     424,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   576,   577,   578,   963,   964,  1030,
    1073,  1079,  1086,  1105,  1106,  1108,  1109,  1119,  1125,  1134,
    1136,  1147,  1158,  1173,  1189,  1246,  1247,  1248,  1249,  1250,
    1251,  1252,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1276,  1277,  1278,  1279,  1280,  1404,
    1405,    56,    57,    83,    84,   242,   843,   844,  1063,  1072,
    1087,  1088,  1090,  1179,  1180,  1018,  1019,  1482,   234,  1482,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   472,   473,
     474,   475,   476,   477,   478,   497,   498,   499,   500,   501,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   519,   520,   521,   591,   938,   939,  1073,  1166,
    1294,  1295,  1296,  1297,  1298,  1299,  1300,  1301,  1302,  1303,
    1304,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,
    1314,  1316,  1317,  1318,  1319,  1320,  1321,  1322,  1323,  1324,
    1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1339,  1366,   529,   311,   335,   336,
     524,   525,   566,   567,   569,   570,   572,   573,   574,   579,
     590,   947,   948,  1362,  1363,  1365,  1382,  1390,  1391,  1392,
    1395,  1396,  1397,  1398,  1399,  1400,  1401,   644,   568,   941,
     942,  1362,  1363,  1365,  1382,  1390,  1391,  1392,  1394,  1395,
    1396,  1397,  1398,  1400,  1401,   470,   571,   594,   595,   596,
     597,   598,   599,   600,   601,   603,   604,   605,   606,   607,
     608,   609,   959,   960,  1073,  1179,  1180,  1294,  1295,  1296,
    1297,  1298,  1304,  1305,  1306,  1308,  1312,  1313,  1314,  1315,
    1362,  1363,  1364,  1366,  1367,  1368,  1369,  1370,  1371,  1372,
    1373,  1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,    63,
     185,   255,   589,   956,   957,  1292,  1293,  1362,  1363,  1382,
    1383,  1384,   584,   585,   586,   587,   588,   953,   954,  1362,
    1363,  1365,  1385,  1386,  1387,  1388,  1389,   580,   950,   951,
    1362,  1363,  1392,  1393,   575,   944,   945,  1362,  1363,  1365,
    1382,  1390,  1391,  1395,  1396,  1397,  1398,  1399,  1400,  1401,
    1402,   644,   272,   522,   547,   548,   549,   550,   767,   768,
    1342,  1343,  1344,  1345,  1346,  1347,   730,   555,   556,   558,
     770,   771,  1342,  1348,  1349,  1350,   560,   561,   562,   563,
     809,   810,  1353,  1354,  1355,  1356,   285,   583,   803,   804,
    1423,  1424,   803,    63,   262,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   794,   799,   800,  1021,  1034,
    1035,  1062,  1073,  1077,  1078,  1079,  1086,  1109,  1119,  1125,
    1142,  1147,  1148,  1153,  1158,  1160,  1165,  1171,  1179,  1180,
    1190,  1191,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,
    1204,  1235,  1236,  1351,  1360,  1411,  1413,  1414,  1429,  1431,
    1433,  1435,  1437,  1439,  1441,  1443,  1444,  1445,  1446,  1447,
    1448,  1449,  1450,  1451,  1452,  1453,   262,   610,   611,   612,
     613,   614,   615,   616,   794,   796,   797,  1428,  1430,  1432,
    1434,  1436,  1438,  1440,  1442,   644,   490,    47,   116,   847,
    1482,   848,  1132,  1482,    47,   116,   862,  1482,    47,   116,
     867,  1482,   129,   175,   188,   200,   201,   240,   393,   394,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   413,   414,   415,   416,   645,   716,   818,   902,  1482,
     149,   150,   490,  1482,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    51,   646,    71,
      71,    71,    51,   646,    71,    71,    71,   646,    51,  1482,
     646,    71,    71,    71,    71,    71,    71,    71,    71,    51,
     646,    71,    71,    71,    71,    51,   646,  1482,    69,   985,
      51,    71,    71,    71,    71,    71,    71,    71,   646,    51,
     644,   646,   646,    69,   724,    71,   646,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    51,   646,  1482,  1482,    69,   824,    51,   644,
    1482,  1482,    69,   833,    51,  1482,  1482,    69,   830,    51,
     646,    71,    71,   646,    51,   393,   646,    69,   836,    51,
      71,    71,    71,    71,    71,    51,   646,    51,   646,   646,
      69,   727,   645,   646,    71,    69,   975,    51,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,   646,    51,    69,   646,    71,    69,  1009,
      51,   645,   646,   646,    71,   647,   649,   742,   743,   746,
     749,    71,    71,    71,    71,    71,    51,   646,    71,   646,
     818,   901,   645,    51,   646,  1482,    69,   753,   646,    69,
    1006,    51,   644,    51,    69,   997,   646,    51,    69,   885,
     645,    69,  1482,    51,   716,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    51,   646,
    1482,   349,   704,   704,    51,   702,  1482,    51,   646,   702,
     644,   645,   645,   645,   645,   645,   645,   746,   746,   645,
     645,   645,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   645,   645,   645,   645,   645,   645,   645,   746,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   398,
     908,   651,   747,   303,   304,   305,    71,    51,   646,    71,
      71,    71,    71,    71,    51,   646,   646,  1482,  1482,    69,
     752,   646,    71,    71,    71,    71,   646,    51,    71,    69,
    1015,    71,    71,   393,   394,   645,   777,   778,   818,   819,
      51,   646,    71,    71,    71,    71,    71,   646,    51,   647,
     988,   989,  1482,    51,   646,    71,    71,    51,   646,    71,
      71,    71,    71,   646,    51,    71,    71,    71,    51,   646,
      51,   646,   389,   390,   391,   392,    69,   913,    71,    71,
      51,   646,    71,    71,  1482,   349,   704,   704,  1482,   349,
     704,   704,  1482,   349,   704,   704,    51,   644,  1482,    51,
     644,  1482,  1482,    71,    71,    71,    71,    71,    71,    51,
     646,    71,    71,    71,    71,    71,    71,    71,    71,    71,
     646,    51,  1482,   349,   646,   646,   646,    71,    71,    71,
      51,   646,   256,   270,   412,   532,   621,   675,   676,  1064,
    1065,  1066,  1067,  1069,    71,    71,    71,    51,   646,    71,
      51,   646,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,   646,    51,    71,    71,    71,    71,    71,
      51,   646,    69,  1019,    51,  1482,    71,   646,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    51,   646,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    51,   646,    51,   646,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    51,   646,    71,    71,    71,
      51,   646,    71,    71,    71,    71,    51,   646,    51,   646,
      71,    51,   646,   460,   540,   542,   543,   756,   757,    71,
      71,    71,    71,    71,    71,    51,   646,   234,   731,   732,
      71,    51,   646,    71,    71,    71,    71,    51,   646,    71,
      71,    51,   646,   646,    71,    71,    71,    71,    71,    71,
      71,   646,    51,    71,    71,    71,    71,   646,    51,   852,
     645,   645,   644,   651,    51,   646,    71,   645,   645,   644,
     651,   645,   645,   644,   651,   645,   645,   645,   645,   716,
     716,   645,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   645,   645,   645,   645,   645,   716,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   398,   644,   717,
     645,   850,   651,   818,   819,   818,   137,   819,   137,   901,
     137,   137,   647,  1470,  1472,  1473,   137,   137,  1482,  1466,
    1482,   933,   137,   137,   818,   137,   936,   137,  1473,   818,
      67,   289,   290,   291,   292,   293,   294,   644,   815,   991,
     713,  1482,   137,   137,   137,   818,   818,   137,   818,   137,
     784,   644,   818,   645,   137,   137,   981,   644,   644,   644,
    1482,   901,   382,   383,   384,   485,   486,   487,   489,   645,
    1130,   840,   840,  1482,   137,   644,   815,   971,   644,   815,
     644,   815,   644,   716,   644,   137,   296,   818,  1482,   818,
     818,   818,   137,   901,  1470,  1473,   645,  1130,  1470,  1473,
     137,   645,   818,   137,   818,   137,   137,    58,    90,    91,
     324,   818,   818,   818,   818,   818,   818,   818,   137,   137,
     137,   137,   129,   393,   394,   819,   820,   821,   137,   137,
     137,  1482,   901,   137,  1473,   647,  1476,  1477,  1477,   491,
     492,   493,   901,   137,   216,   217,   489,   818,   220,   221,
     222,   224,   225,   137,  1482,   230,   231,   232,   230,   231,
     232,   645,   137,   137,   818,   129,   818,   137,    90,    91,
     818,   137,    49,    50,    90,   645,   137,   137,   818,   137,
     870,   644,   815,    51,   644,    10,   111,   138,   139,   140,
     254,   350,   503,   716,   719,   826,   838,    51,    51,   644,
     716,    51,    51,   644,   716,   644,   137,   137,   644,  1000,
     137,   644,   644,   716,   296,   296,   296,   296,   296,   736,
     644,   978,   644,   815,   651,   644,   137,   393,   394,   817,
     644,   901,   644,   716,   819,   137,   137,   817,   137,   137,
     137,   901,   137,   137,   137,   818,   818,   818,   137,   137,
     644,   898,   644,   644,   901,   644,  1482,   137,  1467,   644,
     644,   661,   234,   744,   745,  1482,    69,   743,   749,    71,
     644,   818,   818,   645,   137,   645,   737,   644,   155,   203,
     905,   646,   645,   818,   787,   644,   644,   644,   644,   644,
    1482,   998,  1482,   644,   644,   994,   644,   716,   644,    51,
     716,  1482,   644,   818,   137,   137,   137,   901,   818,   137,
     137,   818,   137,   818,   137,   137,   137,   891,   644,   815,
     349,   704,   704,   702,    71,   646,   702,   746,   746,   746,
     746,  1482,  1482,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   817,   646,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   644,  1482,   645,   137,   790,   644,
     818,   818,   137,   818,   137,   793,   644,   644,    51,    51,
      71,   644,   644,   644,   338,   339,   137,  1482,  1482,   644,
     815,   965,  1016,  1482,   644,  1016,  1482,   818,   818,   716,
     644,   648,    51,   645,   819,   807,   644,   901,   645,   901,
     645,   137,   644,  1011,   815,    69,   989,    71,   781,   644,
     818,  1473,   814,   644,   815,   137,   137,   137,  1473,   644,
     815,   967,   645,   716,   349,   919,   644,   921,   644,   815,
     716,   716,   716,   716,   644,   137,   818,   917,   644,   815,
     665,   664,   349,   704,   704,   349,   704,   704,   349,   704,
     704,  1482,  1482,   680,  1482,   716,  1482,  1482,   137,  1468,
     679,   644,   901,   382,   383,   384,   137,   137,   645,  1130,
     840,   840,  1482,   137,   644,   815,   969,   349,   644,   644,
     644,  1482,   137,   647,  1474,  1475,   669,   644,   667,  1482,
      71,    71,    71,  1068,    71,    51,   646,  1482,  1475,  1475,
     672,   644,   901,   695,   644,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   818,   137,
     647,  1480,  1481,   818,   818,   645,   645,   645,   137,   137,
     645,   818,   137,   818,   818,   818,   818,   818,   644,   963,
     901,  1482,   840,   840,   137,   844,   644,   644,  1482,   644,
    1482,   644,   137,   544,   545,   137,   137,   137,   137,   901,
     137,   645,   137,   234,   542,   543,   137,   137,   137,   137,
     137,   818,   818,   137,   137,   137,   137,   137,   137,   818,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,  1477,   939,
     644,   658,   137,   901,   137,   901,   901,  1477,   137,   137,
    1477,   819,   137,   948,   644,   815,   942,   644,   471,   489,
     818,   818,   818,   137,   818,   137,   137,   818,   818,   137,
     137,   137,   137,   818,   818,   960,   644,   137,   137,   137,
     957,   644,   137,   819,   819,   137,   954,   644,   951,   644,
     137,   945,   644,   539,   541,   557,   644,   644,    69,   757,
     647,   647,  1477,  1479,   137,   818,  1481,   137,   137,   768,
     644,   733,    69,   732,  1470,  1473,   771,   644,   296,   902,
     903,   137,   903,   903,   810,   644,   901,   137,   804,   644,
     644,   137,   137,  1470,  1473,   137,   493,   495,   496,   901,
     137,   137,   644,   815,   799,   137,  1470,  1473,   137,   493,
     495,   496,   901,   644,   815,   796,   645,  1482,  1482,  1132,
     644,   840,  1482,  1482,   490,  1482,  1482,  1482,   150,  1482,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   646,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   645,   132,   133,   134,   864,   865,  1098,  1099,  1100,
     645,   150,   490,    51,   137,  1470,  1471,    51,   648,  1471,
     650,   644,   644,   644,    51,   644,  1482,   815,   275,   646,
    1130,  1131,   644,   644,   644,   644,   723,  1131,   815,   129,
     129,    51,   819,    51,   648,   819,   296,   871,   872,   296,
     875,   876,   644,  1482,    51,   644,    51,  1482,   716,    51,
    1482,   716,   644,    69,   829,    51,   644,   149,   150,   490,
    1482,   137,   137,   646,   726,   646,    51,   644,   723,   646,
      51,   646,   650,   646,  1008,   746,    71,    51,   648,    71,
     644,   746,   815,   901,   904,   741,   644,   818,   646,   275,
     773,    51,   645,    51,   644,    71,    69,   996,   646,  1482,
     644,   716,   644,   704,   296,    51,    51,   646,   646,   646,
     646,   646,   646,   646,   646,   646,   646,   646,   646,   646,
     646,   646,   646,    51,   646,   646,    51,   646,    51,   646,
     646,   646,   746,   748,   646,  1482,  1482,   716,   330,   751,
     644,    51,   644,  1482,   644,   646,   646,   778,   644,   645,
     819,   716,   815,   815,   648,   644,   716,   644,   644,   815,
     644,   644,   644,   644,   644,   644,   746,   746,   704,   704,
     704,   746,   650,  1131,   644,    51,   296,    51,   296,   648,
      51,   644,  1482,  1482,  1482,  1482,    71,   819,  1482,   676,
     644,   821,   648,   821,   650,   815,   816,   816,   816,   816,
     644,   646,   682,   815,   746,   644,   137,   137,   644,   644,
     815,  1477,  1478,    71,   644,   644,   644,   103,   104,   105,
     106,   107,   108,   109,   110,   302,   859,   860,  1091,  1092,
    1093,  1095,  1096,  1097,  1101,  1102,  1104,  1399,    51,   646,
     650,    51,   646,   651,    51,   646,   651,    51,    51,   646,
     646,   646,   646,   646,   646,   646,   646,   646,   646,   646,
     646,   646,   646,   646,    51,   646,    51,   646,   716,   718,
      71,    71,    71,    51,   646,   104,   106,   857,   858,  1091,
    1092,  1093,  1094,  1096,  1097,  1101,  1102,  1103,  1399,   645,
     851,  1471,   650,   648,  1471,  1482,  1482,   646,   137,   774,
     651,    51,   646,    69,   646,   646,   819,   648,   819,    51,
      51,   646,    51,    51,   646,   716,   719,   838,   719,   827,
      51,    51,   716,    51,   644,   644,    69,   716,   645,   853,
     651,    71,    69,   644,   716,    69,   644,   393,   394,   647,
    1003,    51,   137,    51,    69,   646,   296,   745,   746,   746,
     644,   646,    51,   646,   742,   646,   774,    69,  1003,   394,
     817,  1469,  1482,   819,   644,    69,   644,   716,   644,   746,
     746,   296,   746,   746,   645,    51,   646,   815,    71,    71,
     644,   716,    69,  1482,   644,   716,   646,   646,   646,    71,
     644,   646,   646,   646,   129,   137,   646,   296,   296,   648,
    1482,   746,   646,   646,   646,   646,   644,   460,   540,   683,
     684,   646,   646,    51,   644,   648,    51,   648,   716,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    51,   646,
    1482,   651,   840,  1482,   651,   490,  1482,   651,   150,   716,
     716,   716,   716,    51,   646,  1481,   818,   819,   865,   644,
      71,    71,    51,   646,   864,   645,   137,   650,    51,   137,
     644,   149,   150,   490,  1482,  1130,   644,   296,   819,   871,
     296,   645,   819,  1475,   875,    51,    51,    51,   716,   716,
     644,   716,   644,   644,   864,   645,   150,   490,   716,   644,
     644,   644,   716,   644,  1482,  1482,   644,   662,  1482,    71,
     644,   644,   901,    69,   644,   644,   644,   645,   646,   650,
     646,    71,   644,   644,   646,   646,    51,   646,    51,    51,
     746,   746,   644,   716,   716,   644,   644,  1014,   646,   716,
     696,  1482,   696,  1018,   371,   372,   539,   541,    69,   684,
     659,  1482,   758,   539,   760,  1477,   644,   819,  1477,   818,
    1479,   819,  1477,   473,   479,   480,   481,   482,   483,   484,
     494,   502,   837,  1477,  1477,   860,   644,   646,   646,   490,
    1482,   646,   150,  1482,   646,   646,    51,    51,   716,   819,
     716,   858,   644,   646,   857,   137,   137,   650,   356,   645,
     855,   651,   296,   873,   874,   719,   827,   719,    51,   644,
     644,   646,   857,   645,   854,   644,    51,    51,    51,    51,
     644,  1482,   349,   746,   644,   356,   817,    51,   817,    51,
     819,   137,  1473,   746,   746,   646,   644,   644,    69,   644,
      51,   644,  1482,   349,   704,   644,    69,   554,   688,   689,
     690,   645,   645,   137,   644,    51,   644,  1482,   349,   393,
     394,   554,   716,   762,   763,   764,   137,   539,   651,   651,
     651,   651,   651,   716,   716,   644,   646,   650,   137,   645,
     776,   819,   864,   645,   150,   490,    51,    51,   646,    51,
      51,   716,   644,   646,   864,   645,   716,  1003,  1003,  1482,
     349,   644,   776,   650,  1003,  1003,   646,   646,   646,   646,
     644,  1482,   349,   704,   704,   644,   645,   644,    71,   393,
     394,   395,   396,  1482,  1482,   644,  1482,   349,   554,   554,
     645,   395,    71,   716,   764,    51,   137,   490,  1482,   490,
     150,  1482,   150,   646,   646,   644,   137,   716,    51,   644,
     645,   819,   646,   857,   645,   856,   296,   819,   873,   838,
     719,   644,   644,   646,   857,   648,   644,   644,   349,   644,
     817,   644,   644,   349,   704,   704,  1482,    88,   137,  1483,
     689,   689,   716,   716,    51,   646,   539,   691,   692,   349,
     645,   645,  1482,   554,   759,   761,  1482,    51,   651,   651,
     646,   645,   819,   716,   644,   646,   864,   645,    51,    51,
     644,   646,   646,   704,    51,    71,    71,  1482,   554,   685,
     686,   687,   645,   692,  1482,  1482,    51,   645,   762,    51,
     644,   761,   490,   150,   716,   646,   644,   646,   857,   827,
     719,   644,  1482,  1483,  1483,   646,   645,   644,    71,   393,
     394,   395,   396,  1482,    51,    51,   137,  1482,   644,  1482,
     644,   646,   644,   646,    51,    51,    71,  1482,  1483,   686,
     686,   716,   716,   646,   137,   137,   646,    51,   644,   716,
     137,   645,  1483,    51,    71,    71,   815,   646,   646,   137,
     646,  1482,   644,   137,  1483,  1483,   644,   646,    51,   646,
    1482,   646,   644
  };

  const unsigned short
  parser::yyr1_[] =
  {
       0,   652,   653,   653,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   655,   655,   656,
     658,   657,   659,   659,   659,   659,   659,   659,   661,   660,
     662,   662,   662,   662,   662,   662,   663,   664,   663,   665,
     663,   666,   666,   667,   667,   667,   668,   668,   669,   669,
     669,   670,   671,   671,   672,   672,   672,   674,   673,   675,
     675,   676,   676,   676,   676,   676,   677,   678,   678,   679,
     680,   679,   679,   679,   679,   679,   679,   682,   681,   683,
     683,   684,   684,   684,   684,   684,   685,   685,   685,   686,
     686,   687,   688,   688,   688,   689,   689,   690,   691,   691,
     692,   693,   694,   694,   695,   695,   696,   696,   696,   696,
     696,   696,   696,   696,   696,   696,   696,   696,   697,   698,
     699,   700,   701,   702,   703,   703,   703,   703,   704,   704,
     705,   705,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   707,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   707,   707,   708,   708,   708,   708,
     708,   708,   708,   708,   708,   708,   708,   708,   709,   709,
     709,   710,   710,   710,   710,   710,   710,   711,   712,   712,
     712,   712,   713,   713,   713,   714,   714,   715,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     717,   716,   716,   716,   716,   716,   716,   716,   716,   718,
     718,   719,   719,   720,   720,   721,   722,   722,   723,   723,
     724,   725,   725,   726,   726,   727,   728,   730,   729,   731,
     731,   733,   732,   734,   735,   735,   736,   736,   736,   736,
     736,   737,   737,   737,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   738,   738,   740,   739,   741,   739,   742,
     742,   742,   742,   743,   743,   743,   743,   744,   744,   745,
     745,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   747,   746,   746,   746,   746,   746,   746,
     746,   748,   748,   749,   750,   750,   751,   751,   752,   752,
     752,   752,   752,   753,   755,   754,   756,   756,   757,   757,
     758,   759,   757,   757,   757,   760,   760,   761,   761,   762,
     762,   763,   763,   764,   764,   764,   764,   765,   766,   767,
     767,   768,   768,   768,   768,   768,   768,   769,   770,   770,
     771,   771,   771,   771,   772,   772,   773,   773,   774,   774,
     774,   774,   774,   774,   775,   776,   776,   776,   776,   776,
     776,   777,   777,   778,   778,   778,   778,   778,   778,   779,
     779,   780,   780,   781,   781,   781,   781,   781,   781,   781,
     781,   782,   782,   783,   783,   784,   784,   785,   785,   786,
     786,   787,   788,   788,   789,   789,   790,   790,   791,   791,
     792,   792,   793,   793,   793,   793,   793,   793,   793,   793,
     793,   793,   793,   793,   793,   793,   793,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   795,   795,   796,   796,   797,   797,   797,
     797,   797,   797,   797,   797,   797,   798,   798,   799,   799,
     800,   800,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   800,   800,   801,   802,   803,   803,   804,   804,   805,
     805,   806,   806,   807,   807,   808,   809,   809,   810,   810,
     810,   810,   811,   811,   811,   811,   812,   812,   813,   813,
     813,   813,   813,   813,   813,   813,   813,   813,   813,   813,
     813,   813,   813,   813,   813,   813,   813,   813,   813,   813,
     813,   813,   813,   813,   813,   813,   813,   813,   813,   813,
     813,   813,   813,   813,   813,   813,   813,   813,   813,   813,
     813,   813,   813,   813,   813,   813,   813,   813,   814,   814,
     814,   814,   814,   814,   815,   815,   815,   816,   816,   817,
     817,   817,   818,   818,   819,   819,   819,   820,   820,   820,
     821,   821,   822,   823,   823,   824,   824,   825,   825,   825,
     825,   826,   826,   826,   826,   826,   827,   827,   827,   827,
     828,   828,   828,   829,   829,   830,   830,   830,   831,   832,
     832,   833,   833,   833,   834,   835,   835,   836,   837,   837,
     837,   837,   837,   837,   837,   837,   837,   838,   838,   838,
     838,   838,   838,   838,   838,   839,   840,   840,   841,   842,
     843,   843,   844,   844,   844,   844,   844,   844,   844,   845,
     846,   847,   847,   847,   848,   848,   850,   849,   851,   849,
     852,   849,   853,   849,   854,   849,   855,   849,   856,   849,
     857,   857,   858,   858,   858,   858,   858,   858,   858,   858,
     858,   858,   859,   859,   860,   860,   860,   860,   860,   860,
     860,   860,   860,   860,   861,   862,   862,   862,   862,   862,
     862,   863,   863,   863,   863,   863,   863,   864,   864,   865,
     865,   865,   866,   867,   867,   867,   867,   867,   867,   868,
     868,   868,   868,   869,   869,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   871,   871,   872,   872,   873,   873,
     874,   874,   875,   875,   875,   875,   876,   876,   878,   877,
     879,   879,   879,   881,   880,   882,   882,   882,   883,   884,
     884,   885,   886,   887,   888,   888,   888,   888,   889,   890,
     890,   891,   891,   891,   891,   891,   891,   891,   892,   892,
     892,   892,   893,   893,   894,   894,   895,   896,   897,   897,
     898,   898,   899,   899,   899,   899,   899,   899,   899,   899,
     899,   899,   899,   899,   899,   899,   899,   899,   899,   899,
     899,   899,   899,   899,   899,   899,   899,   899,   899,   899,
     899,   899,   899,   899,   899,   899,   900,   900,   901,   901,
     902,   902,   903,   903,   904,   904,   905,   905,   905,   905,
     905,   905,   907,   908,   906,   909,   909,   910,   910,   910,
     910,   911,   912,   912,   913,   913,   913,   913,   914,   915,
     915,   915,   915,   916,   916,   917,   917,   917,   918,   918,
     919,   919,   919,   920,   920,   921,   921,   921,   922,   922,
     923,   923,   924,   924,   925,   926,   926,   926,   926,   927,
     927,   927,   927,   928,   928,   928,   928,   929,   929,   929,
     929,   930,   930,   931,   931,   931,   931,   931,   931,   931,
     932,   932,   932,   932,   932,   932,   932,   932,   932,   932,
     933,   933,   934,   934,   935,   935,   935,   935,   936,   936,
     937,   937,   938,   938,   938,   938,   938,   938,   938,   938,
     938,   938,   938,   938,   938,   938,   938,   938,   938,   938,
     938,   938,   938,   938,   938,   938,   938,   938,   938,   938,
     938,   938,   938,   938,   938,   938,   938,   938,   938,   938,
     938,   938,   938,   938,   938,   938,   938,   938,   938,   938,
     939,   939,   940,   940,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   942,   942,
     943,   943,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   945,   945,   946,   946,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   948,   948,   949,   949,   949,   949,
     950,   950,   950,   950,   951,   951,   952,   952,   953,   953,
     953,   953,   953,   953,   953,   953,   954,   954,   955,   955,
     956,   956,   956,   956,   956,   956,   956,   957,   957,   958,
     958,   959,   959,   959,   959,   959,   959,   959,   959,   959,
     959,   959,   959,   959,   959,   959,   959,   959,   959,   959,
     959,   959,   959,   959,   959,   959,   959,   959,   959,   959,
     959,   959,   959,   959,   959,   959,   960,   960,   961,   961,
     962,   962,   963,   963,   964,   964,   964,   964,   964,   964,
     964,   964,   964,   964,   964,   964,   964,   964,   964,   964,
     964,   964,   964,   964,   964,   964,   964,   964,   964,   964,
     964,   964,   964,   964,   964,   964,   964,   964,   964,   964,
     964,   964,   964,   964,   964,   964,   964,   964,   964,   964,
     964,   964,   964,   964,   964,   964,   965,   965,   966,   966,
     966,   966,   966,   966,   966,   966,   966,   966,   967,   967,
     968,   968,   968,   968,   968,   968,   968,   968,   968,   968,
     968,   968,   969,   969,   970,   970,   970,   970,   970,   970,
     970,   970,   970,   970,   970,   970,   970,   970,   970,   970,
     970,   970,   970,   970,   971,   971,   972,   972,   972,   972,
     972,   972,   972,   972,   972,   972,   972,   972,   972,   972,
     973,   974,   974,   975,   975,   976,   976,   976,   976,   977,
     977,   978,   978,   978,   978,   978,   979,   980,   980,   981,
     981,   981,   981,   981,   982,   982,   983,   984,   984,   985,
     987,   986,   988,   988,   989,   989,   990,   990,   990,   990,
     991,   991,   992,   992,   992,   992,   992,   992,   992,   992,
     992,   992,   992,   992,   992,   993,   993,   993,   993,   994,
     994,   995,   995,   996,   996,   997,   998,   998,   999,   999,
    1000,  1000,  1001,  1001,  1001,  1001,  1001,  1001,  1002,  1003,
    1003,  1003,  1004,  1005,  1005,  1006,  1006,  1006,  1007,  1007,
    1008,  1008,  1009,  1009,  1009,  1010,  1010,  1011,  1011,  1012,
    1012,  1012,  1012,  1012,  1013,  1013,  1014,  1014,  1015,  1015,
    1016,  1016,  1016,  1017,  1017,  1018,  1018,  1019,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1068,  1067,
    1069,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
    1078,  1079,  1079,  1080,  1081,  1082,  1083,  1083,  1084,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1109,  1110,  1110,  1111,  1112,
    1113,  1114,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
    1122,  1122,  1123,  1124,  1125,  1125,  1126,  1126,  1127,  1127,
    1128,  1129,  1130,  1130,  1130,  1130,  1131,  1131,  1132,  1133,
    1134,  1135,  1136,  1137,  1138,  1139,  1140,  1141,  1141,  1142,
    1143,  1144,  1145,  1146,  1147,  1148,  1148,  1149,  1150,  1151,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,
    1162,  1163,  1163,  1163,  1164,  1165,  1166,  1167,  1168,  1169,
    1170,  1171,  1172,  1173,  1174,  1175,  1176,  1176,  1177,  1178,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1196,  1197,
    1198,  1198,  1198,  1198,  1199,  1200,  1201,  1201,  1201,  1202,
    1203,  1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,  1212,
    1213,  1213,  1213,  1214,  1214,  1214,  1215,  1216,  1217,  1218,
    1219,  1220,  1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,
    1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,
    1238,  1238,  1239,  1240,  1240,  1240,  1241,  1241,  1242,  1243,
    1244,  1244,  1244,  1245,  1245,  1245,  1246,  1247,  1248,  1249,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
    1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,  1272,  1273,  1274,  1275,  1275,  1276,  1277,  1278,
    1279,  1280,  1281,  1282,  1283,  1284,  1285,  1286,  1287,  1288,
    1289,  1289,  1289,  1289,  1289,  1289,  1289,  1290,  1291,  1292,
    1293,  1294,  1294,  1294,  1295,  1296,  1297,  1298,  1299,  1300,
    1301,  1302,  1303,  1303,  1303,  1304,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,  1313,  1314,  1315,  1315,  1316,  1317,
    1318,  1319,  1320,  1321,  1322,  1323,  1324,  1325,  1326,  1327,
    1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    1338,  1339,  1340,  1341,  1342,  1343,  1344,  1344,  1345,  1346,
    1347,  1348,  1349,  1350,  1350,  1351,  1352,  1353,  1354,  1355,
    1355,  1356,  1356,  1357,  1358,  1359,  1360,  1361,  1362,  1363,
    1364,  1365,  1366,  1367,  1368,  1369,  1370,  1371,  1372,  1373,
    1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,
    1384,  1385,  1386,  1387,  1388,  1389,  1390,  1391,  1392,  1393,
    1394,  1395,  1396,  1397,  1398,  1399,  1399,  1400,  1401,  1402,
    1403,  1404,  1405,  1406,  1407,  1408,  1408,  1408,  1408,  1409,
    1410,  1411,  1412,  1413,  1414,  1415,  1416,  1417,  1418,  1419,
    1420,  1421,  1422,  1423,  1424,  1425,  1425,  1426,  1427,  1428,
    1429,  1430,  1431,  1432,  1432,  1433,  1433,  1434,  1435,  1436,
    1437,  1438,  1438,  1438,  1438,  1439,  1439,  1439,  1439,  1440,
    1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,  1450,
    1451,  1452,  1453,  1454,  1455,  1456,  1457,  1458,  1459,  1460,
    1461,  1462,  1463,  1464,  1465,  1466,  1467,  1468,  1468,  1469,
    1469,  1470,  1471,  1471,  1472,  1472,  1472,  1472,  1473,  1473,
    1474,  1474,  1474,  1474,  1475,  1475,  1476,  1476,  1476,  1476,
    1477,  1477,  1478,  1478,  1479,  1479,  1480,  1480,  1481,  1482,
    1482,  1482,  1482,  1482,  1482,  1482,  1482,  1482,  1482,  1482,
    1482,  1482,  1482,  1482,  1482,  1482,  1482,  1482,  1482,  1483,
    1483
  };

  const unsigned char
  parser::yyr2_[] =
  {
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     4,     3,
       0,     9,     2,     3,     1,     3,     4,     2,     0,     9,
       2,     3,     1,     3,     4,     2,     3,     0,     9,     0,
       9,     5,     6,     2,     3,     1,     3,     1,     1,     1,
       1,     5,     3,     1,     1,     1,     1,     0,     6,     3,
       1,     1,     1,     1,     1,     1,     5,     1,     3,     3,
       0,     4,     3,     3,     3,     3,     3,     0,     9,     2,
       1,     5,     7,     4,    10,    14,     5,     5,     3,     3,
       3,     6,     5,     5,     3,     3,     3,     8,     2,     1,
       6,     5,     3,     1,     1,     1,     2,     3,     1,     3,
       4,     2,     3,     4,     2,     4,     5,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     1,     3,     4,     2,     3,     4,     2,     4,
       5,     3,     2,     3,     1,     3,     4,     2,     3,     4,
       2,     4,     5,     3,     2,     3,     1,     3,     4,     2,
       3,     4,     2,     4,     5,     3,     2,     3,     1,     3,
       4,     2,     3,     4,     2,     4,     5,     3,     2,     3,
       1,     2,     3,     1,     3,     4,     2,     6,     1,     1,
       1,     1,     1,     2,     3,     3,     4,     4,     3,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     6,     6,
       0,     5,     8,     4,     8,     4,     4,     1,     1,     1,
       3,     0,     1,     5,     8,     7,     5,     8,     2,     1,
       4,     5,     8,     2,     1,     7,     7,     0,     6,     2,
       1,     0,     5,     5,     3,     1,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     5,     1,
       5,     1,     3,     3,     1,     0,     6,     0,     9,     2,
       2,     1,     1,     4,     2,     7,     5,     3,     1,     3,
       1,     3,     1,     2,     2,     2,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     7,     4,
       4,     2,     2,     4,     4,     6,     8,     8,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     6,     6,     0,     5,     8,     4,     8,     4,     4,
       4,     1,     3,     5,     5,     8,     2,     1,     1,     6,
       5,     7,     7,     9,     0,     6,     2,     1,     5,     3,
       0,     0,    10,     2,     2,     6,     5,     3,     1,     1,
       1,     1,     2,     6,     7,     7,     8,     2,     5,     3,
       1,     1,     1,     1,     1,     1,     1,     5,     3,     1,
       1,     1,     1,     1,     5,     8,     2,     1,     3,     2,
       5,     4,     3,     1,     6,     5,     4,     3,     3,     2,
       1,     3,     1,     5,     3,     4,     2,     3,     1,     2,
       5,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     5,     3,     1,     1,     1,     2,     5,     3,
       1,     0,     2,     5,     3,     1,     1,     1,     2,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     6,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     6,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     5,     3,     1,     1,     1,     2,
       5,     3,     1,     1,     1,     5,     3,     1,     1,     1,
       1,     1,     2,     5,     3,     6,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     3,     1,     1,     1,     2,
       2,     1,     1,     1,     2,     2,     1,     2,     2,     1,
       1,     1,     5,     2,     1,     4,     2,     2,     1,     4,
       1,     3,     5,     9,     1,     5,     3,     5,     7,     9,
       5,     7,     8,     2,     1,     5,     7,     4,     5,     2,
       1,     7,     9,     6,     5,     2,     1,     6,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     5,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       4,     3,     6,     8,     3,     1,     0,     8,     0,    10,
       0,     8,     0,    11,     0,    13,     0,    13,     0,    15,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     5,     6,     8,     8,
      10,     7,     9,    10,    12,    12,    14,     3,     1,     1,
       1,     1,     4,     3,     5,     6,     8,     8,    10,     2,
       5,     3,     6,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     3,     3,     3,
       1,     3,     3,     3,     3,     5,     1,     3,     0,     4,
       2,     3,     1,     0,     4,     2,     3,     1,     5,     2,
       1,     5,     3,     5,     4,     6,     3,     5,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     5,
       3,     6,     5,     6,     5,     6,     5,     5,     2,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     6,     1,     1,
       1,     3,     1,     1,     1,     3,     1,     4,     2,     5,
       3,     6,     0,     0,     5,     2,     5,     2,     5,     3,
       6,     5,     2,     1,     4,     4,     4,     4,     2,     2,
       5,     3,     6,     3,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     2,     5,
       2,     5,     2,     5,     2,     2,     5,     3,     6,     2,
       5,     3,     6,     2,     5,     3,     6,     2,     5,     3,
       6,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     6,     1,     1,     1,     1,     3,     1,
       3,     6,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       2,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     2,     5,     3,     6,
       1,     1,     1,     1,     3,     1,     2,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     5,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     5,
       2,     5,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     1,     2,     6,     4,     2,     5,     3,     6,     1,
       3,     1,     1,     1,     1,     1,     5,     1,     3,     1,
       1,     1,     1,     1,     3,     8,     5,     1,     2,     9,
       0,     6,     2,     1,     4,     6,     2,     5,     3,     6,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     5,     7,     8,     3,
       1,     1,     1,     2,     1,     4,     5,     3,     2,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     5,
       1,     1,     5,     1,     2,     6,     9,     9,     5,     8,
       1,     2,     6,     9,     9,     2,     5,     3,     1,     1,
       1,     1,     1,     1,     5,    10,     2,     1,     4,     4,
       3,     2,     1,     5,    10,     2,     1,     3,     4,     3,
       3,     3,     3,     1,     1,     1,     3,     3,     3,     3,
       1,     1,     1,     3,     5,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     3,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     0,     4,
       3,     3,     3,     3,     3,     3,     3,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     1,
       1,     3,     3,     3,     3,     5,     3,     5,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     3,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     5,
       5,     3,     1,     3,     3,     3,     3,     1,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     1,     1,
       3,     3,     3,     3,     3,     1,     3,     1,     1,     1,
       1,     3,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     1,     3,     3,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     1,     3,     3,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     5,     5,     3,     3,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     5,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     3,     3,     3,     3,     3,     1,     1,     3,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     3,     3,     3,     3,     3,     3,
       5,     1,     1,     3,     3,     1,     5,     3,     3,     3,
       1,     3,     1,     1,     1,     1,     1,     3,     3,     3,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     3,     1,     3,     3,     3,     1,     3,     1,     1,
       1,     3,     3,     3,     3,     1,     3,     1,     3,     3,
       3,     1,     3,     1,     3,     3,     3,     3,     3,     1,
       1,     3,     3,     1,     1,     1,     3,     5,     3,     3,
       5,     1,     1,     3,     3,     1,     3,     3,     3,     3,
       3,     1,     1,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     3,     3,     3,     1,     1,     1,     1,
       3,     3,     3,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       6,     1,     1,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     3,     1,     3,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "$end", "error", "$undefined", "AIM_SOLVER", "ANALYTIC_DERIVATION",
  "ANALYTIC_DERIVATION_MODE", "AR", "POSTERIOR_SAMPLING_METHOD",
  "BALANCED_GROWTH_TEST_TOL", "BAYESIAN_IRF", "BETA_PDF", "BLOCK",
  "USE_CALIBRATION", "SILENT_OPTIMIZER", "BVAR_DENSITY", "BVAR_FORECAST",
  "NODECOMPOSITION", "DR_DISPLAY_TOL", "HUGE_NUMBER", "FIG_NAME",
  "WRITE_XLS", "BVAR_PRIOR_DECAY", "BVAR_PRIOR_FLAT", "BVAR_PRIOR_LAMBDA",
  "INTERACTIVE", "SCREEN_SHOCKS", "STEADYSTATE", "BVAR_PRIOR_MU",
  "BVAR_PRIOR_OMEGA", "BVAR_PRIOR_TAU", "BVAR_PRIOR_TRAIN", "DETAIL_PLOT",
  "TYPE", "BVAR_REPLIC", "BYTECODE", "ALL_VALUES_REQUIRED",
  "PROPOSAL_DISTRIBUTION", "REALTIME", "VINTAGE", "CALIB_SMOOTHER",
  "CHANGE_TYPE", "CHECK", "CONDITIONAL_FORECAST",
  "CONDITIONAL_FORECAST_PATHS", "CONF_SIG", "CONSTANT",
  "CONTROLLED_VAREXO", "CORR", "CUTOFF", "CYCLE_REDUCTION",
  "LOGARITHMIC_REDUCTION", "COMMA", "CONSIDER_ALL_ENDOGENOUS",
  "CONSIDER_ONLY_OBSERVED", "INITIAL_CONDITION_DECOMPOSITION", "DATAFILE",
  "FILE", "SERIES", "DOUBLING", "DR_CYCLE_REDUCTION_TOL",
  "DR_LOGARITHMIC_REDUCTION_TOL", "DR_LOGARITHMIC_REDUCTION_MAXITER",
  "DR_ALGO", "DROP", "DSAMPLE", "DYNASAVE", "DYNATYPE", "CALIBRATION",
  "DIFFERENTIATE_FORWARD_VARS", "END", "ENDVAL", "EQUAL", "ESTIMATION",
  "ESTIMATED_PARAMS", "ESTIMATED_PARAMS_BOUNDS", "ESTIMATED_PARAMS_INIT",
  "EXTENDED_PATH", "ENDOGENOUS_PRIOR", "EXPRESSION", "FILENAME", "DIRNAME",
  "FILTER_STEP_AHEAD", "FILTERED_VARS", "FIRST_OBS", "LAST_OBS",
  "SET_TIME", "OSR_PARAMS_BOUNDS",
  "KEEP_KALMAN_ALGO_IF_SINGULARITY_IS_DETECTED", "FLOAT_NUMBER", "DATES",
  "DEFAULT", "FIXED_POINT", "FLIP", "OPT_ALGO", "COMPILATION_SETUP",
  "COMPILER", "ADD_FLAGS", "SUBSTITUTE_FLAGS", "ADD_LIBS",
  "SUBSTITUTE_LIBS", "FORECAST", "K_ORDER_SOLVER", "INSTRUMENTS", "SHIFT",
  "MEAN", "STDEV", "VARIANCE", "MODE", "INTERVAL", "SHAPE", "DOMAINN",
  "GAMMA_PDF", "GRAPH", "GRAPH_FORMAT",
  "CONDITIONAL_VARIANCE_DECOMPOSITION", "NOCHECK", "STD", "HISTVAL",
  "HISTVAL_FILE", "HOMOTOPY_SETUP", "HOMOTOPY_MODE", "HOMOTOPY_STEPS",
  "HOMOTOPY_FORCE_CONTINUE", "HP_FILTER", "HP_NGRID",
  "FILTERED_THEORETICAL_MOMENTS_GRID", "HYBRID", "ONE_SIDED_HP_FILTER",
  "IDENTIFICATION", "INF_CONSTANT", "INITVAL", "INITVAL_FILE", "BOUNDS",
  "JSCALE", "INIT", "INFILE", "INVARS", "INT_NUMBER", "INV_GAMMA_PDF",
  "INV_GAMMA1_PDF", "INV_GAMMA2_PDF", "IRF", "IRF_SHOCKS",
  "IRF_PLOT_THRESHOLD", "IRF_CALIBRATION", "FAST_KALMAN_FILTER",
  "KALMAN_ALGO", "KALMAN_TOL", "DIFFUSE_KALMAN_TOL", "SUBSAMPLES",
  "OPTIONS", "TOLF", "TOLX", "PLOT_INIT_DATE", "PLOT_END_DATE", "LAPLACE",
  "LIK_ALGO", "LIK_INIT", "LINEAR", "LINEAR_DECOMPOSITION",
  "LOAD_IDENT_FILES", "LOAD_MH_FILE", "LOAD_RESULTS_AFTER_LOAD_MH",
  "LOAD_PARAMS_AND_STEADY_STATE", "LOGLINEAR", "LOGDATA", "LYAPUNOV",
  "LINEAR_APPROXIMATION", "LYAPUNOV_FIXED_POINT_TOL",
  "LYAPUNOV_DOUBLING_TOL", "LOG_DEFLATOR", "LOG_TREND_VAR",
  "LOG_GROWTH_FACTOR", "MARKOWITZ", "MARGINAL_DENSITY", "MAX", "MAXIT",
  "MFS", "MH_CONF_SIG", "MH_DROP", "MH_INIT_SCALE", "MH_JSCALE",
  "MH_TUNE_JSCALE", "MH_MODE", "MH_NBLOCKS", "MH_REPLIC", "MH_RECOVER",
  "POSTERIOR_MAX_SUBSAMPLE_DRAWS", "MIN", "MINIMAL_SOLVING_PERIODS",
  "MODE_CHECK", "MODE_CHECK_NEIGHBOURHOOD_SIZE",
  "MODE_CHECK_SYMMETRIC_PLOTS", "MODE_CHECK_NUMBER_OF_POINTS",
  "MODE_COMPUTE", "MODE_FILE", "MODEL", "MODEL_COMPARISON", "MODEL_INFO",
  "MSHOCKS", "ABS", "SIGN", "MODEL_DIAGNOSTICS", "MODIFIEDHARMONICMEAN",
  "MOMENTS_VARENDO", "CONTEMPORANEOUS_CORRELATION", "DIFFUSE_FILTER",
  "SUB_DRAWS", "TAPER_STEPS", "GEWEKE_INTERVAL", "RAFTERY_LEWIS_QRS",
  "RAFTERY_LEWIS_DIAGNOSTICS", "MCMC_JUMPING_COVARIANCE",
  "MOMENT_CALIBRATION", "NUMBER_OF_PARTICLES", "RESAMPLING", "SYSTEMATIC",
  "GENERIC", "RESAMPLING_THRESHOLD", "RESAMPLING_METHOD", "KITAGAWA",
  "STRATIFIED", "SMOOTH", "CPF_WEIGHTS", "AMISANOTRISTANI",
  "MURRAYJONESPARSLOW", "WRITE_EQUATION_TAGS",
  "NONLINEAR_FILTER_INITIALIZATION", "FILTER_ALGORITHM",
  "PROPOSAL_APPROXIMATION", "CUBATURE", "UNSCENTED", "MONTECARLO",
  "DISTRIBUTION_APPROXIMATION", "NAME",
  "USE_PENALIZED_OBJECTIVE_FOR_HESSIAN", "INIT_STATE", "FAST_REALTIME",
  "RESCALE_PREDICTION_ERROR_COVARIANCE", "GENERATE_IRFS", "NAN_CONSTANT",
  "NO_STATIC", "NOBS", "NOCONSTANT", "NODISPLAY", "NOCORR", "NODIAGNOSTIC",
  "NOFUNCTIONS", "NO_HOMOTOPY", "NOGRAPH", "POSTERIOR_NOGRAPH",
  "POSTERIOR_GRAPH", "NOMOMENTS", "NOPRINT", "NORMAL_PDF", "SAVE_DRAWS",
  "MODEL_NAME", "STDERR_MULTIPLES", "DIAGONAL_ONLY", "OBSERVATION_TRENDS",
  "OPTIM", "OPTIM_WEIGHTS", "ORDER", "OSR", "OSR_PARAMS",
  "MAX_DIM_COVA_GROUP", "ADVANCED", "OUTFILE", "OUTVARS", "OVERWRITE",
  "DISCOUNT", "PARALLEL_LOCAL_FILES", "PARAMETERS", "PARAMETER_SET",
  "PARTIAL_INFORMATION", "PERIODS", "PERIOD", "PLANNER_OBJECTIVE",
  "PLOT_CONDITIONAL_FORECAST", "PLOT_PRIORS", "PREFILTER", "PRESAMPLE",
  "PERFECT_FORESIGHT_SETUP", "PERFECT_FORESIGHT_SOLVER",
  "NO_POSTERIOR_KERNEL_DENSITY", "FUNCTION", "PRINT", "PRIOR_MC",
  "PRIOR_TRUNC", "PRIOR_MODE", "PRIOR_MEAN", "POSTERIOR_MODE",
  "POSTERIOR_MEAN", "POSTERIOR_MEDIAN", "MLE_MODE", "PRUNING",
  "QUOTED_STRING", "QZ_CRITERIUM", "QZ_ZERO_THRESHOLD", "DSGE_VAR",
  "DSGE_VARLAG", "DSGE_PRIOR_WEIGHT", "TRUNCATE", "PIPE_E", "PIPE_X",
  "PIPE_P", "RELATIVE_IRF", "REPLIC", "SIMUL_REPLIC", "RPLOT",
  "SAVE_PARAMS_AND_STEADY_STATE", "PARAMETER_UNCERTAINTY", "TARGETS",
  "SHOCKS", "SHOCK_DECOMPOSITION", "SHOCK_GROUPS", "USE_SHOCK_GROUPS",
  "SIGMA_E", "SIMUL", "SIMUL_ALGO", "SIMUL_SEED",
  "ENDOGENOUS_TERMINAL_PERIOD", "SMOOTHER", "SMOOTHER2HISTVAL",
  "SQUARE_ROOT_SOLVER", "STACK_SOLVE_ALGO", "STEADY_STATE_MODEL",
  "SOLVE_ALGO", "SOLVER_PERIODS", "ROBUST_LIN_SOLVE", "STDERR", "STEADY",
  "STOCH_SIMUL", "SYLVESTER", "SYLVESTER_FIXED_POINT_TOL", "REGIMES",
  "REGIME", "REALTIME_SHOCK_DECOMPOSITION", "CONDITIONAL", "UNCONDITIONAL",
  "TEX", "RAMSEY_MODEL", "RAMSEY_POLICY", "RAMSEY_CONSTRAINTS",
  "PLANNER_DISCOUNT", "PLANNER_DISCOUNT_LATEX_NAME",
  "DISCRETIONARY_POLICY", "DISCRETIONARY_TOL",
  "EVALUATE_PLANNER_OBJECTIVE", "TEX_NAME", "UNIFORM_PDF",
  "UNIT_ROOT_VARS", "USE_DLL", "USEAUTOCORR", "GSA_SAMPLE_FILE",
  "USE_UNIVARIATE_FILTERS_IF_SINGULARITY_IS_DETECTED", "VALUES", "VAR",
  "VAREXO", "VAREXO_DET", "VARIABLE", "VAROBS", "VAREXOBS",
  "PREDETERMINED_VARIABLES", "VAR_EXPECTATION", "VAR_EXPECTATION_MODEL",
  "PLOT_SHOCK_DECOMPOSITION", "MODEL_LOCAL_VARIABLE",
  "WRITE_LATEX_DYNAMIC_MODEL", "WRITE_LATEX_STATIC_MODEL",
  "WRITE_LATEX_ORIGINAL_MODEL", "CROSSEQUATIONS", "COVARIANCE",
  "WRITE_LATEX_STEADY_STATE_MODEL", "XLS_SHEET", "XLS_RANGE", "LMMCP",
  "OCCBIN", "BANDPASS_FILTER", "COLORMAP", "VAR_MODEL", "PAC_MODEL", "QOQ",
  "YOY", "AOA", "PAC_EXPECTATION", "TREND_COMPONENT_MODEL", "EQUAL_EQUAL",
  "EXCLAMATION_EQUAL", "LESS", "GREATER", "LESS_EQUAL", "GREATER_EQUAL",
  "PLUS", "MINUS", "TIMES", "DIVIDE", "UNARY", "POWER", "EXP", "LOG", "LN",
  "LOG10", "SIN", "COS", "TAN", "ASIN", "ACOS", "ATAN", "ERF", "DIFF",
  "ADL", "AUXILIARY_MODEL_NAME", "SQRT", "CBRT", "NORMCDF", "NORMPDF",
  "STEADY_STATE", "EXPECTATION", "VAR_ESTIMATION", "DYNARE_SENSITIVITY",
  "MORRIS", "STAB", "REDFORM", "PPRIOR", "PRIOR_RANGE", "PPOST", "ILPTAU",
  "MORRIS_NLIV", "MORRIS_NTRA", "NSAM", "LOAD_REDFORM", "LOAD_RMSE",
  "LOAD_STAB", "ALPHA2_STAB", "LOGTRANS_REDFORM", "THRESHOLD_REDFORM",
  "KSSTAT_REDFORM", "ALPHA2_REDFORM", "NAMENDO", "NAMLAGENDO", "NAMEXO",
  "RMSE", "LIK_ONLY", "VAR_RMSE", "PFILT_RMSE", "ISTART_RMSE",
  "ALPHA_RMSE", "ALPHA2_RMSE", "FREQ", "INITIAL_YEAR", "INITIAL_SUBPERIOD",
  "FINAL_YEAR", "FINAL_SUBPERIOD", "DATA", "VLIST", "VLISTLOG", "VLISTPER",
  "SPECTRAL_DENSITY", "INIT2SHOCKS", "RESTRICTION", "RESTRICTION_FNAME",
  "CROSS_RESTRICTIONS", "NLAGS", "CONTEMP_REDUCED_FORM",
  "REAL_PSEUDO_FORECAST", "DUMMY_OBS", "NSTATES", "INDXSCALESSTATES",
  "NO_BAYESIAN_PRIOR", "SPECIFICATION", "SIMS_ZHA", "ALPHA", "BETA",
  "ABAND", "NINV", "CMS", "NCMS", "CNUM", "GAMMA", "INV_GAMMA",
  "INV_GAMMA1", "INV_GAMMA2", "NORMAL", "UNIFORM", "EPS", "PDF", "FIG",
  "DR", "NONE", "PRIOR", "PRIOR_VARIANCE", "HESSIAN", "IDENTITY_MATRIX",
  "DIRICHLET", "DIAGONAL", "OPTIMAL", "GSIG2_LMDM", "Q_DIAG", "FLAT_PRIOR",
  "NCSK", "NSTD", "WEIBULL", "WEIBULL_PDF", "INDXPARR", "INDXOVR",
  "INDXAP", "APBAND", "INDXIMF", "INDXFORE", "FOREBAND", "INDXGFOREHAT",
  "INDXGIMFHAT", "INDXESTIMA", "INDXGDLS", "EQ_MS", "FILTER_COVARIANCE",
  "FILTER_DECOMPOSITION", "SMOOTHED_STATE_UNCERTAINTY", "EQ_CMS", "TLINDX",
  "TLNUMBER", "RESTRICTIONS", "POSTERIOR_SAMPLER_OPTIONS",
  "OUTPUT_FILE_TAG", "HORIZON", "SBVAR", "TREND_VAR", "DEFLATOR",
  "GROWTH_FACTOR", "MS_IRF", "MS_VARIANCE_DECOMPOSITION", "GROWTH",
  "MS_ESTIMATION", "MS_SIMULATION", "MS_COMPUTE_MDD",
  "MS_COMPUTE_PROBABILITIES", "MS_FORECAST", "SVAR_IDENTIFICATION",
  "EQUATION", "EXCLUSION", "LAG", "UPPER_CHOLESKY", "LOWER_CHOLESKY",
  "MONTHLY", "QUARTERLY", "MARKOV_SWITCHING", "CHAIN", "DURATION",
  "NUMBER_OF_REGIMES", "NUMBER_OF_LAGS", "EPILOGUE", "SVAR",
  "SVAR_GLOBAL_IDENTIFICATION_CHECK", "COEFF", "COEFFICIENTS", "VARIANCES",
  "CONSTANTS", "EQUATIONS", "EXTERNAL_FUNCTION", "EXT_FUNC_NAME",
  "EXT_FUNC_NARGS", "FIRST_DERIV_PROVIDED", "SECOND_DERIV_PROVIDED",
  "SELECTED_VARIABLES_ONLY", "COVA_COMPUTE", "SIMULATION_FILE_TAG",
  "FILE_TAG", "NO_ERROR_BANDS", "ERROR_BAND_PERCENTILES",
  "SHOCKS_PER_PARAMETER", "NO_CREATE_INIT", "SHOCK_DRAWS",
  "FREE_PARAMETERS", "MEDIAN", "DATA_OBS_NBR", "NEIGHBORHOOD_WIDTH",
  "PVALUE_KS", "PVALUE_CORR", "FILTERED_PROBABILITIES",
  "REAL_TIME_SMOOTHED", "PRIOR_FUNCTION", "POSTERIOR_FUNCTION",
  "SAMPLING_DRAWS", "PROPOSAL_TYPE", "PROPOSAL_UPPER_BOUND",
  "PROPOSAL_LOWER_BOUND", "PROPOSAL_DRAWS", "USE_MEAN_CENTER",
  "ADAPTIVE_MH_DRAWS", "THINNING_FACTOR",
  "COEFFICIENTS_PRIOR_HYPERPARAMETERS", "SMM_ESTIMATION", "GMM_ESTIMATION",
  "CONVERGENCE_STARTING_VALUE", "CONVERGENCE_ENDING_VALUE",
  "CONVERGENCE_INCREMENT_VALUE", "MAX_ITERATIONS_STARTING_VALUE",
  "MAX_ITERATIONS_INCREMENT_VALUE", "MAX_BLOCK_ITERATIONS",
  "MAX_REPEATED_OPTIMIZATION_RUNS", "FUNCTION_CONVERGENCE_CRITERION",
  "SAVE_REALTIME", "PARAMETER_CONVERGENCE_CRITERION",
  "NUMBER_OF_LARGE_PERTURBATIONS", "NUMBER_OF_SMALL_PERTURBATIONS",
  "NUMBER_OF_POSTERIOR_DRAWS_AFTER_PERTURBATION", "MAX_NUMBER_OF_STAGES",
  "RANDOM_FUNCTION_CONVERGENCE_CRITERION",
  "RANDOM_PARAMETER_CONVERGENCE_CRITERION", "CENTERED_MOMENTS", "AUTOLAG",
  "RECURSIVE_ORDER_ESTIMATION", "BARTLETT_KERNEL_LAG", "WEIGHTING_MATRIX",
  "PENALIZED_ESTIMATOR", "VERBOSE", "SIMULATION_MULTIPLE", "SEED",
  "BOUNDED_SHOCK_SUPPORT", "EQTAGS", "STEADY_STATE_GROWTH",
  "ANALYTICAL_GIRF", "IRF_IN_PERCENT", "EMAS_GIRF", "EMAS_DROP",
  "EMAS_TOLF", "EMAS_MAX_ITER", "NO_IDENTIFICATION_STRENGTH",
  "NO_IDENTIFICATION_REDUCEDFORM", "NO_IDENTIFICATION_MOMENTS",
  "NO_IDENTIFICATION_MINIMAL", "NO_IDENTIFICATION_SPECTRUM",
  "NORMALIZE_JACOBIANS", "GRID_NBR", "TOL_RANK", "TOL_DERIV", "TOL_SV",
  "CHECKS_VIA_SUBSETS", "MAX_DIM_SUBSETS_GROUPS", "MAX_NROWS",
  "SQUEEZE_SHOCK_DECOMPOSITION", "WITH_EPILOGUE", "SYMBOL_VEC", "';'",
  "'('", "')'", "'['", "']'", "'#'", "':'", "'.'", "$accept",
  "statement_list", "statement", "dsample", "rplot", "trend_var", "$@1",
  "trend_var_list", "log_trend_var", "$@2", "log_trend_var_list", "var",
  "$@3", "$@4", "var_model", "var_symbol_list", "var_model_options_list",
  "var_model_options", "trend_component_model",
  "trend_component_model_options_list", "trend_component_model_options",
  "pac_model", "$@5", "pac_model_options_list", "pac_model_options",
  "var_expectation_model", "var_expectation_model_options_list",
  "var_expectation_model_option", "$@6", "restrictions", "$@7",
  "restrictions_list", "restriction", "restriction_equation_equality",
  "restriction_equation_equality_side", "coeff_def",
  "restriction_crossequation_equality",
  "restriction_crossequation_equality_side", "coeff_def1",
  "restriction_exclusion_equation_list", "restriction_exclusion_equation",
  "var_estimation", "var_estimation_options_list",
  "var_estimation_options", "nonstationary_var_list", "varexo",
  "varexo_det", "predetermined_variables", "parameters",
  "model_local_variable", "named_var_elem", "named_var_1", "named_var",
  "var_list", "varexo_list", "varexo_det_list", "parameter_list",
  "predetermined_variables_list", "model_local_variable_list",
  "change_type", "change_type_arg", "change_type_var_list", "periods",
  "init_param", "expression", "$@8", "comma_expression",
  "expression_or_empty", "initval", "initval_file", "endval",
  "initval_list", "initval_elem", "histval", "histval_list",
  "histval_elem", "histval_file", "epilogue", "$@9",
  "epilogue_equation_list", "epilogue_equation", "$@10",
  "compilation_setup", "compilation_setup_options_list",
  "compilation_setup_option", "model_options", "model_options_list",
  "model", "$@11", "$@12", "equation_list", "equation", "tags_list",
  "tag_pair", "hand_side", "$@13", "comma_hand_side", "pound_expression",
  "shocks", "shock_list", "shock_elem", "det_shock_elem",
  "svar_identification", "$@14", "svar_identification_list",
  "svar_identification_elem", "$@15", "$@16", "svar_equation_list",
  "svar_var_list", "restriction_expression", "restriction_expression_1",
  "restriction_elem_expression", "svar_global_identification_check",
  "markov_switching", "ms_options_list", "ms_options", "svar",
  "svar_options_list", "svar_options", "mshocks", "mshock_list",
  "period_list", "sigma_e", "value_list", "triangular_matrix",
  "triangular_row", "steady", "steady_options_list", "steady_options",
  "check", "check_options_list", "check_options", "model_info",
  "model_info_options_list", "model_info_options",
  "perfect_foresight_setup", "perfect_foresight_setup_options_list",
  "perfect_foresight_setup_options", "perfect_foresight_solver",
  "perfect_foresight_solver_options_list",
  "perfect_foresight_solver_options", "gmm_smm_common_option",
  "gmm_estimation", "gmm_estimation_options_list", "gmm_estimation_option",
  "smm_estimation", "smm_estimation_options_list", "smm_estimation_option",
  "prior_function", "posterior_function",
  "prior_posterior_function_options_list",
  "prior_posterior_function_options", "simul", "simul_options_list",
  "simul_options", "external_function", "external_function_options_list",
  "external_function_options", "stoch_simul", "stoch_simul_options_list",
  "stoch_simul_primary_options", "stoch_simul_options", "symbol_list",
  "symbol_list_ext", "signed_integer", "non_negative_number",
  "signed_number", "signed_inf", "signed_number_w_inf", "estimated_params",
  "estimated_list", "estimated_elem", "estimated_elem1", "estimated_elem2",
  "estimated_elem3", "estimated_params_init", "estimated_init_list",
  "estimated_init_elem", "estimated_params_bounds",
  "estimated_bounds_list", "estimated_bounds_elem", "osr_params_bounds",
  "osr_bounds_list", "osr_bounds_elem", "prior_distribution", "prior_pdf",
  "date_str", "date_expr", "set_time", "data", "data_options_list",
  "data_options", "subsamples", "subsamples_eq", "subsamples_eq_opt",
  "subsamples_name_list", "prior", "$@17", "$@18", "$@19", "$@20", "$@21",
  "$@22", "$@23", "prior_options_list", "prior_options",
  "joint_prior_options_list", "joint_prior_options", "prior_eq",
  "prior_eq_opt", "options", "options_options_list", "options_options",
  "options_eq", "options_eq_opt", "estimation", "estimation_options_list",
  "estimation_options", "list_optim_option", "optim_options",
  "list_sub_sampling_option", "sub_sampling_options",
  "list_sampling_option", "sampling_options", "varobs", "$@24",
  "varobs_list", "varexobs", "$@25", "varexobs_list", "observation_trends",
  "trend_list", "trend_element", "unit_root_vars", "optim_weights",
  "optim_weights_list", "osr_params", "osr_options_list", "osr_options",
  "osr", "dynatype", "dynasave", "load_params_and_steady_state",
  "save_params_and_steady_state", "identification",
  "identification_options_list", "identification_option",
  "model_comparison", "filename", "namespace_qualified_symbol",
  "namespace_qualified_filename", "parallel_local_filename_list",
  "mc_filename_list", "planner_objective", "$@26", "$@27", "ramsey_model",
  "ramsey_policy", "ramsey_constraints", "ramsey_constraints_list",
  "ramsey_constraint", "evaluate_planner_objective",
  "discretionary_policy", "discretionary_policy_options_list",
  "discretionary_policy_options", "ramsey_model_options_list",
  "ramsey_model_options", "ramsey_policy_options_list",
  "ramsey_policy_options", "write_latex_dynamic_model",
  "write_latex_static_model", "write_latex_original_model",
  "write_latex_steady_state_model", "shock_decomposition",
  "realtime_shock_decomposition", "plot_shock_decomposition",
  "initial_condition_decomposition", "squeeze_shock_decomposition",
  "bvar_prior_option", "bvar_common_option", "bvar_density_options_list",
  "bvar_density", "bvar_forecast_option", "bvar_forecast_options_list",
  "bvar_forecast", "sbvar_option", "sbvar_options_list", "sbvar",
  "ms_variance_decomposition_option",
  "ms_variance_decomposition_options_list", "ms_variance_decomposition",
  "ms_forecast_option", "ms_forecast_options_list", "ms_forecast",
  "ms_irf_option", "ms_irf_options_list", "ms_irf",
  "ms_compute_probabilities_option",
  "ms_compute_probabilities_options_list", "ms_compute_probabilities",
  "ms_compute_mdd_option", "ms_compute_mdd_options_list", "ms_compute_mdd",
  "ms_simulation_option", "ms_simulation_options_list", "ms_simulation",
  "ms_estimation_option", "ms_estimation_options_list", "ms_estimation",
  "dynare_sensitivity", "dynare_sensitivity_options_list",
  "dynare_sensitivity_option", "shock_decomposition_options_list",
  "shock_decomposition_option",
  "realtime_shock_decomposition_options_list",
  "realtime_shock_decomposition_option",
  "plot_shock_decomposition_options_list",
  "plot_shock_decomposition_option",
  "initial_condition_decomposition_options_list",
  "initial_condition_decomposition_option", "homotopy_setup",
  "homotopy_list", "homotopy_item", "forecast", "forecast_options",
  "forecast_option", "conditional_forecast",
  "conditional_forecast_options", "conditional_forecast_option",
  "plot_conditional_forecast", "conditional_forecast_paths",
  "conditional_forecast_paths_shock_list",
  "conditional_forecast_paths_shock_elem", "steady_state_model", "$@28",
  "steady_state_equation_list", "steady_state_equation", "calib_smoother",
  "calib_smoother_options_list", "calib_smoother_option", "generate_irfs",
  "generate_irfs_options_list", "generate_irfs_option",
  "generate_irfs_element_list", "generate_irfs_element",
  "generate_irfs_exog_element_list", "extended_path",
  "extended_path_options_list", "extended_path_option",
  "model_diagnostics", "calibration_range", "moment_calibration",
  "moment_calibration_list", "moment_calibration_item", "irf_calibration",
  "irf_calibration_list", "irf_calibration_item", "smoother2histval",
  "smoother2histval_options_list", "smoother2histval_option",
  "shock_groups", "shock_group_list", "shock_group_element",
  "shock_name_list", "init2shocks", "init2shocks_list",
  "init2shocks_element", "o_dr_algo", "o_solve_algo", "o_simul_algo",
  "o_stack_solve_algo", "o_robust_lin_solve",
  "o_endogenous_terminal_period", "o_linear", "o_order", "o_replic",
  "o_drop", "o_ar", "o_nocorr", "o_nofunctions", "o_nomoments", "o_irf",
  "o_irf_shocks", "o_hp_filter", "o_hp_ngrid",
  "o_filtered_theoretical_moments_grid", "o_one_sided_hp_filter",
  "o_periods", "o_solver_periods", "o_extended_path_order", "o_hybrid",
  "o_steady_maxit", "o_simul_maxit", "o_bandpass_filter", "o_dp_maxit",
  "o_osr_maxit", "o_osr_tolf", "o_pf_tolf", "o_pf_tolx", "o_steady_tolf",
  "o_opt_algo", "o_cutoff", "o_markowitz", "o_minimal_solving_periods",
  "o_mfs", "o_simul", "o_simul_replic", "o_simul_seed", "o_qz_criterium",
  "o_qz_zero_threshold", "o_file", "o_pac_name", "o_pac_aux_model_name",
  "o_pac_discount", "o_pac_growth", "$@29", "o_pac_steady_state_growth",
  "o_var_name", "o_var_order", "o_series", "o_datafile", "o_var_datafile",
  "o_var_model_name", "o_var_eq_tags", "o_dirname", "o_huge_number",
  "o_nobs", "o_trend_component_model_name",
  "o_trend_component_model_targets", "o_trend_component_model_eq_tags",
  "o_conditional_variance_decomposition", "o_est_first_obs",
  "o_posterior_sampling_method", "o_first_obs", "o_data_first_obs",
  "o_data_last_obs", "o_keep_kalman_algo_if_singularity_is_detected",
  "o_data_nobs", "o_shift", "o_shape", "o_mode", "o_mean", "o_mean_vec",
  "o_truncate", "o_stdev", "o_jscale", "o_init", "o_bounds", "o_domain",
  "o_interval", "o_variance", "o_variance_mat", "o_prefilter",
  "o_presample", "o_lik_algo", "o_lik_init", "o_nograph",
  "o_posterior_nograph", "o_psd_nograph", "o_shock_decomposition_nograph",
  "o_init_state", "o_forecast_type", "o_shock_decomposition_presample",
  "o_shock_decomposition_forecast", "o_save_realtime", "o_fast_realtime",
  "o_nodisplay", "o_icd_nodisplay", "o_psd_nodisplay", "o_psd_init2shocks",
  "o_icd_max_nrows", "o_psd_max_nrows", "o_graph_format",
  "o_icd_graph_format", "o_psd_graph_format",
  "o_shock_decomposition_with_epilogue", "o_icd_with_epilogue",
  "allowed_graph_formats", "list_allowed_graph_formats",
  "o_subsample_name", "o_bvar_conf_sig", "o_forecasts_conf_sig",
  "o_conditional_forecast_conf_sig", "o_mh_conf_sig", "o_mh_replic",
  "o_posterior_max_subsample_draws", "o_mh_drop", "o_mh_jscale",
  "o_mh_tune_jscale", "o_optim", "o_posterior_sampler_options",
  "o_proposal_distribution", "o_no_posterior_kernel_density",
  "o_mh_init_scale", "o_mode_file", "o_mode_compute", "o_mode_check",
  "o_mode_check_neighbourhood_size", "o_mode_check_number_of_points",
  "o_mode_check_symmetric_plots", "o_prior_trunc", "o_mh_mode",
  "o_mh_nblocks", "o_load_mh_file", "o_load_results_after_load_mh",
  "o_loglinear", "o_linear_approximation", "o_logdata", "o_nodiagnostic",
  "o_bayesian_irf", "o_dsge_var", "o_dsge_varlag", "o_tex", "o_forecast",
  "o_smoother", "o_moments_varendo", "o_contemporaneous_correlation",
  "o_filtered_vars", "o_relative_irf", "o_fast_kalman_filter",
  "o_kalman_algo", "o_kalman_tol", "o_diffuse_kalman_tol",
  "o_marginal_density", "o_print", "o_noprint", "o_xls_sheet",
  "o_xls_range", "o_filter_step_ahead", "o_taper_steps",
  "o_geweke_interval", "o_raftery_lewis_diagnostics",
  "o_raftery_lewis_qrs", "o_constant", "o_noconstant", "o_mh_recover",
  "o_diffuse_filter", "o_plot_priors", "o_aim_solver",
  "o_partial_information", "o_sub_draws", "o_planner_discount",
  "o_planner_discount_latex_name", "o_sylvester",
  "o_sylvester_fixed_point_tol", "o_lyapunov",
  "o_lyapunov_fixed_point_tol", "o_lyapunov_doubling_tol", "o_dr",
  "o_dr_cycle_reduction_tol", "o_dr_logarithmic_reduction_tol",
  "o_dr_logarithmic_reduction_maxiter", "o_psd_detail_plot",
  "o_icd_detail_plot", "o_psd_interactive", "o_psd_screen_shocks",
  "o_psd_steadystate", "o_icd_steadystate", "o_icd_fig_name",
  "o_psd_fig_name", "o_psd_type", "o_icd_type", "o_icd_plot_init_date",
  "o_icd_plot_end_date", "o_psd_plot_init_date", "o_psd_plot_end_date",
  "o_icd_write_xls", "o_psd_write_xls", "o_psd_realtime", "o_psd_vintage",
  "o_psd_diff", "o_icd_diff", "o_psd_flip", "o_icd_flip",
  "o_bvar_prior_tau", "o_bvar_prior_decay", "o_bvar_prior_lambda",
  "o_bvar_prior_mu", "o_bvar_prior_omega", "o_bvar_prior_flat",
  "o_bvar_prior_train", "o_bvar_replic", "o_stderr_multiples",
  "o_diagonal_only", "o_number_of_particles", "o_resampling",
  "o_resampling_threshold", "o_resampling_method", "o_cpf_weights",
  "o_filter_algorithm", "o_nonlinear_filter_initialization",
  "o_proposal_approximation", "o_distribution_approximation",
  "o_gsa_identification", "o_gsa_morris", "o_gsa_stab", "o_gsa_redform",
  "o_gsa_pprior", "o_gsa_prior_range", "o_gsa_ppost", "o_gsa_ilptau",
  "o_gsa_morris_nliv", "o_gsa_morris_ntra", "o_gsa_nsam",
  "o_gsa_load_redform", "o_gsa_load_rmse", "o_gsa_load_stab",
  "o_gsa_alpha2_stab", "o_gsa_logtrans_redform", "o_gsa_threshold_redform",
  "o_gsa_ksstat_redform", "o_gsa_alpha2_redform", "o_gsa_namendo",
  "o_gsa_namlagendo", "o_gsa_namexo", "o_gsa_rmse", "o_gsa_lik_only",
  "o_gsa_var_rmse", "o_gsa_pfilt_rmse", "o_gsa_istart_rmse",
  "o_gsa_alpha_rmse", "o_gsa_alpha2_rmse", "o_gsa_sample_file",
  "o_gsa_neighborhood_width", "o_gsa_pvalue_ks", "o_gsa_pvalue_corr",
  "o_load_ident_files", "o_useautocorr", "o_prior_mc", "o_advanced",
  "o_max_dim_cova_group", "o_homotopy_mode", "o_homotopy_steps",
  "o_homotopy_force_continue", "o_nocheck", "o_controlled_varexo",
  "o_parameter_set", "o_nodecomposition", "o_spectral_density",
  "o_ms_drop", "o_ms_mh_replic", "o_freq", "o_initial_year",
  "o_initial_subperiod", "o_final_year", "o_final_subperiod", "o_data",
  "o_vlist", "o_vlistlog", "o_vlistper", "o_restriction_fname", "o_nlags",
  "o_cross_restrictions", "o_contemp_reduced_form",
  "o_real_pseudo_forecast", "o_no_bayesian_prior", "o_dummy_obs",
  "o_nstates", "o_indxscalesstates", "o_alpha", "o_beta", "o_gsig2_lmdm",
  "o_specification", "o_q_diag", "o_flat_prior", "o_ncsk", "o_nstd",
  "o_ninv", "o_indxparr", "o_indxovr", "o_aband", "o_indxap", "o_apband",
  "o_indximf", "o_indxfore", "o_foreband", "o_indxgforhat",
  "o_indxgimfhat", "o_indxestima", "o_indxgdls", "o_eq_ms", "o_cms",
  "o_ncms", "o_eq_cms", "o_tlindx", "o_tlnumber", "o_cnum",
  "o_k_order_solver", "o_pruning", "o_chain", "o_restrictions",
  "o_duration", "o_number_of_regimes", "o_number_of_lags", "o_parameters",
  "o_coefficients", "o_variances", "o_equations", "o_silent_optimizer",
  "o_instruments", "o_ext_func_name", "o_ext_func_nargs",
  "o_first_deriv_provided", "o_second_deriv_provided",
  "o_filter_covariance", "o_filter_decomposition",
  "o_smoothed_state_uncertainty", "o_selected_variables_only",
  "o_cova_compute", "o_output_file_tag", "o_file_tag", "o_no_create_init",
  "o_simulation_file_tag", "o_coefficients_prior_hyperparameters",
  "o_convergence_starting_value", "o_convergence_ending_value",
  "o_convergence_increment_value", "o_max_iterations_starting_value",
  "o_max_iterations_increment_value", "o_max_block_iterations",
  "o_max_repeated_optimization_runs", "o_function_convergence_criterion",
  "o_parameter_convergence_criterion", "o_number_of_large_perturbations",
  "o_number_of_small_perturbations",
  "o_number_of_posterior_draws_after_perturbation",
  "o_max_number_of_stages", "o_random_function_convergence_criterion",
  "o_random_parameter_convergence_criterion", "o_thinning_factor",
  "o_adaptive_mh_draws", "o_save_draws", "o_proposal_draws",
  "o_use_mean_center", "o_proposal_type", "o_proposal_lower_bound",
  "o_proposal_upper_bound", "o_parameter_uncertainty", "o_horizon",
  "o_filtered_probabilities", "o_real_time_smoothed", "o_no_error_bands",
  "o_error_band_percentiles", "o_shock_draws", "o_shocks_per_parameter",
  "o_free_parameters", "o_median", "o_regimes", "o_regime",
  "o_data_obs_nbr", "o_discretionary_tol", "o_analytic_derivation",
  "o_analytic_derivation_mode", "o_endogenous_prior",
  "o_use_univariate_filters_if_singularity_is_detected",
  "o_mcmc_jumping_covariance", "o_rescale_prediction_error_covariance",
  "o_use_penalized_objective_for_hessian", "o_irf_plot_threshold",
  "o_dr_display_tol", "o_consider_all_endogenous",
  "o_consider_only_observed", "o_no_homotopy", "o_infile", "o_invars",
  "o_period", "o_outfile", "o_outvars", "o_lmmcp", "o_occbin",
  "o_function", "o_sampling_draws", "o_use_shock_groups", "o_colormap",
  "o_icd_colormap", "o_gmm_order", "o_smm_order", "o_gmm_centered_moments",
  "o_smm_centered_moments", "o_gmm_autolag", "o_smm_autolag",
  "o_gmm_recursive_order_estimation", "o_smm_recursive_order_estimation",
  "o_gmm_bartlett_kernel_lag", "o_smm_bartlett_kernel_lag",
  "o_gmm_weighting_matrix", "o_smm_weighting_matrix",
  "o_gmm_penalized_estimator", "o_smm_penalized_estimator",
  "o_gmm_verbose", "o_smm_verbose", "o_smm_simulation_multiple",
  "o_smm_drop", "o_smm_seed", "o_smm_bounded_shock_support",
  "o_analytical_girf", "o_irf_in_percent", "o_emas_girf", "o_emas_drop",
  "o_emas_tolf", "o_emas_max_iter", "o_no_identification_strength",
  "o_no_identification_reducedform", "o_no_identification_moments",
  "o_no_identification_minimal", "o_no_identification_spectrum",
  "o_normalize_jacobians", "o_grid_nbr", "o_tol_rank", "o_tol_deriv",
  "o_tol_sv", "o_checks_via_subsets", "o_max_dim_subsets_groups", "range",
  "integer_range", "integer_range_w_inf", "signed_integer_range",
  "vec_int_number", "vec_int_elem", "vec_int_1", "vec_int", "vec_str_1",
  "vec_str", "vec_value_1", "vec_value", "vec_value_list",
  "vec_of_vec_value", "vec_value_1_w_inf", "vec_value_w_inf", "symbol",
  "number", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short
  parser::yyrline_[] =
  {
       0,   198,   198,   199,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   317,   319,   323,
     325,   325,   329,   331,   333,   335,   337,   339,   343,   343,
     347,   349,   351,   353,   355,   357,   361,   362,   362,   364,
     364,   368,   369,   372,   374,   376,   380,   381,   384,   385,
     386,   389,   392,   393,   396,   397,   398,   401,   401,   403,
     404,   407,   408,   409,   410,   411,   414,   418,   419,   423,
     425,   425,   430,   432,   434,   436,   438,   442,   442,   446,
     447,   450,   452,   454,   456,   458,   462,   464,   469,   473,
     475,   482,   487,   489,   494,   498,   500,   507,   511,   512,
     515,   519,   523,   524,   527,   528,   531,   533,   535,   537,
     539,   541,   543,   545,   547,   549,   551,   553,   557,   560,
     562,   564,   567,   569,   572,   574,   576,   581,   588,   589,
     592,   594,   596,   598,   600,   602,   604,   606,   608,   610,
     612,   614,   618,   620,   622,   624,   626,   628,   630,   632,
     634,   636,   638,   640,   644,   646,   648,   650,   652,   654,
     656,   658,   660,   662,   664,   666,   670,   672,   674,   676,
     678,   680,   682,   684,   686,   688,   690,   692,   696,   698,
     700,   704,   706,   708,   710,   712,   714,   718,   722,   724,
     726,   728,   732,   734,   739,   746,   748,   752,   754,   756,
     758,   760,   762,   764,   766,   768,   770,   772,   774,   776,
     778,   780,   782,   784,   786,   788,   790,   792,   794,   796,
     798,   800,   802,   804,   806,   808,   810,   812,   814,   816,
     818,   818,   820,   822,   824,   826,   828,   830,   832,   836,
     838,   842,   844,   847,   849,   853,   857,   859,   863,   864,
     867,   869,   871,   875,   876,   879,   881,   885,   885,   889,
     890,   893,   893,   897,   899,   900,   903,   905,   907,   909,
     911,   915,   916,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,   929,   930,   933,   933,   935,   935,   939,
     940,   941,   942,   945,   947,   949,   951,   955,   956,   959,
     961,   965,   967,   969,   971,   973,   975,   977,   979,   981,
     983,   985,   987,   989,   991,   993,   995,   997,   999,  1001,
    1003,  1005,  1007,  1009,  1011,  1013,  1015,  1017,  1019,  1021,
    1023,  1025,  1027,  1029,  1031,  1033,  1035,  1037,  1039,  1041,
    1043,  1045,  1047,  1049,  1049,  1051,  1053,  1055,  1057,  1059,
    1061,  1065,  1067,  1071,  1074,  1075,  1078,  1079,  1082,  1083,
    1085,  1087,  1089,  1093,  1097,  1097,  1101,  1102,  1105,  1107,
    1110,  1112,  1109,  1114,  1116,  1120,  1122,  1126,  1128,  1132,
    1133,  1136,  1137,  1140,  1142,  1144,  1146,  1150,  1154,  1158,
    1159,  1162,  1163,  1164,  1165,  1166,  1167,  1170,  1174,  1175,
    1178,  1179,  1180,  1181,  1184,  1185,  1188,  1189,  1192,  1194,
    1196,  1198,  1200,  1202,  1206,  1208,  1210,  1212,  1214,  1216,
    1218,  1222,  1224,  1228,  1230,  1232,  1234,  1236,  1238,  1242,
    1244,  1248,  1249,  1252,  1253,  1254,  1255,  1256,  1257,  1258,
    1259,  1262,  1264,  1268,  1269,  1272,  1273,  1276,  1278,  1282,
    1283,  1285,  1287,  1289,  1293,  1294,  1297,  1298,  1301,  1303,
    1307,  1308,  1311,  1312,  1313,  1314,  1315,  1316,  1317,  1318,
    1319,  1320,  1321,  1322,  1323,  1324,  1325,  1328,  1329,  1330,
    1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,
    1341,  1342,  1343,  1344,  1345,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1353,  1354,  1355,  1356,  1357,  1358,  1359,  1360,
    1361,  1362,  1363,  1364,  1365,  1366,  1367,  1368,  1369,  1370,
    1371,  1372,  1373,  1376,  1378,  1382,  1383,  1386,  1387,  1388,
    1389,  1390,  1391,  1392,  1393,  1394,  1397,  1399,  1403,  1404,
    1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
    1417,  1418,  1419,  1422,  1426,  1430,  1431,  1434,  1435,  1438,
    1440,  1444,  1445,  1448,  1449,  1452,  1456,  1457,  1460,  1461,
    1462,  1463,  1466,  1468,  1470,  1472,  1476,  1477,  1480,  1481,
    1482,  1483,  1484,  1485,  1486,  1487,  1488,  1489,  1490,  1491,
    1492,  1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,  1501,
    1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,  1510,  1511,
    1512,  1513,  1514,  1515,  1516,  1517,  1518,  1519,  1520,  1521,
    1522,  1523,  1524,  1525,  1526,  1527,  1528,  1529,  1532,  1533,
    1534,  1535,  1536,  1537,  1540,  1542,  1544,  1548,  1549,  1553,
    1555,  1560,  1563,  1564,  1567,  1569,  1574,  1577,  1579,  1581,
    1585,  1586,  1589,  1591,  1593,  1597,  1598,  1600,  1605,  1610,
    1616,  1623,  1627,  1632,  1639,  1643,  1651,  1656,  1662,  1669,
    1679,  1681,  1683,  1687,  1689,  1693,  1699,  1706,  1714,  1717,
    1719,  1723,  1730,  1738,  1747,  1750,  1752,  1756,  1764,  1766,
    1768,  1770,  1772,  1774,  1776,  1778,  1780,  1784,  1786,  1788,
    1790,  1792,  1794,  1796,  1798,  1802,  1804,  1805,  1809,  1813,
    1817,  1818,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1830,
    1834,  1838,  1840,  1842,  1846,  1847,  1850,  1850,  1852,  1852,
    1854,  1854,  1856,  1856,  1858,  1858,  1860,  1860,  1862,  1862,
    1866,  1867,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1882,  1883,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1898,  1903,  1905,  1907,  1909,  1911,
    1913,  1917,  1919,  1921,  1923,  1925,  1927,  1931,  1932,  1935,
    1936,  1937,  1940,  1945,  1947,  1949,  1951,  1953,  1955,  1959,
    1961,  1963,  1965,  1969,  1970,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2094,  2096,  2100,  2101,  2104,  2106,
    2110,  2111,  2115,  2117,  2119,  2121,  2125,  2126,  2129,  2129,
    2131,  2133,  2135,  2139,  2139,  2141,  2143,  2145,  2149,  2151,
    2152,  2155,  2157,  2159,  2161,  2163,  2165,  2167,  2171,  2174,
    2175,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2187,  2189,
    2191,  2193,  2197,  2199,  2203,  2205,  2209,  2213,  2217,  2219,
    2223,  2224,  2227,  2228,  2229,  2230,  2231,  2232,  2233,  2234,
    2235,  2236,  2237,  2238,  2239,  2240,  2241,  2242,  2243,  2244,
    2245,  2246,  2247,  2248,  2249,  2250,  2251,  2252,  2253,  2254,
    2255,  2256,  2257,  2258,  2259,  2260,  2263,  2265,  2269,  2270,
    2273,  2274,  2278,  2279,  2282,  2284,  2288,  2290,  2292,  2294,
    2296,  2298,  2302,  2303,  2302,  2305,  2307,  2311,  2313,  2315,
    2317,  2321,  2325,  2326,  2329,  2331,  2333,  2335,  2339,  2343,
    2345,  2347,  2349,  2353,  2354,  2357,  2358,  2359,  2362,  2363,
    2366,  2367,  2368,  2371,  2372,  2375,  2376,  2377,  2380,  2382,
    2386,  2388,  2392,  2394,  2398,  2402,  2404,  2406,  2408,  2412,
    2414,  2416,  2418,  2422,  2424,  2426,  2428,  2432,  2434,  2436,
    2438,  2442,  2444,  2448,  2449,  2450,  2451,  2452,  2453,  2454,
    2457,  2458,  2459,  2460,  2461,  2462,  2463,  2464,  2465,  2466,
    2469,  2470,  2473,  2475,  2479,  2480,  2481,  2482,  2485,  2486,
    2489,  2491,  2495,  2496,  2497,  2498,  2499,  2500,  2501,  2502,
    2503,  2504,  2505,  2506,  2507,  2508,  2509,  2510,  2511,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,  2532,
    2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,  2541,  2542,
    2545,  2546,  2549,  2551,  2555,  2556,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,  2567,  2568,  2571,  2572,
    2575,  2577,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,  2590,  2591,  2592,  2593,  2594,  2597,  2598,  2601,  2603,
    2607,  2608,  2609,  2610,  2611,  2612,  2613,  2614,  2615,  2616,
    2617,  2618,  2619,  2620,  2623,  2624,  2627,  2629,  2631,  2633,
    2637,  2638,  2639,  2640,  2643,  2644,  2647,  2649,  2653,  2654,
    2655,  2656,  2657,  2658,  2659,  2660,  2663,  2664,  2667,  2669,
    2673,  2674,  2675,  2676,  2677,  2678,  2679,  2682,  2683,  2686,
    2688,  2692,  2693,  2694,  2695,  2696,  2697,  2698,  2699,  2700,
    2701,  2702,  2703,  2704,  2705,  2706,  2707,  2708,  2709,  2710,
    2711,  2712,  2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,
    2721,  2722,  2723,  2724,  2725,  2726,  2729,  2730,  2733,  2735,
    2739,  2741,  2745,  2746,  2749,  2750,  2751,  2752,  2753,  2754,
    2755,  2756,  2757,  2758,  2759,  2760,  2761,  2762,  2763,  2764,
    2765,  2766,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,
    2775,  2776,  2777,  2778,  2779,  2780,  2781,  2782,  2783,  2784,
    2785,  2786,  2787,  2788,  2789,  2790,  2791,  2792,  2793,  2794,
    2795,  2796,  2797,  2798,  2799,  2800,  2803,  2804,  2807,  2808,
    2809,  2810,  2811,  2812,  2813,  2814,  2815,  2816,  2819,  2820,
    2823,  2824,  2825,  2826,  2827,  2828,  2829,  2830,  2831,  2832,
    2833,  2834,  2837,  2838,  2841,  2842,  2843,  2844,  2845,  2846,
    2847,  2848,  2849,  2850,  2851,  2852,  2853,  2854,  2855,  2856,
    2857,  2858,  2859,  2860,  2863,  2864,  2867,  2868,  2869,  2870,
    2871,  2872,  2873,  2874,  2875,  2876,  2877,  2878,  2879,  2880,
    2883,  2886,  2887,  2890,  2892,  2896,  2897,  2898,  2899,  2902,
    2903,  2906,  2907,  2908,  2909,  2910,  2913,  2917,  2918,  2921,
    2922,  2923,  2924,  2925,  2928,  2930,  2934,  2938,  2939,  2942,
    2946,  2946,  2950,  2951,  2954,  2956,  2960,  2962,  2964,  2966,
    2970,  2971,  2974,  2975,  2976,  2977,  2978,  2979,  2980,  2981,
    2982,  2983,  2984,  2985,  2986,  2989,  2991,  2993,  2995,  2999,
    3000,  3003,  3004,  3007,  3008,  3011,  3015,  3017,  3021,  3023,
    3027,  3028,  3031,  3032,  3033,  3034,  3035,  3036,  3039,  3043,
    3045,  3047,  3051,  3055,  3056,  3059,  3061,  3063,  3067,  3069,
    3073,  3074,  3077,  3079,  3081,  3085,  3087,  3091,  3092,  3095,
    3096,  3097,  3098,  3099,  3102,  3104,  3108,  3109,  3112,  3113,
    3116,  3117,  3118,  3121,  3123,  3127,  3128,  3131,  3132,  3135,
    3141,  3142,  3148,  3149,  3150,  3151,  3152,  3153,  3154,  3155,
    3156,  3157,  3158,  3159,  3160,  3161,  3162,  3166,  3167,  3168,
    3169,  3170,  3171,  3172,  3173,  3174,  3175,  3181,  3182,  3183,
    3184,  3185,  3186,  3187,  3188,  3190,  3191,  3192,  3193,  3194,
    3195,  3196,  3197,  3198,  3199,  3200,  3201,  3202,  3203,  3203,
    3204,  3205,  3207,  3208,  3209,  3210,  3211,  3212,  3213,  3214,
    3215,  3216,  3218,  3221,  3222,  3223,  3224,  3226,  3229,  3231,
    3234,  3236,  3237,  3238,  3239,  3240,  3241,  3242,  3243,  3244,
    3245,  3246,  3247,  3248,  3249,  3250,  3251,  3252,  3253,  3254,
    3255,  3256,  3257,  3258,  3259,  3261,  3264,  3266,  3269,  3270,
    3271,  3272,  3274,  3276,  3277,  3278,  3279,  3280,  3281,  3282,
    3283,  3284,  3286,  3287,  3288,  3290,  3293,  3295,  3298,  3300,
    3303,  3304,  3305,  3307,  3309,  3311,  3314,  3315,  3318,  3321,
    3322,  3323,  3324,  3325,  3326,  3327,  3328,  3329,  3331,  3332,
    3333,  3334,  3335,  3338,  3339,  3340,  3341,  3342,  3343,  3344,
    3345,  3346,  3347,  3348,  3349,  3350,  3351,  3352,  3353,  3354,
    3355,  3356,  3358,  3360,  3363,  3364,  3365,  3366,  3367,  3368,
    3369,  3370,  3371,  3372,  3373,  3374,  3375,  3377,  3380,  3381,
    3382,  3383,  3384,  3385,  3386,  3387,  3388,  3389,  3390,  3391,
    3392,  3393,  3394,  3395,  3396,  3397,  3398,  3399,  3400,  3401,
    3402,  3403,  3404,  3405,  3406,  3407,  3408,  3409,  3410,  3411,
    3412,  3413,  3414,  3415,  3416,  3417,  3418,  3419,  3420,  3421,
    3422,  3424,  3426,  3429,  3431,  3433,  3436,  3437,  3438,  3439,
    3440,  3441,  3442,  3443,  3444,  3445,  3446,  3447,  3448,  3449,
    3450,  3451,  3452,  3453,  3454,  3455,  3456,  3457,  3458,  3459,
    3460,  3461,  3462,  3463,  3464,  3465,  3466,  3467,  3468,  3469,
    3470,  3471,  3472,  3473,  3474,  3475,  3478,  3479,  3480,  3481,
    3482,  3483,  3484,  3485,  3486,  3487,  3488,  3489,  3490,  3491,
    3492,  3493,  3494,  3495,  3496,  3497,  3498,  3499,  3500,  3501,
    3502,  3503,  3504,  3505,  3506,  3507,  3509,  3512,  3513,  3514,
    3515,  3516,  3517,  3518,  3519,  3521,  3522,  3523,  3524,  3526,
    3527,  3529,  3531,  3533,  3535,  3537,  3539,  3542,  3543,  3544,
    3545,  3546,  3548,  3550,  3553,  3554,  3555,  3556,  3557,  3558,
    3559,  3560,  3561,  3566,  3571,  3577,  3578,  3579,  3580,  3581,
    3582,  3583,  3584,  3585,  3586,  3587,  3588,  3590,  3593,  3594,
    3595,  3596,  3597,  3598,  3599,  3600,  3601,  3602,  3603,  3604,
    3605,  3606,  3607,  3608,  3609,  3610,  3611,  3612,  3613,  3614,
    3615,  3616,  3617,  3618,  3619,  3620,  3623,  3625,  3628,  3629,
    3630,  3631,  3632,  3633,  3635,  3638,  3639,  3641,  3642,  3643,
    3645,  3648,  3650,  3653,  3656,  3659,  3662,  3665,  3668,  3669,
    3670,  3671,  3672,  3674,  3676,  3678,  3680,  3682,  3684,  3686,
    3688,  3690,  3692,  3694,  3696,  3698,  3700,  3702,  3704,  3705,
    3706,  3707,  3708,  3709,  3710,  3711,  3712,  3713,  3714,  3715,
    3716,  3717,  3718,  3719,  3720,  3721,  3722,  3723,  3724,  3725,
    3726,  3727,  3728,  3729,  3730,  3731,  3732,  3734,  3736,  3739,
    3740,  3741,  3742,  3743,  3744,  3745,  3747,  3748,  3749,  3750,
    3751,  3752,  3753,  3754,  3755,  3756,  3757,  3759,  3760,  3762,
    3763,  3764,  3765,  3766,  3768,  3771,  3773,  3776,  3777,  3778,
    3779,  3780,  3782,  3784,  3786,  3789,  3791,  3793,  3795,  3798,
    3799,  3800,  3801,  3803,  3804,  3805,  3806,  3808,  3809,  3810,
    3811,  3812,  3813,  3816,  3817,  3818,  3819,  3820,  3821,  3822,
    3823,  3824,  3825,  3826,  3827,  3829,  3832,  3835,  3837,  3841,
    3843,  3846,  3850,  3851,  3859,  3861,  3863,  3868,  3875,  3876,
    3879,  3881,  3883,  3888,  3895,  3896,  3899,  3901,  3903,  3905,
    3909,  3911,  3915,  3917,  3920,  3922,  3925,  3927,  3931,  3934,
    3935,  3936,  3937,  3938,  3939,  3940,  3941,  3942,  3943,  3944,
    3945,  3946,  3947,  3948,  3949,  3950,  3951,  3952,  3953,  3957,
    3958
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << '\n';
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    unsigned yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  parser::token_number_type
  parser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const token_number_type
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,   649,     2,     2,     2,     2,
     645,   646,     2,     2,     2,     2,   651,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   650,   644,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   647,     2,   648,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643
    };
    const unsigned user_token_number_max_ = 898;
    const token_number_type undef_token_ = 2;

    if (static_cast<int> (t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

#line 25 "DynareBison.yy" // lalr1.cc:1242
} // Dynare
#line 14624 "DynareBison.cc" // lalr1.cc:1242
#line 3960 "DynareBison.yy" // lalr1.cc:1243


void
Dynare::parser::error(const Dynare::parser::location_type &l,
                      const string &m)
{
  driver.error(l, m);
}
